<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<!--<!DOCTYPE html>-->
<!-- paulirish.com/2008/conditional-stylesheets-vs-css-hacks-answer-neither/ -->
<!--[if lte IE 7]> <html class="no-js unsupportedBrowser oldie" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js ie8" lang="en"> <![endif]-->
<!--[if IE 9]>    <html class="no-js ie9" lang="en"> <![endif]-->
<!--[if gt IE 9]><!-->
<html class="no-js" lang="en">
<!--<![endif]-->
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <!--meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" /-->

    <title>
        <fmt:message key="scvmmHomePage.DellSCVMM" />
    </title>

    <link rel="shortcut icon" href="dellclarity.core/images/body/fav.ico" />
    <link rel="icon" type="image/ico" href="images/Dell.ico" />

    <link href="dellclarity.core/styles/global.semantic.css" rel="stylesheet" type="text/css" />
    <link href="styles/custom.css" media="screen,print" rel="stylesheet" type="text/css" />

    <script type="text/javascript">

        var menuFlag = true;

        DellClarity = {
            Config: {
                apiVersion: 2.5,
                debugMode: false,
                developmentMode: false,
                scvmmversion: 3.1,
                consoleType: ''
            },

            initialParameters: location.search,

            // When DellClarity is initialized, we can safely load our custom script
            initialize: function () {
                DellClarity.Resources.load('scripts/custom.js');
                DellClarity.Navigation.defaultView = 'home';

                // After all resources are finished loading, load the menu
                DellClarity.Resources.whenFinishedLoading(function () {
                    DellClarity.SCVMM.loadMenu('navigationMenu');

                    //Get the username and place it in the website banner
                    //var test = DellClarity.SCVMM.getUserName();
                    var userName = DellClarity.SCVMM.getUserName();
                    $('#userNameSpan').text(userName);

                    //Get the console type and based on that type enable the left navigation menu links.
                    var consoleType = DellClarity.SCVMM.getConsoleType();
                    console.log('consoleType:::' + consoleType);

                    if (consoleType && consoleType.toLowerCase() == 'scvmm') {
                        $('nav.menu.navigation ul li #linkHypervisorProfile').css('display', 'block');
                        $('nav.menu.navigation #linkUpdateCenter').css('display', 'block');
                        $('nav.menu.navigation ul li #linkOperationalTemplate').css('display', 'block');
                        $('nav.menu.navigation #configanddeploylink').css('display', 'block');
                        $('nav.menu.navigation #profilesandtemplateslink').css('display', 'block');                        
                        $('nav.menu.navigation #linkWinpeUpdate').css('display', 'block');
                        $('nav.menu.navigation ul li #linkClusterView').css('display', 'block');
                        $('div.header_div_right #onlineHelpLink').css('display', 'block');
                    }

                    if (consoleType && consoleType.toLowerCase() == 'sccm') {
                        //$('nav.menu.navigation #linkBootMediaCreation').css('display', 'block');
                        $('nav.menu.navigation #configanddeploylink').css('display', 'block');
                        $('nav.menu.navigation #linkUpdateCenter').css('display', 'block');
                        $('nav.menu.navigation #profilesandtemplateslink').css('display', 'block');
                        $('nav.menu.navigation ul li #linkOperationalTemplate').css('display', 'block');
                        $('nav.menu.navigation #linkWinpeUpdate').css('display', 'block');
                        $('div.header_div_right #onlineHelpLink').css('display', 'block');
                    }

                    if (consoleType && consoleType.toLowerCase() == 'scom') {
                        $('nav.menu.navigation #monitoringlink').css('display', 'block');
                        $('nav.menu.navigation #profilesandconfiglink').css('display', 'block');
                        $('nav.menu.navigation ul li #linkNetworkSwitchView').css('display', 'block');
                        //$('nav.menu.navigation ul li #linkME4StorageView').css('display', 'block');
                        $('nav.menu.navigation ul li #linkConfiguration').css('display', 'block');
                    }

                    DellClarity.Config.consoleType = consoleType.toLowerCase();

                    if (consoleType && consoleType.toLowerCase() == 'scvmm') {
                        //Get the SCVMM version from the scvmmversion querystring parameter
                        //var version = DellClarity.SCVMM.getQueryStringParam(location.search, 'scvmmversion');
                        var scvmmversion = DellClarity.SCVMM.getScvmmVersion();
                        //version = "4.0.1662.0";
                        //DellClarity.Config.scvmmversion = version == null ? 3.1 : version;
                        //Removing dots in scvmm version for using in Cluster View to decide "Create Cluster" and "Create Logical Switch" buttons needs to display or not. If the SCVMM version is 2016 and above.
                        DellClarity.Config.scvmmversion = scvmmversion == null ? 31 : scvmmversion.replace(/[^0-9]/g, "");
                    }
                });
            },

        };

        function openNav() {
            if (menuFlag) {
                $('nav.menu.navigation').removeClass('short-nav-menu').addClass('long-nav-menu');
                $('#navigation-toggle').removeClass('cux-icon-chevron-sign-right').addClass('cux-icon-chevron-sign-left');
                menuFlag = false;
            } else {
                $('nav.menu.navigation').addClass('short-nav-menu').removeClass('long-nav-menu');
                $('#navigation-toggle').removeClass('cux-icon-chevron-sign-left').addClass('cux-icon-chevron-sign-right');
                menuFlag = true;
            }
        }
    </script>

    <script src="dellclarity.core/scripts/libraries/modernizr.js" type="text/javascript"> </script>
    <script src="dellclarity.core/scripts/global.js" type="text/javascript"> </script>
</head>
<body>
    <header class="header">
        <div>
            <div class="header_icon_div">
                <!-- <i class="cui-icon cux-icon cui-icon-color-white cux-icon-dell-halo" style="font-size: 30px;"></i>  -->
                <img height="20" src="dellclarity.core/images/logos/dell_emc_logo.png" />
            </div>
            <span class="header_idrac_label"><fmt:message key="application.title" />
            </span>
            <span class="header_idrac_license"></span>

            <div class="header_div_right">
                <span class="idracmenu-username" title="User">
                    <i class="nav-right-icon cux-icon cux-icon-user"></i>&nbsp;<span id="userNameSpan" style="font-weight: bold"></span>
                </span>
                <!--changed-->
                <span class="idracmenu-username" title="About">
                    <a href="#/about" style="color: white;"><i class="nav-right-icon cux-icon cux-icon-info-sign"></i> <fmt:message key="about.title"/></a>
                    <!--new-->
                </span>
                <span id="onlineHelpLink" class="idracmenu-username" title="Help">
                    <a id="helpLink" style="color: white;"><i class="nav-right-icon cux-icon cux-icon-question-sign"></i> <fmt:message key="confirmationmodal.help"/></a>
                    <!--new-->
                </span>
            </div>
        </div>
    </header>

    <div class="contentWrapper">
        <nav id="navigationMenu" class="menu navigation short-nav-menu" role="navigation">
            <i class="cux-icon cux-icon-chevron-sign-right" id="navigation-toggle" onclick="openNav()"></i>
             <ul id="navmenugrouplist">
                <li>
                    <a href="#/home" title="Home">
                        <i class="ci ci-nav-icon ci-nav-home-core"></i>
                        <fmt:message key="mainmenu.home" />
                    </a>
                </li>
                
                <li class="hasSubMenu">
                    <a id="profilesandtemplateslink" title="Profiles and Templates" style="display: none;">
                        <i class="cux-icon ci-nav-submenu-icon cux-icon-caret-right"></i>
                        <i class="ci ci-nav-icon ci-profiles-core"></i>
                        <fmt:message key="mainmenu.profilesandtemplates" />
                    </a>

                    <a id="profilesandconfiglink" title="Profiles and Configuration" style="display: none;">
                        <i class="cux-icon ci-nav-submenu-icon cux-icon-caret-right"></i>
                        <i class="ci ci-nav-icon ci-profiles-core"></i>
                        <fmt:message key="mainmenu.profilesandconfiguration" />
                    </a>

                    <ul>
                        <li id="linkHypervisorProfile" style="display: none;">
                            <a href="#/hypervisorProfile.masterDetails" title="Hypervisor Profile">
                                <i class="ci ci-nav-icon ci-hardware-core"></i>
                                <fmt:message key="mainmenu.hypervisorprofile" />
                            </a>
                        </li>

                        <li data-bind="attr: { 'class': $data.cssclass }">
                            <a href="#/credentialProfile.masterDetails" title="Credential Profile">
                                <i class="ci ci-nav-icon ci-profile-encrypted-core"></i>
                                <fmt:message key="mainmenu.credentialprofile" />
                            </a>
                        </li>

                        <li id="linkConfiguration" style="display: none;">
                            <a href="#/configuration.home" title="Configuration">
                                <i class="ci ci-nav-icon ci-config-settings3-core"></i>
                                <fmt:message key="mainmenu.configuration" />
                            </a>
                        </li>

                        <li id="linkOperationalTemplate" style="display: none;">
                            <a href="#/lifecycletemplates.home" title="Operational Template">
                                <i class="ci ci-nav-icon ci-templates-core"></i>
                                <fmt:message key="mainmenu.lifecycletemplate" />
                            </a>
                        </li>

                        <!-- <li>
                            <a href="#/complianceConfiguration.home">
                                <i class="ci ci-nav-icon ci-templates-core" title="Compliance Configuration Profile"></i>
                                <fmt:message key="mainmenu.complianceconfigurationprofile" />
                            </a>
                        </li> -->
                    </ul>
                    <!-- this div is for IE8... for some reason knockout is trying to close a non-existent div so we're adding one here to keep the DOM valid. -->
                    <div class="visuallyhidden">
                    </div>
                </li>

                <li class="hasSubMenu" id="configanddeploy">
                    <!-- <a id="configanddeploylink" style="display: none;" href="#/configanddeploy.home"> -->
                    <a id="configanddeploylink" title="Configuration and Deployment" style="display: none;">
                        <i class="cux-icon ci-nav-submenu-icon cux-icon-caret-right"></i>
                        <i class="ci ci-nav-icon ci-deployment-core"></i>
                        <fmt:message key="mainmenu.configanddeploy" />
                    </a>

                    <a id="monitoringlink" title="Monitoring" style="display: none;">
                        <i class="cux-icon ci-nav-submenu-icon cux-icon-caret-right"></i>
                        <i class="ci ci-nav-icon ci-deployment-core"></i>
                        <fmt:message key="mainmenu.monitoring" />
                    </a>

                    <ul>
                        <li id="serverview">
                            <a href="#/configanddeploy.serverview" title="Server View">
                                <i class="ci ci-nav-icon ci-server-core"></i>
                                <fmt:message key="mainmenu.configanddeploy.serverview" />
                            </a>
                        </li>

                        <li class="hasSubMenu">
                            <a href="#/configanddeploy.chassisview" title="Modular Systems View">
                                <i class="cux-icon ci-nav-submenu-icon cux-icon-caret-right"></i>
                                <i class="ci ci-nav-icon ci-chassis-config-core"></i>
                                <fmt:message key="mainmenu.configanddeploy.chassisview" />
                            </a>

                            <ul id="ChassisData" style="border: none; padding-left: 60px;">
                                
                            </ul>

                            <!-- this div is for IE8... for some reason knockout is trying to close a non-existent div so we're adding one here to keep the DOM valid. -->
                            <div class="visuallyhidden">
                            </div>
                        </li>

                        <li class="hasSubMenu" id="linkClusterView" style="display: none;">
                            <a href="#/configanddeploy.clusterview" title="Cluster View">
                                <i class="cux-icon ci-nav-submenu-icon cux-icon-caret-right"></i>
                                <i class="ci ci-nav-icon ci-cluster-core"></i>
                                <fmt:message key="mainmenu.configanddeploy.clusterview" />
                            </a>

                            <ul id="ClusterData" style="border: none; padding-left: 60px;">
                                
                            </ul>

                            <!-- this div is for IE8... for some reason knockout is trying to close a non-existent div so we're adding one here to keep the DOM valid. -->
                            <div class="visuallyhidden">
                            </div>
                        </li>

                        <li id="linkNetworkSwitchView" style="display: none;">
                            <a href="#/configanddeploy.networkswitchview" title="Network Switch View">
                                <i class="ci ci-nav-icon ci-switch-horiz-core"></i>
                                <fmt:message key="mainmenu.configanddeploy.networkswitchview" />
                            </a>
                        </li>

                        <li id="linkME4StorageView" style="display: none;">
                            <a href="#/configanddeploy.me4storageview" title="ME4 Storage View">
                                <i class="ci ci-nav-icon ci-storage-device-core"></i>
                                <fmt:message key="mainmenu.configanddeploy.me4storageview" />
                            </a>
                        </li>
                    </ul>
                    <!-- this div is for IE8... for some reason knockout is trying to close a non-existent div so we're adding one here to keep the DOM valid. -->
                    <div class="visuallyhidden">
                    </div>
                </li>

                <li id="linkUpdateCenter" style="display: none;">
                    <a href="#/updateCenter.home" title="Maintenance Center">
                        <i class="ci ci-nav-icon ci-nav-appli-manag-core"></i>
                        <fmt:message key="mainmenu.updatecenter" />
                    </a>
                </li>
                <li id="linkWinpeUpdate" style="display: none;">
                    <a href="#/winpeUpdate.details" title="WinPE Update">
                        <i class="ci ci-nav-icon ci-server-core"></i>
                        <fmt:message key="mainmenu.winpeupdate" />
                    </a>
                </li>
                <!-- <li id="linkBootMediaCreation" style="display: none;">
                    <a href="#/lcBootMedia.details">
                        <i class="ci ci-nav-icon ci-included-software-core" title="Boot Media Creation"></i>
                        <fmt:message key="mainmenu.bootmediacreation" />
                    </a>
                </li> -->
                <li id="joblogmenu">
                    <a href="#/jobLog.home" title="Jobs and Logs Center">
                        <i class="ci ci-nav-icon ci-nav-jobs-queue-core"></i>
                        <fmt:message key="mainmenu.jobsandlogs" />
                    </a>
                </li>
            </ul>
        </nav>

        <article id="mainContent" role="main">
            <fmt:message key="genericterms.loading" />
        </article>
    </div>
</body>
</html>
