<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<!DOCTYPE html>
<!-- paulirish.com/2008/conditional-stylesheets-vs-css-hacks-answer-neither/ -->
<!--[if lte IE 7]> <html class="no-js unsupportedBrowser oldie" lang="en"> <![endif]-->
<!--[if IE 8]>    <html class="no-js ie8" lang="en"> <![endif]-->
<!--[if IE 9]>    <html class="no-js ie9" lang="en"> <![endif]-->
<!--[if gt IE 9]><!-->
<html class="no-js" lang="en">
<!--<![endif]-->
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />

    <title>
        <fmt:message key="application.title" />
    </title>

    <link href="dellclarity.core/styles/global.semantic.css" rel="stylesheet" type="text/css" />
    <link href="styles/custom.css" media="screen,print" rel="stylesheet" type="text/css" />

    <link rel="shortcut icon" href="dellclarity.core/images/body/fav.ico" />
    <link rel="icon" type="image/ico" href="dellclarity.core/images/body/fav.ico" />

    <script type="text/javascript" language="javascript">

        RuntimeContext = {
            /// <field type="String" static="true" mayBeNull="true">
            /// If set by an application, it represents the calling search string (querystring) sent by the caller
            /// of the application.
            /// </field>
            initialParameters: location.search
        };

        DellClarity = {
            Config: {
                apiVersion: 2.5,
                debugMode: false,
                developmentMode: false
            },

            // When DellClarity is initialized, we can safely load our custom script
            initialize: function () {
                DellClarity.Resources.load('scripts/custom.js');
                DellClarity.Navigation.defaultView = 'login';
            }
        };
    </script>
    <script src="dellclarity.core/scripts/libraries/modernizr.js" type="text/javascript"> </script>
    <script src="dellclarity.core/scripts/global.js" type="text/javascript"> </script>
</head>
<body class="loginPage">
    <div style="position: relative; height: 60%" class="cui-start-screen cui-theme-blue">
        <div class="cui-start-screen-container">
            <div class="cui-start-screen-row">
                <div class="cui-start-screen-cell">
                    <div class="cui-start-screen-body">
                        <!--<i class="cux-icon cux-icon-color cux-icon-dell-halo cui-start-screen-dell-logo" style="font-size: 150px"></i>-->
                        <div align="center">
                            <img height="90" src="dellclarity.core/images/logos/dell_emc_logo.png"/>
                        </div>
                        <div class="cui-start-screen-application-name">OMIMSSC</div>
                        <div style="padding-top: 0px;" class="cui-start-screen-copyright"> 2009 - 2021 Dell Inc, or its subsidiaries. All Rights Reserved.</div>
                    </div>
                </div>
            </div>
        </div>
        <div class="login-error-div" style="display:none;"><i class="cux-icon cux-icon-remove-sign" style="color:#CE1126; width: 20px; height: 20px"></i> <fmt:message key="login.error.UsernameOfPasswordIsIncorrect" /></div>
    </div>

    <div style="align: center; background-color: #F4F4F4; height: 40%; width: 100%">
        <article role="main" data-bind="template: { name: DellClarity.Controls.Login.loginTemplateName, data: DellClarity.SCVMM.ViewModel.Login.login }">
        </article>
    </div>
</body>
</html>
