<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="modalDialogOverlay" data-bind="visible: visible">
    <article role="alertdialog" class="modalDialog confirmationDialog" data-bind="style: { 'maxWidth': width() + 'px', 'maxHeight': height() + 'px' }">
        <nav class="modalDialogTools">
            <a id="modalHelp" data-bind="visible: isHelpVisible(), click: help">
                <fmt:message key="confirmationmodal.help" />
            </a>
        </nav>
        <div class="modalContentWrapper">
            <table>
                <tbody>
                    <tr>
                        <td width="15%" style="padding-top:1.5em">
                            <!-- ko ifnot: iconClass -->
                                <i class="cux-icon cux-icon-warning-sign" style="color: #F2AF00; font-size: 48px;/*35pt;*/ padding-right:1em"></i>
                            <!-- /ko -->

                            <!-- ko if: iconClass -->
                                <i data-bind="css: iconClass" style="font-size: 48px;/*35pt;*/ padding-right:1em"></i>
                            <!-- /ko -->
                        </td>
                        <td>
                            <!-- ko if: title -->
                            <h1 id="modalTitle" class="confirmation-modal-title" data-bind="text: title"></h1>
                            <!-- /ko -->

                            <p id="modalContents" class="confirmation-modal-contents" data-bind="html: contents">
                            </p>
                            <!-- ko foreach: items -->
                            <p data-bind="html: $data">
                            </p>
                            <!-- /ko -->
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <div class="sectionEditButtons">
                                <!-- ko if: allowCancel -->
                                <button id="btnAccept" type="button" data-bind="click: accept" class="cux-button cux-button-large cux-button-primary">
                                    <fmt:message key="confirmationmodal.yes" />
                                </button>
                                <button id="btnCancel" type="button" data-bind="click: close" class="cux-button cux-button-large cux-button-danger">
                                    <fmt:message key="confirmationmodal.no" />
                                </button>
                                <!-- /ko -->
                                <!-- ko ifnot: allowCancel -->
                                <button id="Button1" type="button" data-bind="click: accept" class="cux-button cux-button-large cux-button-primary">
                                    <fmt:message key="confirmationmodal.ok" />
                                </button>
                                <!-- /ko -->
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </article>
</div>
