<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="modalDialogOverlay" data-bind="visible: visible">
    <article role="dialog" class="modalDialog datetimepickerDialog" data-bind="style: { width: width() ? width() + 'px' : null }">
        <header>
            <h1>
                <fmt:message key="datetime.select" />
            </h1>
        </header>
        <nav class="modalDialogTools">
            <a id="modalClose" data-bind="click: close">
                <fmt:message key="datetime.close" />
            </a>
        </nav>
        <section>
            <fieldset>
                <legend class="visuallyhidden">
                    <fmt:message key="datetime.select" />
                </legend>
                <ul class="labelValuePairs">
                    <li>
                        <label for="date"><span class="labelText">
                            <fmt:message key="datetime.date" />
                        </span></label>
                        <input id="date" class="fieldValue medium rounded" type="date" data-bind="value: date" />
                    </li>
                    <li>
                        <!-- ko if: hourmode() == '12' -->
                        <label for="timeHour12"><span class="labelText">
                            <fmt:message key="datetime.time" />
                        </span></label>
                        <!-- /ko -->
                        <!-- ko if: hourmode() != '12' -->
                        <label for="timeHour24"><span class="labelText">
                            <fmt:message key="datetime.time24" />
                        </span></label>
                        <!-- /ko -->

                        <span class="fieldValue">
                            <!-- ko if: hourmode() == '12' -->
                            <select id="timeHour12" class="rounded" data-bind="value: timeHH12, options: availableTimeHH12" />
                            <!-- /ko -->
                            <!-- ko if: hourmode() != '12' -->
                            <select id="timeHour24" class="rounded" data-bind="value: timeHH24, options: availableTimeHH24" />
                            <!-- /ko -->

                            <label for="timeMM" class="visuallyhidden">
                                <fmt:message key="datetime.selectminutes" />
                            </label>
                            <select id="timeMM" class="rounded" data-bind="value: timeMM, options: availableTimeMM" />

                            <!-- ko if: hourmode() == '12' -->
                            <label for="timeAMPM" class="visuallyhidden">
                                <fmt:message key="datetime.selectampm" />
                            </label>
                            <select id="timeAMPM" class="rounded" data-bind="value: timeAMPM, options: availableTimeAMPM" />
                            <!-- /ko -->
                        </span>
                    </li>
                </ul>

                <div class="sectionEditButtons">
                    <button id="btnAccept" type="button" data-bind="click: accept" class="default">
                        <fmt:message key="confirmationmodal.ok" />
                    </button>
                    <button id="btnCancel" type="button" data-bind="click: close">
                        <fmt:message key="confirmationmodal.cancel" />
                    </button>
                </div>
            </fieldset>
        </section>
    </article>
</div>
