<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_complianceprofile_template" data-bind="with: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details">
    <section id="error_complProfile" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="complianceprofiledetails.help" />
    </p>
    <form id="credProfileForm" autocomplete="off">
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="complianceprofiledetails.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="complProfName">
                        <u>
                            <fmt:message key="complianceprofiledetails.name" />
                        </u>
                    </label>
                    <input id="complProfName" name="complProfName" required data-bind="value: name, styledDisabled: (DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.editFlag() == true), event: { keyup: DellClarity.SCVMM.capsText, blur: DellClarity.SCVMM.trimText }, valueUpdate: 'input'"  type="text" maxlength="59" pattern="^[0-9a-zA-Z ]{1,59}$" title='<fmt:message key="complianceprofiledetails.name.hint" />' value=""  class="value">
                </li>
                <li>
                    <label for="complProfDescription">
                        <u>
                            <fmt:message key="complianceprofiledetails.description" />
                        </u>
                    </label>
                    <textarea id="complProfDescription" name="complProfDescription"  data-bind="value: description, styledDisabled: (DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.editFlag() == true)" class="value" maxlength="255" title='<fmt:message key="complianceprofiledetails.description.hint" />'></textarea>
                </li>
                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="complianceprofiledetails.selectdevicetype" />
                        </u>
                    </span>
                    <span class="value">
                      <label for="selectDeviceType" class="visuallyhidden">
                        <u>
                          <fmt:message key="complianceprofiledetails.selecteddevicetype" />
                        </u>
                      </label>
                        <select id="selectDeviceType" required data-bind="options: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.deviceTypes,
                                optionsValue: 'id', 
                                styledDisabled: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.editFlag() == true,
                                value: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.selectedDeviceType,
                                optionsText: 'name', optionsCaption: '<fmt:message key="complianceprofiledetails.selecteddevicetype" />'">
                        </select>
                    </span>
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="with: model">
            <legend>
                <fmt:message key="complianceprofiledetails.scheduleandrecurrence" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="scheduleDate">
                        <u>
                            <fmt:message key="complianceprofiledetails.scheduleprofiledatetime" /> 
                        </u>
                    </label>

                    <input class="input-append date" required type="text" id="scheduleDate" name="scheduleDate" data-bind="datepicker: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate, event: { change: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.validateDate }, styledDisabled: 1 == 1"/>
                    <a href="" id="clear">Clear calendar</a>
                    <span id="scheduleCalendar" class="add-on"><i class="icon-calendar" data-bind="datepicker: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate, event: { change: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.validateDate }"></i></span>

                    <select class="scheduleHourMinute" id="scheduleHour" data-bind="options: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.optionsHour, value: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledHour, styledDisabled: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate() == null || DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate().length == 0"></select>
                    <span id="scheduleHourMinuteSeparator">:</span>
                    <select class="scheduleHourMinute" id="scheduleMinute" data-bind="options: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.optionsMinute, value: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledMinute, styledDisabled: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate() == null || DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate().length == 0"></select>
                </li>

                <li>
                    <p style="padding-left: 20px;"><fmt:message key="complianceprofiledetails.recurrencehelp" /></p>
                </li>

                <li>
                    <ul id="reccurencechoices">
                        <li>
                            <label>
                            <input type="radio" name="PollingChoices" data-bind="checked: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.recurrenceChoice" value="NEVER">
                            <span><fmt:message key="complianceprofiledetails.scheduleprofilenever" /></span>
                            </label>    
                        </li>
                
                        <li>
                            <label>
                            <input type="radio" name="PollingChoices" data-bind="checked: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.recurrenceChoice" value="ONCE_A_DAY">
                            <span><fmt:message key="complianceprofiledetails.scheduleprofiledaily" /></span>
                            </label>    
                        </li>
                
                        <li>
                            <label>
                            <input type="radio" name="PollingChoices" data-bind="checked: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.recurrenceChoice" value="ONCE_A_WEEK">
                            <span><fmt:message key="complianceprofiledetails.scheduleprofileweekly" /></span>
                            </label>    
                        </li>
                
                        <li>
                            <label>
                            <input type="radio" name="PollingChoices" data-bind=" checked: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.recurrenceChoice" value="ONCE_A_MONTH">
                            <span><fmt:message key="complianceprofiledetails.scheduleprofilemonthly" /></span>
                            </label>    
                        </li>
                    </ul>
                </li>
             </ul>
        </fieldset>

        <fieldset data-bind="with: model">
            <legend>
                <fmt:message key="complianceprofiledetails.scheduledeploytime" />
            </legend>

            <ul class="labelValuePairs">

                <li>
                    <label for="scheduleDeployHour">
                        <u>
                            <fmt:message key="complianceprofiledetails.scheduledeployruntime" /> 
                        </u>
                    </label>

                    <select class="scheduleHourMinute" id="scheduleDeployHour" data-bind="options: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.optionsHour, value: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledHour, styledDisabled: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate() == null || DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate().length == 0"></select>
                    <span id="Span2">:</span>
                    <select class="scheduleHourMinute" id="scheduleDeployMinute" data-bind="options: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.optionsMinute, value: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledMinute, styledDisabled: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate() == null || DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduledDate().length == 0"></select>
                </li>

                <li>
                    <p><fmt:message key="complianceprofiledetails.reboothelp" /></p>
                </li>

                <li>
                    <input type="radio" name="runNow" class="value" id="runNow" value="runNow" data-bind="checked: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduleReboot" />
                    <label for="runNow">
                        <u>
                            <fmt:message key="complianceprofiledetails.runsnow" />
                        </u>
                    </label>
                </li>

                <li>
                    <input type="radio" name="afterReboot" class="value" id="afterReboot" value="afterReboot" data-bind="checked: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.Details.scheduleReboot" />
                    <label for="afterReboot">
                        <u>
                            <fmt:message key="complianceprofiledetails.afterreboot" />
                        </u>
                    </label>
                </li>

            </ul>
        </fieldset>
        <div class="sectionEditButtons">
            <button id="credentialProfileFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="complianceprofiledetails.finish" />
            </button>
            <button id="credentialProfileCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="complianceprofiledetails.cancel" />
            </button>
        </div>
    </form>
</section>
