<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div id="complianceConfigProfile" class="masterDetails" data-bind="with: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile">
    <section id="complianceProfileMaster" class="master">
        <section id="error_complianceprofilemaster" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
        <header class="page-heading">
            <h1>
                <fmt:message key="complianceconfigprofile.title" />
            </h1>
        </header>
        <nav class="action-buttons">
            <ul class="inlineList taskbar">
                <li>
                    <button id="createComplianceProfile" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/complianceConfiguration.details'">
                        <i class="cux-icon cux-icon-file-text"></i><span>
                            <fmt:message key="generic.create" />
                        </span>
                    </button>
                </li>
                <li>
                    <button id="editComplianceProfile" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: complianceProfileTable().checkedRows().length !== 1" type="button">
                        <i class="cux-icon cux-icon-edit"></i><span>
                            <fmt:message key="genericTerms.edit" />
                        </span>
                    </button>
                </li>
                <li>
                    <button id="deleteComplianceProfile" class="cui-button cux-button cux-button-primary disabled cux-button-medium " data-bind="styledDisabled: complianceProfileTable().selectedItemCount() === 0" type="button">
                        <i class="cux-icon cux-icon-trash"></i><span>
                            <fmt:message key="generic.delete" />
                        </span>
                    </button>
                </li>
                <li>
                    <button id="refreshComplianceProfile" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                        <i class="cux-icon cux-icon-repeat"></i><span>
                            <fmt:message key="generic.refresh" />
                        </span>
                    </button>
                </li>
            </ul>
        </nav>
        <form id="credentialProfileForm">
            <fieldset>
                <legend class="visuallyhidden">
                    <fmt:message key="complianceconfigprofile.title" />
                </legend>
                <div class="master-table-wrapper">
                    <!-- ko with: complianceProfileTable -->
                    <table id="complianceProfileTable" class="dataTable">
                        <thead>
                            <tr>
                                <th scope="col" class="checkboxColumn">
                                    <input type="checkbox" id="compProfSelectAll" />
                                    <label for="compProfSelectAll" class="visuallyhidden">
                                        <fmt:message key="complianceconfigprofile.selectAllCompProfiles" />
                                    </label>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="generic.name" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="complianceconfigprofile.description" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="complianceconfigprofile.scheduledate" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="complianceconfigprofile.recurrence" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="complianceconfigprofile.devicetype" />
                                    </strong>
                                </th>
                            </tr>
                        </thead>
                        <!-- ko if: loading() -->
                        <tbody>
                            <tr>
                                <td colspan="5">
                                    <fmt:message key="scrollabletable.loading" />
                                    <span>&nbsp;</span>
                                    <span class="icon spinner"></span>
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && (!data || data().length == 0) -->
                        <tbody>
                            <tr>
                                <td colspan="5">
                                    <fmt:message key="scrollabletable.empty" />
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && data && data().length > 0 -->
                        <tbody data-bind="foreach: data">
                            <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.ComplianceConfigProfile.selectedComplianceProfile() === $data }">

                                <td class="checkboxColumn">
                                    <input type="checkbox" data-bind="checked: checked, indexedid: 'complianceProfile_'" />
                                    <label class="visuallyhidden" data-bind="indexedfor: 'complianceProfile_'">Select Compliance Profile</label>
                                </td>

                                <td data-bind="text: name"></td>

                                <td data-bind="text: description"></td>
                                
                                <td data-bind="text: scheduleDate"></td>

                                <td data-bind="text: recurrencePeriod"></td>

                                <td data-bind="text: deviceType"></td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                    </table>
                    <!-- /ko -->
                </div>
            </fieldset>
        </form>
    </section>

    <section id="complianceProfileDetails" class="details" data-bind="visible: selectedComplianceProfile() !== undefined">
        <header>
            <h1>
                <fmt:message key="generic.details" />
            </h1>
        </header>
        <ul class="labelValuePairs" data-bind="if: selectedComplianceProfile() !== undefined">
            <li>
                <label for="selectedCompProfName">
                    <u>
                        <fmt:message key="generic.name" />
                    </u>
                </label>
                <span id="selectedCompProfName" class="value" data-bind="text: selectedComplianceProfile().name"></span>
            </li>

            <li>
                <label for="selectedCompProfDescription">
                    <u>
                        <fmt:message key="generic.description" />
                    </u>
                </label>
                <span id="selectedCompProfDescription" class="value" data-bind="text: selectedComplianceProfile().description"></span>
            </li>

            <li>
                <label for="selectedCompProfDeviceType">
                    <u>
                        <fmt:message key="complianceconfigprofile.devicetype" />
                    </u>
                </label>
                <span id="selectedCompProfDeviceType" class="value" data-bind="text: selectedComplianceProfile().deviceType"></span>
            </li>

            <li>
                <label for="selectedCompProfileScheduleDate">
                    <u>
                        <fmt:message key="complianceconfigprofile.scheduledate" />
                    </u>
                </label>
                <span id="selectedCompProfileScheduleDate" class="value" data-bind="text: selectedComplianceProfile().scheduleDate"></span>
            </li>

            <li>
                <label for="selectedCompProfileScheduleRecurrence">
                    <u>
                        <fmt:message key="complianceconfigprofile.recurrence" />
                    </u>
                </label>
                <span id="selectedCompProfileScheduleRecurrence" class="value" data-bind="text: selectedComplianceProfile().recurrencePeriod"></span>
            </li>

            <li>
                <label for="selectedDateCreated">
                    <u>
                        <fmt:message key="complianceconfigprofile.created" />
                    </u>
                </label>
                <span id="selectedDateCreated" class="value" data-bind="time: selectedComplianceProfile().dateCreated, timeFormat: 'LLL'"></span>
            </li>

            <li>
                <label for="selectedDateModified">
                    <u>
                        <fmt:message key="complianceconfigprofile.modified" />
                    </u>
                </label>
                <span id="selectedDateModified" class="value" data-bind="time: selectedComplianceProfile().dateModified, timeFormat: 'LLL'"></span>
            </li>
        </ul>
    </section>

</div>

