<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_assignAndDeploy" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignAndDeploy">
    <section id="error_assignAndDeploy" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="configanddeploy.assignanddeploy.help" />
    </p>
    <form id="assignAndDeployForm" autocomplete="off">
        			
        <fieldset>
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.assignanddeploy.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                <span class="label">
                    <u>
                        <fmt:message key="configanddeploy.assignanddeploy.label.template" />
                    </u>
                </span>
                <span class="value">
                  <label for="template" class="visuallyhidden">
                    <u>
                      <fmt:message key="configanddeploy.assignanddeploy.label.template" />
                    </u>
                  </label>
                  <select id="template" data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignAndDeploy.selectedLifeCycleTemplate, 
                        options: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignAndDeploy.lifeCycleTemplates,  
                        optionsValue: 'id', 
                        optionsText: 'name',
                        attr:{required: true},
                        optionsCaption : '<fmt:message key="configanddeploy.assignanddeploy.label.selecttemplate" />'"></select>
                </span>
              </li>
            </ul>
        </fieldset>

        <div>
            <h2><fmt:message key="configanddeploy.assignanddeploy.selectedservers" /> (<span data-bind="text: selectedServersCount"></span>)</h2>
            <button style="float: right;" class="cux-button cux-button-medium cux-button-primary" type="button" data-bind="disable: (!DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignAndDeploy.selectedLifeCycleTemplate()), event: { click: exportPoolAttributes }"><fmt:message key="configanddeploy.assignanddeploy.exportpollattributes" /></button>
                
        </div>

        <fieldset id="serversTable">
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.assignanddeploy.title" />
            </legend>

            <table id="selectedServersTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assignanddeploy.serveridentifier" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assignanddeploy.ipaddress" />
                            </strong>
                        </th>
                    </tr>
                </thead>
                <tbody data-bind="foreach: selectedServersTable">
                    <tr>
                        <td>
                            <span data-bind="text: rowdata.serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="html: rowdata.iDracIp"></span>
                        </td>
                            
                    </tr>
                </tbody>
            </table>
        </fieldset>

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <label for="attributeValuePool">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.attributevaluepool" />
                        </u>
                    </label>
                    <div class="value">
                        <input id="attributeValuePool" type="text" readonly="true" placeholder="Choose File" data-bind="value: selectedFile">
                        <input type="file" id="selectedFile" data-bind="visible: false, event: { change: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignAndDeploy.processFile }" accept=".csv"/>
                        <button type="button" id="browseFiles">Browse...</button>
                    </div>
                </li>
            </ul>
        </fieldset>

        <fieldset>
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: jobName, event: { change: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignAndDeploy.trimJobNameText }" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="configanddeploy.assignanddeploy.jobnamehint" />' />
                </li>
                <li>
                    <label for="jobDescription">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.jobdescription" />
                        </u>
                    </label>
                    <textarea id="jobDescription" name="jobDescription" class="value" maxlength="255" data-bind="value: jobDescription" title='<fmt:message key="configanddeploy.assignanddeploy.jobdescriptionhint" />'></textarea>
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="btn-assign" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="configanddeploy.assignanddeploy.action.assign" />
            </button>
            <button id="btn-assignAndDeploy" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="configanddeploy.assignanddeploy.action.assignanddeploy" />
            </button>
			<button id="btn-cancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="configanddeploy.assignanddeploy.action.cancel" />
            </button>
        </div>
    </form>
</section>
