<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_assignComplianceProfile" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignComplianceProfile">
    <section id="error_assignComplianceProfile" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="configanddeploy.assigncomplianceprofile.help" />
    </p>
    <form id="assignComplianceProfileForm" autocomplete="off">
        			
        <fieldset>
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.assigncomplianceprofile.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                <span class="label">
                    <u>
                        <fmt:message key="configanddeploy.assigncomplianceprofile.label.template" />
                    </u>
                </span>
                <span class="value">
                  <label for="template" class="visuallyhidden">
                    <u>
                      <fmt:message key="configanddeploy.assigncomplianceprofile.label.template" />
                    </u>
                  </label>
                  <select id="template" data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignComplianceProfile.selectedComplianceProfile, 
                        options: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignComplianceProfile.complianceProfiles,  
                        optionsValue: 'id', 
                        optionsText: 'name',
                        attr:{required: true},
                        optionsCaption : '<fmt:message key="configanddeploy.assigncomplianceprofile.label.selectprofile" />'"></select>
                </span>
              </li>
            </ul>
        </fieldset>

        <div>
            <h2><fmt:message key="configanddeploy.assigncomplianceprofile.selectedservers" /> (<span data-bind="text: selectedServersCount"></span>)</h2>
        </div>

        <fieldset id="serversTable">
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.assigncomplianceprofile.title" />
            </legend>

            <table id="selectedServersTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assigncomplianceprofile.serveridentifier" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assigncomplianceprofile.ipaddress" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assigncomplianceprofile.profilename" />
                            </strong>
                        </th>
                    </tr>
                </thead>
                <tbody data-bind="foreach: selectedServersTable">
                    <tr>
                        <td>
                            <span data-bind="text: rowdata.serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="html: rowdata.iDracIp"></span>
                        </td>
                        <td>
                            <span data-bind="text: rowdata.assignedComplianceProfile"></span>
                        </td>    
                    </tr>
                </tbody>
            </table>
        </fieldset>

        <fieldset>
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <ul class="labelValuePairs" data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignComplianceProfile.selectedComplianceProfile() === '0'">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="configanddeploy.assigncomplianceprofile.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: jobName, event: { change: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.AssignComplianceProfile.trimJobNameText }" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="configanddeploy.assigncomplianceprofile.jobnamehint" />' />
                </li>
                <li>
                    <label for="jobDescription">
                        <u>
                            <fmt:message key="configanddeploy.assigncomplianceprofile.jobdescription" />
                        </u>
                    </label>
                    <textarea id="jobDescription" name="jobDescription" class="value" maxlength="255" data-bind="value: jobDescription" title='<fmt:message key="configanddeploy.assigncomplianceprofile.jobdescriptionhint" />'></textarea>
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="configanddeploy.assigncomplianceprofile.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="btn-assign" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="configanddeploy.assigncomplianceprofile.action.assign" />
            </button>
			<button id="btn-cancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="configanddeploy.assigncomplianceprofile.action.cancel" />
            </button>
        </div>
    </form>
</section>
