<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_configanddeploy_chassissubview" style="float: left; min-width:100%;" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisSubView">
    <section id="error_configanddeploy_chassissubview" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <header class="page-heading">
        <h1>
            <fmt:message key="configanddeploy.chassissubview.title" />
        </h1>
    </header>
    <form>
        <p>
            <fmt:message key="configanddeploy.chassissubview.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configanddeploy.chassissubview.title" />
            </legend>

            <nav id="tabMenu" class="menu tabs" role="navigation">
                <ul>
                    <li id="servers">
                        <a id="sleds">
                            <fmt:message key="configanddeploy.chassissubview.sleds" />
                        </a>
                    </li>
                    <li id="ioms">
                        <a id="switches">
                            <fmt:message key="configanddeploy.chassissubview.switches" />
                        </a>
                    </li>
                    <li id="storagedevices">
                        <a id="storage">
                            <fmt:message key="configanddeploy.chassissubview.storage" />
                        </a>
                    </li>
                </ul>
            </nav>

            <section class="tabPanel" data-bind="visible: activeTab() == 'sleds'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="discovery.home.title" />
                    </h1>
                </header>

                <!-- ko with: chassieServerTable -->
                <table id="chassieServerTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRowsServers" type="checkbox" />
                                <label for="cbSelectionAllRowsServers" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.idracip" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.servicetag" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.model" />
                                </strong>
                            </th>
                            <!-- <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.linktoserver" />
                                </strong>
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.clustername" />
                                </strong>
                            </th>
                            
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <!-- <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </td> -->
                            <td>
                                <a data-bind="href: 'https://' + ipAddress, text: ipAddress" target="_blank"></a>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: model"></span>
                            </td>
                            <!-- <td>
                                <a data-bind="href: linktoserver">Link to Server</a>
                            </td> -->
                            <td>
                                <span data-bind="text: clusterName"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <tfoot>
                        <tr>
                            <td colspan="6">
                                <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- /ko -->
            </section>

            <section class="tabPanel" data-bind="visible: activeTab() == 'switches'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="discovery.home.title" />
                    </h1>
                </header>

                <!-- <nav class="action-buttons">
                    <ul class="inlineList configanddeploy-actions">
                        <li>
                            <button id="vlanAssignment" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-search"></i>
                                <span>
                                    <fmt:message key="configanddeploy.chassissubview.vlanassignment" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="captureconfiguration" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-paste"></i>
                                <span>
                                    <fmt:message key="configanddeploy.chassissubview.captureconfiguration" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="deployiomodule" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-rocket"></i>
                                <span>
                                    <fmt:message key="configanddeploy.chassissubview.deployiomodule" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="refreshinventory" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-repeat"></i>
                                <span>
                                    <fmt:message key="configanddeploy.chassissubview.refreshinventory" />
                                </span>
                            </button>
                        </li>
                    </ul>
                </nav> -->

                <!-- ko with: chassieSwitchesTable -->
                <table id="chassieSwitchesTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRowsSwitches" type="checkbox" />
                                <label for="cbSelectionAllRowsSwitches" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </th> -->

                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisswitches.ipaddress" />
                                </strong>
                            </th>

                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisswitches.servicetag" />
                                </strong>
                            </th>

                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisswitches.iomtype" />
                                </strong>
                            </th>

                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisswitches.model" />
                                </strong>
                            </th>

                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisswitches.firmware" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisswitches.slot" />
                                </strong>
                            </th>
                            
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <!-- <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </td> -->
                            <td>
                                <!-- ko if: ipAddress && ipAddress != 'Not Applicable' -->
                                <a data-bind="href: managementUrl, text: ipAddress" target="_blank"></a>
                                <!-- /ko -->

                                <!-- ko if: ipAddress && ipAddress == 'Not Applicable' -->
                                <span data-bind="text: ipAddress"></span>
                                <!-- /ko -->
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: iomType"></span>
                            </td>
                            <td>
                                <span data-bind="text: model"></span>
                            </td>
                            <td>
                                <span data-bind="html: firmware"></span>
                            </td>
                            <td>
                                <span data-bind="text: slot"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    
                </table>
                <!-- /ko -->
            </section>

            <section class="tabPanel" data-bind="visible: activeTab() == 'storage'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="discovery.home.title" />
                    </h1>
                </header>

                <!-- ko with: chassieStorageTable -->
                <table id="chassieStorageTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRowsStorage" type="checkbox" />
                                <label for="cbSelectionAllRowsStorage" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.servicetag" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.model" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.capacity" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.slot" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassissubview.disks" />
                                </strong>
                            </th>
                            
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <!-- <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </td> -->
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: model"></span>
                            </td>
                            <td>
                                <span data-bind="text: capacity"></span>
                            </td>
                            <td>
                                <span data-bind="text: slot"></span>
                            </td>
                            <td>
                                <span data-bind="text: disks"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    
                </table>
                <!-- /ko -->
            </section>
        </fieldset>
    </form>
</section>
