<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_chassisview_home" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView">
    <section id="error_chassisview_home" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <header class="page-heading">
        <h1>
            <fmt:message key="configanddeploy.chassisview.home" />
        </h1>
    </header>
    <form>

        <!--ko if: DellClarity.Config.consoleType != 'scom' -->
        <p>
            <fmt:message key="configanddeploy.chassisview.help" />
        </p>
        <!-- /ko -->

        <!--ko if: DellClarity.Config.consoleType == 'scom' -->
        <p>
            <fmt:message key="configanddeploy.chassisview.help.scom" />
        </p>
        <!-- /ko -->

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configanddeploy.chassisview.home" />
            </legend>

                <nav class="action-buttons">
                    <ul class="inlineList configanddeploy-actions">
                        <li>
                            <button id="linkDiscoverForm" data-bind="styledDisabled: disableLink()" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/discovery.discover'">
                                <i class="cux-icon cux-icon-search"></i>
                                <span>
                                    <fmt:message key="configanddeploy.chassisview.discover" />
                                </span>
                            </button>
                        </li>

                        <li>
                            <button id="deleteChassis" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: chassisTable().checkedRows().length === 0" type="button">
                                <i class="cux-icon cux-icon-trash"></i><span>
                                    <fmt:message key="generic.delete" />
                                </span>
                            </button>
                        </li>

                        <li>
                            <button id="refreshChassisView" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="generic.refresh" />
                                </span>
                            </button>
                        </li>

                        <!--ko if: DellClarity.Config.consoleType == 'scom' -->
                        <li>
                            <button id="syncChassis" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onmouseover='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.enableDetails("sync")' onmouseout='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.disableDetails()'>
                                <i class="cux-icon cux-icon-refresh"></i>
                                <span data-bind="visible: detailsEnabled() != 'sync'">
                                    <fmt:message key="configanddeploy.chassisview.sync" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'sync'">
                                    <fmt:message key="configanddeploy.chassisview.syncwith" />
                                </span>
                            </button>
                        </li>

                        <li>
                            <button id="resolveSyncErrors" onmouseover='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.enableDetails("resolvesyncerrors")' onmouseout='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.disableDetails()' data-bind="styledDisabled: disableLink()" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-check"></i>
                                <span data-bind="visible: detailsEnabled() != 'resolvesyncerrors'">
                                    <fmt:message key="configanddeploy.chassisview.resolvesync" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'resolvesyncerrors'">
                                    <fmt:message key="configanddeploy.chassisview.resolvesyncerrors" />
                                </span>
                            </button>
                        </li>
                        <!-- /ko -->

                        <!--ko if: DellClarity.Config.consoleType != 'scom' -->
                        <li>
                            <button id="assignChassis" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: chassisTable().checkedRows().length === 0" onmouseover='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.enableDetails("assignchassis")' onmouseout='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.disableDetails()'>
                                <i class="cux-icon cux-icon-paste"></i>
                                <span data-bind="visible: detailsEnabled() != 'assignchassis'">
                                    <fmt:message key="configanddeploy.chassisview.assign" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'assignchassis'">
                                    <fmt:message key="configanddeploy.chassisview.assignchassis" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="deployChassis" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: chassisTable().checkedRows().length === 0" onmouseover='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.enableDetails("deploychassis")' onmouseout='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.disableDetails()'>
                                <i class="cux-icon cux-icon-rocket"></i>
                                <span data-bind="visible: detailsEnabled() != 'deploychassis'">
                                    <fmt:message key="configanddeploy.chassisview.deploy" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'deploychassis'">
                                    <fmt:message key="configanddeploy.chassisview.deploychassis" />
                                </span>
                            </button>
                        </li>
                        <!-- /ko -->
                    </ul>
                </nav>
            
            <section>
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="configanddeploy.chassisview.home" />
                    </h1>
                </header>
              <!-- ko with: chassisTable -->
                <table id="chassisTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRows" type="checkbox" />
                                <label for="cbSelectionAllRows" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </th>
                            <!--ko if: DellClarity.Config.consoleType == 'scom' -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.healthstatus" />
                                </strong>
                            </th>
                            <!-- /ko -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.chassisip" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.servicetag" />
                                </strong>
                            </th>
                            <th scope="col" data-bind="visible: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.selectedChassisType() == ''">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.chassistype" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.firmwareversion" />
                                </strong>
                            </th>
                            <!--ko if: DellClarity.Config.consoleType != 'scom' -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.assignedot" />
                                </strong>
                            </th>
                            <!-- /ko -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.computesleds" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.ioms" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.storagesleds" />
                                </strong>
                            </th>
                            <!--ko if: DellClarity.Config.consoleType == 'scom' -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.chassisview.alertrelayserver" />
                                </strong>
                            </th>
                            <!-- /ko -->
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td>
                            <!--ko if: DellClarity.Config.consoleType == 'scom' -->                        
                            <td style="text-align: center">
                                <span data-bind="html: healthStatus"></span>
                            </td>
                            <!-- /ko -->
                            <td>
                                <a data-bind="href: chassisIpLink, text: chassisIp" target="_blank"></a>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td data-bind="visible: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ChassisView.selectedChassisType() == ''">
                                <span data-bind="text: chassisModel"></span>
                            </td>
                            <td>
                                <span data-bind="text: firmwareVersion"></span>
                            </td>
                            <!--ko if: DellClarity.Config.consoleType != 'scom' -->
                            <td>
                                <span data-bind="html: assignedOTLink"></span>
                            </td>  
                            <!-- /ko -->
                            <td>
                                <span data-bind="text: computeSleds"></span>
                            </td>
                            <td>
                                <span data-bind="text: ioms"></span>
                            </td>
                            <td>
                                <span data-bind="text: storageSleds"></span>
                            </td>
                            <!--ko if: DellClarity.Config.consoleType == 'scom' -->
                            <td>
                                <span data-bind="text: alertRelayServer"></span>
                            </td>  
                            <!-- /ko -->
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <tfoot>
                        <tr>
                            <td colspan="10">
                                <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- /ko -->

            </section>

        </fieldset>
    </form>
</section>
