<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_configanddeploy_clustersubview" style="float: left; min-width:100%;" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ClusterSubView">
    <section id="error_configanddeploy_clustersubview" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <header class="page-heading">
        <h1>
            <!-- ko if: !selectedClusterName() && (!selectedClusterName || selectedClusterName().length == 0) -->
                <fmt:message key="configanddeploy.clustersubview.title" />
            <!-- /ko -->

            <!-- ko if: selectedClusterName() && (selectedClusterName || selectedClusterName().length > 0) -->
                <span data-bind="text: selectedClusterName"></span>
            <!-- /ko -->
        </h1>
    </header>
    <form>
        <p>
            <fmt:message key="configanddeploy.clustersubview.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configanddeploy.clustersubview.title" />
            </legend>

            <section>
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="discovery.home.title" />
                    </h1>
                </header>

                <!-- ko with: clusterServerTable -->
                <table id="clusterServerTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRowsServers" type="checkbox" />
                                <label for="cbSelectionAllRowsServers" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="configanddeploy.clustersubview.compliancechoices" />
                                    </u>
                                </label>
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clustersubview.hostname" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clustersubview.idracip" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clustersubview.servicetag" />
                                </strong>
                            </th>
                            <!-- <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clustersubview.workload" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clustersubview.virtualmachines" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clustersubview.osversion" />
                                </strong>
                            </th> -->
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <!-- <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="configanddeploy.clustersubview.compliancechoices" />
                                    </u>
                                </label>
                            </td> -->
                            <td>
                                <span data-bind="text: hostName"></span>
                            </td>
                            <td>
                                <a data-bind="href: iDracIpLink, text: ipAddress" target="_blank"></a>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <!-- <td>
                                <span data-bind="text: workload"></span>
                            </td>
                            <td>
                                <span data-bind="text: virtualmachines"></span>
                            </td>
                            <td>
                                <span data-bind="text: osVersion"></span>
                            </td> -->
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    
                </table>
                <!-- /ko -->
            </section>
        </fieldset>
    </form>
</section>
