<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_clusterview_home" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ClusterView">
    <section id="error_clusterview_home" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <header class="page-heading">
        <h1>
            <!-- ko if: !selectedClusterModal() && (!selectedClusterModal || selectedClusterModal().length == 0) -->
                <fmt:message key="configanddeploy.clusterview.home" />
            <!-- /ko -->

            <!-- ko if: selectedClusterModal() && (selectedClusterModal || selectedClusterModal().length > 0) -->
                <span data-bind="text: selectedClusterModal"></span>
            <!-- /ko -->
        </h1>
    </header>
    <form>
        <!--ko if: DellClarity.Config.scvmmversion >= 4000000 -->
        <p>
            <fmt:message key="configanddeploy.clusterview.help" />
        </p>
        <!-- /ko -->

        <!--ko if: DellClarity.Config.scvmmversion < 4000000 -->
        <p>
            <fmt:message key="configanddeploy.clusterview.pagehelp" />
        </p>
        <!-- /ko -->

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configanddeploy.clusterview.home" />
            </legend>

                <nav class="action-buttons">
                    <ul class="inlineList configanddeploy-actions">

                        <!--ko if: DellClarity.Config.scvmmversion >= 4000000 -->
                        <li>
                            <button id="createCluster" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/configanddeploy.createcluster'">
                                <i class="cux-icon cux-icon-file-text"></i><span>
                                    <fmt:message key="generic.create" />
                                </span>
                            </button>
                        </li>

                        <li>
                            <button id="configureNetwork" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/configanddeploy.configurenetwork'">
                                <i class="cux-icon cux-icon-file-alt"></i><span>
                                    <fmt:message key="configanddeploy.clusterview.configurenetwork" />
                                </span>
                            </button>
                        </li>
                        <!-- /ko -->

                        <li>
                            <button id="refreshClusterView" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="generic.refresh" />
                                </span>
                            </button>
                        </li>
                    </ul>
                </nav>
            
            <section>
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="configanddeploy.clusterview.home" />
                    </h1>
                </header>
              <!-- ko with: clusterTable -->
                <table id="clusterTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- <th scope="col" class="checkboxColumn" data-bind="visible: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ClusterView.selectedClusterType() != ''">
                                <input id="cbSelectionAllRows" type="checkbox" />
                                <label for="cbSelectionAllRows" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="configanddeploy.clusterview.compliancecluster" />
                                    </u>
                                </label>
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clusterview.clusterfqdn" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configanddeploy.clusterview.computesleds" />
                                </strong>
                            </th>
                            <th scope="col" data-bind="visible: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ClusterView.selectedClusterType() == ''">
                                <strong>
                                    <fmt:message key="configanddeploy.clusterview.clustertype" />
                                </strong>
                            </th>
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <!-- <td class="checkboxColumn" data-bind="visible: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ClusterView.selectedClusterType() != ''">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td> -->

                            <td>
                                <span data-bind="text: groupName"></span>
                            </td>
                            <td>
                                <span data-bind="text: numOfNodes"></span>
                            </td>
                            <td data-bind="visible: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ClusterView.selectedClusterType() == ''">
                                <span data-bind="text: clusterTypeDisplayName"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <tfoot>
                        <tr>
                            <td colspan="10">
                                <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- /ko -->

            </section>

        </fieldset>
    </form>
</section>
