<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_configurenetwork_template" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork">
    <section id="error_configurenetwork" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <form id="configureNetworkForm" autocomplete="off">
    <p> <fmt:message key="configanddeploy.configurenetwork.help" /> </p>

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configanddeploy.configurenetwork.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="logicalSwitchName">
                        <u>
                            <fmt:message key="configanddeploy.configurenetwork.logicalswitchname" />
                        </u>
                    </label>
                    <input id="logicalSwitchName" name="logicalSwitchName" required data-bind="value: name"  type="text" maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="configanddeploy.configurenetwork.logicalswitchname.title" />' value=""  class="value" placeholder='<fmt:message key="configanddeploy.configurenetwork.logicalswitchname.hint"/>'>
                </li>
                <li>
                <span class="label">
                    <u>
                        <fmt:message key="configanddeploy.configurenetwork.hostGroup" />
                    </u>
                </span>
                <span class="value">
                  <label for="hostGroup" class="visuallyhidden">
                    <u>
                      <fmt:message key="configanddeploy.configurenetwork.hostgroup" />
                    </u>
                  </label>
                    <select id="hostGroup" required data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork.hostGroup,
                                options: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork.hostGroups, 
                                optionsCaption: '<fmt:message key="configanddeploy.configurenetwork.selecthostgroup" />'">
                    </select>
                </span>
              </li>
              <!-- <li>
                <span class="label">
                    <u>
                        <fmt:message key="configanddeploy.configurenetwork.credentialprofiles" />
                    </u>
                </span>
                <span class="value">
                  <label for="credntialProfile" class="visuallyhidden">
                    <u>
                      <fmt:message key="configanddeploy.configurenetwork.credentialprofiles" />
                    </u>
                  </label>
                    <select id="credntialProfile" required data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork.credentialProfile,
                                options: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork.credentialProfiles, 
                                optionsValue: 'id', 
                                optionsText: 'name', 
                                optionsCaption: '<fmt:message key="configanddeploy.configurenetwork.selectcredentialprofile" />'">
                    </select>
                </span>
              </li> -->
            </ul>
          </fieldset>

        
            <div style="width: 100%;">
                <h2 style="color: #16609E;"><fmt:message key="configanddeploy.configurenetwork.settingsmanagement" /></h2>
                <div style="width: 48%; float: left; padding: 0 2em 0 1em;">
                    <ul class="labelValuePairs">
                        <li>
                            <label for="configureNetworkManagementStartIP">
                                <u>
                                    <fmt:message key="configanddeploy.configurenetwork.startip" />
                                </u>
                            </label>
                            <input id="configureNetworkManagementStartIP" name="configureNetworkManagementStartIP" required data-bind="value: managementStartIP, pattern: 'ipv4'" type="text" placeholder="192.168.1.2" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                        </li>
                        <li>
                            <label for="configureNetworkManagementEndIP">
                                <u>
                                    <fmt:message key="configanddeploy.configurenetwork.endip" />
                                </u>
                            </label>
                            <input id="configureNetworkManagementEndIP" name="configureNetworkManagementEndIP" required data-bind="value: managementEndIP, pattern: 'ipv4'" type="text" placeholder="192.168.1.5" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                        </li>
                        <li>
                            <label for="configureNetworkManagementSubnet">
                                <u>
                                    <fmt:message key="configanddeploy.configurenetwork.subnet" />
                                </u>
                            </label>
                            <input id="configureNetworkManagementSubnet" name="configureNetworkManagementSubnet" required data-bind="value: managementSubnet, pattern: 'ipv4cidr'" type="text" placeholder="192.168.1.1/24" title="<fmt:message key="configanddeploy.configurenetwork.subnetErrorMessage"/>" class="value">
                        </li>                
                    </ul>
                </div>
       
                <div style="width: 52%; padding: 0 0 0 2em;">
                    <ul class="labelValuePairs">
                        <li>
                            <label for="configureNetworkDNSServer">
                                <u>
                                    <fmt:message key="configanddeploy.configurenetwork.dnsserver" />
                                </u>
                            </label>
                            <input id="configureNetworkDNSServer" name="configureNetworkDNSServer" required data-bind="value: dnsServer, pattern: 'ipv4'" type="text" placeholder="192.168.0.1" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                        </li>
                        <li>
                            <label for="configureNetworkDNSSuffix">
                                <u>
                                    <fmt:message key="configanddeploy.configurenetwork.dnssuffix" />
                                </u>
                            </label>
                            <input id="configureNetworkDNSSuffix" name="configureNetworkDNSSuffix" required data-bind="value: dnsSuffix" type="text" class="value">
                        </li>
                        <li>
                            <label for="configureNetworkGateway">
                                <u>
                                    <fmt:message key="configanddeploy.configurenetwork.gateway" />
                                </u>
                            </label>
                            <input id="configureNetworkGateway" name="configureNetworkGateway" required data-bind="value: gateway, pattern: 'ipv4'" placeholder="192.168.1.1" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" type="text" class="value">
                        </li>
                    </ul>
                 </div>
             </div>


        <div style="width: 100%;">
            <div style="width: 48%; float: left; padding: 0 2em 0 0;">
                <h2 style="color: #16609E;"><fmt:message key="configanddeploy.configurenetwork.settingssmb1" /></h2>
                <ul class="labelValuePairs" style="padding-left: 1em;">
                    <li>
                        <label for="configureNetworkSMB1Vlan">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.vlan" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB1Vlan" name="configureNetworkSMB1Vlan" required data-bind="value: smb1Vlan" type="number" min="2" max="4094" placeholder="2" class="value">
                    </li>
                    <li>
                        <label for="configureNetworkSMB1StartIP">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.startip" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB1StartIP" name="configureNetworkSMB1StartIP" required data-bind="value: smb1StartIP, pattern: 'ipv4'" type="text" placeholder="192.168.1.6" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                    </li>
                    <li>
                        <label for="configureNetworkSMB1EndIP">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.endip" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB1EndIP" name="configureNetworkSMB1EndIP" required data-bind="value: smb1EndIP, pattern: 'ipv4'" type="text" placeholder="192.168.1.10" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                    </li>  
                    <li>
                        <label for="configureNetworkSMB1Subnet">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.subnet" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB1Subnet" name="configureNetworkSMB1Subnet" required data-bind="value: smb1Subnet, pattern: 'ipv4cidr'" type="text" placeholder="192.168.1.1/24" title="<fmt:message key="configanddeploy.configurenetwork.subnetErrorMessage"/>" class="value">
                    </li>              
                </ul>
            </div>
       
            <div style="width: 52%; padding: 0 2em 0 0; float: right; display: inline;">
                <h2 style="color: #16609E;"><fmt:message key="configanddeploy.configurenetwork.settingssmb2" /></h2>
                <ul class="labelValuePairs" style="padding-left: 1em;">
                    <li>
                        <label for="configureNetworkSMB2Vlan">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.vlan" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB2Vlan" name="configureNetworkSMB2Vlan" required data-bind="value: smb2Vlan" type="number" min="2" max="4094" placeholder="2" class="value">
                    </li>
                    <li>
                        <label for="configureNetworkSMB2StartIP">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.startip" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB2StartIP" name="configureNetworkSMB2StartIP" required data-bind="value: smb2StartIP, pattern: 'ipv4'" type="text" placeholder="192.168.1.11" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                    </li>
                    <li>
                        <label for="configureNetworkSMB2EndIP">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.endip" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB2EndIP" name="configureNetworkSMB2EndIP" required data-bind="value: smb2EndIP, pattern: 'ipv4'" type="text" placeholder="192.168.1.15" title="<fmt:message key="configanddeploy.configurenetwork.ipErrorMessage"/>" class="value">
                    </li>     
                    <li>
                        <label for="configureNetworkSMB2Subnet">
                            <u>
                                <fmt:message key="configanddeploy.configurenetwork.subnet" />
                            </u>
                        </label>
                        <input id="configureNetworkSMB2Subnet" name="configureNetworkSMB2Subnet" required data-bind="value: smb2Subnet, pattern: 'ipv4cidr'" type="text" placeholder="192.168.1.1/24" title="<fmt:message key="configanddeploy.configurenetwork.subnetErrorMessage"/>" class="value">
                    </li>           
                </ul>
            </div>
        </div>

        <fieldset id="jobOptions">
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <p>
                <fmt:message key="scvmm.joboptions.description" />
            </p>

            <ul class="labelValuePairs">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="configanddeploy.configurenetwork.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork.jobName" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="configanddeploy.configurenetwork.jobname.hint" />' />
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.ConfigureNetwork.goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="configanddeploy.configurenetwork.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="configureNetworkFinish" class="cux-button cux-button-large cux-button-primary"  type="submit">
                <fmt:message key="configanddeploy.configurenetwork.finish" />
            </button>
            <button id="configureNetworkCancel" class="cux-button cux-button-large cux-button-danger"  type="button">
                <fmt:message key="configanddeploy.configurenetwork.cancel" />
            </button>
        </div>
    </form>

</section>
