<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_createcluster_template" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster">
    <section id="error_createcluster" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <!-- <header>
        <h1>
            <fmt:message key="createcluster.selectservers" />
        </h1>
    </header> -->

    <form id="createClusterForm" autocomplete="off">
    <p> <fmt:message key="createcluster.help" /> </p>

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="createcluster.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="clusterName">
                        <u>
                            <fmt:message key="createcluster.clustername" />
                        </u>
                    </label>
                    <input id="clusterName" name="clusterName" required data-bind="value: name"  type="text" maxlength="15" pattern="^[0-9a-zA-Z- ]{1,15}$" title='<fmt:message key="createcluster.name.title" />' value=""  class="value" placeholder='<fmt:message key="createcluster.name.hint"/>'>
                </li>
                <li>
                    <label for="ipAddress">
                        <fmt:message key="createcluster.staticipaddress" />
                    </label>
                    <input id="ipAddress" type="text" value="" class="value" placeholder="192.168.1.10" data-bind="value: ipAddress, pattern: 'ipv4'" 
                        title="<fmt:message key="createcluster.IPErrorMessage"/>" required />
                    <i style="display: inline; margin: 0; white-space: nowrap; font-size:23px;" class="cux-icon cux-icon-info-sign status-icon info-status" title="The subnet details for Storage Space &#13;Direct cluster's IP address is selected &#13;from management configuration of the &#13;selected Logical Switch profile."> </i> 
                </li>
                <li>
                <span class="label">
                    <u>
                        <fmt:message key="createcluster.logicalswitch" />
                    </u>
                </span>
                <span class="value">
                  <label for="logicalSwitchCreateCluster" class="visuallyhidden">
                    <u>
                      <fmt:message key="createcluster.logicalswitch" />
                    </u>
                  </label>
                    <select id="logicalSwitchCreateCluster" required data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.logicalSwitch,
                                options: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.logicalSwitches, 
                                optionsValue: 'switchId', 
                                optionsText: 'switchName', 
                                optionsCaption: '<fmt:message key="createcluster.selectlogicalswitch" />'">
                    <option value="">
                      <fmt:message key="createcluster.logicalswitch" />
                    </option>
                </select>
                </span>
              </li>
              <li>
                <span class="label">
                    <u>
                        <fmt:message key="createcluster.applythisoperationaltemplate" />
                    </u>
                </span>
                <span class="value">
                  <label for="operationalTemplateCreateCluster" class="visuallyhidden">
                    <u>
                      <fmt:message key="createcluster.applythisoperationaltemplate" />
                    </u>
                  </label>
                    <select id="operationalTemplateCreateCluster" required data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.operationalTemplate,
                                options: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.operationalTemplates, 
                                optionsValue: 'lctId', 
                                optionsText: 'lctName', 
                                optionsCaption: '<fmt:message key="createcluster.selectoperationaltemplate" />'">
                    <option value="">
                      <fmt:message key="createcluster.operationaltemplate" />
                    </option>
                </select>
                </span>
              </li>
                </ul>
          </fieldset>

        <fieldset>
            <legend data-bind="visible: createClusterTable().length > 0">
                <fmt:message key="createcluster.selectservers" />
            </legend>

            <!-- ko with: createClusterTable -->
            <div>
                <button style="float: right;" class="cux-button cux-button-medium cux-button-primary" type="button" 
                    data-bind="disable: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.selectedServers() && DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.selectedServers().length < 2,
                               event: { click: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.exportPoolAttributes }">
                    <fmt:message key="createcluster.exportpollattributes" /></button>                
            </div>

            <span id="selectServerCheck1_validationMessage" class="validationMessage forTable" style="display: none" />
                <table id="createClusterTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input type="checkbox" id="selectServerCheck1" />
                                <label for="selectServerCheck1" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="createcluster.serveridentifier" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="createcluster.ipaddress" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="createcluster.model" />
                                </strong>
                            </th>
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: ipAddress"></span>
                            </td>
                            <td>
                                <span data-bind="text: model"></span>
                            </td>                            
                        </tr>
                    </tbody>
                    <!-- /ko -->
                </table>
                <!-- /ko -->
            </fieldset>

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="createcluster.title" />
            </legend>
            <ul class="labelValuePairs">
              <li>
                  <label for="attributeValuePool">
                      <u>
                          <fmt:message key="createcluster.attributevaluepool" />
                      </u>
                  </label>
                  <div class="value">
                      <input id="attributeValuePool" type="text" readonly="true" placeholder="Choose File" data-bind="value: selectedFile">
                      <input type="file" id="selectedFile" data-bind="visible: false, event: { change: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.processFile }" accept=".csv"/>
                      <a href="" id="clear">Clear File</a>
                      <button type="button" class="cux-button cux-button-medium cux-button-primary" id="browseFiles">Browse</button>
                  </div>
              </li>
              
            </ul>
          </fieldset>
       
        <fieldset id="jobOptions">
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <p>
                <fmt:message key="scvmm.joboptions.description" />
            </p>

            <ul class="labelValuePairs">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="createcluster.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.jobName" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="createcluster.jobname.hint" />' />
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.CreateCluster.goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="createcluster.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="createClusterFinish" class="cux-button cux-button-large cux-button-primary"  type="submit">
                <fmt:message key="createcluster.finish" />
            </button>
            <button id="createClusterCancel" class="cux-button cux-button-large cux-button-danger"  type="button">
                <fmt:message key="createcluster.cancel" />
            </button>
        </div>
    </form>

</section>
