<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_lctComplianceDetailedReport" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctComplianceDetailReport">
    <section id="error_lctComplianceDetailedReport" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="configanddeploy.lctcompliancedetailedreport.help" />
    </p>

    <form id="lctComplianceDetailedReportForm" autocomplete="off">

        <fieldset>

            <div style="float: right; border: 1px solid lightgray">
                <div>
                    <span data-bind="style: { background: '#FF6666', padding: '0 10px', display: 'inline' }"></span>
                    <span data-bind="style: { display: 'inline', padding: '0 5px' }"><fmt:message key="configanddeploy.lctcompliancedetailedreport.attributenotavailable" /></span>
                </div>

                <div>
                    <span data-bind="style: { background: '#FFFF66', padding: '0 10px', display: 'inline' }"></span>
                    <span data-bind="style: { display: 'inline', padding: '0 5px' }"><fmt:message key="configanddeploy.lctcompliancedetailedreport.attributenotmatched" /></span>
                </div>
            </div>

            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.lctcompliancedetailedreport.title" />
            </legend>

            <!-- ko with: lctComplianceDetailsTable -->
            <table class="compliance-table">
                <tbody>
                    <tr>
                        <td>
                            <div>
                                <div class="components-mismatched">
                                    <!-- ko template: { name: 'components-mismatched-template', foreach: misMatchedComponents } --> <!-- /ko -->
                                </div>

                                <div class="components-missing">
                                    <!-- ko template: { name: 'components-missing-template', foreach: missingComponents } --> <!-- /ko -->
                                </div>
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table> 
            <!-- /ko -->
        </fieldset>
        			
        <div class="sectionEditButtons">
			<button id="btn-cancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="configanddeploy.lctcompliancedetailedreport.action.cancel" />
            </button>
        </div>
    </form>
</section>

<script type="text/html" id="components-missing-template">
    <table class="components-table">
        <tbody>
            <tr>
                <td class="component-icon">
                    <div class="component-container">
                        <img data-bind="attr: { src: iconPath, width: '35', height: '35' }" />
                    </div>

                    <table class="component-title-wrapper">
                        <tbody>
                            <tr>
                                <td><span class="component-title" data-bind="text: componentName"></span></td>
                            </tr>
                        </tbody>
                    </table>
                </td>
                <td><span data-bind="style: { background: '#FF6666', padding: '0 10px' }"></span></td>
            </tr>
        </tbody>
    </table> 
</script>

<script type="text/html" id="components-mismatched-template">

    <table class="components-table">
        <tbody>
            <tr>
                <td class="component-icon">
                    <div class="component-container">
                        <img data-bind="attr: { src: iconPath, width: '35', height: '35' }" />
                    </div>

                    <table class="component-title-wrapper">
                        <tbody>
                            <tr>
                                <td><span class="component-title" data-bind="text: componentName"></span></td>
                            </tr>
                        </tbody>
                    </table>
                </td>
                <td>
                    <table class="attributes-table">
                        <thead>
                            <tr>
                                <th scope="col">
                                    <strong><fmt:message key="configanddeploy.lctcompliancedetailedreport.attributename" /></strong>
                                </th>
                                <th scope="col">
                                    <strong><fmt:message key="configanddeploy.lctcompliancedetailedreport.attributelctvalue" /></strong>
                                </th>
                                <th scope="col">
                                    <strong><fmt:message key="configanddeploy.lctcompliancedetailedreport.attributedevicevalue" /></strong>
                                </th>
                            </tr>
                        </thead>
                        
                        <tbody>
                            <!-- ko template: { name: 'attributes-group-template', foreach: misMatchGroup } --> <!-- /ko -->
                            <!-- ko if: $data.containsSubComponent === true -->
                                <!-- ko template: { name: 'subcomponents-template', foreach: subComponents } --> <!-- /ko -->
                            <!-- /ko -->
                        </tbody>
                    </table>
                </td>
            </tr>
        </tbody>
    </table>                    
    
</script>

<script type="text/html" id="subcomponents-template">
    
    <b><span data-bind="text: componentName"></span></b>

    <!-- ko template: { name: 'subattributes-group-template', foreach: misMatchGroup } --> <!-- /ko -->
    <!-- ko if: $data.containsSubComponent === true -->
        <!-- ko template: { name: 'subcomponents-template', foreach: subComponents } --> <!-- /ko -->
    <!-- /ko -->
</script>

<script type="text/html" id="attributes-group-template">
    <!-- ko if: groupName !== 'NA' -->
        <br/>
        <b><span data-bind="text: groupName"></span></b>
    <!-- /ko -->

    <!-- ko template: { name: 'attributes-missing-template', foreach: missingAttributes } --> <!-- /ko -->
    <!-- ko template: { name: 'attributes-mismatched-template', foreach: misMatchedAttributes } --> <!-- /ko -->
</script>

<script type="text/html" id="subattributes-group-template">
    <!-- ko if: groupName !== 'NA' -->
        <br/>
        <b><span data-bind="style: { padding: '0 15px' }, text: groupName"></span></b>
    <!-- /ko -->

    <!-- ko template: { name: 'subattributes-missing-template', foreach: missingAttributes } --> <!-- /ko -->
    <!-- ko template: { name: 'subattributes-mismatched-template', foreach: misMatchedAttributes } --> <!-- /ko -->
</script>

<script type="text/html" id="attributes-mismatched-template">
    <tr>
        <td data-bind="style: {padding: '0 15px'}, text: attributeName"></td>
        <td data-bind="text: attributeLctValue"></td>
        <td data-bind="text: attributeDeviceValue, style: { background: '#FFFF66' }"></td>
    </tr>
</script>

<script type="text/html" id="attributes-missing-template">
    <tr>
        <td data-bind="style: { padding: '0 15px' }, text: attributeName"></td>
        <td data-bind="text: attributeValue"></td>
        <td><span data-bind="style: { background: '#FF6666', padding: '0 10px' }"></span></td>
    </tr>
</script>

<script type="text/html" id="subattributes-mismatched-template">
    <tr>
        <td data-bind="style: { padding: '0 25px' }, text: attributeName"></td>
        <td data-bind="text: attributeLctValue"></td>
        <td data-bind="text: attributeDeviceValue, style: { background: '#FFFF66' }"></td>
    </tr>
</script>

<script type="text/html" id="subattributes-missing-template">
    <tr>
        <td data-bind="style: { padding: '0 25px' }, text: attributeName"></td>
        <td data-bind="text: attributeValue"></td>
        <td><span data-bind="style: { background: '#FF6666', padding: '0 10px' }"></span></td>
    </tr>
</script>
