<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_lctComplianceSummary" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctComplianceSummary">
    <section id="error_lctComplianceSummary" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="configanddeploy.lctcompliancesummary.help" />
    </p>
    <form id="lctComplianceSummaryForm" autocomplete="off">
        			
        <fieldset>
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.lctcompliancesummary.title" />
            </legend>

            <!-- ko with: lctComplianceSummaryTable -->
            <table id="lctComplianceSummaryTable" class="lctsummary-table">
                <thead>
                    <tr>
                        <th scope="col" style="width:25%;">
                            <strong>
                                <fmt:message key="configanddeploy.lctcompliancesummary.serveridentifier" />
                            </strong>
                        </th>
                        <th scope="col" style="width:25%;">
                            <strong>
                                <fmt:message key="configanddeploy.lctcompliancesummary.compliancestatus" />
                            </strong>
                        </th>
                        <th scope="col" style="width:50%;">
                            <strong>
                                <fmt:message key="configanddeploy.lctcompliancesummary.differences" />
                            </strong>
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr>
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="text: complianceStatus"></span>
                        </td>
                        <td>
                            <ul class="labelValuePairs">
                                <li>
                                    <label for="componentsNonCompliant"><u>
                                        <fmt:message key="configanddeploy.lctcompliancesummary.componentsnoncompliant" />
                                    </u></label>
                                    <span id="componentsNonCompliant" class="value" data-bind="text: componentsNonCompliant"></span>
                                </li>
                                <li>
                                    <label for="componentsInLctNotInDevice"><u>
                                        <fmt:message key="configanddeploy.lctcompliancesummary.componentsinlctnotindevice" />
                                    </u></label>
                                    <span id="componentsInLctNotInDevice" class="value" data-bind="text: componentsInLctNotInDevice"></span>
                                </li>
                                <!-- <li>
                                    <label for="componentsInDeviceNotInLct"><u>
                                        <fmt:message key="configanddeploy.lctcompliancesummary.componentsindevicenotinlct" />
                                    </u></label>
                                    <span id="componentsInDeviceNotInLct" class="value" data-bind="text: componentsInDeviceNotInLct"></span>
                                </li> -->
                                <li>
                                    <label for="attributesNotCompliant"><u>
                                        <fmt:message key="configanddeploy.lctcompliancesummary.attributesNotCompliant" />
                                    </u></label>
                                    <span id="attributesNotCompliant" class="value" data-bind="text: attributesNotCompliant"></span>
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
            </table>
            <!-- /ko -->
        </fieldset>

        <div class="sectionEditButtons">
            <button id="btn-assign" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="configanddeploy.lctcompliancesummary.action.detailreport" />
            </button>
			<button id="btn-cancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="configanddeploy.lctcompliancesummary.action.cancel" />
            </button>
        </div>
    </form>
</section>
