<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_lctDeploy" data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctDeploy">
    <section id="error_lctDeploy" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="configanddeploy.deploy.help" />
    </p>

  
    <span>NOTE:</span>
    <ul style="padding: 0.5em 0 1em 1.5em; list-style-type: square !important;">
        <li>
            <fmt:message key="configanddeploy.assignanddeploy.note" />
        </li>

        <li data-bind="visible: DellClarity.SCVMM.fromPage === 'serverview'">
            <fmt:message key="configanddeploy.deploy.help.note" />
        </li>
    </ul>

    <form id="assignAndDeployForm" autocomplete="off">
        <fieldset id="Fieldset1" style="padding-top: 1em">
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.assignanddeploy.title" />
            </legend>
       
            <ul class="labelValuePairs">
                <li>
                    <label for="template"><u>
                        <fmt:message key="configanddeploy.assignanddeploy.label.template" />
                    </u></label>
                    <span id="template" class="value" data-bind="text: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctDeploy.selectedLifeCycleTemplate()"></span>
                </li>
            </ul>
        </fieldset>

        <fieldset id="serversTable">
            <legend class="visuallyhidden">
               <fmt:message key="configanddeploy.assignanddeploy.title" />
            </legend>
            
            <div>
                <h2 style="margin: 1em 0 !important"><fmt:message key="configanddeploy.assignanddeploy.selectedservers" /> (<span data-bind="text: selectedServersCount"></span>)</h2>
                <button style="float: right;" class="cux-button cux-button-medium cux-button-primary" type="button" data-bind="disable: (!DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctDeploy.selectedLifeCycleTemplate()), event: { click: exportPoolAttributes }"><fmt:message key="configanddeploy.assignanddeploy.exportpollattributes" /></button>                
            </div>

            <table id="selectedServersTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assignanddeploy.serveridentifier" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configanddeploy.assignanddeploy.ipaddress" />
                            </strong>
                        </th>
                    </tr>
                </thead>
                <!--ko if: deviceTypeFlag() === 'serverview' -->
                <tbody data-bind="foreach: selectedServersTable">
                    <tr>
                        <td>
                            <span data-bind="text: rowdata.serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="html: rowdata.iDracIp"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->

                <!--ko if: deviceTypeFlag() === 'chassisview' -->
                <tbody data-bind="foreach: selectedServersTable">
                    <tr>
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="html: iDracIp"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
        </fieldset>

        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <label for="attributeValuePool">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.attributevaluepool" />
                        </u>
                    </label>
                    <div class="value">
                        <input id="attributeValuePool" type="text" readonly="true" placeholder="Choose File" data-bind="value: selectedFile">
                        <input type="file" id="selectedFile" data-bind="visible: false, event: { change: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctDeploy.processFile }" accept=".csv"/>
                        <a href="" id="clear">Clear File</a>
                        <button type="button" class="cux-button cux-button-medium cux-button-primary" id="browseFiles">Browse</button>
                    </div>
                </li>
            </ul>
        </fieldset>

        <fieldset>
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: jobName, event: { change: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.LctDeploy.trimJobNameText }" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="configanddeploy.assignanddeploy.jobnamehint" />' />
                </li>
                <li>
                    <label for="jobDescription">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.jobdescription" />
                        </u>
                    </label>
                    <textarea id="jobDescription" name="jobDescription" class="value" maxlength="255" data-bind="value: jobDescription" title='<fmt:message key="configanddeploy.assignanddeploy.jobdescriptionhint" />'></textarea>
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="configanddeploy.assignanddeploy.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="btn-deploy" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="configanddeploy.assignanddeploy.action.deploy" />
            </button>
			<button id="btn-cancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="configanddeploy.assignanddeploy.action.cancel" />
            </button>
        </div>
    </form>
</section>
