<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_configanddeploy_networkswitchview"  data-bind="with: DellClarity.SCVMM.ViewModel.ConfigAndDeploy.NetworkSwitchView">
    <section id="error_configanddeploy_networkswitchview" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    <header class="page-heading">
        <h1>
            <fmt:message key="configanddeploy.networkswitchview.title" />
        </h1>
    </header>
    <p>
        <fmt:message key="configanddeploy.networkswitchview.help" />
    </p>
    <form>
        <section>
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="configanddeploy.networkswitchview.title" />
                </h1>
            </header>
            <nav class="action-buttons">
                <ul class="inlineList configanddeploy-actions">
                    <li>
                        <button id="linkDiscoverForm" data-bind="styledDisabled: disableLink()" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/discovery.discover'">
                            <i class="cux-icon cux-icon-search"></i>
                            <span>
                                <fmt:message key="configanddeploy.networkswitchview.discover" />
                            </span>
                        </button>
                    </li>
                    <li>
                        <button id="deleteNetworkSwitch" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: networkSwitchTable().checkedRows().length === 0" type="button">
                            <i class="cux-icon cux-icon-trash"></i><span>
                                <fmt:message key="generic.delete" />
                            </span>
                        </button>
                    </li>
                    <li>
                        <button id="networkSwitchRefresh" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                            <i class="cux-icon cux-icon-repeat"></i><span>
                                <fmt:message key="generic.refresh" />
                            </span>
                        </button>
                    </li>
                    <li>
                        <button id="syncNetworkSwitch" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onmouseover='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.NetworkSwitchView.enableDetails("sync")' onmouseout='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.NetworkSwitchView.disableDetails()'>
                            <i class="cux-icon cux-icon-refresh"></i>
                            <span data-bind="visible: detailsEnabled() != 'sync'">
                                <fmt:message key="configanddeploy.networkswitchview.sync" />
                            </span>
                            <span data-bind="visible: detailsEnabled() == 'sync'">
                                <fmt:message key="configanddeploy.networkswitchview.syncwith" />
                            </span>
                        </button>
                    </li>
                    <li>
                        <button id="resolveSyncErrors" onmouseover='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.NetworkSwitchView.enableDetails("resolvesyncerrors")' onmouseout='DellClarity.SCVMM.ViewModel.ConfigAndDeploy.NetworkSwitchView.disableDetails()' data-bind="styledDisabled: disableLink()" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                            <i class="cux-icon cux-icon-check"></i>
                            <span data-bind="visible: detailsEnabled() != 'resolvesyncerrors'">
                                <fmt:message key="configanddeploy.networkswitchview.resolvesync" />
                            </span>
                            <span data-bind="visible: detailsEnabled() == 'resolvesyncerrors'">
                                <fmt:message key="configanddeploy.networkswitchview.resolvesyncerrors" />
                            </span>
                        </button>
                    </li>
                </ul>
            </nav>
           
             <!-- ko with: networkSwitchTable -->
            <table id="networkSwitchTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input id="cbSelectionAllRowsServers" type="checkbox" />
                            <label for="cbSelectionAllRowsServers" class="visuallyhidden">
                                <u>
                                    <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                </u>
                            </label>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.healthstatus" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.ipaddress" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.hostname" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.servicetag" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.model" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.firmwareversion" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="configanddeploy.networkswitchview.alertRelayServer" /></strong>
                        </th>
                    </tr>
                </thead>

                <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="configanddeploy.chassissubview.compliancechoices" />
                                    </u>
                                </label>
                            </td>
                            <td style="text-align: center">
                                <span data-bind="html: healthStatus"></span>
                            </td>
                            <td>
                                <a data-bind="href: switchIpLink, text: ipAddress" target="_blank"></a>
                            </td>
                            <td>
                                <span data-bind="text: hostName"></span>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: model"></span>
                            </td>
                            <td>
                                <span data-bind="text: firmwareVersion"></span>
                            </td>
                            <td>
                                <span data-bind="text: alertRelayServer"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <tfoot>
                        <tr>
                            <td colspan="6">
                                <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- /ko -->
        </section>
    </form>
</section>

