<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_configuration_template" data-bind="with: DellClarity.SCVMM.ViewModel.Configuration">
    <section id="error_configuration" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>

    <header class="page-heading">
        <h1>
            <fmt:message key="configuration.title" />
        </h1>
    </header>

    <p> <fmt:message key="configuration.help" /> </p>

    <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configuration.title" />
            </legend>
            <nav class="action-buttons">
                <ul class="inlineList configanddeploy-actions">
                    <li>
                        <button id="editConfiguration" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                            <i class="cux-icon cux-icon-edit"></i>
                            <span>
                                <fmt:message key="genericTerms.edit" />
                            </span>
                        </button>
                    </li>
                </ul>
            </nav>

            <!-- ko with: configurationTable -->
            <table id="configurationTable" class="dataTable">
                <thead>
                    <tr>
                        <!-- <th scope="col">

                        </th> -->
                        <th scope="col">
                            <strong>
                                <fmt:message key="configuration.devicetype" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configuration.discoverytype" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configuration.discoveryinterval" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configuration.healthinterval" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configuration.metricsmonitoring" />
                            </strong>
                        </th>
                        <th scope="col">
                            <strong>
                                <fmt:message key="configuration.metricsinterval" />
                            </strong>
                        </th>
                    </tr>
                </thead>

                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="7">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && (!data || data().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="7">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                        <tr>
                            <!-- <td style="text-align: center">
                                <span data-bind="html: isDeviceSelectedIcon"></span>
                            </td> -->
                            <td>
                                <span data-bind="text: deviceType"></span>
                            </td>
                            <td>
                                <span data-bind="text: discoveryType"></span> 
                            </td>
                            <td>
                                <span data-bind="text: discoveryInterval"></span>
                            </td>
                            <td>
                                <span data-bind="text: healthInterval"></span>
                            </td>
                            <td>
                                <span data-bind="text: metricsMonitoring"></span> 
                            </td>
                            <td>
                                <span data-bind="text: metricsInterval"></span>
                            </td>
                        </tr>
                    </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
    </fieldset>
</section>
