<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_editconfiguration_template" data-bind="with: DellClarity.SCVMM.ViewModel.EditConfiguration">
    <section id="error_editconfiguration" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <header>
        <h1 class="visuallyhidden">
            <fmt:message key="configuration.selectdevices" />
        </h1>
    </header>

    <form id="editConfigurationForm" autocomplete="off">
    <p> <fmt:message key="editconfiguration.help" /> </p>
    <section id="editsconfiguration">
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="configuration.title" />
            </legend>
            <!-- ko with: DellClarity.SCVMM.ViewModel.EditConfiguration.editConfigurationTable -->
            <span id="configurationCheck1_validationMessage" class="validationMessage forTable" style="display: none" />
                <table id="editConfigurationTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- <th scope="col">
                               
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configuration.devicetype" />
                                </strong>
                            </th>
                            <!-- <th scope="col">
                                <strong>
                                    <fmt:message key="configuration.discoverytype" />
                                </strong>
                            </th> -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configuration.discoveryinterval" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configuration.healthinterval" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configuration.metricsmonitoring" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="configuration.metricsinterval" />
                                </strong>
                            </th>
                        </tr>
                    </thead>

                    <!-- ko if: (!DellClarity.SCVMM.ViewModel.EditConfiguration.editConfigurationTable() || DellClarity.SCVMM.ViewModel.EditConfiguration.editConfigurationTable().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="7">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: DellClarity.SCVMM.ViewModel.EditConfiguration.editConfigurationTable() && DellClarity.SCVMM.ViewModel.EditConfiguration.editConfigurationTable().length > 0 -->
                    <tbody data-bind="foreach: DellClarity.SCVMM.ViewModel.EditConfiguration.editConfigurationTable">
                        <tr>
                            <!-- <td class="checkboxColumn">
                                <input name="device" type="checkbox" data-bind="checked: isDeviceSelected, event: { change: DellClarity.SCVMM.ViewModel.EditConfiguration.deviceSelectEvent }, indexedid: id" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td> -->
                            <td>
                                <span data-bind="text: deviceType, styledDisabled: isDeviceSelected ? false : true"></span>
                            </td>
                            <!-- <td> -->
                                <!-- ko if: typeof $data.discoveryType != 'undefined' -->      
                                <!-- <select style="width: 6em;" data-bind="event: { change: DellClarity.SCVMM.ViewModel.EditConfiguration.discoveryTypeSelectEvent }, styledDisabled: isDeviceSelected ? false : true, options: discoveryTypeOptions, value: discoveryType, indexedid: 'discoveryType_' + id"></select> --> 
                                <!-- /ko -->
                            <!-- </td> -->
                            <td>
                                <input style="width: 8em;" type="number" min="1" max="99999999" data-bind="value: discoveryInterval, styledDisabled: isDeviceSelected ? false : true, event: { keydown: DellClarity.SCVMM.validateNumber, keyup: DellClarity.SCVMM.ViewModel.EditConfiguration.validateMaxNumber, blur: DellClarity.SCVMM.ViewModel.EditConfiguration.discoveryIntervalChangeEvent }, indexedid: 'discoveryInterval_' + id"/>
                            </td>
                            <td>
                                <input style="width: 8em;" type="number" min="1" max="99999999" data-bind="value: healthInterval, styledDisabled: isDeviceSelected ? false : true, event: { keydown: DellClarity.SCVMM.validateNumber, keyup: DellClarity.SCVMM.ViewModel.EditConfiguration.validateMaxNumber, blur: DellClarity.SCVMM.ViewModel.EditConfiguration.healthIntervalChangeEvent }, indexedid: 'healthInterval_' + id"/>
                            </td>
                            <td>
                                <!-- ko if: typeof $data.metricsMonitoring != 'undefined' -->      
                                <select style="width: 6em;" data-bind="event: { change: DellClarity.SCVMM.ViewModel.EditConfiguration.metricsMonitoringSelectEvent }, styledDisabled: (isDeviceSelected && discoveryType == 'Detailed' && deviceType != 'Network Switches') ? false : true, options: metricsMonitoringOptions, value: metricsMonitoring, indexedid: 'metricsMonitoring_' + id"></select> 
                                <!-- /ko -->
                            </td>
                            <td>
                                <input style="width: 8em;" type="number" min="1" max="99999999" data-bind="value: metricsInterval, styledDisabled: (isDeviceSelected && discoveryType == 'Detailed' && metricsMonitoring == 'Yes' && deviceType != 'Network Switches') ? false : true, event: { keydown: DellClarity.SCVMM.validateNumber, keyup: DellClarity.SCVMM.ViewModel.EditConfiguration.validateMaxNumber, blur: DellClarity.SCVMM.ViewModel.EditConfiguration.metricsIntervalChangeEvent }, indexedid: 'metricsInterval_' + id"/>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                </table>
                <!-- /ko -->
            </fieldset>
    </section>
        
        <div class="sectionEditButtons">
            <button id="configurationFinish" class="cux-button cux-button-large cux-button-primary"  type="submit">
                <fmt:message key="configuration.finish" />
            </button>
            <button id="configurationCancel" class="cux-button cux-button-large cux-button-danger"  type="button">
                <fmt:message key="configuration.cancel" />
            </button>
        </div>
    </form>

</section>
