<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div id="credentialMasterDetails" class="masterDetails" data-bind="with: DellClarity.SCVMM.ViewModel.CredentialMasterDetails">
    <section id="credentialProfileMaster" class="master">
        <section id="error_credentialprofilemaster" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
        <header class="page-heading">
            <h1>
                <fmt:message key="credentialMasterDetails.credProfiles" />
            </h1>
        </header>
		<p>
            <fmt:message key="credentialMasterDetails.help" />
        </p>
        <nav class="action-buttons">
            <ul class="inlineList taskbar">
                <li>
                    <!--a id="createCredProfile" href="#/credentialProfile.details">
                        <fmt:message key="generic.create" />
                    </a-->
                    <button id="createCredProfile" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/credentialProfile.details'">
                        <i class="cux-icon cux-icon-file-text"></i><span>
                            <fmt:message key="generic.create" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a id="editCredProfile" data-bind="styledDisabled: credentialProfileTable().checkedRows().length !== 1">
                        <fmt:message key="genericTerms.edit" />
                    </a-->
                    <button id="editCredProfile" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: credentialProfileTable().checkedRows().length !== 1" type="button">
                        <i class="cux-icon cux-icon-edit"></i><span>
                            <fmt:message key="genericTerms.edit" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a-- id="deleteCredProfile" data-bind="styledDisabled: credentialProfileTable().selectedItemCount() === 0">
                        <fmt:message key="generic.delete" />
                    </!--a-->
                    <button id="deleteCredProfile" class="cui-button cux-button cux-button-primary disabled cux-button-medium " data-bind="styledDisabled: credentialProfileTable().selectedItemCount() === 0" type="button">
                        <i class="cux-icon cux-icon-trash"></i><span>
                            <fmt:message key="generic.delete" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a-- id="refreshCredProfile">
                        <fmt:message key="generic.refresh" />
                    </!--a-->
                    <button id="refreshCredProfile" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                        <i class="cux-icon cux-icon-repeat"></i><span>
                            <fmt:message key="generic.refresh" />
                        </span>
                    </button>
                </li>
            </ul>
        </nav>
        <form id="credentialProfileForm">
            <fieldset>
                <legend class="visuallyhidden">
                    <fmt:message key="credentialMasterDetails.credProfTable" />
                </legend>
                <div class="master-table-wrapper">
                    <!-- ko with: credentialProfileTable -->
                    <table id="credProfileTable" class="dataTable">
                        <thead>
                            <tr>
                                <th scope="col" class="checkboxColumn">
                                    <input type="checkbox" id="credProfSelectAll" />
                                    <label for="credProfSelectAll" class="visuallyhidden">
                                        <fmt:message key="credentialMasterDetails.selectAllCreds" />
                                    </label>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="generic.name" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="credentialMasterDetails.username" />
                                    </strong>
                                </th>

                                <!-- Removed for BETA -->
                                <!--<th scope="col">
                                    <strong><fmt:message key="credentialMasterDetails.associatedhosts" /></strong>
                                </th>-->

                                <!--<th scope="col">
                                    <strong><fmt:message key="credentialMasterDetails.certificateCheck" /></strong>
                                </th-->
                                
                                <th scope="col">
                                    <strong>
                                        <fmt:message key="credentialMasterDetails.type" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="credentialMasterDetails.defaultFor" />
                                    </strong>
                                </th>
                            </tr>
                        </thead>
                        <!-- ko if: loading() -->
                        <tbody>
                            <tr>
                                <td colspan="5">
                                    <fmt:message key="scrollabletable.loading" />
                                    <span>&nbsp;</span>
                                    <span class="icon spinner"></span>
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && (!data || data().length == 0) -->
                        <tbody>
                            <tr>
                                <td colspan="5">
                                    <fmt:message key="scrollabletable.empty" />
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && data && data().length > 0 -->
                        <tbody data-bind="foreach: data">
                            <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.CredentialMasterDetails.selectedCredential() === $data }">

                                <td class="checkboxColumn">
                                    <input type="checkbox" data-bind="checked: checked, indexedid: 'credentialProfile_'" />
                                    <label class="visuallyhidden" data-bind="indexedfor: 'credentialProfile_'">Select Credential Profile</label>
                                </td>

                                <td data-bind="text: name"></td>

                                <td data-bind="text: username"></td>
                                <!-- Removed for BETA -->
                                <!--<td data-bind="foreach: associatedHosts">
                                    <span data-bind="text: $index() ? ',' + $data : $data"></span>
                                </td>-->
                                <!-- ko if: $data.iDracCertificateCheck === true -->
                                <!-- Removed for BETA -->
                                <!--<td>
                                    <fmt:message key="generic.enabled" />
                                </td>-->

                                <!-- /ko -->

                                <!-- ko if: $data.iDracCertificateCheck === false -->
                                <!-- Removed for BETA -->
                                <!--<td>
                                    <fmt:message key="generic.disabled" />
                                </td>-->
                                <!-- /ko -->

                                <td data-bind="text: credentialType"></td>

                                <td data-bind="text: isDefault"></td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                    </table>
                    <!-- /ko -->
                </div>
            </fieldset>
        </form>
    </section>

    <section id="credentialProfileDetails" class="details" data-bind="visible: selectedCredential() !== undefined">
        <header>
            <h1>
                <fmt:message key="generic.details" />
            </h1>
        </header>
        <ul class="labelValuePairs" data-bind="if: selectedCredential() !== undefined">
            <li>
                <label for="selectedCredProfName">
                    <u>
                        <fmt:message key="generic.name" />
                    </u>
                </label>
                <span id="selectedCredProfName" class="value" data-bind="text: selectedCredential().name"></span>
            </li>

            <li>
                <label for="selectedCredProfDescription">
                    <u>
                        <fmt:message key="generic.description" />
                    </u>
                </label>
                <span id="Span1" class="value" data-bind="text: selectedCredential().description"></span>
            </li>

            <li data-bind="if: selectedCredential().credentialType == 'Proxy Credential Profile'">
                <label for="selectedCredentialProxyURL">
                    <u>
                        <fmt:message key="credentialMasterDetails.proxyURL" />
                    </u>
                </label>
                <span id="selectedCredentialProxyURL" class="value" data-bind="text: selectedCredential().proxyServerUrl"></span>
            </li>

            <li>
                <label for="selectedDateCreated">
                    <u>
                        <fmt:message key="credentialMasterDetails.created" />
                    </u>
                </label>
                <span id="selectedDateCreated" class="value" data-bind="time: selectedCredential().dateCreated, timeFormat: 'LLL'"></span>
            </li>

            <li>
                <label for="selectedDateModified">
                    <u>
                        <fmt:message key="credentialMasterDetails.modified" />
                    </u>
                </label>
                <span id="selectedDateModified" class="value" data-bind="time: selectedCredential().dateModified, timeFormat: 'LLL'"></span>
            </li>
        </ul>
    </section>

</div>

