<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_credentialprofile_template" data-bind="with: DellClarity.SCVMM.ViewModel.CredentialProfile.Details">
    <section id="error_credProfile" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <!--ko if: DellClarity.Config.consoleType != 'scom' -->
    <p>
        <fmt:message key="credentialprofile.help" />
    </p>
    <!-- /ko -->

    <!--ko if: DellClarity.Config.consoleType == 'scom' -->
    <p>
        <fmt:message key="credentialprofile.help.scom" />
    </p>
    <!-- /ko -->

    <form id="credProfileForm" autocomplete="off">
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="credentialprofile.title" />
            </legend>
            <ul class="labelValuePairs">

                 <li>
                    <span class="label">
                        <u>
                            <fmt:message key="credentialprofile.selectcredentialprofiletype" />
                        </u>
                    </span>
                    <span class="value">
                      <label for="selectcredentialProfile" class="visuallyhidden">
                        <u>
                          <fmt:message key="credentialprofile.selectedcredentialprofiletype" />
                        </u>
                      </label>
                        <select id="selectcredentialProfile" required data-bind="value: credentialType, options: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.credentialProfileTypes,
                                optionsValue: 'id', 
                                styledDisabled: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.editFlag() == true,
                            optionsText: 'name', optionsCaption: '<fmt:message key="credentialprofile.selectedcredentialprofiletype" />'">
                        </select>
                    </span>
                </li>

                <li>
                    <label for="credProfName">
                        <u>
                            <fmt:message key="credentialprofile.name" />
                        </u>
                    </label>
                    <input id="credProfName" name="credProfName" required data-bind="value: name, styledDisabled: (DellClarity.SCVMM.ViewModel.CredentialProfile.Details.editFlag() == true && DellClarity.SCVMM.ViewModel.CredentialProfile.Details.isPredefinedCP() == true), event: { keyup: DellClarity.SCVMM.capsText, blur: DellClarity.SCVMM.trimText }, valueUpdate: 'input'"  type="text" maxlength="59" pattern="^[0-9a-zA-Z ]{1,59}$" title='<fmt:message key="credentialprofile.name.hint" />' value=""  class="value">
                </li>
                <li>
                    <label for="credProfDescription">
                        <u>
                            <fmt:message key="credentialprofile.description" />
                        </u>
                    </label>
                    <textarea id="credProfDescription" name="credProfDescription"  data-bind="value: description, styledDisabled: (DellClarity.SCVMM.ViewModel.CredentialProfile.Details.editFlag() == true && DellClarity.SCVMM.ViewModel.CredentialProfile.Details.isPredefinedCP() == true)" class="value" maxlength="255" title='<fmt:message key="credentialprofile.description.title" />'></textarea>
                </li>
            </ul>
        </fieldset>

        <!-- visible when selected credential profile is Device Credential Profile and console type is SCOM-->
        <!--ko if: DellClarity.Config.consoleType == 'scom' -->
        <fieldset data-bind="with: model, styledDisabled: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.editFlag()">
            <!--ko if:credentialType() == '1' -->
	        <legend>
		        <fmt:message key="credentialprofile.protocol" />
	        </legend>
	
	        <ul class="labelValuePairs">
	            <li>
		          <input type="radio" id="http" name="http" class="value" value="HTTP" data-bind="checked: protocolType" />
		          <label for="http">
		            <u>
			          <fmt:message key="credentialprofile.http" />
		            </u>
		          </label>
	            </li>
                <li>
			        <input type="radio" id="snmp" name="snmp" class="value" value="SNMP" data-bind="checked: protocolType" />
			        <label for="snmp">
				        <u>
					        <fmt:message key="credentialprofile.snmp" />
				        </u>
			        </label>
		        </li>
	        </ul>
            <!--/ko-->
        </fieldset>
        <!--/ko-->

        <fieldset data-bind="with: model">
            <legend>
                <fmt:message key="credentialprofile.credentials" />
            </legend>
            <ul class="labelValuePairs">
                <!-- visible when selected credential profile type is Device Credential Profile -->
                <!--ko if:credentialType() == '1' -->
                <li>
                    <label for="domainUser">
                        <u>
                            <fmt:message key="credentialprofile.username" />
                        </u>
                    </label>
                    <input id="domainUser" name="domainUser" data-bind="value: username, styledDisabled: (DellClarity.Config.consoleType == 'scom' && protocolType() == 'SNMP') ? true : false, attr: { required: (DellClarity.Config.consoleType == 'scom' && protocolType() == 'SNMP') ? false : true }, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.trimUsernameText }" type="text" maxlength="59" class="value" title='<fmt:message key="credentialprofile.username.title" />' placeholder='<fmt:message key="credentialprofile.username.hint" />'>
                </li>
                <!--/ko-->

                <!-- visible when selected credential profile type is not Device Credentials -->
                <!--ko if:credentialType() !== '1' && credentialType() !== '4' -->
                <li>
                    <label for="userName">
                        <u>
                            <fmt:message key="credentialprofile.username" />
                        </u>
                    </label>
                    <input id="userName" name="userName" required data-bind="value: username, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.trimUsernameText }" type="text" maxlength="59" class="value" title='<fmt:message key="credentialprofile.username.title" />' placeholder='<fmt:message key="credentialprofile.username.hinttext" />'>
                </li>
                <!--/ko-->

                <!--ko if:credentialType() == '4' -->
                <li>
                    <label for="proxyUserName">
                        <u>
                            <fmt:message key="credentialprofile.username" />
                        </u>
                    </label>
                    <input id="proxyUserName" name="proxyUserName" data-bind="value: username, attr: { required: password() && password().length > 0 ? true : false }, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.trimUsernameText }" type="text" maxlength="59" title='<fmt:message key="credentialprofile.username.title" />' class="value" placeholder='<fmt:message key="credentialprofile.username.proxyusernamehint" />'>
                </li>                

                <li>
                    <label for="proxyPassword">
                        <u>
                            <fmt:message key="credentialprofile.password" />
                        </u>
                    </label>
                    <input id="proxyPassword" name="proxyPassword" data-bind="value: password, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.trimPasswordText }" type="password" maxlength="59" title='<fmt:message key="credentialprofile.password.title" />' class="value">
                </li>
                <!--/ko-->

                <!--ko if:credentialType() != '4' -->
                <li>
                    <label for="password">
                        <u>
                            <fmt:message key="credentialprofile.password" />
                        </u>
                    </label>
                    <input id="password" name="password" data-bind="value: password, styledDisabled: (credentialType() == '1' && DellClarity.Config.consoleType == 'scom' && protocolType() == 'SNMP') ? true : false, attr: { required: (DellClarity.Config.consoleType == 'scom' && protocolType() == 'SNMP') ? false : true }, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.trimPasswordText }" type="password" maxlength="59" title='<fmt:message key="credentialprofile.password.title" />' class="value">
                </li>
                <!--/ko-->

                <!-- visible when selected credential profile is Windows Credential Profile -->
                <!--ko if:credentialType() == '2' -->
                <li>
                    <label for="domain">
                        <u>
                            <fmt:message key="credentialprofile.domain" />
                        </u>
                    </label>
                    <input id="domain" name="domain" data-bind="value: domain, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.validateDomain }" type="text" maxlength="255" title='<fmt:message key="credentialprofile.domain.title" />' class="value" placeholder='<fmt:message key="credentialprofile.domain.hint" />'>
                </li>
                <!--/ko-->

                <!-- visible when selected credential profile is Proxy Server Credentials -->
                <!--ko if:credentialType() == '4' -->
                <li>
                    <label for="proxyserverurl">
                        <u>
                            <fmt:message key="credentialprofile.proxyserverurl" />
                        </u>
                    </label>
                    <input id="proxyserverurl" name="proxyserverurl" required data-bind="value: proxyServerUrl, valueUpdate: 'afterkeydown', event: { keyup: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.validateProxyServerUrl }" type="text" maxlength="255" title='<fmt:message key="credentialprofile.proxyserverurl.title" />' class="value" placeholder='<fmt:message key="credentialprofile.proxyserverurl.hint" />'>
                </li>
                <!--/ko-->

                <!-- visible when selected credential profile is Device Credential Profile and console type is SCOM-->
                <!--ko if:credentialType() == '1' && DellClarity.Config.consoleType == 'scom' -->
                <!--ko if:protocolType() == 'SNMP' -->
                <li>
                    <label for="communityString">
                        <u>
                            <fmt:message key="credentialprofile.communitystring" />
                        </u>
                    </label>
                    <input id="communityString" name="communityString" required data-bind="value: communityString, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.trimCommunityString }" type="password" maxlength="59" class="value" title='<fmt:message key="credentialprofile.communitystring.title" />' placeholder='<fmt:message key="credentialprofile.communitystring.hint" />'>
                </li>
                <!--/ko-->

                <!--ko if:protocolType() == 'HTTP' -->
                <li>
                    <label for="portNumber">
                        <u>
                            <fmt:message key="credentialprofile.portnumberwsman" />
                        </u>
                    </label>
                    <input id="portNumber" name="portNumber" data-bind="value: portNumber, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.validatePortNumber }" type="text" class="value" title='<fmt:message key="credentialprofile.portnumberwsman.title" />' placeholder='<fmt:message key="credentialprofile.portnumberwsman.hint" />'>
                </li>
                <!--/ko-->
                <!--ko if:protocolType() == 'SNMP' -->
                <li>
                    <label for="portNumberSnmp">
                        <u>
                            <fmt:message key="credentialprofile.portnumbersnmp" />
                        </u>
                    </label>
                    <input id="portNumberSnmp" name="portNumberSnmp" data-bind="value: portNumberSnmp, event: { blur: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.validatePortNumberSnmp }" type="text" class="value" title='<fmt:message key="credentialprofile.portnumbersnmp.title" />' placeholder='<fmt:message key="credentialprofile.portnumbersnmp.hint" />'>
                </li>
                <!--/ko-->
                <!--/ko-->

                <!-- visible when selected credential profile is Device Credential Profile -->
                <li data-bind="visible: credentialType() == '1'">
                    <span class="label">
                        <u>
                            <fmt:message key="credentialprofile.defaultcredentialprofile" />
                        </u>
                    </span>
                    <span class="value">
                      <label for="selectcredentialprofiledefault" class="visuallyhidden">
                        <u>
                          <fmt:message key="credentialprofile.selectcredentialprofiledefault" />
                        </u>
                      </label>
                        <select id="selectcredentialprofiledefault" data-bind="value: isDefault, options: DellClarity.SCVMM.ViewModel.CredentialProfile.Details.defaultCredentialProfile,
                                optionsValue: 'name', optionsText: 'name'">
                        </select>
                    </span>
                </li>

                <!-- Removed for BETA -->
                <!--<li>
                    <input type="checkbox" data-bind="checked: iDracCertificateCheck" id="disableCAandCN" name="disableCAandCN" class="value" />
                    <label for="disableCAandCN">
                        <u>
                            <fmt:message key="credentialprofile.disableca" />
                        </u>
                    </label>
                </li>-->
                <!-- <li>
                    <input type="checkbox" data-bind="checked: isDefault" id="setDefault" name="setDefault" class="value" />
                    <label for="setDefault">
                        <u>
                            <fmt:message key="credentialprofile.makeDefault" />
                        </u>
                    </label>
                </li> -->
            </ul>

        </fieldset>
        <div class="sectionEditButtons">
            <button id="credentialProfileFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="credentialprofile.finish" />
            </button>
            <button id="credentialProfileCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="credentialprofile.cancel" />
            </button>
        </div>
    </form>
</section>
