<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="masterDetails" data-bind="with: DellClarity.SCVMM.ViewModel.DeploymentMasterDetails">
    <section id="deploymentMasterSection" class="master">
        <header><h1><fmt:message key="credentialMasterDetails.deploymentTemplates" /></h1></header>
        <ul class="inlineList taskbar">
            <li>
                <!--a id="createDeployment" href="#/deployment.deploymentTemplate"><fmt:message key="generic.create" /></a-->
                <button id= "createDeployment" class="cui-button cux-button cux-button-small  cux-button-primary"   type="button" onclick="window.location.href='#/deployment.deploymentTemplate'">
            <i class="ci ci-action-new-core"></i><span ><fmt:message key="generic.create" /></span></button>
            </li>
            <li>
                <!--a id="editDeployment" data-bind="styledDisabled: deploymentTemplatesTable().checkedRows().length !== 1"><fmt:message key="genericTerms.edit" /></a-->
                <button id= "editDeployment" class="cui-button cux-button disabled cux-button-small " data-bind="styledDisabled: deploymentTemplatesTable().checkedRows().length !== 1"  type="button" onclick="window.location.href='#/deployment.deploymentTemplate'">
            <i class="ci ci-action-edit-core"></i><span ><fmt:message key="genericTerms.edit" /></span></button>
            </li>
            <li>
                <!--a id="deleteDeployment" data-bind="styledDisabled: deploymentTemplatesTable().selectedItemCount() === 0"><fmt:message key="generic.delete" /></a-->
                <button id= "deleteDeployment" class="cui-button cux-button disabled cux-button-small " data-bind="styledDisabled: deploymentTemplatesTable().selectedItemCount() === 0"  type="button" >
            <i class="ci ci-action-delete-core"></i><span ><fmt:message key="generic.delete" /></span></button>
            </li>
            <li>
                <!--a id="refreshDeploymentTable"><fmt:message key="generic.refresh" /></a-->
            <button id= "refreshDeploymentTable" class="cui-button cux-button cux-button-small  cux-button-primary"  type="button" >
            <i class="ci ci-action-refresh-core"></i><span ><fmt:message key="generic.refresh" /></span></button>
            
        </ul>
        <form id="deploymentTemplateTableForm">
            <fieldset>
                <legend class="visuallyhidden">
                    <fmt:message key="credentialMasterDetails.deploymentTemplates" />
                </legend>
                <!-- ko with: deploymentTemplatesTable -->
                <table id="deploymentTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input id="selectAllDeployment" type="checkbox"/>
                                <label for="selectAllDeployment" class="visuallyhidden"><u><fmt:message key="credentialMasterDetails.selectAll"/></u></label>
                            </th>
                            <th scope="col"><strong><fmt:message key="generic.name" /></strong></th>
                            <th scope="col"><strong><fmt:message key="deploymenttemplate.masterdetails.created" /></strong></th>
                            <th scope="col"><strong><fmt:message key="deploymenttemplate.masterdetails.modified" /></strong></th>
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="4">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="4">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.DeploymentMasterDetails.selectedProfile() === $data }">
                            <td class="checkboxColumn">
                                <input type="checkbox" data-bind="checked: checked, indexedid:'deploymentTemplate_'"/>
                                <label class="visuallyhidden" data-bind="indexedfor:'deploymentTemplate_'">
                                    <u>
                                        <fmt:message key="credentialMasterDetails.templatechoices"/>                                                                                 
                                    </u>
                                </label>
                            </td>
                            <td data-bind="text: $data.name"></td>
                            <td data-bind="time: $data.dateCreated, timeFormat: 'LLL'"></td>
                            <td data-bind="time: $data.dateModified, timeFormat: 'LLL'"></td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                </table>
                <!-- /ko -->
            </fieldset>
        </form>
    </section>
    <section id="deploymentDetailsSection" class="details" data-bind="visible: selectedProfile() !== undefined">
        <header><h1><fmt:message key="generic.details"/></h1></header>
        <ul class="labelValuePairs" data-bind="if: selectedProfile() !== undefined">
            <li>
                <label for="selectedDeploymentProfileName"><u><fmt:message key="generic.name" /></u></label>
                <span id="selectedDeploymentProfileName" class="value" data-bind="text: selectedProfile().name"></span>
            </li>
            <li>
                <label for="selectedDeploymentDescription"><u><fmt:message key="generic.description" /></u></label>
                <span id="selectedDeploymentDescription" class="value" data-bind="text: selectedProfile().description"></span>
            </li>
            <li>
                <label for="selectedDeploymentProfileHardwareProfile"><u><fmt:message key="deploymenttemplate.hardwareprofile" /></u></label>
                <span id="selectedDeploymentProfileHardwareProfile" class="value" data-bind="text: selectedProfile().hardwareProfileDisplay"></span>
            </li>
            <li>
                <label for="selectedDeploymentProfileHypervisorProfile"><u><fmt:message key="deploymenttemplate.hypervisorprofile" /></u></label>
                <span id="selectedDeploymentProfileHypervisorProfile" class="value" data-bind="text: selectedProfile().hypervisorProfileDisplay"></span>
            </li>
            <li>
                <label for="selectedDeploymentUpdateSource"><u><fmt:message key="deploymenttemplate.updatesource" /></u></label>
                <span id="selectedDeploymentUpdateSource" class="value" data-bind="text: selectedProfile().updateSourceDisplay"></span>
            </li>
        </ul>
    </section>
</div>
