<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_deploymentTemplate" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.DeploymentTemplate">
    <section id="error_deployTemplate" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" ></section>
    <p>
        <fmt:message key="deployment.deployment.help" />
    </p>
    <form id="deploymentTemplateForm">
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="deployment.deployment.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="deploymentTemplateName"><u>
                        <fmt:message key="deployment.deployment.name" />
                    </u></label>
                    <input id="deploymentTemplateName" name="deploymentTemplateName" required type="text" value="" class="value" 
                           data-bind="value: name, event:{keyup:DellClarity.SCVMM.capsText, blur:DellClarity.SCVMM.trimText}, valueUpdate:'input'" maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="deployment.deployment.name.hint" />'>
                </li>
                <li>
                    <label for="deploymentTemplateDescription"><u>
                        <fmt:message key="deployment.deployment.description" />
                    </u></label>
                    <textarea id="deploymentTemplateDescription" name="deploymentTemplateDescription" class="value" maxlength="255" title='<fmt:message key="deployment.deployment.description.title" />' data-bind="value: description"></textarea>
                </li>
                <li>
                    <label for="deploymentHardwareProfile"><u>
                        <fmt:message key="deployment.deployment.hardwareprofile" />
                    </u></label>
                    <span class="value">
                        <select id="deploymentHardwareProfile" name="deploymentHardwareProfile" data-bind="options:  DellClarity.SCVMM.ViewModel.Deployment.hardwareProfiles(), optionsText: 'name', optionsValue: 'id', 
                                                                 value: hardwareProfileId, optionsCaption: '<fmt:message key="deployment.deploymenttemplate.hardwareprofile" />'">
                             
                        </select>
                        <a href="#/hardwareProfile.wizard" id="createNewHardwareProfile">
                            <fmt:message key="deployment.deployment.createnew" />
                        </a>
                    </span>
                </li>
                <li>
                    <label for="deploymentHypervisorProfile"><u>
                        <fmt:message key="deployment.deployment.hypervisorprofile" />
                    </u></label>
                    <span class="value">
                        <select id="deploymentHypervisorProfile" name="deploymentHypervisorProfile" required data-bind="options:  DellClarity.SCVMM.ViewModel.Deployment.hypervisorProfiles(), optionsText: 'name', optionsValue: 'id', 
                                                                value: hypervisorProfileId, optionsCaption: '<fmt:message key="deployment.deploymenttemplate.hypervisorprofile" />'">

                        </select>
                        <a href="#/hypervisorProfile.wizard" id="createNewHypervisorProfile">
                            <fmt:message key="deployment.deployment.createnew" />
                        </a>
                    </span>
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="deployment.deployment.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="deploymentUpdateSource"><u>
                        <fmt:message key="deployment.deployment.updatesource" />
                    </u></label>
                    <span class="value">
                        <select id="deploymentUpdateSource" name="deploymentUpdateSource" data-bind="options: DellClarity.SCVMM.ViewModel.Deployment.updateSources(), optionsText: 'name', optionsValue: 'id', 
                                                                 value: updateSourceId, optionsCaption: '<fmt:message key="deployment.deploymenttemplate.updatesource" />'">
                             
                        </select>
                        <a href="#/updateCenter.updatesourcedetails" id="createNewUpdateSource">
                            <fmt:message key="deployment.deployment.createnew" />
                        </a>
                    </span>
                </li>
                <li data-bind="styledDisabled: updateSourceId() === undefined">
                    <input type="checkbox" data-bind="checked: continueOnError" id="continueOnError" name="continueOnError" class="value" />
                    <label for="continueOnError">
                        <u>
                            <fmt:message key="deployment.deployment.continueonerror" />
                        </u>
                    </label>
                </li>

                <li data-bind="styledDisabled: updateSourceId() === undefined">
                    <fmt:message key="deployment.deployment.downgradewithosd" />
                </li>
        </fieldset>
        <div class="sectionEditButtons">
            <button id="deploymentTemplateFinish" type="submit">
                <fmt:message key="deployment.deployment.finish" />
            </button>
            <button id="deploymentTemplateCancel" type="button">
                <fmt:message key="deployment.deployment.cancel" />
            </button>
        </div>
    </form>
</section>
