<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_scheduleDeployment" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.ScheduleDeployment">
    <header>
        <h1>
            <fmt:message key="deployment.scheduledeployment.scheduledeployment" />
        </h1>
    </header>
    <form>
        <p>
            <fmt:message key="deployment.scheduledeployment.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="deployment.scheduledeployment.scheduledeployment" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="deploymentJobName">
                        <u>
                            <fmt:message key="deployment.scheduledeployment.deploymentjobname" />
                        </u>
                    </label>
                    <input id="deploymentJobName" name="deploymentJobName" required type="text" value="" class="value" data-bind="value: deployJobName" maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="deployment.scheduledeployment.deploymentjobname.title" />' placeholder='<fmt:message key="deployment.scheduledeployment.deploymentjobname.hint"/>' />
                </li>
                <li>
                    <label for="deploymentJobDescrip">
                        <u>
                            <fmt:message key="deployment.scheduledeployment.deploymentjobdescription" />
                        </u>
                    </label>
                    <textarea id="deploymentJobDescrip" class="value" data-bind="value: deployJobDesc" maxlength="255" title='<fmt:message key="deployment.scheduledeployment.deploymentjobdescription.title" />' placeholder='<fmt:message key="deployment.scheduledeployment.deploymentjobdescription.hint"/>'></textarea>
                </li>
            </ul>
        </fieldset>
        <!-- Not supported in BETA, please don't delete -->
        <!--
            <fieldset>
                <legend>
                    <fmt:message key="deployment.scheduledeployment.scheduledeployment" />
                </legend>
                <ul class="labelValuePairs">
                    <li>
                        <input type="radio" name="runDeployment" class="value" id="runDeployment" name="runDeployment" required value="forceReboot" data-bind="checked: scheduleDeploy" />
                        <label for="runDeployment">
                            <u>
                                <fmt:message key="deployment.scheduledeployment.rundeploymentjobnow" />
                            </u>
                        </label>
                    </li>
                
                
                    <li>
                        <span class="label">
                            <u>
                                <input type="radio" id="schedDeployment" name="runDeployment" value="scheduleUpdate" data-bind="checked: scheduleDeploy">
                                <label for="schedDeployment">
                                    <fmt:message key="deployment.scheduledeployment.scheduledeploymentjob" />
                                </label>
                            </u>
                        </span>
                        <span class="value">
                            <label for="scheduleUpdateDate" class="visuallyhidden">
                                <u>
                                    <fmt:message key="deployment.scheduledeployment.scheduleddate" />
                                </u>
                            </label>
                        
                        
                            <input type="text" id="scheduleUpdateDate" data-bind="enable: scheduleDeploy() == 'scheduleUpdate',  datepicker: deployDate, datepickerOptions: { dataType: 'moment' }, attr: { required: scheduleDeploy() === 'scheduleUpdate' } " />
                            <label for="scheduleHours" class="visuallyhidden"><u><fmt:message key="deployment.scheduledeployment.hourPicker" /></u></label>
                            <select id="scheduleHours" data-bind="enable: scheduleDeploy() == 'scheduleUpdate', options: optionsHour, value: deployHour, attr: { required: scheduleDeploy() === 'scheduleUpdate' }"></select>
                            <span>:</span>
                            <label for="scheduleMinutes" class="visuallyhidden"><u><fmt:message key="deployment.scheduledeployment.minutePicker" /></u></label>
                            <select id="scheduleMinutes" data-bind="enable: scheduleDeploy() == 'scheduleUpdate', options: optionsMinute, value: deployMinute, attr: { required: scheduleDeploy() === 'scheduleUpdate' }"></select>
                        
                        </span>
                    </li>
                
                </ul>
            </fieldset>
            -->
        <!-- Not supported in BETA, please don't delete -->
        <!--<div id="deploySchedule">
            <fmt:message key="deployment.scheduledeployment.scheduledon" />
            <time data-bind="time: isoScheduledDateTime, timeFormat: 'LLL'"></time>
        </div>-->
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="deployment.scheduledeployment.jobList" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <input type="checkbox" id="goToJobList" class="value" data-bind="checked: goToJobList">
                    <label for="goToJobList">
                        <u>
                            <fmt:message key="deployment.scheduledeployment.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>
    </form>
</section>
