<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_selectComponents" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.SelectComponents">
    <header>
        <h1>
            <fmt:message key="deployment.selectservers.selectcomponentstoupdate" />
        </h1>
    </header>
    <form>
        <fieldset>
            <legend>
                <fmt:message key="deployment.selectservers.selectcomponentstoupdate" />
            </legend>
            <p>
                <fmt:message key="deployment.selectprofile.help" />
            </p>
            <ul class="inlineList">
                <li><a id="exportToCsv" tabindex="1" >
                    <fmt:message key="deployment.selectservers.exporttocsv" />
                </a></li>
                <li><a id="copyToClipboard" tabindex="2" >
                    <fmt:message key="deployment.selectservers.copytoclipboard" />
                </a></li>
                <li><a id="refresh" tabindex="3" >
                    <fmt:message key="deployment.selectservers.refresh" />
                </a></li>
            </ul>
            <table id="serversComponentTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input type="checkbox" id="toUpdateSelection1" />
                            <label class="visuallyhidden" for="toUpdateSelection1">
                                <u>
                                    <fmt:message key="deployment.selectprofile.toupdate" />
                                </u>
                            </label>
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectprofile.servicetag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectprofile.idracip" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.component" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.version" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.baseline" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.criticality" />
                        </th>
                    </tr>
                </thead>
                <!-- ko with: DellClarity.SCVMM.ViewModel.Deployment.SelectServers.selectedItems -->
                <tbody data-bind="foreach: $data">
                    <tr data-bind="css: {selected: isFirmwareSelect}">
                        <td>
                            <input type="checkbox" data-bind="checked: isFirmwareSelect, indexedid: 'toUpdateSelection'" />
                            <label class="visuallyhidden" data-bind="indexedfor: 'toUpdateSelection'">
                                <u>
                                    <fmt:message key="deployment.selectprofile.toupdate" />
                                </u>
                            </label>
                        </td>
                        <td data-bind="text: serviceTag"></td>
                        <td data-bind="text: iDracIp"></td>
                        <td data-bind="text: component"></td>
                        <td data-bind="text: version"></td>
                        <td data-bind="text: baseline"></td>
                        <td data-bind="text: criticality"></td>
                    </tr>
                    <tr>
                </tbody>
                <!-- /ko -->
            </table>
        </fieldset>
    </form>
</section>
