<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_selectProfile" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.SelectProfile">
    <section id="error_selectProfile" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <header>
        <h1>
            <fmt:message key="deployment.selectservers.selecttemplateprofile" />
        </h1>
    </header>
    <p>
        <fmt:message key="deployment.selectprofile.help" />
    </p>
    <form id="selectProfileForm">
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="deployment.selectservers.selecttemplateprofile" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="deployTemplate">
                        <u>
                            <fmt:message key="deployment.selectprofile.selectdeploymenttemplate" />
                        </u>
                    </label>
                    <span class="value">
                        <select id="deployTemplate" name="deployTemplate" required data-bind="options: DellClarity.SCVMM.ViewModel.Deployment.deploymentTemplates(), optionsCaption: '<fmt:message key="deployment.selectprofile.selectTemplate" />', optionsText: 'name', optionsValue: 'id', value: selectedTemplate">                     
                        </select>
                        <a id="createDeploymentTemplate" href="#/deployment.deploymentTemplate">
                            <fmt:message key="deployment.selectprofile.createnew" />
                        </a>
                    </span>
                </li>
            </ul>
        </fieldset>
        <fieldset>
            <legend>
                <fmt:message key="deployment.selectprofile.credentialProfile" />
            </legend>
            <li>
                <ul class="labelValuePairs">
                    <li>
                        <span class="label">
                            <u>
                                <input type="radio" id="allServers" name="selectCredentialProfile" value="allServers" data-bind="checked: credProfileChoice" />
                                <label for="allServers">
                                    <fmt:message key="deployment.selectprofile.usethiscredentialprofile" />
                                </label>
                            </u>
                        </span>
                        <span class="value">
                            <label for="credProfMain" class="visuallyhidden">
                                <u>
                                    <fmt:message key="deployment.selectprofile.credentialProfile" />
                                </u>
                            </label>
                            <span class="icon spinner" data-bind="visible: gettingCredentialProfiles() === true"></span>
                            <select id="credProfMain" name="credProfMain" 
                                data-bind="visible: gettingCredentialProfiles() === false, options: DellClarity.SCVMM.ViewModel.Deployment.credProfiles, optionsText: 'name', optionsValue: 'id', 
                                          attr:{required: credProfileChoice() == 'allServers'}, value: selectedProfile,  enable: credProfileChoice() == 'allServers',
                                          optionsCaption: '<fmt:message key="deployment.selectprofile.selectProfile"/>' ">                     
                            </select>
                            <a id="createProfileDetails" href="#/credentialProfile.details" data-bind="visible: gettingCredentialProfiles() === false, css: { disabled: credProfileChoice() != 'allServers' }">
                                <fmt:message key="deployment.selectprofile.createnew" />
                            </a>
                        </span>
                    </li>
                    <li>
                        <input type="radio" id="eachServer" name="selectCredentialProfile" class="value" value="selectedServers"
                            data-bind="checked: credProfileChoice" />
                        <label for="eachServer">
                            <u>
                                <fmt:message key="deployment.selectprofile.selectcredentialprofile" />
                            </u>
                        </label>
                        <p id="credentialProfile_info">
                            <fmt:message key="deployment.selectprofile.comment" />
                        </p>
                        <!-- ko with: DellClarity.SCVMM.ViewModel.Deployment.SelectServers.selectedItems -->
                        <table id="eachServerTable" class="dataTable" data-bind="css: { disabled: DellClarity.SCVMM.ViewModel.Deployment.SelectProfile.credProfileChoice() != 'selectedServers' }">
                            <thead>
                                <tr>
                                    <th scope="col">
                                        <fmt:message key="deployment.selectprofile.servicetag" />
                                    </th>
                                    <th scope="col">
                                        <fmt:message key="deployment.selectprofile.model" />
                                    </th>
                                    <th scope="col">
                                        <fmt:message key="deployment.selectprofile.idracip" />
                                    </th>
                                    <th scope="col">
                                        <fmt:message key="deployment.selectprofile.credentialProfile" />
                                    </th>
                                </tr>
                            </thead>
                            <!-- ko if: length == 0 -->
                            <tbody>
                                <tr>
                                    <td colspan="4">
                                        <fmt:message key="scrollabletable.empty" />
                                    </td>
                                </tr>
                            </tbody>
                            <!-- /ko -->
                            <!-- ko if: length > 0 -->

                            <tbody data-bind="foreach: $data">
                                <tr>
                                    <td data-bind="text: serviceTag"></td>
                                    <td data-bind="text: model"></td>
                                    <td data-bind="text: iDracIp"></td>
                                    <td>
                                        <label data-bind="indexedfor: 'credProf'" class="visuallyhidden">
                                            <u>
                                                <fmt:message key="deployment.selectprofile.credentialProfile" />
                                            </u>
                                        </label>
                                            <span class="icon spinner" data-bind="visible: DellClarity.SCVMM.ViewModel.Deployment.SelectProfile.gettingCredentialProfiles() === true"></span>
                                            <select data-bind="visible: DellClarity.SCVMM.ViewModel.Deployment.SelectProfile.gettingCredentialProfiles() === false, enable: DellClarity.SCVMM.ViewModel.Deployment.SelectProfile.credProfileChoice() === 'selectedServers',
                                                               indexedid: 'credProf', options: DellClarity.SCVMM.ViewModel.Deployment.credProfiles(), optionsText: 'name', 
                                                               optionsValue: 'id', value: credentialProfileId, attr:{required: DellClarity.SCVMM.ViewModel.Deployment.SelectProfile.credProfileChoice() == 'selectedServers'},
                                                               optionsCaption: '<fmt:message key="deployment.selectprofile.selectProfile" />'">                                          
                                            </select> 
                                    </td>
                                </tr>
                            </tbody>
                            <!-- /ko -->
                        </table>
                        <!-- /ko -->
                    </li>
                </ul>
            </li>
        </fieldset>
    </form>
</section>
