<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_selectServers" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.SelectServers">
    <section id="error_selectServers" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <header>
        <h1>
            <fmt:message key="deployment.selectserverstoupdate.selectserversmenu" />
        </h1>
    </header>
    <p>
        <fmt:message key="deployment.selectservers.help" />
    </p>
    <form id="selectServersForm">
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="deployment.selectserverstoupdate.selectserversmenu" />
            </legend>
            <!-- ko with: serverData -->
            <span id="selectServerCheck1_validationMessage" class="validationMessage forTable" style="display: none" />
            <table id="serversTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input type="checkbox" id="selectServerCheck1" />
                            <label for="selectServerCheck1" class="visuallyhidden">
                                <u>
                                    <fmt:message key="deployment.selectprofile.selectserveroption" />
                                </u>
                            </label>
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.servicetag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.model" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.generation" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.idracip" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.cpu" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.selectservers.memory" />
                        </th>
                        <!-- BETA: out of scope for the beta, please don't remove -->
                        <!--<th scope="col">
                            <fmt:message key="deployment.selectservers.baremetalGroups" />
                        </th>-->

                    </tr>
                </thead>
                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->

                <!-- ko if: !loading() && (!data || data().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && data && data().length > 0 -->
                <tbody data-bind="foreach: data" class="checkbox-group-required">
                    <tr data-bind="css: {selected: checked}">
                        <td class="checkboxColumn">
                            <input type="checkbox" name="selectServerCheck"
                                   data-bind="checked: checked, indexedid: 'selectServer'" />
                            <label data-bind="indexedfor: 'selectServer'" class="visuallyhidden">
                                <u>
                                    <fmt:message key="deployment.selectprofile.selectserveroption" />
                                </u>
                            </label>
                        </td>
                        <td data-bind="text: serviceTag"></td>
                        <td data-bind="text: model"></td>
                        <td data-bind="html: servergeneration"></td>
                        <td data-bind="text: iDracIp"></td>
                        <td data-bind="text: cpu"></td>
                        <td data-bind="text: memory"></td>
                        <!-- BETA: out of scope for the beta, please don't remove -->
                        <!--<td data-bind="text: baremetalGroup"></td>-->
                    </tr>
                </tbody>
                <!-- /ko -->
                <tfoot>
                    <tr>
                        <td colspan="11">
                            <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                            <!-- /ko -->
                        </td>
                    </tr>
                </tfoot>
            </table>
            <!-- /ko -->
            <!-- <div class="statusIndicator" data-bind="if: validating()">
                <span class="spinner">
                    <img alt="spinner" src="dellclarity.core/images/body/spinner.gif" />
                    <fmt:message key="deployment.selectservers.validatingmessage" />
                </span>
            </div> -->
            <!-- <div>
                <span>&nbsp;</span>
                  <button type="button" id="licenseAvailability"><fmt:message key="deployment.selectservers.checklicenseavailable" /></button>
            </div>
            <div class="licensestatus" style="display:none">
                <span>&nbsp;</span>
                <ul class="labelValuePairs">
                    <li>
                        <label for="licenseAvailable"><u><fmt:message key="deployment.selectservers.licenseavailable" /></u></label>
                        <span id="licenseAvailable" class="value" data-bind="text: licensesAvailable"></span>
                    </li>
                    <li>
                        <label for="selectedServers"><u><fmt:message key="deployment.selectservers.selectedservers" /></u></label>
                        <span id="selectedServers" class="value" data-bind="text: selectedServers"></span>
                    </li>
                </ul>
            </div> -->
        </fieldset>
    </form>
</section>
