<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_serverIdentification" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.ServerID">
    <section id="error_serverIdentification" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <header>
        <h1>
            <fmt:message key="deployment.serveridentification.title" />
        </h1>
    </header>
    <form id="serverIdentificationForm">
        <p>
            <fmt:message key="deployment.serveridentification.help" />
        </p>
        <fieldset>
            <legend class="visuallyHidden">
                <fmt:message key="deployment.selectservers.selectcomponentstoupdate" />
            </legend>
            <table id="serverComponentsTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <fmt:message key="deployment.serveridentification.servicetag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="deployment.serveridentification.model" />
                        </th>
                        <!-- Removed for BETA -->
                        <!--<th scope="col">
                            <fmt:message key="deployment.serveridentification.ipaddress" />
                        </th>-->
                        <th scope="col">
                            <fmt:message key="deployment.serveridentification.hostname" />
                        </th>
                        <!-- Removed for BETA -->
                        <!--<th scope="col">
                            <fmt:message key="deployment.serveridentification.serveridentity" />
                        </th>-->
                    </tr>
                </thead>
                <!-- ko with: DellClarity.SCVMM.ViewModel.Deployment.SelectServers.selectedItems --> 
                <tbody data-bind="foreach: $data">
                    <tr data-bind="css: {selected: DellClarity.SCVMM.ViewModel.Deployment.ServerID.selectedServer() === $data }">
                        <td data-bind="text: serviceTag"></td>
                        <td data-bind="text: model"></td>
                        <!-- Removed for BETA -->
                        <!--<td data-bind="text: ipAddress"></td>-->
                        <td data-bind="text: hostName"></td>
                        <!-- Removed for BETA -->
                        <!--<td data-bind="text: serverIdentity"></td>-->
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
        </fieldset>
        
        <!-- ko with: DellClarity.SCVMM.ViewModel.Deployment.ServerID.selectedServer -->
            <fieldset>
                <legend>
                    <fmt:message key="deployment.serveridentification.generalinformation" />
                </legend>
                <ul class="labelValuePairs">
                    <li>
                        <label for="genInf1">
                            <u>
                                <fmt:message key="deployment.selectserverstoupdate.servicetag" />
                            </u>
                        </label>
                        <span class="value" id="genInf1" data-bind="text: serviceTag"></span>
                    </li>
                    <li>
                        <label for="genInf3">
                            <u>
                                <fmt:message key="deployment.serveridentification.model" />
                            </u>
                        </label>
                        <span class="value" id="genInf3" data-bind="text: model"></span>

                    </li>
                    <li>
                        <label for="genInf4">
                            <u>
                                <fmt:message key="deployment.selectserverstoupdate.idracip" />
                            </u>
                        </label>
                        <span class="value" id="genInf4" data-bind="text: iDracIp"></span>
                    </li>
                </ul>
            </fieldset>

            <fieldset>
                <legend>
                    <fmt:message key="deployment.serveridentification.hostnameandnic" />
                </legend>
                <ul class="labelValuePairs">
                    <li>
                        <label for="osName">
                            <u>
                                <fmt:message key="deployment.serveridentification.postosname" />
                            </u>
                        </label>
                        <input id="osName" type="text" data-bind="value: hostName" required class="value" maxlength="15"/>
                    </li>
                    <li>
                        <label for="nicId">
                            <u>
                                <fmt:message key="deployment.serveridentification.servermanagementnicidentifier" />
                            </u>
                        </label>
                        <select class="value" id="nicId" required data-bind="options: nicIdentifiers, value: nicIdentifierId, optionsText: 'name', 
                            optionsCaption: '<fmt:message key="deployment.serveridentification.NicIdentifierSelect"/>',optionsValue: 'id'">
                        </select>
                    </li>
                </ul>
            </fieldset>
            <fieldset>
                <legend>
                    <fmt:message key="deployment.serveridentification.networking" />
                </legend>
                <ul class="labelValuePairs">
                    <li>
                        <input type="radio" class="value" id="useDHCP" value="useDHCP" name="networking" data-bind="checked: $parent.allNetworkingChoice" />
                        <label for="useDHCP">
                            <u>
                                <fmt:message key="deployment.serveridentification.obtainusingdhcp" />
                            </u>
                        </label>
                    </li>
                    <li>
                        <input type="radio" class="value" id="staticIP" name="networking" value="staticIP" data-bind="checked: $parent.allNetworkingChoice" />
                        <label for="staticIP">
                            <u>
                                <fmt:message key="deployment.serveridentification.staticip" />
                            
                            </u>
                        </label>
                        <ul class="labelValuePairs">
                            <li>
                                <label for="logicalNetworkSelect">
                                    <u>
                                        <fmt:message key="deployment.serveridentification.scvmm" />
                                    </u>
                                </label>
                                <div class="value">
                                    <span class="icon spinner" data-bind="visible: $parent.gettingLogicalNets() === true"></span>
                                    <select id="logicalNetworkSelect" data-bind="enable: obtainUsingDhcp() == 'staticIP',visible: $parent.gettingLogicalNets() === false, options: $parent.scvmmLogicalNets,
                                                                                           optionsValue: 'id', optionsText: 'name', value: $parent.allScvmmNetwork, attr:{required: obtainUsingDhcp() === 'staticIP'},
                                                                                           optionsCaption: '<fmt:message key="deployment.serveridentification.scvmmLogicalNetworkSelect"/>'"></select>
                                </div>
                            </li>
                            <li>
                                <label for="ipPoolSelect">
                                    <u>
                                        <fmt:message key="deployment.serveridentification.ipsubnet" />
                                    </u>
                                </label>
                                <div class="value">
                                    <span class="icon spinner" data-bind="visible: $parent.gettingLogicalNets() === true"></span>
                                    <select id="ipPoolSelect" data-bind="enable: obtainUsingDhcp() == 'staticIP', visible: $parent.gettingLogicalNets() === false, options: $parent.ipPoolList, value: $parent.allIpPool, optionsValue: 'id', optionsText: 'name', attr:{required: obtainUsingDhcp() === 'staticIP'},
                                                                             optionsCaption: '<fmt:message key="deployment.serveridentification.ipPoolSelect"/>'"></select>
                                </div>
                            </li>
                            <li>
                                <label for="ipInput">
                                        <u>
                                            <fmt:message key="deployment.serveridentification.ipaddress" />
                                        </u>
                                    </label>
                                <input class="value" id="ipInput" type="text" placeholder='<fmt:message key="deployment.serveridentification.mandatorywatermark"/>' data-bind="enable: obtainUsingDhcp() === 'staticIP',  value: $parent.allIpAddress, pattern: 'ipv4'"
                                    title='<fmt:message key="deployment.serverid.ipexample"/>' />
                            </li>
                            <!-- Removed for BETA -->
                            <!--<li>
                                <input type="radio" class="value" id="subnetRadio" name="ipAddressOption" value="subnet" data-bind="enable: obtainUsingDhcp() === 'staticIP', checked: $parent.allIpType" >
                                <label for="subnetRadio">
                                    <u>
                                        <fmt:message key="deployment.serveridentification.autoip"/>
                                    </u>
                                </label>
                            </li>
                            <li>
                                <span class="label">
                                    <u>
                                        <input type="radio" id="ipAddressRadio" name="ipAddressOption" value="ip" data-bind="enable: obtainUsingDhcp() === 'staticIP', checked: $parent.allIpType" >
                                
                                        <label for="ipAddressRadio">                         
                                                <fmt:message key="deployment.serveridentification.ipaddress" />
                                        </label>
                                    </u>
                                </span>                      
                                <span class="value">
                                    <label class="visuallyhidden" for="ipInput">
                                        <u>
                                            <fmt:message key="deployment.serveridentification.ipaddress" />
                                        </u>
                                    </label>
                                    <input id="ipInput" type="text" data-bind="enable: obtainUsingDhcp() === 'staticIP' && ipType() === 'ip',  value: $parent.allIpAddress,
                                                                        attr:{required: obtainUsingDhcp() === 'staticIP' && ipType() === 'ip'}"/>
                                </span>
                            </li>-->
                        </ul>
                    </li>
                    <!-- Removed for BETA -->
                    <!--<li>
                        <input type="checkbox" class="value" id="maintMode" name="networking"
                               data-bind="checked: $parent.allMaintenanceMode"  />
                        <label for="maintMode">
                            <u>
                                <fmt:message key="deployment.serveridentification.maintainancemode" />
                            </u>
                        </label>
                    </li>-->
                    <!-- Removed for BETA -->
                    <!--<li>
                        <input type="checkbox" class="value" id="applyToAll" data-bind="checked: DellClarity.SCVMM.ViewModel.Deployment.ServerID.applyAllNetSettings" />
                        <label for="applyToAll">
                            <u>
                                <fmt:message key="deployment.serveridentification.applysettingstoallservers" />
                            </u>
                        </label>
                    </li>-->

                </ul>
            </fieldset>
        <!-- /ko -->
    </form>
</section>
