<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_deployment_summary" data-bind="with: DellClarity.SCVMM.ViewModel.Deployment.Summary">
    <section id="error_deploymentWizard" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <header>
        <h1><fmt:message key="deployment.summary.title" /></h1>
    </header>

    <p>
        <fmt:message key="deployment.summary.help" />
    </p>
    
    <p><strong><fmt:message key="deployment.summary.jobname" /></strong></p>
    <span data-bind="text: DellClarity.SCVMM.ViewModel.Deployment.ScheduleDeployment.deployJobName"></span>
    
    <p><strong><fmt:message key="deployment.summary.unassignedServers" /></strong></p>
  
    <table class="dataTable">
        <thead>
            <tr>
                <th scope="col"><strong><fmt:message key="deployment.summary.hostName" /></strong></th>
                <th scope="col"><strong><fmt:message key="deployment.summary.serviceTag" /></strong></th>
            </tr>
        </thead>
        <!-- ko with: DellClarity.SCVMM.ViewModel.Deployment.SelectServers.selectedItems -->
        <tbody data-bind="foreach: $data">
            <tr>
                <td>
                    <span data-bind="text: hostName"></span>
                </td>
                <td>
                    <span data-bind="text: serviceTag"></span>
                </td>
            </tr>
        </tbody>
        <!-- /ko -->
    </table>

    <p><strong><fmt:message key="deployment.summary.deployTemp" /></strong></p>
    <span data-bind="text: summaryDeploymentTemplateName"></span>
    
    <p><strong><fmt:message key="deployment.summary.hardwareProf" /></strong></p>
    <span data-bind="text: summaryHardwareProfileName"></span>
    
    <p><strong><fmt:message key="deployment.summary.hyperVisorProf" /></strong></p>
    <span data-bind="text: summaryHyperVisorProfileName"></span>

    <p><strong><fmt:message key="deployment.summary.updatesource" /></strong></p>
    <span data-bind="text: summaryUpdateSourceName"></span>
    
    <!-- Not supported in BETA, please don't delete -->
    <!--<p><strong>Deployment Scheduled on: </strong></p>
    <time data-bind="time: DellClarity.SCVMM.ViewModel.Deployment.ScheduleDeployment.isoScheduledDateTime, timeFormat: 'LLL'"></time>-->
</section>
