<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_discovery_discoverAction" data-bind="with: DellClarity.SCVMM.ViewModel.Discovery.Discover">
    <section id="error_discover" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" ></section>
    <form id="discoverForm" autocomplete="off">
        <!-- ko with: model -->

        <!--ko if: DellClarity.Config.consoleType != 'scom' -->
        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'serverview'">
            <fmt:message key="discovery.discoveraction.help" />
        </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'chassisview'">
            <fmt:message key="discovery.discoveraction.chassishelp" />
        </p>
        <!-- /ko -->

        <!--ko if: DellClarity.Config.consoleType == 'scom' -->
        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'serverview'">
            <fmt:message key="discovery.discoveraction.help.scom" />
        </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'chassisview'">
            <fmt:message key="discovery.discoveraction.chassishelp.scom" />
        </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'chassisview'">
            <strong><fmt:message key="discovery.discoveraction.chassishelpnote.scom" /></strong>
        </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'networkswitchview'">
            <fmt:message key="discovery.discoveraction.networkswitchhelp.scom" />
        </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'networkswitchview'">
            <strong><fmt:message key="discovery.discoveraction.networkswitchhelpnote.scom" /></strong>
        </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'me4storageview'">
            <fmt:message key="discovery.discoveraction.me4storagehelp.scom" />
        </p>
        <!-- /ko -->
        
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="discovery.discoveraction.title" />
            </legend>
            <!--BETA. Commented out for the BETA
            <ul class="labelValuePairs">
                <li>
                    <input type="radio" id="discoveryUsingIpRange" name="discoveryType" class="value" value="ipDiscover" data-bind="checked: discoveryType" />
                    <label for="discoveryUsingIpRange">
                        <u>
                            <fmt:message key="discovery.discoveraction.discoveryusingiprange" />
                        </u>
                    </label>
                </li>
                
                <li>
                    <input type="radio" id="autoDiscoveryOption" name="discoveryType" class="value" value="csvDiscover" data-bind="checked: discoveryType" />
                    <label for="autoDiscoveryOption">
                        <u>
                            <fmt:message key="discovery.discoveraction.autodiscoveryoption" />
                        </u>
                    </label>
                </li>
                
                <li>
                    <input type="radio" id="discoverByImportingFromScvmm" name="discoveryType" class="value" value="scvmmImportDiscover" data-bind="checked: discoveryType" />
                    <label for="discoverByImportingFromScvmm">
                        <u>
                            <fmt:message key="discovery.discoveraction.discoverbyimportingfromscvmm" />
                        </u>
                    </label>
                </li>
                -->
            </ul>
        </fieldset>
        <fieldset data-bind="enable: discoveryType() == 'ipDiscover', visible: discoveryType() == 'ipDiscover'">
            <legend>
                <fmt:message key="discovery.discoveraction.discoveryusingiprange" />
            </legend>
            
            <ul class="labelValuePairs">
                <li>
                    <input type="radio" id="usingIpAddress" name="usingIpAddress" class="value" value="ipAddress" data-bind="checked: discoverUsingIpType" />
                    <label for="usingIpAddress">
                        <u>
                            <fmt:message key="discovery.discoveraction.discoverusingipaddress" />
                        </u>
                    </label>
                </li>
              <li>
                <input type="radio" id="usingIpRange" name="usingIpRange" class="value" value="ipRange" data-bind="checked: discoverUsingIpType" />
                <label for="usingIpRange">
                  <u>
                    <fmt:message key="discovery.discoveraction.discoverusingiprange" />
                  </u>
                </label>
              </li>
              <li class="applyCredProfileForm">
                <span class="label">
                    <u>
                        <fmt:message key="discovery.discoveraction.applythiscredentialprofile" />
                    </u>
                </span>
                <span class="value">
                  <label for="credentialProfileIpDiscover" class="visuallyhidden">
                    <u data-bind="visible: DellClarity.SCVMM.fromPage != 'chassisview'">
                      <fmt:message key="discovery.discoveraction.applythiscredentialprofile" />
                    </u>
                    <u data-bind="visible: DellClarity.SCVMM.fromPage == 'chassisview'">
                      <fmt:message key="discovery.discoveraction.applythiscredentialprofilechassis" />
                    </u>
                  </label>
                    <select id="credentialProfileIpDiscover" data-bind="value: DellClarity.SCVMM.ViewModel.Discovery.Discover.ipRangeCredentialProfile,
                        options: DellClarity.SCVMM.ViewModel.Discovery.Discover.credentialProfiles, 
                        optionsValue: 'id', 
                        optionsText: 'name', 
                        attr:{required: discoveryType() === 'ipDiscover'}, 
                        optionsCaption: '<fmt:message key="discovery.discoveraction.selectcredentialprofile" />'">
                    </select>
                    <a href="#/credentialProfile.details" id="createCredProfile">
                        <fmt:message key="deployment.deployment.createnew" />
                    </a>
                </span>
              </li>
            </ul>
          <fieldset data-bind="enable: discoverUsingIpType() == 'ipAddress', visible: discoverUsingIpType() == 'ipAddress'">
                <legend class="visuallyhidden">
                    <fmt:message key="discovery.discoveraction.discoverusingipaddress" />
                </legend>
                <ul class="labelValuePairs">
                    <!--<li>
                        <input type="checkbox" id="useIpv6AddressIpAddress" class="value" value="useIPv6AddressIpAddress" data-bind="checked: useIPv6AddressIpAddress" />
                        <label for="useIpv6AddressIpAddress">
                            <u>
                                <fmt:message key="discovery.discoveraction.useipv6address" />
                            </u>
                        </label>
                    </li>-->
                    <li>
                        
                        <!-- ko if: useIPv6AddressIpAddress() === false -->
                        <label for="ipAddress">
                            <u data-bind="visible: DellClarity.SCVMM.fromPage === 'serverview'">
                                <fmt:message key="discovery.discoveraction.ipaddress" />
                            </u>
                            <u data-bind="visible: DellClarity.SCVMM.fromPage === 'chassisview'">
                                <fmt:message key="discovery.discoveraction.ipaddresschassis" />
                            </u>
                            <u data-bind="visible: DellClarity.SCVMM.fromPage === 'networkswitchview'">
                              <fmt:message key="discovery.discoveraction.ipaddressnetworkswitch" />
                            </u>
                            <u data-bind="visible: DellClarity.SCVMM.fromPage === 'me4storageview'">
                              <fmt:message key="discovery.discoveraction.ipaddressme4storage" />
                            </u>
                        </label>
                        <input id="ipAddress" type="text" value="" class="value" placeholder="192.168.1.10" data-bind="value: ipAddress, pattern: 'ipv4'" 
                            title="<fmt:message key="discovery.discoveraction.IPErrorMessage"/>" required />
                        <!-- /ko -->

                        <!-- ko if: useIPv6AddressIpAddress() === true --> 
                        <label for="ipAddressv6">
                            <u>
                                <fmt:message key="discovery.discoveraction.ipaddress" />
                            </u>
                        </label>
                        <input id="ipAddressv6" type="text" value="" class="value" placeholder="2001:0DB8:AC10:FE01::" data-bind="value: ipAddress, pattern: 'ipv6'"  required />
                        <!-- /ko -->                     
                    </li>
                </ul>
            </fieldset>

            <fieldset data-bind="enable: discoverUsingIpType() == 'ipRange', visible: discoverUsingIpType() == 'ipRange'">
                <legend class="visuallyhidden">
                    <fmt:message key="discovery.discoveraction.discoverusingiprange" />
                </legend>
                <ul class="labelValuePairs">
                    <!--<li>
                        <input type="checkbox" id="useIpv6Address" class="value" value="useIPv6Address" data-bind="checked: useIPv6Address" />
                        <label for="useIpv6Address">
                            <u>
                                <fmt:message key="discovery.discoveraction.useipv6address" />
                            </u>
                        </label>
                    </li>-->
                    <li>
                        <label for="ipAddressStartRange">
                            <u>
                                <fmt:message key="discovery.discoveraction.ipaddressstartrange" />
                            </u>
                        </label>
                        <input id="ipAddressStartRange" type="text" value="" class="value" data-bind="value: ipStartRange, pattern: 'ipv4'" 
                            title="<fmt:message key="discovery.discoveraction.lowerIPErrorMessage"/>" placeholder="192.168.1.10" required/>
                    </li>
                    <li>
                        <label for="ipAddressEndRange">
                            <u>
                                <fmt:message key="discovery.discoveraction.ipaddressendrange" />
                            </u>
                        </label>
                        <input id="ipAddressEndRange" type="text" value="" class="value"  data-bind="value: ipEndRange, pattern: 'ipv4'" 
                            title="<fmt:message key="discovery.discoveraction.upperIPErrorMessage"/>" placeholder="192.168.1.255" required/>
                    </li>
                    <li>
                        <input type="checkbox" class="value" id="enableExcludeRange" value="enableExcludeRange" data-bind="checked: enableExcludeRange" />
                        <label for="enableExcludeRange">
                            <u>
                                <fmt:message key="discovery.discoveraction.enableexcluderange" />
                            </u>
                        </label>
                        <ul class="labelValuePairs">
                            <li>
                                <label for="excludeIpAddressStartRange">
                                    <u>
                                        <fmt:message key="discovery.discoveraction.ipaddressstartrange" />
                                    </u>
                                </label>
                                <input id="excludeIpAddressStartRange" type="text" value="" class="value"  data-bind="value: ipStartExcludeRange, pattern: 'ipv4', attr: {required : enableExcludeRange(), disabled: !enableExcludeRange()}" 
                                    title='<fmt:message key="discovery.discoveraction.excluderangestartiphelp" />' placeholder="192.168.1.30"/>
                            </li>
                            <li>
                                <label for="excludeIpAddressEndRange">
                                    <u>
                                        <fmt:message key="discovery.discoveraction.ipaddressendrange" />
                                    </u>
                                </label>
                                <input id="excludeIpAddressEndRange" type="text" value="" class="value"  data-bind="value: ipEndExcludeRange, pattern: 'ipv4', attr: {required : enableExcludeRange(), disabled: !enableExcludeRange()}" 
                                    title='<fmt:message key="discovery.discoveraction.excluderangeendiphelp" />' placeholder="192.168.1.40"/>
                            </li>
                        </ul>
                    </li>
                </ul>
            </fieldset>
        </fieldset>

        <!--ko if: DellClarity.Config.consoleType != 'scom' -->
        <fieldset data-bind="enable: discoveryType() == 'ipDiscover', visible: discoveryType() == 'ipDiscover' && DellClarity.SCVMM.fromPage == 'chassisview'">
	        <legend>
		        <fmt:message key="discovery.discoveraction.chassisdiscovery" />
	        </legend>
	
	        <ul class="labelValuePairs">
	            <li>
		          <input type="radio" id="deepDiscovery" name="deepDiscovery" class="value" value="deep" data-bind="checked: chassisDiscoveryType" />
		          <label for="deepDiscovery">
		            <u>
			          <fmt:message key="discovery.discoveraction.deepdiscovery" />
		            </u>
		          </label>
	            </li>
                <li>
			        <input type="radio" id="shallowDiscovery" name="shallowDiscovery" class="value" value="shallow" data-bind="checked: chassisDiscoveryType" />
			        <label for="shallowDiscovery">
				        <u>
					        <fmt:message key="discovery.discoveraction.shallowdiscovery" />
				        </u>
			        </label>
		        </li>
	        </ul>
        </fieldset>
        <!-- /ko -->

        <!-- BETA: THis section has been commented out for BETA 1.0 and will be re-introduced in later versions -->
        <!--<fieldset data-bind="enable: discoveryType() == 'csvDiscover', visible: discoveryType() == 'csvDiscover'">
            <legend>
                <fmt:message key="discovery.discoveraction.autodiscovery" />
            </legend>
            <p>
                <fmt:message key="discovery.discoveraction.autodiscoveryhelp" />
            </p>
            <ul class="labelValuePairs">
              <li>
                <label for="csvFilePath">
                  <u>
                    <fmt:message key="discovery.discoveraction.csvfilepath" />
                  </u>
                </label>
                <input id="csvFilePath" type="text" class="value" data-bind="value: csvFilePath" required>
                <ul class="labelValuePairs">
                  <li>
                    <label for="catalogPathUsername">
                      <u>
                        <fmt:message key="discovery.discoveraction.sharepathusername" />
                      </u>
                    </label>
                    <input id="catalogPathUsername" type="text" value=""  class="value" data-bind="value: sharePathUsername" required>
                  </li>
                  <li>
                    <label for="sharePathPassword">
                      <u>
                        <fmt:message key="discovery.discoveraction.sharepathpassword" />
                      </u>
                    </label>
                    <input id="sharePathPassword" type="password" value=""  class="value" data-bind="value: sharePathPassword" required>
                  </li>
                </ul>
              </li>
              <li class="applyCredProfileForm">
                <span class="label">
                    <u>
                        <fmt:message key="discovery.discoveraction.applythiscredentialprofile" />
                    </u>
                </span>
                <span class="value">
                  <label for="credentialProfileCsvDiscover" class="visuallyhidden">
                    <u>
                      <fmt:message key="discovery.discoveraction.applythiscredentialprofile" />
                    </u>
                  </label>
                    <select id="credentialProfileCsvDiscover" data-bind="value: DellClarity.SCVMM.ViewModel.Discovery.Discover.csvCredentialProfile, options: DellClarity.SCVMM.ViewModel.Discovery.Discover.credentialProfiles, optionsText: 'name',
                      optionsValue: 'id', attr:{required: discoveryType() === 'csvDiscover'},  optionsCaption: '<fmt:message key="discovery.discoveraction.selectcredentialprofile" />'">
                    <option value="">
                      <fmt:message key="discovery.discoveraction.credentialprofile" />
                    </option>
                  </select>
                </span>
              </li>
            </ul>
        </fieldset>-->
        <fieldset id="importAllFieldset" data-bind="enable: discoveryType() === 'scvmmImportDiscover', visible: discoveryType() === 'scvmmImportDiscover'">
            <legend>
                <fmt:message key="discovery.discoveraction.discoverbyimportingfromscvmm" />
            </legend>
            <p>
                <fmt:message key="discovery.discoveraction.discoverbyimportingfromscvmmhelp" />
            </p>
            <ul class="labelValuePairs">
                <li>
                    <span class="label">
                        <u>
                            <input type="checkbox" class="value" id="applyThisCredentialProfile" value="applyCredentials" data-bind="checked: DellClarity.SCVMM.ViewModel.Discovery.Discover.applyCredentials" />
                            <label for="applyThisCredentialProfile">
                                <fmt:message key="discovery.discoveraction.applythiscredentialprofile" />
                            </label>
                        </u></span>
                    <span class="value">
                        <label for="credentialProfile" class="visuallyhidden">
                            <u>
                                <fmt:message key="discovery.discoveraction.applythiscredentialprofile" />
                            </u>
                        </label>
                        <select id="credentialProfile" data-bind="value: DellClarity.SCVMM.ViewModel.Discovery.Discover.importCredentialProfile, options: DellClarity.SCVMM.ViewModel.Discovery.Discover.credentialProfiles, optionsText: 'name', 
                    enable: DellClarity.SCVMM.ViewModel.Discovery.Discover.applyCredentials() == true, optionsCaption: '<fmt:message key="discovery.discoveraction.selectcredentialprofile" />', attr: {required: DellClarity.SCVMM.ViewModel.Discovery.Discover.applyCredentials() === true}">
                            <option value="">
                                <fmt:message key="discovery.discoveraction.credentialprofile" />
                            </option>
                        </select>
                    </span>
                </li>
            </ul>
            <!-- /ko -->
        </fieldset>
        <fieldset id="importIndividualServersFieldSet" data-bind="enable: discoveryType() == 'scvmmImportDiscover', visible: discoveryType() == 'scvmmImportDiscover'">
            <legend class="visuallyhidden">
                <fmt:message key="discovery.discoveraction.title" />
            </legend>

            <table id="discoverTable" class="dataTable" data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.Discovery.Discover.applyCredentials() === true">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input id="cbSelectionAllRowsDiscover" type="checkbox" />
                            <label for="cbSelectionAllRowsDiscover" class="visuallyhidden">
                                <u>
                                    <fmt:message key="discovery.discoveraction.selectrow" />
                                </u>
                            </label>
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.discoveraction.hostname" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.discoveraction.idracip" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.discoveraction.credentialprofile" />
                        </th>
                    </tr>
                </thead>
                
                <!-- ko with: DellClarity.SCVMM.ViewModel.Discovery.Discover.table() -->
                    <!-- ko if: !data || data().length == 0 -->
                        <tbody>
                            <tr>
                                <td colspan="4">
                                    <fmt:message key="scrollabletable.empty" />
                                </td>
                            </tr>
                        </tbody>
                    <!-- /ko -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input type="checkbox" id="server" name="server" data-bind="checked: checked, indexedid: 'server'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server'">
                                    <u>
                                        <fmt:message key="discovery.discoveraction.selectrow" />
                                    </u>
                                </label>
                            </td>
                            <td>
                                <span data-bind="text: hostName"></span>
                            </td>
                            <td>
                                <span data-bind="text: iDracIp"></span>
                            </td>
                            <td>
                                <label class="visuallyhidden" data-bind="indexedfor: 'credential'">
                                    <u>
                                        <fmt:message key="discovery.discoveraction.credentialprofile" />
                                    </u>
                                </label>
                                <select id="credentialprofileTable" class="value" data-bind="indexedid: 'credential', value: credentialProfileId, options: DellClarity.SCVMM.ViewModel.Discovery.Discover.credentialProfiles, optionsValue: 'id', optionsText: 'name', 
                                                                                            attr: {required: $data.checked() === true}, optionsCaption: '<fmt:message key="discovery.discoveraction.selectcredentialprofile" />' ">
                                    <option value="">
                                        <fmt:message key="discovery.discoveraction.credentialprofile" />
                                    </option>
                                </select>
                            </td>
                        </tr>
                    </tbody>
                <!-- /ko -->
            </table>
        </fieldset>
        <fieldset id="jobOptions">
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <p>
                <fmt:message key="scvmm.joboptions.description" />
            </p>

            <ul class="labelValuePairs">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="discovery.discoveraction.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: jobName" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="discovery.discoveraction.hint" />' />
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="discovery.discoveraction.gotothejoblist" />
                        </u>
                    </label>
                </li>
                <!-- Out of scope for the BETA, please don't delete -->
                <!--<li>
                    <span class="label">
                        <u>
                            <input id="addDiscoveredServersToTheGroupCheckbox" type="checkbox" value="addServersToGroup" data-bind="checked: addServersToGroup" />
                            <label for="addDiscoveredServersToTheGroupCheckbox">
                                <fmt:message key="discovery.discoveraction.adddiscoveredserverstothegroup" />
                            </label>
                        </u>
                    </span>
                    <span class="value">
                        <label for="addDiscoveredServersToTheGroup" class="visuallyhidden">
                            <u>
                                <fmt:message key="discovery.discoveraction.adddiscoveredserverstothegroup" />
                            </u>
                        </label>
                        <select id="addDiscoveredServersToTheGroup" data-bind="value: group, options: serverGroups, optionsText: 'name', enable: addServersToGroup, optionsCaption: '<fmt:message key="discovery.discoveraction.selectservergroup" />'">
                            <option>
                                <fmt:message key="discovery.serversgroup.selectagroup" />
                            </option>
                        </select>
                        <a href="#/discovery.createServerGroup">
                            <fmt:message key="discovery.serversgroup.createnew" />
                        </a>
                    </span>
                </li>-->
            </ul>
        </fieldset>
        <!-- /ko -->
        <div class="sectionEditButtons">
            <button id="discoveryFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="discovery.discoveraction.finish" />
            </button>
            <button id="discoverCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="discovery.discoveraction.cancel" />
            </button>
        </div>

    </form>
</section>
