<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_discovery_fixCompliance" data-bind="with: DellClarity.SCVMM.ViewModel.Discovery.FixCompliance">
    <form>
        <p>
            <fmt:message key="discovery.fixcompliance.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="discovery.fixcompliance.title" />
            </legend>
            <!-- ko with: table -->
            <table id="fixComplianceTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input id="chkAllRowsfixCompliance" type="checkbox" />
                            <label for="chkAllRowsfixCompliance" class="visuallyhidden">
                                <u>
                                    <fmt:message key="discovery.fixcompliance.selectrow" />
                                </u>
                            </label>
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.servicetag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.model" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.idracip" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.bios" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.idrac" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.lc" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.fixcompliance.compliancestatus" />
                        </th>
                    </tr>
                </thead>
                <!-- ko if: !data || data().length == 0 -->
                <tbody>
                    <tr>
                        <td colspan="8">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr>
                        <td class="checkboxColumn">
                            <input type="checkbox" id="server" name="server" data-bind="checked: checked, indexedid: 'server'" />
                            <label class="visuallyhidden" data-bind="indexedfor: 'server'">
                                <u>
                                    <fmt:message key="discovery.fixcompliance.selectrow" />
                                </u>
                            </label>
                        </td>
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="text: model"></span>
                        </td>
                        <td>
                            <span data-bind="text: iDracIp"></span>
                        </td>
                        <td>
                            <span data-bind="text: bios"></span>
                        </td>
                        <td>
                            <span data-bind="text: iDrac"></span>
                        </td>
                        <td>
                            <span data-bind="text: lc"></span>
                        </td>
                        <td>
                            <span data-bind="text: complianceStatus, visible: !applyingCompliant()"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </fieldset>
        <div class="sectionEditButtons">
            <button id="fixComplianceFinish" type="submit">
                <fmt:message key="discovery.fixcompliance.finish" />
            </button>
            <button id="fixComplianceCancel" type="button">
                <fmt:message key="discovery.fixcompliance.cancel" />
            </button>
        </div>
    </form>
</section>

