<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_discovery_home" data-bind="with: DellClarity.SCVMM.ViewModel.Discovery.Home">
    <section id="error_discovery" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <header>
        <h1>
            <fmt:message key="discovery.home.title" />
        </h1>
    </header>
    <form>
        <p>
            <fmt:message key="discovery.home.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="discovery.home.title" />
            </legend>
            <nav>
                <ul class="inlineList">
                    <li>
                        <a id="linkDiscoverForm" data-bind="styledDisabled: disableLink()" href="#/discovery.discover" class="dialogLink">
                            <fmt:message key="discovery.home.discover" />
                        </a>
                    </li>
                    <li>
                        <a id="linkRefresh">
                            <fmt:message key="discovery.home.refresh" />
                        </a>
                    </li>
                    <!-- removed for this Sprint -->
                    <!--<li>
                        <a id="linkFixComplianceForm" href="#/discovery.fixCompliance" tabindex="3" class="dialogLink">
                            <fmt:message key="discovery.home.fixcompliance" />
                        </a>
                    </li>-->
                    <!-- BETA. Commented out for the BETA.
                    <li>
                        <a id="groupServers" href="#/discovery.serversGroup" class="dialogLink">
                            <fmt:message key="discovery.home.groupservers" />
                        </a>
                    </li>
                    -->
                    <!--<li>
                        <a id="serverWhiteList" href="#/whiteList.settings" tabindex="5">
                            <fmt:message key="discovery.home.serverwhitelist" />
                        </a>
                    </li>-->
                    <li>
                        <a id="remove" data-bind="styledDisabled: (selectedHosts().length === 0 && activeTab() === 'hosts') || (selectedServers().length == 0 && activeTab() === 'servers')">
                            <fmt:message key="discovery.home.delete" />
                        </a>
                    </li>
                    <li>
                        <a id="sync">
                            <fmt:message key="discovery.home.sync" />
                        </a>
                    </li>
                    <li>
                        <a id="resolveSyncErrors" data-bind="styledDisabled: disableLink()">
                            <fmt:message key="discovery.home.resolvesyncerrors" />
                        </a>
                    </li>
                </ul>
            </nav>

            <nav id="tabMenu" class="menu tabs" role="navigation">
                <ul>
                    <li>
                        <a href="#/discovery.home">
                            <fmt:message key="discovery.home.baremetalservers" />
                        </a>
                    </li>
                    <li>
                        <a href="#/discovery.home/hosts">
                            <fmt:message key="discovery.home.hosts" />
                        </a>
                    </li>
                </ul>
            </nav>

            <section class="tabPanel" data-bind="visible: activeTab() == 'servers'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="discovery.home.title" />
                    </h1>
                </header>
                <!-- ko with: bareMetalServerTable -->
                <table id="baremetalServerTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRows" type="checkbox" />
                                <label for="cbSelectionAllRows" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.idracip" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.servicetag" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.chassisServiceTag" />
                                </strong>
                            </th>
                            <!-- BETA. Commented out for the BETA.
                            <th scope="col">
                                <strong><fmt:message key="discovery.home.groupName" /></strong>
                            </th>
                            -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.model" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.generation" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.compliancestatus" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.idracver" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.lcver" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.driverpackver" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.bios" />
                                </strong>
                            </th>
                            
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.cpu" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.memory" />
                                </strong>
                            </th>
                            <!-- <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.licensestatus" />
                                </strong>
                            </th> -->
                            
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td>
                            <td>
                                <a data-bind="if: iDracIpLink(), href: iDracIpLink, text: iDracIpLink" target="_blank"></a>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: chassisServiceTag"></span>
                            </td>
                            <!-- BETA. Commented out for the BETA.
                                <td>
                                    <span data-bind="text: groupName"></span>
                                </td>
                                -->
                            <td>
                                <span data-bind="text: model"></span>
                            </td>
                            <td>
                                <span data-bind="html: generation"></span>
                            </td>
                            <td>
                                <span data-bind="text: complianceStatus"></span>
                            </td>
                            <td>
                                <span data-bind="text: iDracVer"></span>
                            </td>
                            <td>
                                <span data-bind="text: lcVer"></span>
                            </td>
                            <td>
                                <span data-bind="text: driverPackVer"></span>
                            </td>
                            <td>
                                <span data-bind="text: bios"></span>
                            </td>
                            
                            <td>
                                <span data-bind="text: cpu"></span>
                            </td>
                            <td>
                                <span data-bind="text: memory"></span>
                            </td>
                            <!-- <td>
                                <span data-bind="text: licenseStatus"></span>
                            </td> -->
                            
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <tfoot>
                        <tr>
                            <td colspan="12">
                                <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- /ko -->
            </section>

            <section class="tabPanel" data-bind="visible: activeTab() == 'hosts'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="discovery.home.title" />
                    </h1>
                </header>
                <!-- ko with: hostTable -->
                <table id="hostTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input id="cbSelectionAllRowsHostTable" type="checkbox" />
                                <label for="cbSelectionAllRowsHostTable" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.hostname" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="discovery.home.clusterFQDN" /></strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.idracip" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.servicetag" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.chassisServiceTag" />
                                </strong>
                            </th>
                            <!-- BETA. Commented out for the BETA.
                            <th scope="col">
                                <strong><fmt:message key="discovery.home.groupName" /></strong>
                            </th>
                            -->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.model" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.generation" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="discovery.home.compliancestatus" /></strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.idracver" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.lcver" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.bios" />
                                </strong>
                            </th>

                            <!-- Out of Scope for BETA -->
                            <!--<th scope="col">
                                <strong><fmt:message key="discovery.home.servertype" /></strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="discovery.home.compliancestatus" /></strong>
                            </th>-->
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.cpu" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.home.memory" />
                                </strong>
                            </th>
                            <!-- <th scope="col">
                                <strong><fmt:message key="discovery.home.licensestatus" /></strong>
                            </th> -->
                            
                            
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="8">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="8">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input name="hosts" type="checkbox" data-bind="checked: checked, indexedid: 'hosts_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'hosts_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td>
                            <td>
                                <span data-bind="text: hostName"></span>
                            </td>
                            <td>
                                <span data-bind="text: clusterFQDN"></span>
                            </td>
                            <td>
                                <a data-bind="if: iDracIpLink(), href: iDracIpLink, text: iDracIpLink" target="_blank"></a>
                            </td>
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <td>
                                <span data-bind="text: chassisServiceTag"></span>
                            </td>
                            <!-- BETA. Commented out for the BETA.
                                <td>
                                    <span data-bind="text: groupName"></span>
                                </td>
                                -->
                            <td>
                                <span data-bind="text: model"></span>
                            </td>
                            <td>
                                <span data-bind="html: generation"></span>
                            </td>
                            <td>
                                <span data-bind="text: complianceStatus"></span>
                            </td>
                            <td>
                                <span data-bind="text: iDracVer"></span>
                            </td>
                            <td>
                                <span data-bind="text: lcVer"></span>
                            </td>
                            <td>
                                <span data-bind="text: bios"></span>
                            </td>
                            
                            
                            <!-- Out of Scope for BETA
                                <td>
                                    <span data-bind="text: serverType"></span>
                                </td>
                                <td>
                                    <span data-bind="text: complianceStatus"></span>
                                </td>-->
                            <td>
                                <span data-bind="text: cpu"></span>
                            </td>
                            <td>
                                <span data-bind="text: memory"></span>
                            </td>
                            <!-- <td>
                                <span data-bind="text: licenseStatus"></span>
                            </td> -->
                            
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <tfoot>
                        <tr>
                            <td colspan="8">
                                <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                                <!-- /ko -->
                            </td>
                        </tr>
                    </tfoot>
                </table>
                <!-- /ko -->
            </section>
        </fieldset>
    </form>
</section>
