<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_discovery_resolvesyncerrors_template" data-bind="with: DellClarity.SCVMM.ViewModel.Discovery.ResolveSyncErrors">
    <section id="error_discovery_resolvesyncerrors" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <header>
        <h1 data-bind="visible: DellClarity.SCVMM.fromPage === 'serverview'">
            <fmt:message key="resolvesyncerrors.selectservers" />
        </h1>

        <h1 data-bind="visible: DellClarity.SCVMM.fromPage === 'chassisview'">
            <fmt:message key="resolvesyncerrors.selectmodularsystems" />
        </h1>

        <h1 data-bind="visible: DellClarity.SCVMM.fromPage === 'networkswitchview'">
            <fmt:message key="resolvesyncerrors.selectnetworkswitches" />
        </h1>
    </header>

    <form id="resolveSyncErrorsForm" autocomplete="off">

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'serverview'"> <fmt:message key="discovery.home.resolvesynchelp" /> </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'chassisview'"> <fmt:message key="discovery.home.resolvesyncchassisviewhelp" /> </p>

        <p data-bind="visible: DellClarity.SCVMM.fromPage === 'networkswitchview'"> <fmt:message key="discovery.home.resolvesyncnetworkswitchviewhelp" /> </p>

    <section id="resolveSyncErrors">
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="resolvesyncerrors.title" />
            </legend>
            <!-- ko with: resolveSyncTable -->
            <span id="selectServerCheck1_validationMessage" class="validationMessage forTable" style="display: none" />
                <table id="resolveSyncTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input type="checkbox" id="selectServerCheck1" />
                                <label for="selectServerCheck1" class="visuallyhidden">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.resolvesynerrors.serveridentifier" />
                                </strong>
                            </th>
                            <th scope="col">
                                <strong>
                                    <fmt:message key="discovery.resolvesynerrors.hostname" />
                                </strong>
                            </th>
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="12">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr>
                            <td class="checkboxColumn">
                                <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'server_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'server_'">
                                    <u>
                                        <fmt:message key="discovery.home.compliancechoices" />
                                    </u>
                                </label>
                            </td>
                            <td>
                                <span data-bind="text: serverIdentifier"></span>
                            </td>
                            <td>
                                <span data-bind="text: hostName"></span>
                            </td>
                            
                        </tr>
                    </tbody>
                    <!-- /ko -->
                </table>
                <!-- /ko -->
            </fieldset>
    </section>
        
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="resolvesyncerrors.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                <span class="label">
                    <u>
                        <fmt:message key="discovery.resolvesyncerrors.applythiscredentialprofile" />
                    </u>
                </span>
                <span class="value">
                  <label for="credentialProfileResolveSync" class="visuallyhidden">
                    <u>
                      <fmt:message key="discovery.resolvesyncerrors.applythiscredentialprofile" />
                    </u>
                  </label>
                    <select id="credentialProfileResolveSync" required data-bind="value: DellClarity.SCVMM.ViewModel.Discovery.ResolveSyncErrors.credentialProfile, options: DellClarity.SCVMM.ViewModel.Discovery.ResolveSyncErrors.credentialProfiles, 
                   optionsValue: 'id', optionsText: 'name', optionsCaption: '<fmt:message key="discovery.resolvesyncerrors.selectcredentialprofile" />'">
                    <option value="">
                      <fmt:message key="discovery.resolvesyncerrors.credentialprofile" />
                    </option>
                </select>
                    <a href="#/credentialProfile.details" id="createCredProfile">
                            <fmt:message key="deployment.deployment.createnew" />
                        </a>
                </span>
              </li>
            </ul>
          </fieldset>
            <!-- ko with: model -->
            <fieldset id="jobOptions">
            <legend>
                <fmt:message key="scvmm.joboptions.title" />
            </legend>

            <p>
                <fmt:message key="scvmm.joboptions.description" />
            </p>

            <ul class="labelValuePairs">
                <li>
                    <label for="jobName">
                        <u>
                            <fmt:message key="discovery.discoveraction.jobname" />
                        </u>
                    </label>
                    <input id="jobName" type="text" value=""  class="value" data-bind="value: jobName" required maxlength="50" pattern="^.{1,50}$" title='<fmt:message key="discovery.discoveraction.hint" />' />
                </li>
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="discovery.discoveraction.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>
            <!-- /ko -->

        <div class="sectionEditButtons">
            <button id="resolveSyncErrorsFinish" class="cux-button cux-button-large cux-button-primary"  type="submit">
                <fmt:message key="discovery.resolvesyncerrors.finish" />
            </button>
            <button id="resolveSyncErrorsCancel" class="cux-button cux-button-large cux-button-danger"  type="button">
                <fmt:message key="discovery.resolvesyncerrors.cancel" />
            </button>
        </div>
    </form>

</section>
