<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_serversGroup_template" data-bind="with: DellClarity.SCVMM.ViewModel.Discovery.ServersGroup">
    <section id="error_serverGroup" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <form>
        <p>
            <fmt:message key="discovery.serversgroup.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="discovery.serversgroup.help" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="groupNameSelect">
                        <u>
                            <fmt:message key="discovery.serversgroup.servergroupname" />
                        </u>
                    </label>
                    <span class="value">
                        <select id="groupNameSelect" data-bind="value: group, options: serverGroups, optionsValue: 'name', optionsText: 'name', optionsCaption: '<fmt:message key="discovery.serversgroup.selectservergroup" />'">
                            <option value="">
                                <fmt:message key="discovery.serversgroup.selectagroup" />
                            </option>
                        </select>
                        <a id="createServerGroup" href="#/discovery.createServerGroup">
                            <fmt:message key="discovery.serversgroup.createnew" />
                        </a>
                    </span>
                </li>
            </ul>
            <table id="serversTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input id="chkAllRowsServersGroup" type="checkbox" />
                            <label for="chkAllRowsServersGroup" class="visuallyhidden">
                                <u>
                                    <fmt:message key="discovery.serversgroup.servicetag" />
                                </u>
                            </label>
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.serversgroup.servicetag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.serversgroup.model" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.serversgroup.idracip" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.serversgroup.servertype" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.serversgroup.cpu" />
                        </th>
                        <th scope="col">
                            <fmt:message key="discovery.serversgroup.memory" />
                        </th>
                    </tr>
                </thead>
                <!-- ko if: !table() || table().length == 0 -->
                <tbody>
                    <tr>
                        <td colspan="8">
                            <fmt:message key ="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !table() || table().length > 0 -->
                <tbody data-bind="foreach: table">
                    <tr>
                        <td class="checkboxColumn">
                            <input name="servers" id="servers" type="checkbox" data-bind="checked: selected, indexedid: 'server'"  />
                            <label for="servers" class="visuallyhidden" data-bind="indexedfor: 'server'">
                                <u>
                                    <fmt:message key="discovery.serversgroup.servicetag" />
                                </u>
                            </label>
                        </td>
                        <td>
                            <span data-bind="text: serviceTagGroupName"></span>
                        </td>
                        <td>
                            <span data-bind="text: model"></span>
                        </td>
                        <td>
                            <span data-bind="text: iDracIp"></span>
                        </td>
                        <td>
                            <span data-bind="text: serverType"></span>
                        </td>
                        <td>
                            <span data-bind="text: cpu"></span>
                        </td>
                        <td>
                            <span data-bind="text: memory"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
        </fieldset>
        <div class="sectionEditButtons">
            <button id="serversGroupFinish" type="submit">
                <fmt:message key="discovery.serversgroup.finish" />
            </button>
            <button id="serversGroupCancel" type="button">
                <fmt:message key="discovery.serversgroup.cancel" />
            </button>
        </div>
    </form>
</section>
