<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="firmwareInventory" data-bind="with: DellClarity.SCVMM.ViewModel.FirmwareInventory">
    <header>
        <h1>
            <fmt:message key="scvmmHomePage.DellSCVMM" />            
        </h1>
    </header>
    <form>
        <p>
            <fmt:message key="firmwareupdatewizard.updatesystems.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="firmwareupdatewizard.updatesystems.title" />
            </legend>
            <ul class="inlineList">
                <!--<li><a id="runfirmwareWizard" href="#/firmwareUpdate.wizard"><fmt:message key="firmwareInventory.wizardTitle" /></a></li>-->
                <li><a id="firmwareExportToCsv" tabindex="1">
                        <fmt:message key="firmwareupdatewizard.updatesystems.exporttocsv" />
                    </a></li>
                <li><a id="firmwareCopyToClipboard" tabindex="2">
                        <fmt:message key="firmwareupdatewizard.updatesystems.copytoclipboard" />
                    </a></li>
                <li><a id="firmwareRefreshSystems" tabindex="3">
                        <fmt:message key="firmwareupdatewizard.updatesystems.refresh" />
                    </a></li>
            </ul>
            
            <table id="firmwareInventoryServers" class="dataTable">
                <thead>
                    <th scope="col">
                        <strong><fmt:message key="firmwareupdatewizard.updatesystems.servicetag" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="firmwareupdatewizard.updatesystems.idracip" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="firmwareupdatewizard.updatesystems.component" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="firmwareupdatewizard.updatesystems.version" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="firmwareupdatewizard.updatesystems.baseline" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="firmwareupdatewizard.updatesystems.criticality" /></strong>
                    </th>
                </thead>
                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && (!firmwareInventory || firmwareInventory().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && firmwareInventory && firmwareInventory().length > 0 -->
                <tbody data-bind="foreach: firmwareInventory">
                    <tr>
                        <td data-bind="text: serverServiceTag"></td>
                        <td data-bind="text: model"></td>
                        <td data-bind="text: component"></td>
                        <td data-bind="text: version"></td>
                        <td data-bind="text: baseline"></td>
                        <td data-bind="text: criticality"></td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
        </fieldset>
    </form>
</section>
