<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>

<section id="page_firmwareUpdate_updateSystem" data-bind="with: DellClarity.SCVMM.ViewModel.FirmwareUpdate.SelectSystems">
    <section id="error_selectSystems" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <header>
        <h1>
            <fmt:message key="firmwareupdatewizard.updatesystems.title" />
        </h1>
    </header>
    <form>
        <p>
            <fmt:message key="firmwareupdatewizard.updatesystems.help" />
        </p>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="firmwareupdatewizard.updatesystems.title" />
            </legend>
            <ul class="inlineList">
                <li><a id="exportToCsv" tabindex="1">
                        <fmt:message key="firmwareupdatewizard.updatesystems.exporttocsv" />
                    </a></li>
                <li><a id="copyToClipboard" tabindex="2">
                        <fmt:message key="firmwareupdatewizard.updatesystems.copytoclipboard" />
                    </a></li>
                <li><a id="refreshSystems" tabindex="3">
                        <fmt:message key="firmwareupdatewizard.updatesystems.refresh" />
                    </a></li>
            </ul>
            <!-- ko if: !firmwareInventoryData || firmwareInventoryData.length == 0 -->
            <tbody>
                <tr>
                    <td colspan="7">
                        <fmt:message key ="scrollabletable.empty" />
                    </td>
                </tr>
            </tbody>
            <!-- /ko -->
            <!-- ko with: firmwareInventoryData -->
            <table id="firmwareServersTable" class="dataTable">
                <thead>
                    <th scope="col" class="checkboxColumn">
                        <input class="value" type="checkbox" id="sysUpdateSelection" />
                        <label class="visuallyhidden" for="sysUpdateSelection">
                            <u>
                                <fmt:message key="firmwareupdatewizard.updatesystems.systemupdatechoice" />
                            </u>
                        </label>
                    </th>
                    <th scope="col">
                        <fmt:message key="firmwareupdatewizard.updatesystems.servicetag" />
                    </th>
                    <th scope="col">
                        <fmt:message key="firmwareupdatewizard.updatesystems.idracip" />
                    </th>
                    <th scope="col">
                        <fmt:message key="firmwareupdatewizard.updatesystems.component" />
                    </th>
                    <th scope="col">
                        <fmt:message key="firmwareupdatewizard.updatesystems.version" />
                    </th>
                    <th scope="col">
                        <fmt:message key="firmwareupdatewizard.updatesystems.baseline" />
                    </th>
                    <th scope="col">
                        <fmt:message key="firmwareupdatewizard.updatesystems.criticality" />
                    </th>
                </thead>
                <!-- ko if: !data || data().length == 0 -->
                <tbody>
                    <tr>
                        <td colspan="8">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr data-bind="css: {selected: checked}">
                        <td>
                            <input type="checkbox"
                                   data-bind="checked: checked, indexedid: 'selectFirmwareServers'" />
                            <label data-bind="indexedfor: 'selectFirmwareServers'" class="visuallyhidden">
                                <u>
                                    <fmt:message key="deployment.selectprofile.selectserveroption" />
                                </u>
                            </label>
                        </td>
                        <td data-bind="text: serverServiceTag"></td>
                        <td data-bind="text: model"></td>
                        <td data-bind="text: component"></td>
                        <td data-bind="text: version"></td>
                        <td data-bind="text: baseline"></td>
                        <td data-bind="text: criticality"></td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </fieldset>
    </form>
</section>
