<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_hardwareprofile_bootsettings">
    <header>
        <h1>
            <fmt:message key="hardwareprofile.bootsettings.title" />
        </h1>
    </header>
    
    <!-- ko with: DellClarity.SCVMM.ViewModel.HardwareProfile.BootSettings.bootSettingsModel() -->
    <section data-bind="visible: mode() === 'BIOS'">
        <header>
            <h1>
                <a class="toggleSection" data-bind="css: {expand: !isExpanded(), collapse: isExpanded()}, text: isExpanded() ? DellClarity.SCVMM.Translations.genericterms.Collapse : DellClarity.SCVMM.Translations.genericterms.Expand"></a> &nbsp;
                <span><fmt:message key="hardwareprofile.bootsettings.bootorder" /></span>
                <a class="editlink" href="#/hardwareProfile.edit.bootSettings/BIOS" data-bind="visible: isExpanded"><fmt:message key="hardwareprofile.common.edit" /></a>
            </h1>
        </header>

        <div data-bind="visible: isExpanded">
            <ul class="labelValuePairs">
                <li>
                    <label for="biosbootMode"><u><fmt:message key="hardwareprofile.bootsettings.bootmode" /></u></label>
                    <span id="biosbootMode" class="value" data-bind="text: mode"></span>
                </li>
            </ul>
                
            <fieldset>
                <legend><fmt:message key="hardwareprofile.bootsettings.bootdevicesequence" /></legend>
                <table class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.order" />
                            </th>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.name" />
                            </th>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.enabled" />
                            </th>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.type" />
                            </th>
                        </tr>
                    </thead>
                    <tbody data-bind="foreach: biosBootSequence.sequences.sort(function (a, b) { return a.order() - b.order(); })">
                        <tr>
                            <td data-bind="text: order"></td>
                            <td data-bind="text: name"></td>
                            <td data-bind="text: enabled"></td>
                            <td data-bind="text: type"></td>
                        </tr>
                    </tbody>
                </table>
            </fieldset>

            <ul class="labelValuePairs">
                <li>
                    
                    <!-- ko if: retry() === true -->
                    <label for="biosBootsequenceretryEnabled"><u><fmt:message key="hardwareprofile.bootsettings.bootsequenceretry" /></u></label>
                    <span id="biosBootsequenceretryEnabled" class="value" >Enabled</span>
                    <!-- /ko -->
                    <!-- ko if: retry() === false -->
                    <label for="biosBootsequenceretryDisabled"><u><fmt:message key="hardwareprofile.bootsettings.bootsequenceretry" /></u></label>
                    <span id="biosBootsequenceretryDisabled" class="value" >Disabled</span>
                    <!-- /ko -->
                </li>
            </ul>
        </div>
    </section>
    <section data-bind="visible: mode() === 'UEFI'">
        <header>
            <h1>
                <a class="toggleSection" data-bind="css: { expand: !isExpanded(), collapse: isExpanded() }, text: isExpanded() ? DellClarity.SCVMM.Translations.genericterms.Collapse : DellClarity.SCVMM.Translations.genericterms.Expand"></a> &nbsp;
                <span><fmt:message key="hardwareprofile.bootsettings.bootorder" /></span>
                <a class="editlink" href="#/hardwareProfile.edit.bootSettings/UEFI" data-bind="visible: isExpanded"><fmt:message key="hardwareprofile.common.edit" /></a>
            </h1>
        </header>

        <div data-bind="visible: isExpanded">
            <ul class="labelValuePairs">
                <li>
                    <label for="uefiBootMode"><u><fmt:message key="hardwareprofile.bootsettings.bootmode" /></u></label>
                    <span id="uefiBootMode" class="value" data-bind="text: mode"></span>
                </li>
            </ul>
                
            <fieldset>
                <legend><fmt:message key="hardwareprofile.bootsettings.bootdevicesequence" /></legend>
                <table class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.order" />
                            </th>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.name" />
                            </th>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.enabled" />
                            </th>
                            <th scope="col">
                                <fmt:message key="hardwareprofile.bootsettings.type" />
                            </th>
                        </tr>
                    </thead>
                    <tbody data-bind="foreach: uefiBootSequence.sequences.sort(function (a, b) { return a.order() - b.order(); })">
                        <tr>
                            <td data-bind="text: order"></td>
                            <td data-bind="text: name"></td>
                            <td data-bind="text: enabled"></td>
                            <td data-bind="text: type"></td>
                        </tr>
                    </tbody>
                </table>
            </fieldset>

            <ul class="labelValuePairs">
                <li>
                    <!-- ko if: retry() === true -->
                    <label for="uefiBootsequenceretryEnabled"><u><fmt:message key="hardwareprofile.bootsettings.bootsequenceretry" /></u></label>
                    <span id="uefiBootsequenceretryEnabled" class="value" ><fmt:message key="generic.enabled" /></span>
                    <!-- /ko -->
                    <!-- ko if: retry() === false -->
                    <label for="uefiBootsequenceretryDisabled"><u><fmt:message key="hardwareprofile.bootsettings.bootsequenceretry" /></u></label>
                    <span id="uefiBootsequenceretryDisabled" class="value" ><fmt:message key="generic.disabled" /></span>
                    <!-- /ko -->
                </li>
            </ul>
        </div>
    </section>
    <!-- /ko -->   
    
    <!-- ko foreach: DellClarity.SCVMM.ViewModel.HardwareProfile.BootSettings.parentSequences -->
    <!--<section>
        <header>
            <h1>
                <a class="toggleSection" data-bind="css: {expand: !isExpanded(), collapse: isExpanded()}, text: isExpanded() ? DellClarity.SCVMM.Translations.genericterms.Collapse : DellClarity.SCVMM.Translations.genericterms.Expand"></a> &nbsp;
                <span data-bind="text: name"></span>
                <a class="editlink" data-bind="visible: isExpanded, attr: {href: '#/hardwareProfile.edit.sequence/bootSettings/' + order()}"><fmt:message key="hardwareprofile.common.edit" /></a>
            </h1>
        </header>
        
        <table class="dataTable" data-bind="visible: isExpanded">
            <thead>
                <tr>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.order" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.name" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.enabled" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.type" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.id" />
                    </th>
                </tr>
            </thead>
            <tbody data-bind="foreach: sequences.sort(function(a,b){return a.order() - b.order();})">
                <tr>
                    <td data-bind="text: order"></td>
                    <td data-bind="text: name"></td>
                    <td data-bind="text: enabled"></td>
                    <td data-bind="text: type"></td>
                    <td data-bind="text: id"></td>
                </tr>
            </tbody>
        </table>
    </section>-->
    <!-- /ko -->
    
    <!-- This section has been added as a special request from the BDC -->
    <!-- ko with: DellClarity.SCVMM.ViewModel.HardwareProfile.BootSettings -->
    <section>
        <header>
            <h1>
                <a id="hardDriveToggle" data-bind="css: { expand: !hardDriveSequenceIsExpanded(), collapse: hardDriveSequenceIsExpanded() }, text: hardDriveSequenceIsExpanded() ? DellClarity.SCVMM.Translations.genericterms.Collapse : DellClarity.SCVMM.Translations.genericterms.Expand"></a> &nbsp;
                <span><fmt:message key="hardwareprofile.bootsettings.hardDriveSequence"/></span>
                <a class="editlink" data-bind="visible: hardDriveSequenceIsExpanded, attr: { href: '#/hardwareProfile.edit.sequence/bootSettings/' + hardDriveSequences().order() + '/1' }"><fmt:message key="hardwareprofile.common.edit" /></a>
            </h1>
        </header>
        
        <table class="dataTable" data-bind="visible: hardDriveSequenceIsExpanded()">
            <thead>
                <tr>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.order" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.name" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.enabled" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.type" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.bootsettings.id" />
                    </th>
                </tr>
            </thead>
            <tbody data-bind="foreach: hardDriveSequences().sequences().sort(function (a, b) { return a.order() - b.order(); })">
                <tr>
                    <td data-bind="text: order"></td>
                    <td data-bind="text: name"></td>
                    <td data-bind="text: enabled"></td>
                    <td data-bind="text: type"></td>
                    <td data-bind="text: id" class="longTextNoSpaces"></td>
                </tr>
            </tbody>
        </table>
    </section>
    <!-- /ko -->
</section>
