<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_hardwaredetails_template">
       <section id="error_profileDetails" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <header>
        <h1><fmt:message key="hardwareprofile.details.title" />
        </h1>
    </header>
    <p>
        <fmt:message key="hardwareprofile.details.help" />
    </p>
    <form>
        <fieldset data-bind="with: DellClarity.SCVMM.ViewModel.HardwareProfile.NameAndDescription">
            <legend class="visuallyhidden"><fmt:message key="hardwareprofile.details.hardwareprofiledetails" /></legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="referenceServerSelected">
                        <u><fmt:message key="hardwareprofile.details.referenceserverselected" /></u>
                    </label>
                    <span id="referenceServerSelected" class="value" data-bind="text: referenceServerIdracIp"></span>
                </li>
            </ul>
        </fieldset>

        <fieldset data-bind="with: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails">
            <legend>
                <fmt:message key="deployment.deployment.dedicatedhotsparestrategy" />
            </legend>
            <ul class="labelValuePairs">
                <li data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.HardwareProfile.Wizard.hasReferenceServer() === true && dedicatedHotSpareStrategy() == 'Custom'">
                    <input type="radio" name="dedicatedHotspareStrategy" class="value" id="defaultSettings" required value="Default" data-bind="checked: dedicatedHotSpareStrategy" />
                    <label for="defaultSettings">
                        <u>
                            <fmt:message key="hardwareprofile.details.default" />
                        </u>
                    </label>
                    <span>
                         <fmt:message key="deployment.deployment.defaultMessage" />
                        <ul class="bulletedList">
                            <li><fmt:message key="deployment.deployment.defaultMessageDesc1" /></li>
                            <li><fmt:message key="deployment.deployment.defaultMessageDesc2" /></li>
                        </ul>

                    </span>
                </li>
                <li data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.HardwareProfile.Wizard.hasReferenceServer() === true && dedicatedHotSpareStrategy() == 'Default'">
                     <input type="radio" name="dedicatedHotspareStrategy" class="value" id="customizeSettings" required value="Custom" data-bind="checked: dedicatedHotSpareStrategy" />
                     <label for="customizeSettings">
                         <u>
                             <fmt:message key="hardwareprofile.details.createspecifiedHSperVD" />
                         </u>
                      </label>
                      <span>
                          <fmt:message key="deployment.deployment.createspecifiedHSperVDMessage" />
                          <br /><br />  
                          <ul class="labelValuePairs">
                              <li>
                                <span class="label">
                                    <label for="noOfDhsPerVirtualDisk">
                                        <u>
                                            <fmt:message key="deployment.deployment.numberofdhspervirtualdisk" />
                                        </u>
                                    </label>
                                </span>
                                <span class="value">
                                    <select id="noOfDhsPerVirtualDisk" name="noOfDhsPerVirtualDisk" data-bind="enable: dedicatedHotSpareStrategy() == 'Custom', options:DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.noOfDHSperVDList, 
                                        optionsText: 'name', optionsValue: 'id', value: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.numberofDHSInASingleVD"">
                                    </select>
                                </span>
                            </li>
                         </ul>
                      </span>
                </li>
            </ul>
        </fieldset>

        <fieldset data-bind="with: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.model">
            <legend>
                <fmt:message key="hardwareprofile.details.include" />
            </legend>
            <ul class="labelValuePairs" data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.model().gettingSettings() === true">
                <li>
                    <input id="biosSettings" type="checkbox" class="value" data-bind="checked: biosSettingsSelected" />
                    <label for="biosSettings">
                        <u><fmt:message key="hardwareprofile.details.biossettings" /></u>
                    </label>
                    <ul class="labelValuePairs">
                        <li>
                            <input id="biosSettingsContinueOnError" type="checkbox" class="value" data-bind="checked: biosSettingsContinueOnError, enable: biosSettingsSelected" />
                            <label for="biosSettingsContinueOnError">
                                <u><fmt:message key="hardwareprofile.details.continueonerror" /></u>
                            </label>
                        </li>
                    </ul>
                </li>
                <li>
                    <input id="bootSettings" type="checkbox" class="value" data-bind="checked: bootSettingsSelected" />
                    <label for="bootSettings">
                        <u><fmt:message key="hardwareprofile.details.bootsettings" /></u>
                    </label>
                </li>
                <li>
                    <input id="raidConfig" type="checkbox" class="value" data-bind="checked: raidSettingsSelected" />
                    <label for="raidConfig">
                        <u><fmt:message key="hardwareprofile.details.raidsettings" /></u>
                    </label>
                </li>
                <!-- The following elements have been temporarily removed due to lack of beta support
                <!--<li>
                    <input id="nicCnaSettings" type="checkbox" class="value" data-bind="checked: niccnaSettingsSelected" />
                    <label for="nicCnaSettings">
                        <u><fmt:message key="hardwareprofile.details.niccnasettings" /></u>
                    </label>
                    <ul class="labelValuePairs">
                        <li>
                            <input id="nicCnaSettingsContinueOnError" type="checkbox" class="value" data-bind="checked: niccnaSettingsContinueOnError, enable: niccnaSettingsSelected" />
                            <label for="nicCnaSettingsContinueOnError">
                                <u><fmt:message key="hardwareprofile.details.continueonerror" /></u>
                            </label>
                        </li>
                    </ul>
                </li>
                <li>
                    <input id="idracSettings" type="checkbox" class="value" data-bind="checked: idracSettingsSelected" />
                    <label for="idracSettings">
                        <u><fmt:message key="hardwareprofile.details.idracsettings" /></u>
                    </label>
                </li> -->

            </ul>
            <!-- <div class="statusIndicator">
                <span class="spinner" data-bind="visible: gettingSettings">
                    <img alt="spinner" src="dellclarity.core/images/body/spinner.gif" />
                    <fmt:message key="hardwareprofile.details.gettingsettingsstatusmessage" />
                </span>
            </div> -->

        </fieldset>
    </form>
</section>
