<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_hardwareprofile_edit_sequence_template">
    <header class="visuallyhidden">
        <h1></h1>
    </header>
    <form>
        <fieldset>
            <legend>
                <!-- ko if: sequences().length > 0 -->
                <span><fmt:message key="hardwareprofile.bootsettings.action" /></span>
                <button id="btnHardwareProfileSequenceMoveUp" type="button" data-bind="enable: selectedSequence()!=null && selectedSequence().order() > 0"><fmt:message key="hardwareprofile.bootsettings.sequencemoveup" /></button>
                <button id="btnHardwareProfileSequenceMoveDown" type="button" data-bind="enable: selectedSequence()!=null && (selectedSequence().order() < sequences().length - 1)"><fmt:message key="hardwareprofile.bootsettings.sequencemovedown" /></button>
                <!-- /ko -->
            </legend>
            <table id="sequenceTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col"><fmt:message key="hardwareprofile.bootsettings.order" /></th>
                        <th scope="col"><fmt:message key="hardwareprofile.bootsettings.name" /></th>
                        <th scope="col"><fmt:message key="hardwareprofile.bootsettings.enabled" /></th>
                        <th scope="col"><fmt:message key="hardwareprofile.bootsettings.type" /></th>
                        <!-- ko if: subSequencesShowId -->
                        <th scope="col"><fmt:message key="hardwareprofile.bootsettings.id" /></th>
                        <!-- /ko -->
                    </tr>
                </thead>
                <!-- ko if: sequences().length > 0 -->
                <tbody data-bind="foreach: sequences">
                    <tr data-bind="css: {selected: $parent.selectedSequence() == $data}">
                        <td data-bind="text: order"></td>
                        <td data-bind="text: name"></td>
                        <td data-bind="text: enabled"></td>
                        <td data-bind="text: type"></td>
                        <!-- ko if: $parent.subSequencesShowId -->
                        <td data-bind="text: id"></td>
                        <!-- /ko -->
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- ko if: subSequencesStandAlone -->
            <div class="sectionEditButtons">
                <button id="btnHardwareProfileSequenceSave" type="submit">
                    <fmt:message key="genericTerms.save" />
                </button>
                <button id="btnHardwareProfileSequenceCancel" type="button">
                    <fmt:message key="genericTerms.cancel" />
                </button>
            </div>
            <!-- /ko -->
        </fieldset>
    </form>
</section>
