<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="masterDetails" data-bind="with: DellClarity.SCVMM.ViewModel.HardwareProfile.Home">
    <section id="hardwareProfileMaster" class="master">
        <header>
            <h1>
                <fmt:message key="hardwareprofile.title" />
            </h1>
        </header>
        <ul class="inlineList taskbar">
            <li>
                <a id="createHardwareProfile" href="#/hardwareProfile.wizard"><fmt:message key="generic.create" /></a>
            </li>
            <li>
                <a id="editHardwarepProfile" data-bind="styledDisabled: hardwareTable().checkedRows().length !== 1">
                    <fmt:message key="genericTerms.edit" />
                </a>
            </li>
            <li>
                <a id="deleteHardwareProfile" data-bind="styledDisabled: hardwareTable().checkedRows().length === 0"><fmt:message key="generic.delete" /></a>
            </li>
            <li>
                <a id="refreshHardwareProfile"><fmt:message key="generic.refresh" /></a>
            </li>
        </ul>
        
        <form id="hardwareProfileMasterDetailsForm">
            <fieldset>
                <legend class="visuallyhidden"><fmt:message key="hardwareProfile.masterdetails.table" /></legend>
                <!-- ko with: hardwareTable -->
                <table id="hardwareProfileTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input id="selectAllHardware" type="checkbox"/>
                                <label for="selectAllHardware" class="visuallyhidden">Select All</label>            
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="generic.name" /></strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="hardwareProfile.masterdetails.created" /></strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="hardwareProfile.masterdetails.modified" /></strong>
                            </th>
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="4">
                                <fmt:message key="scrollabletable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="4">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.HardwareProfile.Home.selectedHardwareProfile() === $data }">
                            <td class="checkboxColumn">
                                <input type="checkbox" data-bind="checked: checked, indexedid: 'hardwareProfile_'" />
                                <label class="visuallyhidden" data-bind="indexedfor: 'hardwareProfile_'">
                                    <u>
                                        <fmt:message key="hardwareProfile.masterdetails.choice" />
                                    </u>
                                </label>
                            </td>
                            <td>
                                <span data-bind="text: name"></span>
                            </td>
                            <td>
                                <span data-bind="time: dateCreated, timeFormat: 'LLL'"></span>
                            </td>
                            <td>
                                <span data-bind="time: dateModified, timeFormat: 'LLL'"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                </table>
                <!-- /ko -->
            </fieldset>
        </form>
    </section>
    <section id="hardwareProfileDetails" class="details" data-bind="visible: selectedHardwareProfile() !== undefined">
        <header><h1><fmt:message key="generic.details"/></h1></header>
        <ul class="labelValuePairs" data-bind="if: selectedHardwareProfile() !== undefined">
            <li>
                <label for="hardwareProfName"><u><fmt:message key="generic.name" /></u></label>
                <span id="hardwareProfName" class="value" data-bind="text: selectedHardwareProfile().name"></span>
            </li>
            <li>
                <label for="hardwareProfDescription"><u><fmt:message key="generic.description" /></u></label>
                <span id="hardwareProfDescription" class="value" data-bind="text: selectedHardwareProfile().description"></span>
            </li>
        </ul>
    </section>
</div>
