<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_hardwareprofile_niccnasettings">
    <header>
        <h1>
            <fmt:message key="hardwareprofile.niccnasettings.title" />
        </h1>
    </header>
    
    <!-- ko with: DellClarity.SCVMM.ViewModel.HardwareProfile.Wizard.model -->
    <form data-bind="with: nicCnaSettings">
        <h2>
            <fmt:message key="hardwareprofile.niccnasettings.adapterconfig" />
        </h2>
        <p>
            <fmt:message key="hardwareprofile.niccnasettings.help" />
        </p>
        <hr />

        <ul class="inlineList">
            <li><a id="addAdapter">
                    <fmt:message key="hardwareprofile.niccnasettings.addadapter" />
                </a></li>
            <li><a id="removeAdapter">
                    <fmt:message key="hardwareprofile.niccnasettings.removeadapter" />
                </a></li>
            <li><a id="configAdapter">
                    <fmt:message key="hardwareprofile.niccnasettings.configadapter" />
                </a></li>
        </ul>
        <table id="niccnaSettingsTable" class="dataTable">
            <thead>
                <tr>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.niccnasettings.adapter" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.niccnasettings.location" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.niccnasettings.slot" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.niccnasettings.configured" />
                    </th>
                    <th scope="col">
                        <fmt:message key="hardwareprofile.niccnasettings.configuredfunctions" />
                    </th>
                </tr>
            </thead>
            <tbody data-bind="foreach: adapters">
                <tr data-bind="css: {selected: $data === $parent.selectedAdapter() }">
                    <td data-bind="text: name"></td>
                    <td data-bind="text: location"></td>
                    <td data-bind="text: slot"></td>
                    <td data-bind="text: configured"></td>
                    <td data-bind="text: functions"></td>
                </tr>
            </tbody>
        </table>
        
        <!-- ko if: adapters().length > 0 -->
        <fieldset id="adapterDetail" data-bind="with: selectedAdapter">
            <legend><fmt:message key="hardwareprofile.niccnasettings.niccnadetails" /></legend>
            <!-- ko foreach: ports -->
            <table class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">&nbsp;</th>
                        <th scope="col">
                            <fmt:message key="hardwareprofile.niccnasettings.portpartition" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hardwareprofile.niccnasettings.functions" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hardwareprofile.niccnasettings.bandwidthallocation" />
                        </th>
                    </tr>
                </thead>
                <tbody data-bind="foreach: partitions">
                    <tr>
                        <td>
                            <a class="togglePartitionDetails" data-bind="css: {partitionExpand: !isExpanded(), partitionCollapse: isExpanded()}, text: isExpanded() ? DellClarity.SCVMM.Translations.genericterms.Collapse : DellClarity.SCVMM.Translations.genericterms.Expand">
                                <fmt:message key="hardwareprofile.niccnasettings.expand" />
                            </a>
                        </td>
                        <td data-bind="text: $parent.number() + '-' + number()"></td>
                        <td>
                            <label class="visuallyhidden" data-bind="indexedfor: 'functionSelect_' + $parent.number()"><fmt:message key="hardwareprofile.niccnasettings.functionselect" /></label>
                            <select data-bind="indexedid: 'functionSelect_' + $parent.number(), options: DellClarity.SCVMM.ViewModel.HardwareProfile.NicCnaSettings.lookups.functions, value: func"></select>
                        </td>
                        <td>
                            <label data-bind="indexedfor: 'bandwidthmin_' + $parent.number()"><fmt:message key="hardwareprofile.niccnasettings.min" /></label>
                            <input type="text" data-bind="indexedid: 'bandwidthmin_' + $parent.number(), value: minBandwidth" class="short"/> %
                            <span>&nbsp;</span>
                            <label data-bind="indexedfor: 'bandwidthmax_' + $parent.number()"><fmt:message key="hardwareprofile.niccnasettings.max" /></label>
                            <input type="text" data-bind="indexedid: 'bandwidthmax_' + $parent.number(), value: maxBandwidth" class="short"/> %
                        </td>
                    </tr>
                    <tr data-bind="visible: isExpanded">
                        <td colspan="4">
                            <ul class="partitionMenu">
                                <li>
                                    <a data-bind="css: {selectedMenuItem: currentMenuItem() === 0}"><fmt:message key="hardwareprofile.niccnasettings.nic" /></a>
                                </li>
                                <li>
                                    <a data-bind="css: {selectedMenuItem: currentMenuItem() === 1}"><fmt:message key="hardwareprofile.niccnasettings.iscsi" /></a>
                                </li>
                            </ul>

                            <!-- ko if: currentMenuItem() === 0 -->
                            <fieldset class="partitionFieldset" data-bind="with: nicSettings">
                                <legend><fmt:message key="hardwareprofile.niccnasettings.nicsettings" /></legend>
                                <ul class="labelValuePairs">
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxBootProtocol_' + $parents[1].number(), checked: bootProtocol" />
                                        <label data-bind="indexedfor: 'cbxBootProtocol_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.bootprotocol" /></u></label>
                                        <ul class="labelValuePairs">
                                            <li>
                                                <input type="radio" class="value" value="pxe" data-bind="indexedid: 'rdoPxe_' + $parents[1].number(), indexedname: 'bootProtocol_' + $parents[1].number(), checked: bootProtocol" />
                                                <label data-bind="indexedfor: 'rdoPxe_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.pxe" /></u></label>
                                            </li>
                                            <li>
                                                <input type="radio" class="value" value="iscsi" data-bind="indexedid: 'rdoIscsi_' + $parents[1].number(), indexedname: 'bootProtocol_' + $parents[1].number(), checked: bootProtocol" />
                                                <label data-bind="indexedfor: 'rdoIscsi_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.iscsi" /></u></label>
                                            </li>
                                            <li>
                                                <input type="radio" class="value" value="fcoe" data-bind="indexedid: 'rdoFcoe_' + $parents[1].number(), indexedname: 'bootProtocol_' + $parents[1].number(), checked: bootProtocol" />
                                                <label data-bind="indexedfor: 'rdoFcoe_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.fcoe" /></u></label>
                                            </li>
                                        </ul>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableWakeOnLan_' + $parents[1].number(), checked: wakeOnLan" />
                                        <label data-bind="indexedfor: 'cbxEnableWakeOnLan_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enablewakeonlan" /></u></label>
                                        <ul class="labelValuePairs">
                                            <li>
                                                <label data-bind="indexedfor: 'selWakeOnLanLinkSpeed_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.wakeonlanlinkspeed" /></u></label>
                                                <select class="value" data-bind="indexedid: 'selWakeOnLanLinkSpeed_' + $parents[1].number(), options: DellClarity.SCVMM.ViewModel.HardwareProfile.NicCnaSettings.lookups.wakeOnLanSpeed, value: wakeOnLanSpeed, enable: wakeOnLan"></select>
                                            </li>
                                        </ul>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableVLanMode_' + $parents[1].number(), checked: vLanMode" />
                                        <label data-bind="indexedfor: 'cbxEnableVLanMode_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enablevlanmode" /></u></label>
                                        <ul class="labelValuePairs">
                                            <li>
                                                <label data-bind="indexedfor: 'selVLanLinkSpeed_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.vlanlinkspeed" /></u></label>
                                                <select class="value" data-bind="indexedid: 'selVLanLinkSpeed_' + $parents[1].number(), options: DellClarity.SCVMM.ViewModel.HardwareProfile.NicCnaSettings.lookups.vlanLinkSpeed, value: vLanLinkSpeed, enable: vLanMode"></select>
                                            </li>
                                            <li>
                                                <label data-bind="indexedfor: 'selFlowControl_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.flowcontrol" /></u></label>
                                                <select class="value" data-bind="indexedid: 'selFlowControl_' + $parents[1].number(), options: DellClarity.SCVMM.ViewModel.HardwareProfile.NicCnaSettings.lookups.vlanFlowControl, value: vLanFlowControl, enable: vLanMode"></select>
                                            </li>
                                        </ul>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableIPAutoConfiguration_' + $parents[1].number(), checked: ipAutoConfig" />
                                        <label data-bind="indexedfor: 'cbxEnableIPAutoConfiguration_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enableipautoconfiguration" /></u></label>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableSriovConfiguration_' + $parents[1].number(), checked: sriovConfig" />
                                        <label data-bind="indexedfor: 'cbxEnableSriovConfiguration_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enablesriovconfiguration" /></u></label>
                                    </li>
                                </ul>
                            </fieldset>
                            <!-- /ko -->

                            <!-- ko if: currentMenuItem() === 1 -->
                            <fieldset class="partitionFieldset" data-bind="with: iScsiSettings">
                                <legend><fmt:message key="hardwareprofile.niccnasettings.iscsisettings" /></legend>
                                <ul class="labelValuePairs">
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableAll_' + $parents[1].number(), checked: enableAll" />
                                        <label data-bind="indexedfor: 'cbxEnableAll_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enableall" /></u></label>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableChapAuth_' + $parents[1].number(), checked: chapAuth" />
                                        <label data-bind="indexedfor: 'cbxEnableChapAuth_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enablechapauth" /></u></label>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableChapMutualAuth_' + $parents[1].number(), checked: chapMutAuth" />
                                        <label data-bind="indexedfor: 'cbxEnableChapMutualAuth_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enablechapmutualauth" /></u></label>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableIScsiViaDhcp_' + $parents[1].number(), checked: iScsiViaDhcp" />
                                        <label data-bind="indexedfor: 'cbxEnableIScsiViaDhcp_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enableiscsiviadhcp" /></u></label>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableHbaMode_' + $parents[1].number(), checked: hbaMode" />
                                        <label data-bind="indexedfor: 'cbxEnableHbaMode_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enablehbamode" /></u></label>
                                    </li>
                                    <li>
                                        <input type="checkbox" class="value" data-bind="indexedid: 'cbxEnableBootToTarget_' + $parents[1].number(), checked: bootToTarget" />
                                        <label data-bind="indexedfor: 'cbxEnableBootToTarget_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.enableboottotarget" /></u></label>
                                    </li>
                                    <li>
                                        <label data-bind="indexedfor: 'txtLunBusyRetryCount_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.lunbusyretrycount" /></u></label>
                                        <input type="text" class="value" data-bind="indexedid: 'txtLunBusyRetryCount_' + $parents[1].number(), value: lunRetry" />
                                    </li>
                                    <li>
                                        <label data-bind="indexedfor: 'txtDhcpVendorId_' + $parents[1].number()"><u><fmt:message key="hardwareprofile.niccnasettings.dhcpvendorid" /></u></label>
                                        <input type="text" class="value" data-bind="indexedid: 'txtDhcpVendorId_' + $parents[1].number(), value: dhcpVendorId" />
                                    </li>
                                </ul>
                            </fieldset>
                            <!-- /ko -->
                        </td>
                    </tr>
                </tbody>
                <tfoot>
                    <tr>
                        <td colspan="4">
                            <ul class="labelValuePairs">
                                <li>
                                    <label data-bind="indexedfor: 'allocBw'"><u><fmt:message key="hardwareprofile.niccnasettings.allocatedbandwidth" /></u></label>
                                    <span class="value" data-bind="indexedid: 'allocBw', text: allocBw"></span>%
                                </li>
                                <li>
                                    <label data-bind="indexedfor: 'remBw'"><u><fmt:message key="hardwareprofile.niccnasettings.remainingbandwidth" /></u></label>
                                    <span class="value" data-bind="indexedid: 'remBw', text: 100 - allocBw()"></span>%
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tfoot>
            </table>
            <!-- /ko -->
        </fieldset>
        <!-- /ko -->
    </form>
    <!-- /ko -->
</section>
