<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_hardwareprofile_raidconfiguration">
    <header>
        <h1>
            <fmt:message key="hardwareprofile.raidconfig.title" />
        </h1>
    </header>
    
    <!-- ko with: DellClarity.SCVMM.ViewModel.HardwareProfile.Wizard.model -->
    <!-- ko if: !raidConfig -->
    <p><fmt:message key="hardwareprofile.raidconfig.nocontroller" /></p>
    <!-- /ko -->
    <form data-bind="with: raidConfig">
        <fieldset>
            <legend class="visuallyhidden"><fmt:message key="hardwareprofile.raidconfig.title" /></legend>
            <!-- ko if: !controllers() || controllers().length == 0 -->
            <p><fmt:message key="hardwareprofile.raidconfig.nocontroller" /></p>
            <!-- /ko -->
                
            <!-- ko if: controllers() && controllers().length > 0 -->
            <ul class="labelValuePairs">
                <fmt:message key="hardwareprofile.raidconfig.configurationlabel" />
            </ul>
            <label for="numOfControllers"><u><fmt:message key="hardwareprofile.raidconfig.numofcontrollers" /></u></label>
            <span id="numOfControllers" class="value" data-bind="text: controllers() ? controllers().length : 0"></span>

            <fieldset class="multipane">
                <legend>
                    <label for="selController"><fmt:message key="hardwareprofile.raidconfig.selectcontroller" /></label>
                    <select id="selController" data-bind="options: controllers, optionsText: 'name', value: selectedController"></select>
                </legend>
                    
                <!-- ko with: selectedController -->
                <div>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="location"><u><fmt:message key="hardwareprofile.raidconfig.location" /></u></label>
                            <span id="location" class="value" data-bind="text: location"></span>
                        </li>
                        <li>
                            <label for="securityStatus"><u><fmt:message key="hardwareprofile.raidconfig.securityStatus" /></u></label>
                            <span id="securityStatus" class="value" data-bind="text: securityStatus"></span>
                        </li>
                    </ul>
                </div>
                <div>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="physicalDisks"><u><fmt:message key="hardwareprofile.raidconfig.physicaldisks" /></u></label>
                            <span id="physicalDisks" class="value" data-bind="text: physicalDiskCount"></span>
                        </li>
                        <li>
                            <label for="globalHotspares"><u><fmt:message key="hardwareprofile.raidconfig.globalhotspares" /></u></label>
                            <span id="globalHotspares" class="value" data-bind="text: globalHotSpareCount"></span>
                        </li>
                        <li>
                            <label for="virtualDisks"><u><fmt:message key="hardwareprofile.raidconfig.virtualdisks" /></u></label>
                            <span id="virtualDisks" class="value" data-bind="text: $parent.virtualDisks"></span>
                        </li>
                    </ul>
                </div>
                <!-- /ko -->
            </fieldset>
            <!-- /ko -->
                
            <!-- ko if: selectedController() && selectedController().virtualDisks() && selectedController().virtualDisks().length > 0 -->
            <fieldset class="multipane">
                <legend>
                    <label for="selPhysicalDisk"><fmt:message key="hardwareprofile.raidconfig.selectVirtualDisk" /></label>
                    <select id="selPhysicalDisk" data-bind="options: selectedController() ? selectedController().virtualDisks : [], optionsText: 'name', value: selectedVDisk"></select>
                </legend>
                    
                <!-- ko with: selectedVDisk -->
                <div>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="protocol"><u><fmt:message key="hardwareprofile.raidconfig.level" /></u></label>
                            <span id="protocol" class="value" data-bind="text: level"></span>
                        </li>
                        <li>
                            <label for="mediaformat"><u><fmt:message key="hardwareprofile.raidconfig.size" /></u></label>
                            <span id="mediaformat" class="value" data-bind="text: size"></span>
                        </li>
                    </ul>
                </div>

                <div>
                    <ul class="labelValuePairs">
                        <!-- ko if: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.dedicatedHotSpareStrategy() == 'Default' -->
                        <li>
                            <label for="selVDphysicalDisks"><u><fmt:message key="hardwareprofile.raidconfig.physicalDisks" /></u></label>
                            <span id="Span1" class="value" data-bind="text: physicalDisks() ? (physicalDisks().length) - (dedicatedHotSpares() ? dedicatedHotSpares().length : 0) : 0"></span>
                        </li>
                        <li>
                            <label for="dedicatedHotSpares"><u><fmt:message key="hardwareprofile.raidconfig.dedicatedhotspares" /></u></label>
                            <span id="Span2" class="value" data-bind="text: dedicatedHotSpares() ? dedicatedHotSpares().length : 0"></span>
                        </li>
                        <!-- /ko -->
                        <!-- ko if: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.dedicatedHotSpareStrategy() == 'Custom' --> 
                        <li>
                            <label for="selVDphysicalDisks"><u><fmt:message key="hardwareprofile.raidconfig.physicalDisks" /></u></label>
                            <span id="selVDphysicalDisks" class="value" data-bind="text: physicalDisks() ? physicalDisks().length : 0"></span>
                        </li>
                        <!-- Bug 49731 Edit Hw Profile with 1 DHS does not add the DHS dynamically in RAID configuration screen of Hardware Profile wizard -->
                        <!-- Displaying number of DHS selected in drop down instead of checking for array length -->
                        <li>
                            <label for="dedicatedHotSpares"><u><fmt:message key="hardwareprofile.raidconfig.dedicatedhotspares" /></u></label>
                            <span id="dedicatedHotSpares" class="value" data-bind="text: DellClarity.SCVMM.ViewModel.HardwareProfile.ProfileDetails.numberofDHSInASingleVD"></span>
                        </li>
                        <!-- /ko -->
                    </ul>
                </div>
                <!-- /ko -->
            </fieldset>
            <!-- /ko -->
        </fieldset>
    </form>
    <!-- /ko -->   

</section>
