<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_viewscompms" data-bind="with: DellClarity.SCVMM.ViewModel.Dashboard">
    <section id="error_viewscompms" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <section id="pmsDataList">
        <!-- ko if: (syncMSDataAction() == false) -->
        <p>
            <fmt:message key="dashboard.viewscompms.description" />
        </p>
        <!-- /ko -->

        <!-- ko if: (syncMSDataAction() == true) -->
        <p>
            <fmt:message key="dashboard.syncSCOMMSData.description" />
        </p>
        <!-- /ko -->

        <fieldset>
            <!-- ko if: (syncMSDataAction() == true) -->
            <section class="dashboardPanel">
                <header>
                    <h1>
                        <fmt:message key="dashboard.addscompms.title" />
                    </h1>
                </header>
            </section>

            <table id="addPMSTable" class="dataTable" style="height: 25%;">
                <!-- <thead>
						<tr>
							<th scope="col">
								<strong>
									<fmt:message key="dashboard.addscompms.title" />
								</strong>
							</th>
						</tr>
					</thead> -->
                <!-- ko if: (!syncMSPMSList().addedPmsServers || syncMSPMSList().addedPmsServers.length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="dashboard.syncSCOMMSData.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: syncMSPMSList().addedPmsServers && syncMSPMSList().addedPmsServers.length > 0 -->
                <tbody>
                    <tr>
                        <td>
                            <ul id="addedSyncMSData" data-bind="foreach: syncMSPMSList().addedPmsServers">
                                <li data-bind="text: $data"></li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>

            <section class="dashboardPanel">
                <br />
                <header>
                    <h1>
                        <fmt:message key="dashboard.removescompms.title" />
                    </h1>
                </header>
            </section>
            <!-- ko if: (syncMSPMSList().pmsServers && syncMSPMSList().pmsServers.length > 0) -->
            <section class="messageBox warning open" id="staticWarningBox" role="alert" style="display: block; padding: 0.5em !important">
                <header style="margin: 1.2em 0">
                    <div style="padding: 1.5em 0px 0px 1em;">
                        <span class="icon"></span>
                    </div>
                </header>
                <div class="msgBoxContents">
                    <p>
                        <fmt:message key="dashboard.syncSCOMMSData.warning" />
                    </p>
                </div>
            </section>
            <br />
            <!-- /ko -->

            <table id="removePMSTable" class="dataTable" style="height: 25%;">
                <!-- <thead>
						<tr>
							<th scope="col">
								<strong>
									<fmt:message key="dashboard.removescompms.title" />
								</strong>
							</th>
						</tr>
					</thead> -->
                <!-- ko if: (!syncMSPMSList().pmsServers || syncMSPMSList().pmsServers.length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="dashboard.syncSCOMMSData.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: syncMSPMSList().pmsServers && syncMSPMSList().pmsServers.length > 0 -->
                <tbody>
                    <tr>
                        <td>
                            <ul id="removedSyncMSData" data-bind="foreach: syncMSPMSList().pmsServers">
                                <li data-bind="text: $data"></li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </fieldset>

        <fieldset>
            <!-- ko if: (syncMSDataAction() == false) -->
            <table id="consoleTable" class="dataTable" style="height: 25%;">
                <thead>
                    <tr>
                        <th scope="col">
                            <strong>
                                <fmt:message key="dashboard.viewscompms.title" />
                            </strong>
                        </th>
                    </tr>
                </thead>
                <!-- ko if: (!viewPMSServers || viewPMSServers().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: viewPMSServers && viewPMSServers().length > 0 -->
                <tbody>
                    <tr>
                        <td>
                            <ul id="myUL" data-bind="foreach: viewPMSServers">
                                <li>
                                    <span style="white-space: nowrap;" class="(pmsManagementServers.length > 0) ? caret : ''" data-bind="text: consoleFqdn"></span>
                                    <!-- ko if: pmsManagementServers -->
                                    <ul class="nested" data-bind="foreach: pmsManagementServers">
                                        <li data-bind="text: $data"></li>
                                    </ul>
                                    <!-- /ko -->
                                </li>
                            </ul>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </fieldset>
    </section>
    <div class="sectionEditButtons">
        <!-- ko if: (syncMSDataAction() == true) -->
        <button id="btnAccept" type="button" class="cux-button cux-button-large cux-button-primary">
            <fmt:message key="dashboard.removescompms.synchronize" />
        </button>
        <button id="btnCancel" type="button" class="cux-button cux-button-large cux-button-danger">
            <fmt:message key="dashboard.removescompms.cancel" />
        </button>
        <!-- /ko -->

        <!-- ko if: (syncMSDataAction() == false) -->
        <button id="btnClose" type="button" class="cux-button cux-button-large cux-button-danger">
            <fmt:message key="dashboard.removescompms.close" />
        </button>
        <!-- /ko -->
    </div>
</section>
