<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_welcome" data-bind="with: DellClarity.SCVMM.ViewModel.Dashboard">
    <section id="error_dashboard" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <header class="page-heading">
        <h1>
            <fmt:message key="welcome.overview" />
        </h1>
    </header>

    <!--ko if: DellClarity.Config.consoleType != 'scom' -->
    <p>
        <fmt:message key="welcome.help.beta" />
    </p>
    <!-- /ko -->

    <!--ko if: DellClarity.Config.consoleType == 'scom' -->
    <p>
        <fmt:message key="welcome.help.beta.scom" />
    </p>
    <!-- /ko -->

    <!-- ko if: loading() -->
    <div>
        <fmt:message key="scrollabletable.loading" />
        <span>&nbsp;</span>
        <span class="icon spinner"></span>
    </div>
    <!-- /ko -->

    <!-- ko if: !loading() -->
    <section id="dashboardSection" data-bind="with: DellClarity.SCVMM.ViewModel.Dashboard.dashboardData">

    <!--ko if: DellClarity.Config.consoleType != 'scom' -->
    <section class="dashboardPanel">
        <header>
            <h1>
                <fmt:message key="welcome.discovereddevices" />
            </h1>
        </header>

        <ul class="metrics">
            <li>
                <b data-bind="text: complianthostcount + noncomplianthostcount"></b>
                <fmt:message key="welcome.hosts" />
            </li>
            <li>
                <b data-bind="text: complantbaremetalservercount + noncomplantbaremetalservercount"></b>
                <fmt:message key="welcome.baremetalservers" />
            </li>
            <li>
                <b data-bind="text: modularsystemscount"></b>
                <fmt:message key="welcome.modularsystems" />
            </li>
        </ul>

        <div>
            <ul class="linkList">
                <li>
                    <a href="#/configanddeploy.serverview/hosts">
                        <fmt:message key="welcome.viewhosts" />
                    </a>
                </li>
                <li>
                    <a href="#/configanddeploy.serverview">
                        <fmt:message key="welcome.viewbaremetalservers" />
                    </a>
                </li>
                <li>
                    <a href="#/configanddeploy.chassisview">
                        <fmt:message key="welcome.viewmodularsystems" />
                    </a>
                </li>
            </ul>
        </div>
    </section>
    <!-- /ko -->

    <!--ko if: DellClarity.Config.consoleType == 'scom' -->
    <section class="dashboardPanel">
        <header>
            <h1>
                <fmt:message key="welcome.discovereddevices" />
            </h1>
        </header>

            <ul class="metrics">
                <li>
                    <b data-bind="text: complantbaremetalservercount + noncomplantbaremetalservercount"></b>
                    <fmt:message key="welcome.devices" />
                </li>
                <li>
                    <b data-bind="text: modularsystemscount"></b>
                    <fmt:message key="welcome.modularsystems" />
                </li>
                <li>
                    <b data-bind="text: networkswitchescount"></b>
                    <fmt:message key="welcome.networkswitches" />
                </li>
                <!-- <li>
                    <b data-bind="text: me4storagescount"></b>
                    <fmt:message key="welcome.me4storages" />
                </li> -->
            </ul>
        <div>
            <ul class="linkList">
                <li>
                    <a href="#/configanddeploy.serverview">
                        <fmt:message key="welcome.viewdiscoveredservers" />
                    </a>
                </li>
                <li>
                    <a href="#/configanddeploy.chassisview">
                        <fmt:message key="welcome.viewdiscoveredchassis" />
                    </a>
                </li>
                <li>
                    <a href="#/configanddeploy.networkswitchview">
                        <fmt:message key="welcome.viewdiscoverednetworkswitches" />
                    </a>
                </li>
                <!-- <li>
                    <a href="#/configanddeploy.me4storageview">
                        <fmt:message key="welcome.viewdiscoveredme4storages" />
                    </a>
                </li> -->
                <!-- <li>
                    <a href="#/discovery.discover">
                        <fmt:message key="welcome.discoverdevices" />
                    </a>
                </li> -->
            </ul>
        </div>
    </section>
    <!-- /ko -->

    <!--ko if: DellClarity.Config.consoleType == 'scvmm' -->
    <section class="dashboardPanel">
        <header>
            <h1>
                <fmt:message key="welcome.clusterinformation" />
            </h1>
        </header>

        <ul class="metrics">
            <li>
                <b data-bind="text: clusterscount"></b>
                <fmt:message key="welcome.clusters" />
            </li>
        </ul>
        <div>
            <ul class="linkList">
                <li>
                    <a href="#/configanddeploy.clusterview">
                        <fmt:message key="welcome.viewclusters" />
                    </a>
                </li>
            </ul>
        </div>
    </section>
    <!-- /ko -->

    <section class="dashboardPanel">
        <!--ko if: DellClarity.Config.consoleType != 'scom' -->
        <header>
            <h1>
                <fmt:message key="welcome.templateandprofile" />
            </h1>
        </header>
        <!-- /ko -->

        <!--ko if: DellClarity.Config.consoleType == 'scom' -->
        <header>
            <h1>
                <fmt:message key="welcome.profiles" />
            </h1>
        </header>
        <!-- /ko -->

        <ul class="metrics">
            <!--ko if: DellClarity.Config.consoleType != 'scom' -->
            <li>
                <b data-bind="text: lifecycletemplatecount"></b>
                <fmt:message key="welcome.lifecycletemplates" />
            </li>
            <li data-bind="visible: DellClarity.Config.consoleType && DellClarity.Config.consoleType == 'scvmm'">
                <b data-bind="text: hypervisorprofilecount"></b>
                <fmt:message key="welcome.hypervisorprofiles" />
            </li>
            <!-- /ko -->

            <li>
                <b data-bind="text: credentialprofilecount"></b>
                <fmt:message key="welcome.credentialprofiles" />
            </li>
        </ul>
        <div>
            <ul class="linkList">
                <!--ko if: DellClarity.Config.consoleType != 'scom' -->
                <li>
                    <a href="#/lifecycletemplates.home">
                        <fmt:message key="welcome.viewlifecycletemplates" />
                    </a>
                </li>
                <li data-bind="visible: DellClarity.Config.consoleType && DellClarity.Config.consoleType == 'scvmm'">
                    <a href="#/hypervisorProfile.masterDetails">
                        <fmt:message key="welcome.createhypervisor" />
                    </a>
                </li>
                <!-- /ko -->

                <li>
                    <a href="#/credentialProfile.masterDetails">
                        <fmt:message key="welcome.createcredential" />
                    </a>
                </li>
            </ul>
        </div>
    </section>
<!--ko if: DellClarity.Config.consoleType == 'scom' -->
    <section class="dashboardPanel">
        <header>
            <h1 style="display:inline;">
                <fmt:message key="welcome.managementServers" />
            </h1>
			<button id="syncSCOMMSData" style="margin-left:50px; margin-bottom: 0.3em;" class="cux-button cux-button-medium cux-button-primary" title="<fmt:message key="welcome.syncSCOMMSDataToolTip" />" type="button">
                <i class="cux-icon cux-icon-refresh"></i><span>
                    <fmt:message key="welcome.syncSCOMMSData" />
                </span>

            </button>
        </header>

        <ul class="metrics">
            <li>
                <b data-bind="text: scommanagementservercount"></b>
                <fmt:message key="welcome.scomms" />
            </li>
            <li>
                <b data-bind="text: scomproxymanagementservercount"></b>
                <fmt:message key="welcome.proxyms" />
            </li>
        </ul>
        <div>
            <ul class="linkList">
                <li>
                    <a id="viewproxyms">
                        <fmt:message key="welcome.viewproxyms" />
                    </a>
                </li>
            </ul>
        </div>
    </section>
<!-- /ko -->
    <section class="dashboardPanel">
        <header>
            <h1>
                <fmt:message key="welcome.jobs" />
            </h1>
        </header>

        <ul class="metrics">
            <li>
                <b data-bind="text: runningjobcount"></b>
                <fmt:message key="welcome.runningjobs" />
            </li>
            <li>
                <b data-bind="text: failedjobcount"></b>
                <fmt:message key="welcome.failedjobs" />
            </li>
            <li>
                <b data-bind="text: successfuljobcount"></b>
                <fmt:message key="welcome.successjobs" />
            </li>
            <li>
                <b data-bind="text: scheduledjobcount"></b>
                <fmt:message key="welcome.scheduledjobs" />
            </li>
        </ul>
        <div>
            <ul class="linkList">
                <li>
                    <a href="#/jobLog.home">
                        <fmt:message key="welcome.viewjobs" />
                    </a>
                </li>
            </ul>
        </div>
    </section>
    </section>
    <!-- /ko -->

</section>
