<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section class="details" id="page_hostInventory_home_details" data-bind="with: DellClarity.SCVMM.ViewModel.HostInventory.Details">
    <header>
        <hgroup class="labelValuePairs" data-bind="with: hostInventory">
            <h1>
                <label for="idracIp"><u><fmt:message key="hostinventory.details.idracip" /></u></label>
                <span id="idracIp" class="value" data-bind="text: iDracIp"></span>
            </h1>
            <h2>
                <label for="serviceTag"><u><fmt:message key="hostinventory.details.servicetag" /></u></label>
                <span id="serviceTag" class="value" data-bind="text: serviceTag"></span>
            </h2>
        </hgroup>
    </header>
    <section class="detailsArea">
        <header class="visuallyhidden">
            <h1>
                <fmt:message key="hostInventory.detailarea" />
            </h1>
        </header>
        <nav id="tabMenu" class="menu tabs" role="navigation">
            <ul>
                <li>
                    <a href="#/hostInventory.home">
                        <fmt:message key="hostinventory.details.summary" />
                    </a>
                </li>
                <li>
                    <a href="#/hostInventory.home/hardwareInfo">
                        <fmt:message key="hostinventory.details.hardwareinformation" />
                    </a>
                </li>
                <li>
                    <a href="#/hostInventory.home/firmwareInv">
                        <fmt:message key="hostinventory.details.firmwareinventory" />
                    </a>
                </li>
                <!--<li>
                    <a href="#/hostInventory.home/warranty">
                        <fmt:message key="hostinventory.details.warranty" />
                    </a>
                </li>-->
            </ul>
        </nav>
        <section class="tabPanel" data-bind="visible: activeTab() === 'summary'">
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="hostinventory.details.summary" />
                </h1>
            </header>

            <ul class="labelValuePairs" data-bind="with: hostInventory">
                <li>
                    <label for="hostName"><u><fmt:message key="hostinventory.details.hostname"/> </u></label>
                    <span id="hostName" class="value" data-bind="text: hostName"></span>
                </li>
                <li>
                    <label for="chassisTag"><u><fmt:message key="hostinventory.details.chassistag" /></u></label>
                    <span id="chassisTag" class="value" data-bind="text: chassisTag"></span>
                </li>
                <li>
                    <label for="hardwareStat"><u><fmt:message key="hostinventory.details.hardwarestatus" /></u></label>
                    <span id="hardwareStat" class="value" data-bind="text: hardwareStatus"></span>
                </li>
                <li>
                    <label for="firmwareUpdate"><u><fmt:message key="hostinventory.details.firmwareupdate" /></u></label>
                    <span id="firmwareUpdate" class="value" data-bind="text: firmwareUpdate"></span>
                </li>
                <!--<li>
                    <label for="warranty"><u>Warranty </u></label>
                    <span id="warranty" class="value" data-bind="text: warranty"></span>
                </li>-->
            </ul>
        </section>
        <section class="tabPanel" data-bind="visible: activeTab() === 'hardwareInfo'">
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="hostinventory.details.hardwareinformation" />
                </h1>
            </header>
            <span><fmt:message key="hostinventory.details.hardwareinformation" /></span>
        </section>
        <section class="tabPanel" data-bind="visible: activeTab() === 'firmwareInv'">
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="hostinventory.details.firmwareinventory" />
                </h1>
            </header>
            <span><fmt:message key="hostinventory.details.firmwareinventory" /></span>
        </section>
       <!-- <section class="tabPanel" data-bind="visible: activeTab() === 'warranty'">
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="hostinventory.details.warranty" />
                </h1>
            </header>
            <span>Warranty</span>
        </section>-->
    </section>
</section>
