<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section class="master" id="page_hostInventory_home_master" data-bind="with: DellClarity.SCVMM.ViewModel.HostInventory.Home">
    <header>
        <h1>
            <fmt:message key="hostinventory.title" />
        </h1>
    </header>
    <p>
        <fmt:message key="hostinventory.help" />
    </p>
    <form>
        <div data-bind="with: hostInventorySummary">
            <ul id="summary" class="bulletedList">
                <li>
                    <fieldset>
                        <legend>
                            <fmt:message key="hostinventory.hardwaresummary" />
                        </legend>
                        <ul class="labelValuePairs">
                            <li>
                                <label for="criticalHardwareErrors">
                                    <u>
                                        <fmt:message key="hostinventory.hardwaresummary.criticalhardwareerrors" />
                                    </u>
                                </label>
                                <span id="criticalHardwareErrors" class="value" data-bind="text: criticalHardwareErrors" />
                            </li>
                            <li>
                                <label for="hardwareWarnings">
                                    <u>
                                        <fmt:message key="hostinventory.hardwaresummary.hardwarewarnings" />
                                    </u>
                                </label>
                                <span id="hardwareWarnings" class="value" data-bind="text: hardwareWarnings"></span></li>
                        </ul>
                    </fieldset>
                </li>
                <li>
                    <fieldset>
                        <legend>
                            <fmt:message key="hostinventory.firmwaresummary" />
                        </legend>
                        <ul class="labelValuePairs">
                            <li>
                                <label for="criticalFirmwareUpdates">
                                    <u>
                                        <fmt:message key="hostinventory.firmwaresummary.criticalfirmwareupdates" />
                                    </u>
                                </label>
                                <span id="criticalFirmwareUpdates" class="value" data-bind="text: criticalFirmwareUpdates"></span>

                            </li>
                            <li>
                                <label for="recommendedFirmwareUpdates">
                                    <u>
                                        <fmt:message key="hostinventory.firmwaresummary.recommendedfirmwareupdates" />
                                    </u>
                                </label>
                                <span id="recommendedFirmwareUpdates" class="value" data-bind="text: recommendedFirmwareUpdates"></span>
                            </li>
                        </ul>
                    </fieldset>
                </li>
                <!--<li>
                    <fieldset>
                        <legend>
                            <fmt:message key="hostinventory.warrantysummary" />
                        </legend>
                        <ul class="labelValuePairs">
                            <li>
                                <label for="warrantyExpired">
                                    <u>
                                        <fmt:message key="hostinventory.warrantysummary.warrantyexpired" />
                                    </u>
                                </label>
                                <span id="warrantyExpired" class="value" data-bind="text: warrantyExpired"></span></li>
                            <li>
                                <label for="warrantyExpiringSoon">
                                    <u>
                                        <fmt:message key="hostinventory.warrantysummary.warrantyexpiringsoon" />
                                    </u>
                                </label>
                                <span id="warrantyExpiringSoon" class="value" data-bind="text: warrantyExpiringSoon"></span>
                            </li>
                        </ul>
                    </fieldset>
                </li>-->
            </ul>
            <div id="lastUpdatedDate">
                <label for="lastUpdated">
                    <u>
                        <fmt:message key="hostinventory.lastupdated" />
                    </u>
                </label>
                <time id="lastUpdated" class="value" data-bind="time: lastUpdated, timeFormat: 'LLL'"></time>
            </div>
        </div>
        <br />
        <div id="master">
            <ul class="inlineList taskbar">
                <li>
                    <!--a id="refresh">
                    <fmt:message key="hostinventory.refresh" />
                </a-->
                     <button id= "refresh" class="cui-button cux-button cux-button-small  cux-button-primary"  type="button" >
            <i class="ci ci-action-refresh-core"></i><span ><fmt:message key="hostinventory.refresh" /></span></button>
                </li>
                <li><a href="#/firmwareUpdate.wizard">
                    <fmt:message key="hostinventory.firmwareupdate" />
                </a></li>
                <!--<li><a id="renewWarranty">
                    <fmt:message key="hostinventory.renewwarranty" />
                </a></li>-->
            </ul>
            <!-- ko with: hostInventories -->
            <table id="hostInventoryGrid" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.hostname" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.servicetag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.idracip" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.chassistag" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.hardwarestatus" />
                        </th>
                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.firmwareupdate" />
                        </th>
<!--                        <th scope="col">
                            <fmt:message key="hostinventory.inventory.warranty" />
                        </th>-->
                    </tr>
                </thead>
                <!-- ko if: !data || data().length == 0 -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.HostInventory.Home.selectedHostInventory() === $data }">
                        <td>
                            <span data-bind="text: hostName"></span>
                        </td>
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="text: iDracIp"></span>
                        </td>
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="text: hardwareStatus"></span>
                        </td>
                        <td>
                            <span data-bind="text: firmwareUpdate"></span>
                        </td>
                        <!--<td>
                            <span data-bind="text: warranty"></span>
                        </td>-->
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </div>
    </form>
</section>
<!-- ko template: 'views/hostinventory/details.html' -->
<!-- /ko -->
<div class="sectionEditButtons">
    <button id="btnCancelInventory" type="button">
        <fmt:message key="hostinventory.inventory.close" />
    </button>
</div>
