<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_hypervisorprofile_template" data-bind="with: DellClarity.SCVMM.ViewModel.HypervisorProfile.Details">
    <section id="error_hyperProfile" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" ></section>
    <form id="hyperVisorProfileForm">
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="hypervisorprofile.title" />
            </legend>
             <p>
                <fmt:message key="hypervisorprofile.help" />
            </p>
            <ul class="labelValuePairs">
                <li>
                    <label for="hyperProfName">
                        <u>
                            <fmt:message key="hypervisorprofile.name" />
                        </u>
                    </label>
                    <input id="hyperProfName" name="hyperProfName" required type="text" value=""  class="value" data-bind="value: name">
                </li>
                <li>
                    <label for="hyperProfDescription">
                        <u>
                            <fmt:message key="hypervisorprofile.description" />
                        </u>
                    </label>
                    <textarea id="hyperProfDescription" name="hyperProfDescription"  class="value" data-bind="value: description"></textarea>
                </li>
                <li>
                    <label for="scvmmHostGroup">
                        <u>
                            <fmt:message key="hypervisorprofile.hypervgostgroupdestination" />
                        </u>
                    </label>
                    <div class="value">
                        <span class="icon spinner" data-bind="visible: $parent.gettingSettings() === true"></span>
                        <select id="scvmmHostGroup" name="scvmmHostGroup" required
                                data-bind="options: DellClarity.SCVMM.ViewModel.HypervisorProfile.Details.scvmmHostGroups, visible: $parent.gettingSettings() === false,
                                        optionsText: 'name', optionsCaption: '<fmt:message key="hypervisorprofile.selectgroup"/>', optionsValue: 'id', value: scvmmHostGroupId">
                        </select>
                    </div>
                </li>
                <li>
                    <label for="scvmmHostProfile">
                        <u>
                            <fmt:message key="hypervisorprofile.scvmmhostprofile" />
                        </u>
                    </label>
                    <div class="value">
                        <span class="icon spinner" data-bind="visible: $parent.gettingSettings() === true"></span>

                        <select id="scvmmHostProfile" name="scvmmHostProfile" required
                                data-bind="options: DellClarity.SCVMM.ViewModel.HypervisorProfile.Details.scvmmHostProfiles, visible: $parent.gettingSettings() === false,
                                optionsText: 'name', optionsCaption: '<fmt:message key="hypervisorprofile.selectprofile"/>' , optionsValue:'id', value: scvmmHostProfileId">
                        </select>
                    </div>
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="hypervisorprofile.installdrivers" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <input id="applyLifeCycle" type="checkbox" class="value" data-bind="checked: applyLifecycleDrivers" />
                    <label for="applyLifeCycle">
                        <u>
                            <fmt:message key="hypervisorprofile.applyLifeCycle" />
                        </u>
                    </label>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="lc_libraryServer">
                                <u>
                                    <fmt:message key="hypervisorprofile.scvmmlibrary" />
                                </u>
                            </label>
                            <div class="value">
                                <span class="icon spinner" data-bind="visible: $parent.gettingSettings() === true"></span>

                                <select id="lc_libraryServer" type="text" data-bind="visible: $parent.gettingSettings() === false, enable: applyLifecycleDrivers, options: DellClarity.SCVMM.ViewModel.HypervisorProfile.Details.scvmmLibraryServers,
                                    optionsText: 'name', optionsValue: 'id', optionsCaption: '<fmt:message key="hypervisorprofile.selectLibrary"/>', value: lifecycleSCVMMLibraryServerId" ></select>
                            </div>
                        </li>
                        <li>
                            <label for="hypervisorVersion">
                                <u>
                                    <fmt:message key="hypervisorprofile.hypervisorversion" />
                                </u>
                            </label>
                            <div class="value">
                                <span class="icon spinner" data-bind="visible: $parent.gettingSettings() === true"></span>
                                <select id="hypervisorVersion" name="hypervisorVersion" required
                                    data-bind="enable: applyLifecycleDrivers, visible: $parent.gettingSettings() === false, options: DellClarity.SCVMM.ViewModel.HypervisorProfile.Details.hypervisorVersions, 
                                    optionsText: 'name', optionsValue:'id', optionsCaption: '<fmt:message key="hypervisorprofile.selectversion"/>', value: hypervisorVersionId">
                                </select>
                            </div>
                            
                        </li>
                    </ul>
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="with: model">
            <legend>
                <fmt:message key="hypervisorprofile.winpebootimagesource" />
            </legend>
            <ul id="imagesources" class="labelValuePairs">
                <li>
                    <input type="radio" name="winbootImgSrc" value="network" id="winPeNetwork" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPeNetwork">
                        <u>
                            <fmt:message key="hypervisorprofile.network" />
                        </u>
                    </label>
                </li>
                <li>
                    <input id="winPePxe" name="winbootImgSrc" value="winPePxe" type="radio" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPePxe">
                        <u>
                            <fmt:message key="hypervisorprofile.pxe" />
                        </u>
                    </label>
                </li>
                <li>
                    <input id="winPeVflashWith" name="winbootImgSrc" value="vFlashWithWinPe" type="radio" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPeVflashWith">
                        <u>
                            <fmt:message key="hypervisorprofile.vflashwithwinpeimage" />
                        </u>
                    </label>
                </li>
                <li>
                    <input id="winPeVflashCopy" name="winbootImgSrc" value="vFlashCopyWinPe" type="radio" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPeVflashCopy">
                        <u>
                            <fmt:message key="hypervisorprofile.vflashcopywinpeimage" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>
        <!-- ko with: model -->
        <fieldset data-bind="visible: winPeBootImageSource() == 'network'">
            <legend>
                <fmt:message key="hypervisorprofile.network" />
            </legend>
            <p>
                <fmt:message key="hypervisorprofile.help" />
            </p>
            <ul class="labelValuePairs">
                <li>
                    <label for="networkWinPe">
                        <u>
                            <fmt:message key="hypervisorprofile.network.networkwinpepath" />
                        </u>
                    </label>
                    <input id="networkWinPe" name="networkWinPe" type="text" class="value" data-bind="value: networkWinPePath, attr:{required: winPeBootImageSource() === 'network'}">
                    <ul class="labelValuePairs">
                        <li>
                            <label for="winPeUser">
                                <u>
                                    <fmt:message key="hypervisorprofile.network.winpepathusername" />
                                </u>
                            </label>
                            <input id="winPeUser" name="winPeUser" type="text" value="" class="value"
                                   data-bind="value: networkWinPePathUsername, attr:{required: winPeBootImageSource() === 'network'}">
                        </li>
                        <li>
                            <label for="winPePass">
                                <u>
                                    <fmt:message key="hypervisorprofile.network.winpepathpassword" />
                                </u>
                            </label>
                            <input id="winPePass" name="winPePass" type="text" value="" class="value"
                                   data-bind="value: networkWinPePathPassword, attr:{required: winPeBootImageSource() === 'network'}">
                        </li>
                        <li>
                            <label for="winPeDomain">
                                <u>
                                    <fmt:message key="hypervisorprofile.network.domain" />
                                </u>
                            </label>
                            <input id="winPeDomain" name="winPeDomain" type="text" value="" class="value"
                                   data-bind="value: networkWinPePathDomainName, attr: { required: winPeBootImageSource() === 'network' }">
                        </li>
                    </ul>
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="visible: winPeBootImageSource() == 'vFlashWithWinPe'">
            <legend>
                <fmt:message key="hypervisorprofile.vflashwithwinpeimage" />
            </legend>
            <p>
                <fmt:message key="hypervisorprofile.help" />
            </p>
            <ul class="labelValuePairs">
                <li>
                    <label for="partitionIndex">
                        <u>
                            <fmt:message key="hypervisorprofile.vflashwithwinpeimage.partitionindex" />
                        </u>
                    </label>
                    <input id="partitionIndex" name="partitionIndex" type="number" max="3" step="1" value="3" class="value"
                           data-bind="value: vFlashWithWinPeImagePartitionIndex, attr:{required: winPeBootImageSource() === 'vFlashWithWinPe',
                                                                                       min: winPeBootImageSource() == 'vFlashWithWinPe' ? 1 : 0}">
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="visible: winPeBootImageSource() == 'vFlashCopyWinPe'">
            <legend>
                <fmt:message key="hypervisorprofile.vflashcopywinpeimage" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <span class="label">
                        <label for="winPeIsoPath">
                            <u>
                                <fmt:message key="hypervisorprofile.vflashcopywinpeimage.isopath" />
                            </u>
                        </label>
                    </span>
                    <input id="winPeIsoPath" type="text" class="value" data-bind="value: vFlashCopyWinPeImageIsoPath, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe'}">
                    <ul class="labelValuePairs">
                        <li>
                            <label for="winPeIsoUser">
                                <u>
                                    <fmt:message key="hypervisorprofile.vflashcopywinpeimage.isopathusername" />
                                </u>
                            </label>
                            <input id="winPeIsoUser" type="text" value=""  class="value"
                                   data-bind="value: vFlashCopyWinPeImageIsoPathUsername, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe'}">
                        </li>
                        <li>
                            <label for="winPeIsoPass">
                                <u>
                                    <fmt:message key="hypervisorprofile.vflashcopywinpeimage.isopathpassword" />
                                </u>
                            </label>
                            <input id="winPeIsoPass" type="text" value=""  class="value"
                                   data-bind="value: vFlashCopyWinPeImageIsoPathPassword, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe'}">
                        </li>
                        <li>
                            <label for="isoPathPartitionIndex">
                                <u>
                                    <fmt:message key="hypervisorprofile.vflashwithwinpeimage.partitionindex" />
                                </u>
                            </label>
                            <input id="isoPathPartitionIndex" type="number" max="3" step="1" value="3" class="value"
                                   data-bind="value: vFlashCopyWinPeImagePartitionIndex, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe',
                                                                                            min: winPeBootImageSource() == 'vFlashCopyWinPe' ? 1 : 0}">
                        </li>
                    </ul>
                </li>
            </ul>
        </fieldset>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="hypervisorprofile.installomsa" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <input id="installOmsa" type="checkbox" class="value" data-bind="checked: installOmsa" />
                    <label for="installOmsa">
                        <u>
                            <fmt:message key="hypervisorprofile.installomsa" />
                        </u>
                    </label>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="omsaMsiPath">
                                <u>
                                    <fmt:message key="hypervisorprofile.omsamsipath" />
                                </u>
                            </label>
                            <input id="omsaMsiPath" name="omsaMsiPath" type="text" class="value" data-bind="enable: installOmsa, value: omsaMsiPath, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe' && installOmsa}">
                            <ul class="labelValuePairs">
                                <li>
                                    <label for="omsaUserName">
                                        <u>
                                            <fmt:message key="hypervisorprofile.omsaadminusername" />
                                        </u>
                                    </label>
                                    <input id="omsaUserName" name="omsaUserName" type="text" value=""  class="value"
                                           data-bind="enable: installOmsa, value: omsaAdminUsername, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe' && installOmsa}">
                                </li>
                                <li>
                                    <label for="omsaPass">
                                        <u>
                                            <fmt:message key="hypervisorprofile.omsaadminpassword" />
                                        </u>
                                    </label>
                                    <input id="omsaPass" name="omsaPass" type="password" value=""  class="value"
                                           data-bind="enable: installOmsa, value: omsaAdminPassword, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe' && installOmsa}">
                                </li>
                            </ul>
                        </li>
                    </ul>
                </li>
            </ul>
        </fieldset>
        <!-- /ko -->
        <div class="sectionEditButtons">
            <button id="hypervisorFinish" type="submit">
                <fmt:message key="hypervisorprofile.finish" />
            </button>
            <button id="hypervisorCancel" type="button">
                <fmt:message key="hypervisorprofile.cancel" />
            </button>
        </div>
    </form>
</section>
