<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="masterDetails" data-bind="with: DellClarity.SCVMM.ViewModel.HypervisorMasterDetails">
    <section class="master" id="hypervisorMaster">
        <header class="page-heading">
            <h1>
                <fmt:message key="hypervisorMasterDetails.title" />
            </h1>
        </header>
        <nav class="action-buttons">
            <ul class="inlineList taskbar">
                <li>
                    <!--a id="createHypervisor" href="#/hypervisorProfile.wizard"><fmt:message key="generic.create" /></a-->
                    <button id="createHypervisor" class="cui-button cux-button cux-button-medium  cux-button-primary" type="button" onclick="window.location.href='#/hypervisorProfile.wizard'">
                        <i class="cux-icon cux-icon-file-text"></i><span>
                            <fmt:message key="generic.create" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a id="editHypervisor" data-bind="styledDisabled: hyperVisorTable().checkedRows().length !== 1"><fmt:message key="genericTerms.edit" /></a-->
                    <button id="editHypervisor" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: hyperVisorTable().checkedRows().length !== 1" type="button">
                        <i class="cux-icon cux-icon-edit"></i><span>
                            <fmt:message key="genericTerms.edit" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a id="deleteHypervisor" data-bind="styledDisabled: hyperVisorTable().selectedItemCount() === 0"><fmt:message key="generic.delete" /></a-->
                    <button id="deleteHypervisor" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: hyperVisorTable().selectedItemCount() === 0" type="button">
                        <i class="cux-icon cux-icon-trash"></i><span>
                            <fmt:message key="generic.delete" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a id="refreshHypervisorTable"><fmt:message key="generic.refresh" /></a-->
                    <button id="refreshHypervisorTable" class="cui-button cux-button cux-button-medium  cux-button-primary" type="button">
                        <i class="cux-icon cux-icon-repeat"></i><span>
                            <fmt:message key="generic.refresh" />
                        </span>
                    </button>
                </li>
            </ul>
        </nav>
        <form id="hypervisorProfileForm">
            <fieldset>
                <legend class="visuallyhidden">
                    <fmt:message key="hypervisorMasterDetails.table" />
                </legend>
                <div class="master-table-wrapper">
                    <!-- ko with: hyperVisorTable -->
                    <table id="hyperVisorTable" class="dataTable">
                        <thead>
                            <tr>
                                <th scope="col" class="checkboxColumn">
                                    <input id="selectAllHyperVisor" type="checkbox" />
                                    <label for="selectAllHyperVisor" class="visuallyhidden">
                                        <fmt:message key="hypervisorMasterDetails.selectAll" />
                                    </label>
                                </th>
                                <th scope="col"><strong>
                                    <fmt:message key="generic.name" />
                                </strong></th>
                                <th scope="col"><strong>
                                    <fmt:message key="hypervisorMasterDetails.installsource" />
                                </strong></th>
                                <th scope="col"><strong>
                                    <fmt:message key="hypervisorMasterDetails.hostGroup" />
                                </strong></th>
                                <th scope="col"><strong>
                                    <fmt:message key="hypervisorMasterDetails.hostProfile" />
                                </strong></th>
                                <th scope="col"><strong>
                                    <fmt:message key="hypervisorMasterDetails.dellLCDriverSelected" />
                                </strong></th>
                                <th scope="col"><strong>
                                    <fmt:message key="hypervisorMasterDetails.hyperVersion" />
                                </strong></th>
                            </tr>
                        </thead>
                        <!-- ko if: loading() -->
                        <tbody>
                            <tr>
                                <td colspan="7">
                                    <fmt:message key="scrollabletable.loading" />
                                    <span>&nbsp;</span>
                                    <span class="icon spinner"></span>
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && (!data || data().length == 0) -->
                        <tbody>
                            <tr>
                                <td colspan="7">
                                    <fmt:message key="scrollabletable.empty" />
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && data && data().length > 0 -->
                        <tbody data-bind="foreach: data">
                            <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.HypervisorMasterDetails.selectedHypervisor() === $data }">
                                <td class="checkboxColumn">
                                    <input type="checkbox" data-bind="checked: checked, indexedid: 'hypervisorProfile_'" />
                                    <label class="visuallyhidden" data-bind="indexedfor: 'hypervisorProfile_'">HyperVisor Profile Choice</label>
                                </td>
                                <td data-bind="text: $data.name"></td>

                                <!-- ko if: $data.winPeBootImageSource === 'network' -->
                                <td data-bind="text: $data.networkWinPePath"></td>
                                <!-- /ko -->

                                <!-- ko if: $data.winPeBootImageSource === 'winPePxe' -->
                                <td>
                                    <fmt:message key="hypervisorMasterDetails.pxe" />
                                </td>
                                <!-- /ko -->

                                <!-- ko if: $data.winPeBootImageSource === 'vFlashWithWinPe' -->
                                <td>
                                    <fmt:message key="hypervisorMasterDetails.vFlashWinPe" />
                                </td>
                                <!-- /ko -->

                                <!-- ko if: $data.winPeBootImageSource === 'vFlashCopyWinPe' -->
                                <td data-bind="text: $data.vFlashCopyWinPeImageIsoPath"></td>
                                <!-- /ko -->

                                <td data-bind="text: $data.scvmmHostGroupName"></td>
                                <td data-bind="text: $data.scvmmHostProfileName"></td>
                                <td data-bind="text: ($data.applyLifecycleDrivers==true)?'Yes':'No'"></td>
                                <td data-bind="text: $data.hypervisorVersionName"></td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                    </table>
                    <!-- /ko -->
                </div>
            </fieldset>
        </form>
    </section>
    <section class="details" id="hypervisorDetails" data-bind="visible: selectedHypervisor() !== undefined">
        <header>
            <h1>
                <fmt:message key="generic.details" />
            </h1>
        </header>
        <ul class="labelValuePairs" data-bind="if: selectedHypervisor() !== undefined">
            <li>
                <label for="detailsName"><u>
                    <fmt:message key="generic.name" />
                </u></label>
                <span id="detailsName" class="value" data-bind="text: selectedHypervisor().name"></span>
            </li>
            <li>
                <label for="detailsDescription"><u>
                    <fmt:message key="generic.description" />
                </u></label>
                <span id="detailsDescription" class="value" data-bind="text: selectedHypervisor().description"></span>
            </li>

            <li>
                <label for="dateCreated"><u>
                    <fmt:message key="hypervisorMasterDetails.created" />
                </u></label>
                <span id="dateCreated" class="value" data-bind="time: selectedHypervisor().dateCreated, timeFormat: 'LLL'"></span>
            </li>

            <li>
                <label for="dateModified"><u>
                    <fmt:message key="hypervisorMasterDetails.modified" />
                </u></label>
                <span id="dateModified" class="value" data-bind="time: selectedHypervisor().dateModified, timeFormat: 'LLL'"></span>
            </li>
        </ul>
    </section>
</div>
