<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="hypervisorProfileWizardBootImageSection" data-bind="with: DellClarity.SCVMM.ViewModel.HypervisorProfile.Wizard.model ">
    <header><h1><fmt:message key="hypervisorprofile.winPeBootImage.title" /></h1></header>
    <form>
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="hypervisorprofile.awinPeBootImage.title" />
            </legend>
            <p><fmt:message key="hypervisorprofile.winPeBootImage.help" /></p>
            <!-- BETA: out of scope for the beta, please don't remove -->
                <!--<ul id="imagesources" class="labelValuePairs">
                <li>
                    <input type="radio" name="winbootImgSrc" value="network" id="winPeNetwork" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPeNetwork">
                        <u>
                            <fmt:message key="hypervisorprofile.network" />
                        </u>
                    </label>
                </li>
                <li>
                    <input id="winPePxe" name="winbootImgSrc" value="winPePxe" type="radio" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPePxe">
                        <u>
                            <fmt:message key="hypervisorprofile.pxe" />
                        </u>
                    </label>
                </li>
                <li>
                    <input id="winPeVflashWith" name="winbootImgSrc" value="vFlashWithWinPe" type="radio" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPeVflashWith">
                        <u>
                            <fmt:message key="hypervisorprofile.vflashwithwinpeimage" />
                        </u>
                    </label>
                </li>
                <li>
                    <input id="winPeVflashCopy" name="winbootImgSrc" value="vFlashCopyWinPe" type="radio" class="value" data-bind="checked: winPeBootImageSource">
                    <label for="winPeVflashCopy">
                        <u>
                            <fmt:message key="hypervisorprofile.vflashcopywinpeimage" />
                        </u>
                    </label>
                </li>
            </ul>-->
        </fieldset>
        <fieldset id="networkSection" data-bind="visible: winPeBootImageSource() == 'network'">
            <legend class="visuallyhidden">
                <fmt:message key="hypervisorprofile.network" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="networkWinPe">
                        <u>
                            <fmt:message key="hypervisorprofile.network.networkwinpepath" />
                        </u>
                    </label>
                    <input id="networkWinPe" name="networkWinPe" type="text" class="value" data-bind="event: { blur: DellClarity.SCVMM.ViewModel.HypervisorProfile.WinPeBootImageSource.validateNetworkWinPePath }, value: networkWinPePath, attr: { required: winPeBootImageSource() === 'network' }" placeholder='<fmt:message key="hypervisorprofile.winpebootimagesource.networkpathplaceholder" />'>
                </li>

                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="hypervisorprofile.network.credentialprofile" />
                        </u>
                    </span>
                    <span class="value">
                        <label for="credProfile" class="visuallyhidden">
                            <u>
                                <fmt:message key="hypervisorprofile.network.credentialprofile" />
                            </u>
                        </label>
                        <select id="credProfile" name="credProfile" required
                            data-bind="options: DellClarity.SCVMM.ViewModel.HypervisorProfile.Wizard.credProfiles,
                                        optionsText: 'name',
                                        optionsValue: 'id',
                                        value: networkWinPeCredentialProfile,
                                        optionsCaption: '<fmt:message key="hypervisorprofile.network.selectcredentialprofile"/>' ">                     
                        </select>
                        <a id="createCredProfile" data-bind="attr: { href: '#/credentialProfile.details' }">
                            <fmt:message key="hypervisorprofile.network.createnew" />
                        </a>
                    </span>
                </li>
            </ul>
        </fieldset>
        <fieldset id="vFlashWithWinPeFieldset" data-bind="visible: winPeBootImageSource() == 'vFlashWithWinPe'">
            <legend>
                <fmt:message key="hypervisorprofile.vflashwithwinpeimage" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="partitionIndex">
                        <u>
                            <fmt:message key="hypervisorprofile.vflashwithwinpeimage.partitionindex" />
                        </u>
                    </label>
                    <input id="partitionIndex" name="partitionIndex" type="number" max="3" step="1" value="3" class="value"
                            data-bind="value: vFlashWithWinPeImagePartitionIndex, attr:{required: winPeBootImageSource() === 'vFlashWithWinPe',
                                                                                        min: winPeBootImageSource() == 'vFlashWithWinPe' ? 1 : 0}">
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="visible: winPeBootImageSource() == 'vFlashCopyWinPe'">
            <legend>
                <fmt:message key="hypervisorprofile.vflashcopywinpeimage" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <span class="label">
                        <label for="winPeIsoPath">
                            <u>
                                <fmt:message key="hypervisorprofile.vflashcopywinpeimage.isopath" />
                            </u>
                        </label>
                    </span>
                    <input id="winPeIsoPath" type="text" class="value" data-bind="value: vFlashCopyWinPeImageIsoPath, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe'}" placeholder='<fmt:message key="hypervisorprofile.winpebootimagesource.winpeisopathplaceholder" />'>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="isoPathPartitionIndex">
                                <u>
                                    <fmt:message key="hypervisorprofile.vflashwithwinpeimage.partitionindex" />
                                </u>
                            </label>
                            <input id="isoPathPartitionIndex" type="number" max="3" step="1" value="3" class="value"
                                   data-bind="value: vFlashCopyWinPeImagePartitionIndex, attr:{required: winPeBootImageSource() === 'vFlashCopyWinPe',
                                                                                            min: winPeBootImageSource() == 'vFlashCopyWinPe' ? 1 : 0}">
                        </li>
                    </ul>
                </li>
            </ul>
        </fieldset>
        <!-- BETA: out of scope for the beta, please don't remove -->
        <!--<fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="hypervisorprofile.installomsa" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <input id="installOmsa" type="checkbox" class="value" data-bind="checked: installOmsa" />
                    <label for="installOmsa">
                        <u>
                            <fmt:message key="hypervisorprofile.installomsa" />
                        </u>
                    </label>
                    <ul class="labelValuePairs">
                        <li>
                            <label for="omsaMsiPath">
                                <u>
                                    <fmt:message key="hypervisorprofile.omsamsipath" />
                                </u>
                            </label>
                            <input id="omsaMsiPath" name="omsaMsiPath" type="text" class="value" data-bind="enable: installOmsa, value: omsaMsiPath, attr:{required: installOmsa}" placeholder='<fmt:message key="hypervisorprofile.winpebootimagesource.omsamsipathplaceholder" />'>
                        </li>
                    </ul>
                </li>
            </ul>
        </fieldset>-->
    </form>
</section>
