<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="masterDetails">
    <section id="page_jobs_master" class="master" data-bind="with: DellClarity.SCVMM.ViewModel.Jobs.Details">
        <header class="visuallyhidden">
            <h1>
                <fmt:message key="jobs.details.deploymentjobdetails" />
            </h1>
        </header>
        <form>
            <fieldset>
                <legend>
                    <fmt:message key="jobs.details.deploymentjobdetails" />
                    :
                <span id="deploymentJobTitle" class="value" data-bind="text: name"></span>
                </legend>
                <nav>
                    <ul class="inlineList">
                        <li>
                            <a id="exportToCSV">
                                <fmt:message key="jobs.details.exporttocsv" />
                            </a>
                        </li>
                    </ul>
                </nav>
                <table id="detailsTable" class="dataTable">
                    <thead>
                        <tr>
                            <!-- ko if: DellClarity.SCVMM.ViewModel.Jobs.JobViewer.selectedJob().type === 'Deployment' --> 
                            <th scope="col">
                                <fmt:message key="jobs.details.servicetag" />
                            </th>
                            <!-- /ko -->
                            <th scope="col">
                                <fmt:message key="jobs.details.idracip" />
                            </th>
                            <th scope="col">
                                <fmt:message key="jobs.details.status" />
                            </th>
                            <th scope="col">
                                <fmt:message key="jobs.details.warnings" />
                            </th>
                            <th scope="col">
                                <fmt:message key="jobs.details.deploymentjobdetails" />
                            </th>
                            <th scope="col">
                                <fmt:message key="jobs.details.starttime" />
                            </th>
                            <th scope="col">
                                <fmt:message key="jobs.details.endtime" />
                            </th>
                        </tr>
                    </thead>
                    <tbody data-bind="foreach: jobSteps">
                        <tr data-bind="css: { 'selected': $parent.detailsJob() === $data}">
                            <!-- ko if: DellClarity.SCVMM.ViewModel.Jobs.JobViewer.selectedJob().type === 'Deployment' --> 
                            <td>
                                <span data-bind="text: serviceTag"></span>
                            </td>
                            <!-- /ko -->
                            <td>
                                <span data-bind="text: iDracIp"></span>
                            </td>
                            <td>
                                <span data-bind="text: status"></span>
                            </td>
                            <td>
                                <span data-bind="text: warnings"></span>
                            </td>
                            <td>
                                <span class="toolTip-Dynamic" data-bind="text:details, attr: {title: details}"></span>
                            </td>
                            <td>
                                <span data-bind="text: startTime"></span>
                            </td>
                            <td>
                                <span data-bind="text: endTime"></span>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </fieldset>
        </form>
    </section>
    <section id="page_jobs_details" class="details" data-bind="with: DellClarity.SCVMM.ViewModel.Jobs.Details.detailsJob">
        <header class="visuallyhidden">
            <h1>
                <fmt:message key="jobs.details.deploymentjobdetails" />
            </h1>
        </header>
        <ul class="labelValuePairs">
            <li>
                <label for="deploymentJob">
                    <u>
                        <fmt:message key="jobs.details.deploymentjob" />
                    </u>
                </label>
                <span id="deploymentJob" class="value" data-bind="text: DellClarity.SCVMM.ViewModel.Jobs.Details.jobName"></span>
            </li>
            <li>
                <label for="serverIP">
                    <u>
                        <fmt:message key="jobs.details.serverip" />
                    </u>
                </label>
                <span id="serverIP" class="value" data-bind="text: serverIp"></span>
            </li>
            <li>
                <label for="startTime">
                    <u>
                        <fmt:message key="jobs.details.starttime" />
                    </u>
                </label>
                <span id="startTime" class="value" data-bind="text: startTime"></span>
            </li>
            <li>
                <label for="endTime">
                    <u>
                        <fmt:message key="jobs.details.endtime" />
                    </u>
                </label>
                <span id="endTime" class="value" data-bind="text: endTime"></span>
            </li>
            <li>
                <label for="deploymentStatus">
                    <u>
                        <fmt:message key="jobs.details.deploymentstatus" />
                    </u>
                </label>
                <span id="deploymentStatus" class="value" data-bind="text: status"></span>
            </li>
            <li>
                <label for="deploymentJobDetails">
                    <u>
                        <fmt:message key="jobs.details.deploymentjobdetails" />
                    </u>
                </label>
                <span id="deploymentJobDetails" class="value" data-bind="text: details"></span>
            </li>
        </ul>
    </section>
</div>
