<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_jobViewer_jobTree"  data-bind="with: DellClarity.SCVMM.ViewModel.Jobs.JobViewer">
    <header><h1><fmt:message key="jobviewer.jobtree.title" /></h1></header>
    <section id="error_jobViewer" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    <p>
        <fmt:message key="jobviewer.jobtree.help" />
    </p>
    <form>
        <fieldset id="jobFilterFieldSet">
            <legend class="visuallyhidden"><fmt:message key="jobviewer.jobfilter" /></legend>
            <label for="jobFilter"><fmt:message key="jobviewer.filter" /></label>
            <select id="jobFilter" data-bind="options: jobTypesList,
                                                optionsText: 'name',
                                                optionsValue: 'id',
                                                value: selectedFilter"></select>
        </fieldset>
        <section>
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="jobviewer.welcome.deployments" />
                </h1>
            </header>
            <nav>
                <ul class="inlineList">
                    <li>
                        <a id="deployRefresh" class="jobRefresh" tabindex="1">
                            <fmt:message key="jobviewer.welcome.refresh" />
                        </a>
                    </li>
                    <!-- Not Supported in BETA -->
                    <!--<li>
                        <a id="ExportToCSV" tabindex="2">
                            <fmt:message key="jobviewer.welcome.exporttocsv" />
                        </a>
                    </li>
                    <li>
                        <a id="deployPurgeJob" tabindex="2">
                            <fmt:message key="jobviewer.welcome.purgejob" />
                        </a>
                    </li>-->
                </ul>
            </nav>
            <!-- ko with: table -->
            <table id="deploymentTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" data-bind="sort: 'name'">
                            <strong><fmt:message key="jobviewer.jobtree.jobname" /></strong>
                        </th>
                        <th scope="col" data-bind="sort: 'type'">
                            <strong><fmt:message key="jobviewer.jobtype" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="jobviewer.jobtree.jobdescription" /></strong>
                        </th>
                        <th scope="col" data-bind="sort:'startTime'">
                            <strong><fmt:message key="jobviewer.jobtree.dateStarted" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="jobviewer.jobtree.endtime" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="jobviewer.jobtree.jobstatus" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="jobviewer.jobtree.jobcompletionstatus" /></strong>
                        </th>
                    </tr>
                </thead>
                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="7">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && (!data || data().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="7">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr> <!-- data-bind="css: { 'selected': $parent.selectedJob() === $data }"> -->
                        <!-- ko if: steps !== null -->
                            <!-- ko if: steps.length >= 1 -->
                            <td>
                                <a data-bind="text: name, indexedid: 'jobName'" href="#/jobs.details"></a>
                            </td>
                            <!-- /ko -->
                            <!-- ko if: steps.length === 0 -->
                            <td>
                                <span data-bind="text: name, indexedid: 'jobName'"></span>
                            </td>
                            <!-- /ko -->
                        <!-- /ko -->
                        <!-- ko if: steps === null -->
                            <td>
                                <span data-bind="text: name, indexedid: 'jobName'"></span>
                            </td>
                        <!-- /ko -->
                        <td>
                            <span data-bind="text:type"></span>
                        </td>
                        <td>
                            <span data-bind="text: description"></span>
                        </td>
                        <td>
                            <time data-bind="time: startTime, timeFormat: 'LLL'"></time>
                        </td>
                        <td>
                            <time data-bind="time: endTime, timeFormat: 'LLL'"></time>
                        </td>
                        <td>
                            <span data-bind="text: status"></span>
                        </td>
                        <td>
                            <span data-bind="text: completionStatus"></span>
                            <!-- ko if: isRunning -->
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                            <!-- /ko -->
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() -->
                <tfoot>
                    <tr>
                        <td colspan="7">
                            <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                            <!-- /ko -->
                        </td>
                    </tr>
                </tfoot>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </section>
    </form>
</section>

