<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_joblogviewer" data-bind="with: DellClarity.SCVMM.ViewModel.jobLogView">
    <header class="page-heading">
        <h1>
            <fmt:message key="joblogviewer.title" />
        </h1>
    </header>
    <section id="error_joblogviewer" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    <p>
        <fmt:message key="joblogviewer.help" />
    </p>
    <form>
        <p>
            <!--fmt:message key="discovery.home.help" /-->
        </p>

        <fieldset>
            <legend class="visuallyhidden">
                <!--fmt:message key="discovery.home.title" /-->
            </legend>


            <nav id="tabMenu" class="menu tabs" role="navigation">
                <ul>
                    <li>
                        <a href="#/jobLog.home" id="running">
                            <fmt:message key="joblogviewer.tab.running" />
                        </a>
                    </li>
                    <li>
                        <a href="#/jobLog.home/history" id="history">
                            <fmt:message key="joblogviewer.tab.history" />
                        </a>
                    </li>
                    <li>
                        <a href="#/jobLog.home/scheduled" id="scheduled">
                            <fmt:message key="joblogviewer.tab.scheduled" />
                        </a>
                    </li>
                    <li>
                        <a href="#/jobLog.home/log" id="log">
                            <fmt:message key="joblogviewer.tab.logs" />
                        </a>
                    </li>
                </ul>
            </nav>

            <section class="tabPanel" data-bind="visible: activeTab() == 'running'">
                <header class="visuallyhidden">
                    <h1>
                        <!--fmt:message key="discovery.home.title" /-->
                    </h1>
                </header>
                <!--fieldset id="Fieldset2">
            <legend class="visuallyhidden"><fmt:message key="jobviewer.jobfilter" /></legend>
            <label for="jobFilter"><fmt:message key="jobviewer.filter" /></label>
            <select id="jobFilter" data-bind="options: jobTypesList,
                                                optionsText: 'name',
                                                optionsValue: 'id',
                                                value: selectedFilter"></select>
         </!--fieldset-->
                <nav class="action-buttons">
                    <ul class="inlineList">
                        <li>
                            <!--a id="jobRefresh" class="jobRefresh" data-bind="styledDisabled: disableLink()">
                                    <fmt:message key="managejobs.welcome.refresh" />
                                </a-->
                            <button id="jobRefresh" class="jobRefresh cui-button cux-button cux-button-medium cux-button-primary" data-bind="styledDisabled: disableLink()" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="managejobs.welcome.refresh" />
                                </span>
                            </button>
                        </li>

                    </ul>
                </nav>


                <div>
                    <table id="runningjobsTable" class="dataTable"></table>
                    <div class="noResultsDiv" hidden>
                        <span class="notice">
                            <label>
                                <fmt:message key="joblogviewer.tab.nodata" />
                            </label>
                        </span>
                    </div>
                    <div id="runningjobsTablePager"></div>
                </div>

            </section>
            <section class="tabPanel" data-bind="visible: activeTab() == 'history'">
                <header class="visuallyhidden">
                    <h1>
                        <!--fmt:message key="discovery.home.title" /-->
                        History
                    </h1>
                </header>
                <fieldset id="joblogHistoryFilterFieldSet" data-bind="visible: DellClarity.Config.consoleType != 'scom'">
                    <legend class="visuallyhidden">
                        <fmt:message key="jobviewer.jobfilter" />
                    </legend>
                    <label for="jobFilter">
                        <fmt:message key="jobviewer.filter" />
                    </label>
                    <select id="jobFilter" data-bind="options: jobTypesList,
                        optionsText: 'name',
                        optionsValue: 'id',
                        value: selectedFilter">
                    </select>
                </fieldset>
                <nav>
                    <ul class="inlineList">
                        <li>
                            <!--a id="jobRefresh" class="jobRefresh" data-bind="styledDisabled: disableLink()">
                        <fmt:message key="managejobs.welcome.refresh" />
                    </a-->
                            <nav class="action-buttons">
                                <button id="jobRefresh" class="jobRefresh cui-button cux-button cux-button-medium cux-button-primary" data-bind="styledDisabled: disableLink()" type="button">
                                    <i class="cux-icon cux-icon-repeat"></i><span>
                                        <fmt:message key="managejobs.welcome.refresh" />
                                    </span>
                                </button>
                            </nav>
                        </li>

                    </ul>
                </nav>

                <div>
                    <table id="historyjobsTable" class="dataTable"></table>
                    <div class="noResultsDiv" hidden>
                        <span class="notice">
                            <label>
                                <fmt:message key="joblogviewer.tab.nodata" />
                            </label>
                        </span>
                    </div>
                    <div id="historyjobsTablePager"></div>
                </div>


            </section>

            <section class="tabPanel" data-bind="visible: activeTab() == 'scheduled'">
                <header class="visuallyhidden">
                    <h1>
                        <!--fmt:message key="discovery.home.title" /-->
                        Scheduled
                    </h1>
                </header>
                <fieldset id="joblogFilterFieldSet" data-bind="visible: DellClarity.Config.consoleType != 'scom'">
                    <legend class="visuallyhidden">
                        <fmt:message key="jobviewer.jobfilter" />
                    </legend>
                    <label for="jobFilter">
                        <fmt:message key="jobviewer.filter" />
                    </label>
                    <select id="jobFilter" data-bind="options: jobTypesList,
                        optionsText: 'name',
                        optionsValue: 'id',
                        value: selectedFilter">
                    </select>
                </fieldset>
                <nav class="action-buttons">
                    <ul class="inlineList">
                        <li>
                            <!--a id="jobRefresh" class="jobRefresh" data-bind="styledDisabled: disableLink()">
                                <fmt:message key="managejobs.welcome.refresh" />
                            </a-->
                            <button id="jobRefresh" class="jobRefresh cui-button cux-button cux-button-medium cux-button-primary" data-bind="styledDisabled: disableLink()" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="managejobs.welcome.refresh" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="jobCancel" data-bind="visible: DellClarity.Config.consoleType != 'scom'" class="jobCancel cui-button cux-button cux-button-medium cux-button-danger" disabled="disabled" type="button">
                                <i class="cux-icon cux-icon-remove-sign"></i><span>
                                    <fmt:message key="managejobs.welcome.cancel" />
                                </span>
                            </button>
                        </li>
                    </ul>
                </nav>

                <div>
                    <table id="scheduledjobsTable" class="dataTable"></table>
                    <div class="noResultsDiv" hidden>
                        <span class="notice">
                            <label>
                                <fmt:message key="joblogviewer.tab.nodata" />
                            </label>
                        </span>
                    </div>
                    <div id="scheduledjobsTablePager"></div>
                </div>

            </section>

            <section class="tabPanel" data-bind="visible: activeTab() == 'log'">
                <header class="visuallyhidden">
                    <h1>
                        <!--fmt:message key="discovery.home.title" /-->
                        Running
                    </h1>
                </header>
                <nav class="action-buttons">
                    <ul class="inlineList">
                        <li>
                            <!--a id="jobRefresh" class="jobRefresh" data-bind="styledDisabled: disableLink()">
                        <fmt:message key="managejobs.welcome.refresh" />
                    </a-->
                            <button id="jobRefresh" class="jobRefresh cui-button cux-button cux-button-medium cux-button-primary" data-bind="styledDisabled: disableLink()" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="managejobs.welcome.refresh" />
                                </span>
                            </button>
                        </li>

                    </ul>
                </nav>
                <div>
                    <table id="logsTable" class="dataTable"></table>
                    <div class="noResultsDiv" hidden>
                        <span class="notice">
                            <label>
                                <fmt:message key="joblogviewer.tab.nodata" />
                            </label>
                        </span>
                    </div>
                    <div id="logsTablePager"></div>
                </div>


            </section>
            <div id="pager"></div>
    </form>
</section>
