<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_lifecycletemplate_additionalconfiguration" data-bind="with: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration">
    <section id="error_additionalConfiguration" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <header>
        <h1>
            <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.title" />
        </h1>
    </header>
    <p>
        <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.help" />
    </p>

    <form id="editAttributesForm" autocomplete="off">
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.title" />
            </legend>
            <div style="overflow: auto;">
            <table class="components">
                <tbody>
                    <tr data-bind="foreach: componentIcons">
                        <td>
                            <div class="component-container" data-bind="attr: { id: componentFqdd }, css: { 'component-active': DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedComponentIndex() == $index() }">
                                <img data-bind="attr: { src: componentMetaData.iconpath, width: '45', height: '45' }" />
                            </div>
                            
                            <table class="component-title-wrapper">
                                <tbody>
                                    <tr>
                                        <td class="include-component"><input type="checkbox" class="component-select-checkbox" data-bind="checked: componentMetaData.componentSelected,
                                             event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.includeComponentCheck }"/></td>
                                        <td><span class="component-title" data-bind="text: componentName, css: { 'component-active': DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedComponentIndex() === $index() }"></span></td>
                                    </tr>
                                </tbody>
                            </table>
                        </td>
                    </tr>
                </tbody>
            </table>
            </div>
            <p>
                <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.note" /><br />
                <!-- ko if: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.deviceType() &&  DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.deviceType() == 'S2D'-->
                    <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.s2dhelp" />
                <!-- /ko -->
            </p>
        </fieldset>

        <!-- ko if: loading() -->
            <div>
                <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.loading" />
                <span>&nbsp;</span>
                <span class="icon spinner"></span>
            </div>
        <!-- /ko -->

        <!-- ko foreach: components -->
            <!-- ko if: $data !== "" -->
                <fieldset data-bind="visible: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedComponentIndex() === $index()">
                    <legend class="component-header">
                        <span data-bind="text: componentName"></span> <fmt:message key="lifecycletemplates.edittemplate.additionalconfiguration.settings" />
                    </legend>
                </fieldset>

                <div class="component-data-wrapper" data-bind="visible: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedComponentIndex() === $index()">
                    <div class="component-data">
                        <!-- ko template: { name: 'components-view-template', foreach: componentGroups } --> <!-- /ko -->
                    </div>

                    <!-- ko if: $data.containsSubComponent === true -->
                    <div class="subcomponent-data">
                        <!-- ko template: { name: 'subcomponents-view-template', foreach: subComponent } --> <!-- /ko -->
                    </div>
                    <!-- /ko -->
                </div>
                
            <!-- /ko -->
        <!-- /ko -->
    </form>
</section>

<script type="text/html" id="components-view-template">
    <!-- ko if: groupDisplayName !== 'NA' -->
        <!-- ko if: componentAttributes && componentAttributes.length > 0 -->
            <header>
                <h2>
                    <a class="toggleSection" data-bind="css: { expand: !isExpanded(), collapse: isExpanded() }, event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.toggleGroupExpand }, text: isExpanded() ? DellClarity.SCVMM.Translations.genericterms.Collapse : DellClarity.SCVMM.Translations.genericterms.Expand"></a>&nbsp;
                        <span class="component-group-title" data-bind="text: groupDisplayName"></span>
                </h2>
            </header>
         <!-- /ko -->

        <!-- ko if: isExpanded()-->
            <!-- ko template: { name: 'componentsattribute-edit-template', foreach: componentAttributes } --> <!-- /ko -->
        <!-- /ko -->
    
    <!-- /ko -->

    <!-- ko if: groupDisplayName === 'NA' -->
            <!-- ko template: { name: 'componentsattribute-edit-template', foreach: componentAttributes } --> <!-- /ko -->
    <!-- /ko -->
</script>

<script type="text/html" id="componentsattribute-edit-template">
    <ul class="labelValuePairs">
		<li data-bind="styledDisabled: $data.isReadOnly"> 
            <div class="attribute-indicator" title="Dependent Attribute" data-bind="css: { 'commented-attribute': $data.isIDRACCommented === true }"></div>

            <!-- ko if: $parents[1].componentMetaData.componenttype  != 'Virtual' -->                         
                <input type="checkbox" class="attribute-select-checkbox" data-bind="checked: $data.isUserSelected, event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.userAttributeCheck }"/>
            <!-- /ko -->

            <!-- ko if: ( $parents[1].componentMetaData.componenttype  === 'Physical' && $data.isSystemSpecific === false ) || ( $parents[1].componentMetaData.componenttype  === 'Virtual' && $data.setValue != 'Pool Value' )-->
                <!-- ko if: attributeType  != 'Boolean' -->
				<label>
					<u>
                        <span data-bind="styledDisabled: ($parents[1].componentName === 'Windows' && (attributeName === 'LOGICALNETWORK' || attributeName === 'IPSUBNET' || attributeName === 'IPADDRESS')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableWindowsAttributes() :
                                                         ($parents[1].componentName === 'Linux' && (attributeName === 'IPADDRESS' || attributeName === 'SUBNETMASK' || attributeName === 'DEFAULTGATEWAY' || attributeName === 'PRIMARYDNSSERVER' || attributeName === 'SECONDARYDNSSERVER')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxIPAttributes() :
                                                         ($parents[1].componentName === 'Linux' && attributeName === 'SHARECREDENTIALPROFILE') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxShareTypeAttributes():false,
                            text: displayName"></span>

                        <!-- ko if: attributeType === 'Range' || attributeType === 'minmaxrange' -->
	                        <span data-bind="text: '(' + possibleValues[0].attributeDisplayValue + ' - ' + possibleValues[1].attributeDisplayValue + ')'"></span>
                        <!-- /ko -->
					</u>
				</label>
                <!-- /ko -->

				<!-- ko if: attributeType === 'String' || attributeType === 'Integer' || attributeType === 'Password' -->
	                <input class='stringenum' 
                        data-bind="styledDisabled: ($parents[1].componentName === 'Windows' && (attributeName === 'LOGICALNETWORK' || attributeName === 'IPSUBNET' || attributeName === 'IPADDRESS')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableWindowsAttributes() :
                                        ($parents[1].componentName === 'Linux' && (attributeName === 'IPADDRESS' || attributeName === 'SUBNETMASK' || attributeName === 'DEFAULTGATEWAY' || attributeName === 'PRIMARYDNSSERVER' || attributeName === 'SECONDARYDNSSERVER')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxIPAttributes() :
                                        ($parents[1].componentName === 'Linux' && attributeName === 'SHARECREDENTIALPROFILE') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxShareTypeAttributes() :
                                        (attributeName === 'operatingsystems') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.operatingSystemFlag() : 
                                        ($parents[1].componentName === 'Windows' && attributeName == 'LCBOOTMEDIAIMG') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableBootImg() :false,
                                   value: setValue,
                                   style: { width: ($parents[1].componentName === 'Windows' && attributeName == 'LCBOOTMEDIAIMG' ) ? '28%': 'auto'},
                                   event: { keydown: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.validateNumber, blur: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.changeStringVal },
                                   attr: {
                                       id: attributeName,
                                       required: ((($parents[1].componentName === 'Windows' && attributeName == 'LCBOOTMEDIAIMG') || ($parents[1].componentName === 'Linux' && (attributeName === 'ROOTPASSWORD' || attributeName === 'ISOFILENAME' || attributeName === 'ISOSHAREPATH'))) && $parents[1].componentFqdd === DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedOSType() &&
                                                  DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.osComponentSelected() === true) ? true : false,
                                       placeholder: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.getPlaceholderForInput($parents[1], $data) ,
                                   type: (attributeType === 'Password') ? 'password' : (attributeType === 'Integer') ? 'number' : 'text' }" />
                <!-- /ko -->

                <!-- ko if: attributeType === 'Range'  || attributeType === 'minmaxrange' -->
	                <input type="text" class="lct-range-input" data-bind="value: setValue,
                    attr: {
                        id: attributeName,
                        min: possibleValues[0].attributeActualValue,
                        max: possibleValues[1].attributeActualValue,
                        maxlength: possibleValues[1].attributeActualValue.length
                    },
                    event: {
                        keydown: DellClarity.SCVMM.validateNumber,
                        keyup: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.validateMaxRange,
                        blur: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.validateMinRange
                    },
                    valueUpdate: 'input'"/>
                <!-- /ko -->
                   
                <!-- ko if: attributeType === 'Enumeration' -->
                <select data-bind=" styledDisabled: ($parents[1].componentName === 'Windows' && (attributeName === 'LOGICALNETWORK' || attributeName === 'IPSUBNET' || attributeName === 'IPADDRESS')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableWindowsAttributes() :
                    ($parents[1].componentName === 'Linux' && (attributeName === 'IPADDRESS' || attributeName === 'SUBNETMASK' || attributeName === 'DEFAULTGATEWAY' || attributeName === 'PRIMARYDNSSERVER' || attributeName === 'SECONDARYDNSSERVER')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxIPAttributes() :
                    ($parents[1].componentName === 'Linux' && attributeName === 'SHARECREDENTIALPROFILE') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxShareTypeAttributes():
                    (attributeName === 'operatingsystems' ) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.operatingSystemFlag()  : false,
                    value: setValue,
                    options: ($parents[1].componentName === 'Linux' && attributeName === 'OSVERSION')?DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.filterOSSPecificVersions(possibleValues):possibleValues,
                    optionsText: 'attributeDisplayValue',
                    optionsValue: 'attributeActualValue',
                    attr: {
                        id: attributeName,
                        required: ($parents[1].componentMetaData.componenttype === 'Virtual' && 
                                    (($parents[1].componentName === 'Firmware Update' && DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.fwComponentSelected()  === true) ||
                                     ((attributeName === 'OSNAME' ||
                                     (($parents[1].componentName === 'Windows' || ($parents[1].componentName === 'Linux' && (attributeName === 'OSVERSION' || attributeName === 'ISOSHARETYPE' || attributeName === 'SHARECREDENTIALPROFILE' || attributeName === 'ENABLEDHCP'))) && $parents[1].componentFqdd === DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedOSType())) && DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.osComponentSelected() === true))
                            )? true : false},
                    event: { change: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.changeEnumValueEvt },
                    optionsCaption: $parents[1].componentMetaData.componenttype === 'Virtual' ? 'Select' : null">
                </select>
                              
                <!-- /ko -->

                <!-- ko if: attributeType  === 'OSBoolean' -->
                <!-- <div> -->
                    <input type="checkbox" 
                        data-bind="checked: setValue == 'true', 
                                   styledDisabled: (attributeName === 'networkfallback') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.deploymentMethod() === 'networkboot' : false,
                                   event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.checkBoxBindRetValue }" />
                    <span data-bind="text: displayName"></span>
                <!-- </div> -->
                <!-- /ko -->

                <!-- ko if: attributeType  === 'Date' -->
                    <input type="text" data-bind="value: setValue" />
                <!-- /ko -->

                <!-- ko if: $parents[1].componentMetaData.componenttype  === 'Virtual' && attributeType  === 'Boolean'-->                         
                    <input type="checkbox" data-bind="checked: $data.isUserSelected, event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.checkBoxBindRetValue }"/>
                    <span data-bind="text: displayName"></span>
                <!-- /ko -->

                <!-- ko if: $parents[1].componentMetaData.componenttype  != 'Virtual' && attributeType  === 'Boolean' -->
                    <span data-bind="text: displayName"></span>
                <!-- /ko -->

                <!-- ko if: attributeType === 'OrderListSeq' -->
                            
                <div class="value">
                    <div class="order-list-seq">
                        <ul data-bind="foreach: possibleValues">
                            <li class="order-list-element" data-bind="event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectListItem }">
                                <span data-bind="text: $data.attributeDisplayValue"></span>
                            </li>
                        </ul>
                    </div>
                    <div class="arrow-controls">
                        <table>
                            <tbody>
                                <tr>
                                    <td>
                                        <div class= "arrow-button up-arrow up-arrow-disabled" data-bind="event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.moveUp }"></div>
                                    </td>
                                </tr>

                                <tr>
                                    <td>
                                        <div class= "arrow-button down-arrow down-arrow-disabled" data-bind="event: { click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.moveDown }"></div>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            
                            
                <!-- /ko -->
            <!-- /ko -->

            <!-- ko if: ( $parents[1].componentMetaData.componenttype  === 'Physical' && $data.isSystemSpecific === true ) || ( $parents[1].componentMetaData.componenttype  === 'Virtual' && $data.setValue  === 'Pool Value' ) -->
                <label>
					<u>
                        <span data-bind="styledDisabled: ($parents[1].componentName === 'Windows' && (attributeName === 'LOGICALNETWORK' || attributeName === 'IPSUBNET' || attributeName === 'IPADDRESS')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableWindowsAttributes() :
                                            ($parents[1].componentName === 'Linux' && (attributeName === 'IPADDRESS' || attributeName === 'SUBNETMASK' || attributeName === 'DEFAULTGATEWAY' || attributeName === 'PRIMARYDNSSERVER' || attributeName === 'SECONDARYDNSSERVER')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxIPAttributes() :
                                            ($parents[1].componentName === 'Linux' && attributeName === 'SHARECREDENTIALPROFILE') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxShareTypeAttributes() :
                                            (attributeName === 'operatingsystems') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.operatingSystemFlag() : false,
                                         text: displayName"></span>
					</u>
				</label>

                <span data-bind="styledDisabled: ($parents[1].componentName === 'Windows' && (attributeName === 'LOGICALNETWORK' || attributeName === 'IPSUBNET' || attributeName === 'IPADDRESS')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableWindowsAttributes() :
                                    ($parents[1].componentName === 'Linux' && (attributeName === 'IPADDRESS' || attributeName === 'SUBNETMASK' || attributeName === 'DEFAULTGATEWAY' || attributeName === 'PRIMARYDNSSERVER' || attributeName === 'SECONDARYDNSSERVER')) ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxIPAttributes() :
                                    ($parents[1].componentName === 'Linux' && attributeName === 'SHARECREDENTIALPROFILE') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.disableLinuxShareTypeAttributes():
                                    (attributeName === 'operatingsystems') ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.operatingSystemFlag() : false,
                                 text: 'Pool Value'"></span>
            <!-- /ko -->
		</li>
        </ul>
</script>

<script type="text/html" id="subcomponents-view-template">
    <div data-bind="visible: !($data.componentName === 'Windows' || $data.componentName === 'Linux') || (($data.componentName === 'Windows' || $data.componentName === 'Linux') && $data.componentFqdd === DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedOSType())">
        <fieldset>
		    <legend>
                <span data-bind="text: ($data.componentName === 'Windows' || $data.componentName === 'Linux') && $data.componentFqdd === DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedOSType() ? DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedOSName() : componentName"></span>
            </legend>
        </fieldset>

        <div class="component-data">
            <!-- ko template: { name: 'components-view-template', foreach: componentGroups } --> <!-- /ko -->
        </div>

        <!-- ko if: $data.containsSubComponent === true -->
            <div class="subcomponent-data" data-bind="visible: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.AdditionalConfiguration.selectedComponentIndex() === $index()">
            <!-- ko template: { name: 'subcomponents-view-template', foreach: subComponent } --> <!-- /ko -->
            </div>
        <!-- /ko -->
    </div>
</script>
