<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_lifecycletemplate_nameAndType" data-bind="with: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType">
    <section id="error_nameAndType" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <header>
        <h1>
            <fmt:message key="lifecycletemplates.edittemplate.nameandtype.title" />
        </h1>
    </header>
    <p>
        <fmt:message key="lifecycletemplates.edittemplate.nameandtype.help" />
    </p>
    <form id="editLifeCycleTemplateForm" autocomplete="off">
        <fieldset>
            <legend class="visuallyhidden">
               <fmt:message key="lifecycletemplates.edittemplate.nameandtype.title" />
            </legend>
        </fieldset>
		
		<fieldset>
			<legend class="visuallyhidden">
				<fmt:message key="lifecycletemplates.edittemplate.nameandtype.title" />
			</legend>
			<ul class="labelValuePairs">
				<li>
					<label for="lifeCycleTemplateName">
						<u>
							<fmt:message key="lifecycletemplates.edittemplate.nameandtype.templatename" />
						</u>
					</label>
					<input id="lifeCycleTemplateName" type="text" value="" class="value" data-bind="value: name, event: { keyup: DellClarity.SCVMM.capsText, blur: DellClarity.SCVMM.trimText, input: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.validateNameOnEdit }, valueUpdate: 'input'" maxlength="30" pattern="^.{1,30}$" title='<fmt:message key="lifecycletemplates.edittemplate.name.hint" />' required /> <!--data-bind="value: templateName, event: { keyup: DellClarity.SCVMMAdmin.ViewModel.ConsoleEnrollment.EnrollConsole.disableEnrollConsole }"-->               
				</li>

                <li>
                    <label for="lifeCycleTemplateDescription">
                        <u>
                            <fmt:message key="lifecycletemplates.edittemplate.nameandtype.templatedescription" />
                        </u>
                    </label>
                    <textarea id="lifeCycleTemplateDescription" name="lifeCycleTemplateDescription" class="value" maxlength="255" data-bind="value: description" title='<fmt:message key="lifecycletemplates.edittemplate.nameandtype.description.title" />'></textarea>   <!--data-bind="value: description, event: { keyup: DellClarity.SCVMMAdmin.ViewModel.ConsoleEnrollment.EnrollConsole.disableEnrollConsole }">-->
                </li>
             </ul>
         </fieldset>

        <fieldset data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.lctEditFlag()">
	        <legend>
		        <fmt:message key="lifecycletemplates.edittemplate.nameandtype.deviceType" />
	        </legend>
	
	        <ul class="labelValuePairs">
	            <li>
		          <input type="radio" id="server" name="server" class="value" value="SERVER" data-bind="checked: deviceType, click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.updateDeviceList" />
		          <label for="server">
		            <u>
			          <fmt:message key="lifecycletemplates.edittemplate.nameandtype.server" />
		            </u>
		          </label>
	            </li>
                <li>
			        <input type="radio" id="modularsystem" name="modularsystem" class="value" value="CHASSIS" data-bind="checked: deviceType, click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.updateDeviceList" />
			        <label for="modularsystem">
				        <u>
					        <fmt:message key="lifecycletemplates.edittemplate.nameandtype.chassis" />
				        </u>
			        </label>
		        </li>
	        </ul>
        </fieldset>

         <fieldset>
			<legend class="visuallyhidden">
				<fmt:message key="lifecycletemplates.edittemplate.nameandtype.title" />
			</legend>
			<ul class="labelValuePairs">

                <li>
                    <span class="label">
                        <u>
                            <label for="selectReferenceIP">
                                <fmt:message key="lifecycletemplates.edittemplate.nameandtype.referenceip" />
                            </label>
                        </u>
                    </span>
                    <span class="value">
                        <div class="editable-dropdown">
                            <input class="editable-dropdown-input" id="referenceIP" type="text" value="" class="value" title="<fmt:message key="lifecycletemplates.edittemplate.iperrormessage"/>" placeholder="192.168.1.10" required data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.lctEditFlag(), value: referenceIP, pattern: 'ipv4', event: { input: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.filterServersList, keyup: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.navigateServersList}, valueUpdate: 'input'"/> 

                            <!-- ko if: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.lctEditFlag() === false -->
                                <ul class="editable-dropdown-list" id="reference-servers-list" data-bind="visible: (DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.showDiscoveredServersList() === true)">
                                    <!-- ko foreach: discoveredServersList -->
                                        <li class="reference-server-data" data-bind="text: $data, css: { 'selected-server': $data == DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.highlightedOption()}, event: {mouseover: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.highlightOption, mouseout: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.unhighlightOption}, click: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.NameAndType.selectReferenceServer"></li>
                                    <!-- /ko -->
                                </ul>
                            <!-- /ko -->
                        </div>
                    </span>
                </li>
			</ul>
		</fieldset>
    </form>
</section>
