<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div id="lifeCycleTemplatesMasterDetails" class="masterDetails" data-bind="with: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.Home">
    <section id="lifeCycleTemplatesMaster" class="master">
        <section id="error_lifecycletemplatesmaster" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
        <header class="page-heading">
            <h1>
                <fmt:message key="lifecycletemplatesmasterdetails.lifecycletemplates" />
            </h1>
        </header>
        <nav class="action-buttons">
            <ul class="inlineList taskbar">
                <li>
                    <!--a id="createLifeCycleTemplate" href="#/lifecycletemplates.editlifecycletemplate">
                        <fmt:message key="generic.create" />
                    </a-->
                    <button id="createLifeCycleTemplate" class="cui-button cux-button cux-button-medium  cux-button-primary" type="button" onclick="window.location.href='#/lifecycletemplates.editlifecycletemplate'">
                        <i class="cux-icon cux-icon-file-text"></i><span>
                            <fmt:message key="generic.create" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a-- id="editLifeCycleTemplate" data-bind="styledDisabled: lifeCycleTemplatesTable().checkedRows().length !== 1">
                        <fmt:message key="genericTerms.edit" />
                    </!--a-->
                    <button id="editLifeCycleTemplate" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: lifeCycleTemplatesTable().checkedRows().length !== 1" type="button">
                        <i class="cux-icon cux-icon-edit"></i><span>
                            <fmt:message key="genericTerms.edit" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a id="deleteLifeCycleTemplate" data-bind="styledDisabled: lifeCycleTemplatesTable().selectedItemCount() === 0">
                        <fmt:message key="generic.delete" />
                    </a-->
                    <button id="deleteLifeCycleTemplate" class="cui-button cux-button disabled cux-button-medium " data-bind="styledDisabled: lifeCycleTemplatesTable().checkedRows().length === 0" type="button">
                        <i class="cux-icon cux-icon-trash"></i><span>
                            <fmt:message key="generic.delete" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--a id="refreshLifeCycleTemplate">
                        <fmt:message key="generic.refresh" />
                    </a-->
                    <button id="refreshLifeCycleTemplate" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                        <i class="cux-icon cux-icon-repeat"></i><span>
                            <fmt:message key="generic.refresh" />
                        </span>
                    </button>
                </li>
            </ul>
        </nav>
        <form id="lifeCycleTemplateForm">
            <fieldset>
                <legend class="visuallyhidden">
                    <fmt:message key="lifecycletemplatemasterdetails.lifecycletemplatestable" />
                </legend>

                <div class="master-table-wrapper">
                    <!-- ko with: lifeCycleTemplatesTable -->
                    <table id="lctTable" class="dataTable">
                        <thead>
                            <tr>
                                <th scope="col" class="checkboxColumn">
                                    <input type="checkbox" id="lifeCycleTemplateSelectAll" />
                                    <label for="lifeCycleTemplateSelectAll" class="visuallyhidden">
                                        <fmt:message key="lifecycletemplatemasterdetails.selectalltemplates" />
                                    </label>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="lifecycletemplatemasterdetails.name" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="lifecycletemplatemasterdetails.referenceip" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="lifecycletemplatemasterdetails.servermodel" />
                                    </strong>
                                </th>

                                <th scope="col">
                                    <strong>
                                        <fmt:message key="lifecycletemplatemasterdetails.servicetag" />
                                    </strong>
                                </th>
                                <th scope="col">
                                    <strong>
                                        <fmt:message key="lifecycletemplatemasterdetails.devicetype" />
                                    </strong>
                                </th>
                            </tr>
                        </thead>
                        <!-- ko if: loading() -->
                        <tbody>
                            <tr>
                                <td colspan="6">
                                    <fmt:message key="scrollabletable.loading" />
                                    <span>&nbsp;</span>
                                    <span class="icon spinner"></span>
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && (!data || data().length == 0) -->
                        <tbody>
                            <tr>
                                <td colspan="6">
                                    <fmt:message key="scrollabletable.empty" />
                                </td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                        <!-- ko if: !loading() && data && data().length > 0 -->
                        <tbody data-bind="foreach: data">
                            <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.LifeCycleTemplates.Home.selectedLifeCycleTemplate() === $data }">

                                <td class="checkboxColumn">
                                    <input type="checkbox" data-bind="checked: checked, indexedid: 'lifeCycleTemplate_'" />
                                    <label class="visuallyhidden" data-bind="indexedfor: 'lifeCycleTemplate_'">Select Life Cycle Profile</label>
                                </td>

                                <td data-bind="text: name"></td>
                                <td data-bind="text: referenceIP"></td>
                                <td data-bind="text: model"></td>
                                <td data-bind="text: serviceTag"></td>
                                <td data-bind="text: deviceType"></td>
                            </tr>
                        </tbody>
                        <!-- /ko -->
                    </table>
                    <!-- /ko -->
                </div>
            </fieldset>
        </form>
    </section>

    <section id="lifeCycleTemplatesDetails" class="details" data-bind="visible: selectedLifeCycleTemplate() !== undefined">
        <header>
            <h1>
                <fmt:message key="generic.details" />
            </h1>
        </header>
        <ul class="labelValuePairs" data-bind="if: selectedLifeCycleTemplate() !== undefined">
            <li>
                <label for="selectedLifeCycleTemplateName">
                    <u>
                        <fmt:message key="lifecycletemplatemasterdetails.templatename" />
                    </u>
                </label>
                <span id="selectedLifeCycleTemplateName" class="value" data-bind="text: selectedLifeCycleTemplate().name"></span>
            </li>

            <li>
                <label for="selectedLifeCycleTemplateDescription">
                    <u>
                        <fmt:message key="lifecycletemplatemasterdetails.description" />
                    </u>
                </label>
                <span id="selectedLifeCycleTemplateDescription" class="value" data-bind="text: selectedLifeCycleTemplate().description"></span>
            </li>

            <li>
                <label for="selectedLifeCycleTemplateDateCreated">
                    <u>
                        <fmt:message key="lifecycletemplatemasterdetails.created" />
                    </u>
                </label>
                <span id="selectedLifeCycleTemplateDateCreated" class="value" data-bind="time: selectedLifeCycleTemplate().dateCreated, timeFormat: 'LLL'"></span>
            </li>

            <li>
                <label for="selectedLifeCycleTemplateDateModified">
                    <u>
                        <fmt:message key="lifecycletemplatemasterdetails.modified" />
                    </u>
                </label>
                <span id="selectedLifeCycleTemplateDateModified" class="value" data-bind="time: selectedLifeCycleTemplate().dateModified, timeFormat: 'LLL'"></span>
            </li>
        </ul>
    </section>
</div>
