<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_backupserverprofile_template" data-bind="with: DellClarity.SCVMM.ViewModel.BackupServerProfile">
    <section id="error_updatecenter_backupserverprofile" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <form id="backupserverprofileForm" autocomplete="off">
        <fieldset data-bind="with: model">
            
            <p>
                 <fmt:message key="updatecenter.backupserverprofile.desc" /> 
            </p>
            <ul class="labelValuePairs">

               <li>
                    <label for="jobname">
                        <u>
                            <fmt:message key="updatecenter.backupserverprofile.jobname" /> 
                        </u>
                    </label>
                    <input id="jobname" name="jobname" class="value"  maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="updatecenter.backupserverprofile.name.title" />'  placeholder='<fmt:message key="updatecenter.backupserverprofile.jobname.hint"/>' type="text" class="value"   required data-bind="value: jobname ">
                </li>
               
                <li>
                    <label for="description">
                        <u>
                               <fmt:message key="updatecenter.backupserverprofile.jobdesc" /> 
                        </u>
                    </label>
                    <textarea id="description" class="value" name="description" maxlength="256"  data-bind="value: jobdescription"   placeholder='<fmt:message key="updatecenter.backupserverprofile.jobdesc.hint"/>' class="value"  ></textarea>
                </li>
                
                <li>
                    <label for="protectionvault">
                        <u>
                           <fmt:message key="updatecenter.backupserverprofile.protectionvault" /> 
                        </u>
                    </label>
                    <span class="value">
                   <select id="protectionvault"  required data-bind="options: DellClarity.SCVMM.ViewModel.BackupServerProfile.protectionVault,
                                                             optionsText: 'name',
                                                             optionsValue: 'id',
                                                             value: selectedVault,                                                             
                                                             optionsCaption: 'Select the vault'">

                   </select>
                    <a id="createProtectionVault" href="#/updateCenter.protectionvaultdetails">
                        <fmt:message key="updatecenter.backupserverprofile.createProtectionVault" />
                    </a>
                   </span>
                </li>
            </ul>
        </fieldset>
        <fieldset data-bind="with: model">
            <legend>
                 <fmt:message key="updatecenter.backupserverprofile.schedulebackup" /> 
            </legend>
            <!-- <ul class="labelValuePairs">

                <li>
                    <label for="scheduleDate">
                        <u>
                          <fmt:message key="updatecenter.backupserverprofile.schedulebackup" /> 
                        </u>
                    </label>

                    <span class="value">
                        <input class="input-append date" type="text" id="scheduleDate" name="scheduleDate" data-bind="datepicker: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate, event: { change: DellClarity.SCVMM.ViewModel.BackupServerProfile.validateDate }, attr: { required: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate }, styledDisabled: 1==1" placeholder='<fmt:message key="updatecenter.backupserverprofile.runnow" />'"/>
                        <a href="" id="clear">Clear calendar</a>
                        <span id="scheduleCalendar" class="add-on"><i class="icon-calendar" data-bind="datepicker: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate, event: { change: DellClarity.SCVMM.ViewModel.BackupServerProfile.validateDate }"></i></span>

                        <select class="scheduleHourMinute" id="scheduleHour" data-bind="options: DellClarity.SCVMM.ViewModel.BackupServerProfile.optionsHour, value: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledHour, styledDisabled: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate() == null || DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate().length == 0"></select>
                        <span id="scheduleHourMinuteSeparator">:</span>
                        <select class="scheduleHourMinute" id="scheduleMinute" data-bind="options: DellClarity.SCVMM.ViewModel.BackupServerProfile.optionsMinute, value: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledMinute, styledDisabled: DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate() == null || DellClarity.SCVMM.ViewModel.BackupServerProfile.scheduledDate().length == 0"></select>
                    </span>
                </li>
              
 
            </ul> -->

            <ul class="labelValuePairs">
                <li>
                    <input type="radio" name="runNow" class="value" id="runNow" value="runNow" data-bind="checked: $parent.scheduleExport" />
                    <label for="runNow">
                        <u>
                            <fmt:message key="updatecenter.backupserverprofile.schedulebackupnow" />
                        </u>
                    </label>
                </li>
                
                
                <li>

                        
                    <input type="radio" id="scheduleExport" name="scheduleExport" value="scheduleExport" data-bind="checked: $parent.scheduleExport">
                    <label for="scheduleExport">
                        <fmt:message key="updatecenter.backupserverprofile.schedule" />
                    </label>

                   <ul class="labelValuePairs" data-bind="visible: $parent.scheduleExport() == 'scheduleExport'">
                        <li>
                                
                                <label for="scheduleDate">
                                    <u>
                                        <fmt:message key="updatecenter.backupserverprofile.schedulebackup" /> 
                                    </u>
                                </label>

                                <input class="input-append date" required type="text" id="scheduleDate" name="scheduleDate" data-bind="datepicker: $parent.scheduledDate, event: { change: $parent.validateDate }, styledDisabled: 1 == 1"/>
                                <a href="" id="clear">Clear calendar</a>
                                <span id="scheduleCalendar" class="add-on"><i class="icon-calendar" data-bind="datepicker: $parent.scheduledDate, event: { change: $parent.validateDate }, attr: { required: $parent.scheduleExport() == 'scheduleExport' }"></i></span>

                                <select class="scheduleHourMinute" id="scheduleHour" data-bind="options: $parent.optionsHour, value: $parent.scheduledHour, styledDisabled: $parent.scheduledDate() == null || $parent.scheduledDate().length == 0"></select>
                                <span id="scheduleHourMinuteSeparator">:</span>
                                <select class="scheduleHourMinute" id="scheduleMinute" data-bind="options: $parent.optionsMinute, value: $parent.scheduledMinute, styledDisabled: $parent.scheduledDate() == null || $parent.scheduledDate().length == 0"></select>
                                
                        </li>

                        <li>
                           <p style="padding: 0 20px;white-space:pre-line;"><fmt:message key="updatecenter.backupserverprofile.recurrencehelp" /></p>
                        </li>

                        <li>
                            <ul id="reccurencechoices">
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind="checked: $parent.recurrenceChoice" value="NEVER">
                                    <span><fmt:message key="updatecenter.backupserverprofile.schedulebackupnever" /></span>
                                    </label>    
                                </li>
                
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind="checked: $parent.recurrenceChoice" value="ONCE_A_WEEK">
                                    <span><fmt:message key="updatecenter.backupserverprofile.schedulebackupweekly" /></span>
                                    </label>    
                                </li>
                
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind="checked: $parent.recurrenceChoice" value="ONCE_A_FORTNIGHT">
                                    <span><fmt:message key="updatecenter.backupserverprofile.schedulebackuptwoweeks" /></span>
                                    </label>    
                                </li>
                
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind=" checked: $parent.recurrenceChoice" value="ONCE_A_MONTH">
                                    <span><fmt:message key="updatecenter.backupserverprofile.schedulebackupmonthly" /></span>
                                    </label>    
                                </li>
                            </ul>
                        </li>
                    </ul>
            </li>
                
         </ul>
        </fieldset>
        
        <fieldset>
            <legend  class="visuallyhidden">
                <fmt:message key="updatecenter.backupserverprofile.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="updatecenter.backupserverprofile.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="runUpdateFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="updatecenter.runupdate.finish" />
            </button>
            <button id="runUpdateCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="updatecenter.runupdate.cancel" />
            </button>
        </div>
    </form>
</section>
