<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_collectlclogs_template" data-bind="with: DellClarity.SCVMM.ViewModel.CollectLCLogs">
    <section id="error_updatecenter_collectlclogs" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
      <section id="warning_updatecenter_collectlclogs" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <form id="collectlclogsForm" autocomplete="off">
        <fieldset data-bind="with: model">
            
            <p>
                 <fmt:message key="updatecenter.collectlclogs.desc" /> 
            </p>
            <ul class="labelValuePairs">

               <li>
                    <label for="jobname">
                        <u>
                            <fmt:message key="updatecenter.collectlclogs.jobname" /> 
                        </u>
                    </label>
                    <input id="jobname" name="jobname" class="value"  maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="updatecenter.collectlclogs.name.title" />'  placeholder='<fmt:message key="updatecenter.collectlclogs.jobname.hint"/>' type="text" class="value"   required data-bind="value: jobname ">
                </li>
               
                <li>
                    <label for="description">
                        <u>
                               <fmt:message key="updatecenter.collectlclogs.jobdesc" /> 
                        </u>
                    </label>
                    <textarea id="description" class="value" name="description" maxlength="256"  data-bind="value: jobdescription" title='<fmt:message key="updatecenter.collectlclogs.jobdesc.title" />'  placeholder='<fmt:message key="updatecenter.collectlclogs.jobdesc.hint"/>' class="value"  ></textarea>
                </li>
                
            </ul>
        </fieldset>
        <fieldset>
            <legend>
                 <fmt:message key="updatecenter.collectlclogs.schedulelclogs" /> 
            </legend>

            <ul class="labelValuePairs">

                <li>
                    <input type="radio" name="completeLCLogDump" class="value" id="completeLCLogDump" value="completeLCLogDump" data-bind="checked: schedulelclogs" />
                    <label for="completeLCLogDump">
                        <u>
                            <fmt:message key="updatecenter.collectlclogs.completelclogdump" />
                        </u>
                    </label>
                </li>

                <li>
                    <input type="radio" name="runNow" class="value" id="runNow" value="runNow" data-bind="checked: schedulelclogs" />
                    <label for="runNow">
                        <u>
                            <fmt:message key="updatecenter.collectlclogs.schedulelclogsnow" />
                        </u>
                    </label>
                </li>
                
                
                <li>

                        
                    <input type="radio" id="schedulelclogs" name="schedulelclogs" value="schedulelclogs" data-bind="checked: schedulelclogs">
                    <label for="schedulelclogs">
                        <fmt:message key="updatecenter.collectlclogs.schedule" />
                    </label>

                   <ul class="labelValuePairs" data-bind="visible: schedulelclogs() == 'schedulelclogs'">
                        <li>
                                
                                <label for="scheduleDate">
                                    <u>
                                        <fmt:message key="updatecenter.collectlclogs.schedulelclogsdatetime" /> 
                                    </u>
                                </label>

                                <input class="input-append date" required type="text" id="scheduleDate" name="scheduleDate" data-bind="datepicker: scheduledDate, event: { change: validateDate }, styledDisabled: 1 == 1"/>
                                <a href="" id="clear">Clear calendar</a>
                                <span id="scheduleCalendar" class="add-on"><i class="icon-calendar" data-bind="datepicker: scheduledDate, event: { change: validateDate }, attr: { required: schedulelclogs() == 'schedulelclogs' }"></i></span>

                                <select class="scheduleHourMinute" id="scheduleHour" data-bind="options: optionsHour, value: scheduledHour, styledDisabled: scheduledDate() == null || scheduledDate().length == 0"></select>
                                <span id="scheduleHourMinuteSeparator">:</span>
                                <select class="scheduleHourMinute" id="scheduleMinute" data-bind="options: optionsMinute, value: scheduledMinute, styledDisabled: scheduledDate() == null || scheduledDate().length == 0"></select>
                                
                        </li>

                        <li>
                           <p style="padding-left: 20px;"><fmt:message key="updatecenter.collectlclogs.recurrencehelp" /></p>
                        </li>

                        <li>
                            <ul id="reccurencechoices">
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind="checked: recurrenceChoice" value="NEVER">
                                    <span><fmt:message key="updatecenter.collectlclogs.schedulelclogsnever" /></span>
                                    </label>    
                                </li>
                
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind="checked: recurrenceChoice" value="ONCE_A_DAY">
                                    <span><fmt:message key="updatecenter.collectlclogs.schedulelclogsdaily" /></span>
                                    </label>    
                                </li>
                
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind="checked: recurrenceChoice" value="ONCE_A_WEEK">
                                    <span><fmt:message key="updatecenter.collectlclogs.schedulelclogsweekly" /></span>
                                    </label>    
                                </li>
                
                                <li>
                                    <label>
                                    <input type="radio" name="PollingChoices" data-bind=" checked: recurrenceChoice" value="ONCE_A_MONTH">
                                    <span><fmt:message key="updatecenter.collectlclogs.schedulelclogsmonthly" /></span>
                                    </label>    
                                </li>
                            </ul>
                        </li>
                    </ul>
                    <br/>

                    
                    <ul class="labelValuePairs">
                        <!--ko if: (schedulelclogs() == 'schedulelclogs' || schedulelclogs() == 'runNow') -->
                        <br/>
                        <li>
                            <input type="checkbox" class="value" id="backupLCLogs" data-bind="checked: backupLCLogs" />
                            <label for="backupLCLogs">
                                <u>
                                    <fmt:message key="updatecenter.collectlclogs.backuplclogs" />
                                </u>
                            </label>
                        </li>
                        <!--/ko-->
                        <li>
                            <ul class="labelValuePairs" data-bind="styledDisabled: (schedulelclogs() == 'schedulelclogs' || schedulelclogs() == 'runNow') && (backupLCLogs() == false)">
                                <li>
                                    <label for="networkShare">
                                        <u>
                                            <fmt:message key="updatecenter.collectlclogs.networkshare" /> 
                                        </u>
                                    </label>
                                    <input id="networkShare" name="networkShare" type="text" placeholder='<fmt:message key="updatecenter.collectlclogs.networkshare.hint"/>' class="value" required data-bind="value: networkShare, event: { change: DellClarity.SCVMM.ViewModel.CollectLCLogs.validateNetworkShare }" />
                                </li>

                                <li>
                                    <span class="label">
                                        <u>
                                             <fmt:message key="updatecenter.collectlclogs.credentialprofile" />
                                        </u>
                                    </span>
                                    <span class="value">
                                        <label for="Credentialprofile" class="visuallyhidden">
                                            <u>
                                                <fmt:message key="updatecenter.collectlclogs.credentialprofile" />
                                            </u>
                                        </label>

                                        <select id="Credentialprofile" name="Credentialprofile" 
                                            data-bind="value: selectedCredentialProfile,
                                                       options: DellClarity.SCVMM.ViewModel.CollectLCLogs.credentialProfiles, optionsText: 'name', optionsValue: 'id', 
                                                       attr: { required: (schedulelclogs() == 'completeLCLogDump') || ((schedulelclogs() == 'schedulelclogs' || schedulelclogs() == 'runNow') && (backupLCLogs() == true)) },
                                                       optionsCaption: '<fmt:message key="updatecenter.collectlclogs.credProfile"/>' ">                     
                                        </select>
                                        <a id="createCredProfile">
                                            <fmt:message key="updatecenter.collectlclogs.createnew" />
                                        </a>
                                    </span>
                                </li>
                        </ul>
                    </li>
                </ul>
            </li>
        </ul>
        </fieldset>

        <fieldset>
            <legend  class="visuallyhidden">
                <fmt:message key="updatecenter.collectlclogs.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="updatecenter.collectlclogs.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="collectLCLogsFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="updatecenter.collectlclogs.finish" />
            </button>
            <button id="collectLCLogsCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="updatecenter.collectlclogs.cancel" />
            </button>
        </div>
    </form>
</section>
