<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_displaylclogs_template"  data-bind="with: DellClarity.SCVMM.ViewModel.DisplayLCLogs">
    <section id="error_updatecenter_displaylclogs" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    
    <form>
        <section>

            <p>
                <fmt:message key="updatecenter.displaylclogs.helpmessage" />
            </p>


            <!-- ko if: DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRows() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRowsOrg().length >= 50000 -->
            <p>
                 <fmt:message key="updatecenter.displaylclogs.help" />
            </p>
            <!-- /ko -->

            <!-- ko if: !DellClarity.SCVMM.ViewModel.DisplayLCLogs.loading() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRowsOrg() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRowsOrg().length > 0 -->
            <div>
                <label for="searchFilter">
                    <u>
                        <fmt:message key="updatecenter.displaylclogs.search" />
                    </u>
                </label>
                <input style="width:22%;" name="searchFilter" id="searchFilter" type="text" data-bind="value: searchString, changeOnEnter: true, event: { keypress: loadSearchResults }" />

                <!-- ko if: (searchString() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableSearchRows() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableSearchRows().length > 0) || (!searchString() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRowsOrg() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRowsOrg().length > 0)-->
                    <button class="cux-button cux-button-medium cux-button-primary" style="float: right;" data-bind="event: { click: exportData }">
                        <i class="cux-icon cux-icon-export"></i><span>
                            <fmt:message key="updatecenter.displaylclogs.exporttocsv" />
                        </span>
                    </button>
                <!-- /ko -->
            </div>
            <!-- /ko -->

            <table id="displayLCLogsTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.displaylclogs.messageid" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.displaylclogs.dateandtime" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.displaylclogs.severity" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.displaylclogs.description" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.displaylclogs.category" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.displaylclogs.comments" /></strong>
                        </th>
                    </tr>
                </thead>
                <!-- ko if: DellClarity.SCVMM.ViewModel.DisplayLCLogs.loading() -->
                <tbody>
                    <tr>
                        <td colspan="3">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !DellClarity.SCVMM.ViewModel.DisplayLCLogs.loading() && (!DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRows() || DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRows().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="3">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
               <!-- ko with:  DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRows -->                
                <tbody data-bind="foreach: $data">
                    <tr> 
                        <td>
                            <a data-bind="event: { click: DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayEventMessage }"><span data-bind=" text: messageId"></span></a>
                            <!-- <span data-bind=" text: messageId"></span> -->
                        </td>
                        <td>
                            <span data-bind="text: timeStamp"></span>
                        </td>
                        <td>
                            <span data-bind="text: severity"></span>
                        </td>
                        <td>
                            <span data-bind="text: message"></span>
                        </td>
                        <td>
                            <span data-bind="text: category"></span>
                        </td>
                        <td>
                           <span style="display: inline-block;line-height: normal;" data-bind="html: comment"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            
            <!-- ko if: DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRows() && DellClarity.SCVMM.ViewModel.DisplayLCLogs.displayTableRows().length > 0 -->
            <div>
                <div style="float: left; padding-top: 5px;">
                    <span id="items_count" data-bind="text: itemCount"></span>
                    <fmt:message key="scrollabletable.footer" />
                    <span id="displayed_rows" data-bind="text: firstDisplayedRowNumber() + '-' + lastDisplayedRowNumber()"></span>
                </div>
                <div style="float: right; padding-top: 5px;" data-bind="visible: lastPage() > 1">
                    <label for="current_page" class="visuallyhidden">
                        <fmt:message key="scrollabletable.currentpage" />
                    </label>
                    <input style="float: left; margin-top: 1px;" id="current_page" type="text" role="textbox" maxlength="7" size="2" data-bind="value: displayCurrentPage, changeOnEnter: true, event: { keypress: loadPage }" />
                    <span style="float: left; margin-left: 3px;">
                        <fmt:message key="scrollabletable.pager" />
                    </span><span style="float: left; margin-left: 3px;" id="last_page" data-bind="text: lastPage"></span>
                    <span style="float: left; margin-left: 10px;" data-bind="styledDisabled: currentPage() == 1, event: { click: loadPreviousPage }" class="icon pageleft vmiddle" id="prev_pager"></span>
                    <span style="float: left;" data-bind="styledDisabled: currentPage() == lastPage(), event: { click: loadNextPage }" class="icon pageright vmiddle" id="next_pager"></span>
                </div>
            </div>
            <!-- /ko -->

        </section>
    </form>
</section>

