<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_home" data-bind="with: DellClarity.SCVMM.ViewModel.UpdateCenter">
    <section id="error_updatecenter_home" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }"></section>
    <!-- <h1>
        <fmt:message key="updatecenter.home" />            
    </h1> -->
    <form>
        <!-- p>
            <fmt:message key="updatecenter.help" />
        </!-->
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="updatecenter.home" />
            </legend>

            <nav id="tabMenu" class="menu tabs" role="navigation">
                <ul>
                    <li>
                        <a href="#/updateCenter.home">
                            <fmt:message key="updatecenter.home" />
                        </a>
                    </li>
                    <li data-bind="attr: { class: (activeTab() == 'updategroups' || activeTab() == 'pollingandnotification' || activeTab() == 'protectionvault') ? 'selected' : '' }">
                        <a href="#/updateCenter.home/updatesettings">
                            <fmt:message key="updatecenter.updatesettings" />
                        </a>
                    </li>
                </ul>

                <div class="notification_bell_wrapper">
                    <!-- ko if: !notificationStatus() -->
                    <a title="<fmt:message key="updatecenter.home.noupdatesavailable" />" class="cux-icon cux-icon-bell-alt notification_bell"></a>
                    <!-- /ko -->

                    <!-- ko if: notificationStatus() -->
                    <a title="<fmt:message key="updatecenter.home.updatesavailable" />" class="cux-icon cux-icon-bell-alt notification_bell_selected"></a>
                    <!-- /ko -->
                </div>
            </nav>
            

             <section class="tabPanel" data-bind="visible: activeTab() == 'updatecenter'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="updatecenter.home" />
                    </h1>
                </header>
                 <p>
                     <fmt:message key="updatecenter.help" />
                 </p>

                 <fieldset class="multipane1">
                    <legend>
                    </legend>
                    <div style="width: 100%;">
                                <div style="width:35%;">
                                    <strong><fmt:message key="updatecenter.home.selectupdategroup" /></strong><br />
                                    <!--p><fmt:message key="updatecenter.home.selectupdategrouphelp" /></p-->
                                    <label for="selUpdateGroup" class="visuallyhidden">
                                        <u>
                                            <fmt:message key="updatecenter.home.selectupdategroup" />
                                        </u>
                                    </label>

                                    <select id="selUpdateGroup" data-bind="foreach: updateGroupTypes">
                                        <!-- ko if: options -->
                                        <optgroup data-bind="attr: { label: name }, foreach: options">
                                            <option data-bind="attr: { id: id }, text: name, option: $data"></option>
                                        </optgroup>
                                        <!-- /ko -->
                                    </select>
                                </div>
                                <div style="width:35%;">
                                    <strong><fmt:message key="updatecenter.home.selectupdatesource" /></strong><br />
                                    <!--p><fmt:message key="updatecenter.home.selectupdatesourcehelp" /></p-->
                                    <label for="selUpdateSource" class="visuallyhidden">
                                        <u>
                                            <fmt:message key="updatecenter.home.selectupdatesource" />
                                        </u>
                                    </label>

                                    <select id="selUpdateSource" data-bind="foreach: updateSourceTypes">
                                        <!-- ko if: options -->
                                        <optgroup data-bind="attr: { label: name }, foreach: options">
                                            <option data-bind="attr: { id: id }, text: name, option: $data"></option>
                                        </optgroup>
                                        <!-- /ko -->
                                    </select>
                                </div>

                            <!-- ko if: typeof DellClarity.MultiselectView.filterTypes  != 'undefined' -->
                            <div  style="width:15%" data-bind="visible: DellClarity.MultiselectView.filterTypes() && DellClarity.MultiselectView.filterTypes().length == 3">
                           
                                <strong><fmt:message key="updatecenter.home.filterupdates" /></strong><br />
                   
                                <select id="multiselect-dropdown-view"  class="multiselect-dropdown-view"></select>

                                <a id="clearSelection" class="clearFilter"> <b><fmt:message key="updatecenter.home.clearfilters" /></b></a>
                      
                                <!-- ko template: {name:DellClarity.MultiselectView.templateName} -->
                                <!-- /ko -->
                     
                            </div> 
                            <!-- /ko -->
                    </div>

                    <!-- <div>
                        <strong><fmt:message key="updatecenter.home.filterupdates" /></strong>
                        <p><fmt:message key="updatecenter.home.filterupdateshelp" /></p>
                    </div> -->
                </fieldset>
                    
                <nav class="action-buttons">
                    <ul class="inlineList update-center-actions">
                        <li>
                            <button id="linkRunUpdate" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-play"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.runupdate" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="linkRefreshInventory" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-repeat"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.refreshinventory" />
                                </span>
                            </button>
                        </li>
                     
                        
                          <!-- <li>
                            <button id="backup" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button" onmouseover='DellClarity.SCVMM.ViewModel.UpdateCenter.enableDetails("backup")' onmouseout='DellClarity.SCVMM.ViewModel.UpdateCenter.disableDetails()'>
                                <i class="cux-icon cux-icon-upload"></i>
                                <span data-bind="visible: detailsEnabled() != 'backup'">
                                    <fmt:message key="updatecenter.home.export" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'backup'">
                                    <fmt:message key="updatecenter.home.backup" />
                                </span>
                            </button>
                        </li>
                         <li>
                            <button id="restore" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button" onmouseover='DellClarity.SCVMM.ViewModel.UpdateCenter.enableDetails("restore")' onmouseout='DellClarity.SCVMM.ViewModel.UpdateCenter.disableDetails()'>
                                <i class="cux-icon cux-icon-download"></i>
                                <span data-bind="visible: detailsEnabled() != 'restore'">
                                    <fmt:message key="updatecenter.home.restoreprofile.import" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'restore'">
                                    <fmt:message key="updatecenter.home.restoreprofile.restore" />
                                </span>
                            </button>
                        </li> -->
                        <!-- <li>
                            <button id="manageJobs" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/updateCenter.managejobs'">
                                <i class="cux-icon cux-icon-tasks"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.managejobs" />
                                </span>
                            </button>
                        </li> -->

                        <li>
                            <div class="buttondropdown">
                            <button id="ServerProfile" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-align-justify"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.deviceprofile" />
                                </span>
                                <i class="cux-icon cux-icon-angle-down"></i>
                            </button>
                            <div class="button-dropdown-content">
                                <ul>
                                    <li id="backup">
                                        <a>
                                            <i class="cux-icon cux-icon-upload"></i>
                                            <fmt:message key="updatecenter.home.export" />
                                        </a>
                                    </li>
                                    <li id="restore">
                                        <a>
                                            <i class="cux-icon cux-icon-download"></i>
                                            <fmt:message key="updatecenter.home.restoreprofile.import" />
                                        </a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        </li>

                        <li>
                            <button id="partReplacement" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button" onmouseover='DellClarity.SCVMM.ViewModel.UpdateCenter.enableDetails("partreplacement")' onmouseout='DellClarity.SCVMM.ViewModel.UpdateCenter.disableDetails()'>
                                <i class="cux-icon cux-icon-cogs"></i>
                                <span data-bind="visible: detailsEnabled() != 'partreplacement'">
                                    <fmt:message key="updatecenter.home.configure" />
                                </span>
                                <span data-bind="visible: detailsEnabled() == 'partreplacement'">
                                    <fmt:message key="updatecenter.home.partreplacement" />
                                </span>
                            </button>
                        </li>
                        <!-- <li>
                            <button id="collectlclogs" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-file-alt"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.collectlclogs" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <button id="viewlclogs" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-copy"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.viewlclogs" />
                                </span>
                            </button>
                        </li> -->

                        <li>
                            <div class="buttondropdown">
                            <button id="lcLogs" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-briefcase"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.lclogs" />
                                </span>
                                <i class="cux-icon cux-icon-angle-down"></i>
                            </button>
                            <div class="button-dropdown-content">
                                <ul>
                                    <li id="collectlclogs">
                                        <a>
                                            <i class="cux-icon cux-icon-file-alt"></i>
                                            <fmt:message key="updatecenter.home.collectlclogs" />
                                        </a>
                                    </li>
                                    <li id="viewlclogs">
                                        <a>
                                            <i class="cux-icon cux-icon-copy"></i>
                                            <fmt:message key="updatecenter.home.viewlclogs" />
                                        </a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        </li>


                        <li>
                            <div class="buttondropdown">
                            <button id="exportInventory" disabled="disabled" class="disabled cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-circle-arrow-up"></i>
                                <span>
                                    <fmt:message key="updatecenter.home.exportinventory" />
                                </span>
                                <i class="cux-icon cux-icon-angle-down"></i>
                            </button>
                            <div class="button-dropdown-content">
                                <ul>
                                    <li id="exportxml">
                                        <a>
                                            <i class="cux-icon cux-icon-arrow-down"></i>
                                            <fmt:message key="updatecenter.home.exportxml" />
                                        </a>
                                    </li>
                                    <li id="exportcsv">
                                        <a>
                                            <i class="cux-icon cux-icon-arrow-down"></i>
                                            <fmt:message key="updatecenter.home.exportcsv" />
                                        </a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                        </li>
                    </ul>
                </nav>

              <table id="tablegrid" class="dataTable"></table> 
              <div id="tablegridpager"></div>

            </section>

            <section class="subtabSettingsPanel" data-bind="visible: activeTab() == 'updatesettings'">
                <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="updatecenter.updatesettings" />
                    </h1>
                </header>
                <!-- <p>
                    <fmt:message key="updatesettings.help" />
                </p> -->
                <nav id="subTabMenu" class="menu tabs" role="navigation">
                    <ul>
                        <li>
                            <a href="#/updateCenter.home/updatesettings">
                                <fmt:message key="updateCenter.updatesettings.updatesource" />
                            </a>
                        </li>
                        <li>
                            <a href="#/updateCenter.home/updategroups">
                                <fmt:message key="updateCenter.updatesettings.updategroups" />
                            </a>
                        </li>
                        <li>
                            <a href="#/updateCenter.home/pollingandnotification">
                                <fmt:message key="updateCenter.updatesettings.pollingandnotification" />
                            </a>
                        </li>
                         <li >
                            <a href="#/updateCenter.home/protectionvault">
                                <fmt:message key="updatecenter.updatesettings.protectionvault" />
                            </a>
                        </li>
                    </ul>
                </nav>

                <section class="subtabPanel">
                <p>
                    <fmt:message key="updatesource.help" />
                </p>
                <nav class="action-buttons">
                    <ul class="inlineList taskbar">
                        <li>
                            <!--<a id="createUpdateSource" href="#/updateCenter.updatesourcedetails">
                                <fmt:message key="updatecenter.updatessource.create" />
                            </a>-->
                            <button id="createUpdateSource" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/updateCenter.updatesourcedetails'">
                                <i class="cux-icon cux-icon-file-text"></i><span>
                                    <fmt:message key="updatecenter.updatessource.create" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <!--<a id="editUpdateSource" data-bind="styledDisabled: updateSourceTable() && updateSourceTable().checkedRows().length !== 1">
                                <fmt:message key="updatecenter.updatessource.edit" />
                            </a>-->

                            <button id="editUpdateSource" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: updateSourceTable() && updateSourceTable().checkedRows().length !== 1">
                                <i class="cux-icon cux-icon-edit"></i><span>
                                    <fmt:message key="updatecenter.updatessource.edit" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <!--<a id="deleteUpdateSource" data-bind="styledDisabled: updateSourceTable() && updateSourceTable().selectedItemCount() === 0">
                                <fmt:message key="updatecenter.updatessource.delete" />
                            </a>-->

                            <button id="deleteUpdateSource" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: updateSourceTable() && updateSourceTable().selectedItemCount() === 0">
                                <i class="cux-icon cux-icon-trash"></i><span>
                                    <fmt:message key="updatecenter.updatessource.delete" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <!--<a id="refreshUpdateSource">
                                <fmt:message key="updatecenter.updatessource.refresh" />
                            </a>-->

                            <button id="refreshUpdateSource" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="updatecenter.updatessource.refresh" />
                                </span>
                            </button>
                        </li>
                    </ul>
                </nav>

                <!-- ko with: updateSourceTable -->
                <table id="updateSourceTable" class="dataTable">
                <thead>
                    <th scope="col" class="checkboxColumn">
                        <input id="cbSelectionAllRowsUpdateSource" type="checkbox" />
                        <label for="cbSelectionAllRowsUpdateSource" class="visuallyhidden">
                            <u>
                                <fmt:message key="updateCenter.updategroups.updatesourcechoices" />
                            </u>
                        </label>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.updatesource.name" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.updatesource.description" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.updatesource.sourcetype" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.updatesource.location" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.updatesource.credentialprofile" /></strong>
                    </th>
                </thead>
                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="6">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && (!data || data().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="5">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr>
                        <td class="checkboxColumn">
                            <input name="server" type="checkbox" data-bind="checked: checked, indexedid: 'source_'" />
                            <label class="visuallyhidden" data-bind="indexedfor: 'source_'">
                                <u>
                                    <fmt:message key="updateCenter.updatesource.updatesourcechoices" />
                                </u>
                            </label>
                        </td>
                        
                        <!-- ko if: isDefault -->
                        <td data-bind="text: name + '(default)'"></td>
                        <!-- /ko -->

                        <!-- ko if: !isDefault -->
                        <td data-bind="text: name"></td>
                        <!-- /ko -->
                        
                        <td data-bind="text: description"></td>
                        <td data-bind="text: sourceType"></td>
                        <td data-bind="text: location"></td>
                        <td data-bind="text: credentials"></td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->
            </section>
            </section>

            <section class="subtabSettingsPanel master" data-bind="visible: activeTab() == 'updategroups'">

            <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="updatecenter.updatesettings" />
                    </h1>
                </header>

                <nav class="menu tabs" role="navigation">
                    <ul>
                        <li>
                            <a href="#/updateCenter.home/updatesettings">
                                <fmt:message key="updateCenter.updatesettings.updatesource" />
                            </a>
                        </li>
                        <li class="selected">
                            <a href="#/updateCenter.home/updategroups">
                                <fmt:message key="updateCenter.updatesettings.updategroups" />
                            </a>
                        </li>
                        <li>
                            <a href="#/updateCenter.home/pollingandnotification">
                                <fmt:message key="updateCenter.updatesettings.pollingandnotification" />
                            </a>
                        </li>
                         <li >
                            <a href="#/updateCenter.home/protectionvault">
                                <fmt:message key="updatecenter.updatesettings.protectionvault" />
                            </a>
                        </li>
                    </ul>
                </nav>
                
            <section class="subtabPanel">
          
            <div id="updateGroupMasterDetails" class="masterDetails">
            <section id="updateGroupMaster" class="master">

                  <p>
              <fmt:message key="updategroups.help" />
            </p>
                <nav class="action-buttons">
            <ul class="inlineList taskbar">
                <li>
                    <!--<a id="createUpdateGroup" href="#/updateCenter.updategroupdetails">
                        <fmt:message key="updatecenter.updategroups.create" />
                    </a>-->

                    <button id="createUpdateGroup" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" onclick="window.location.href='#/updateCenter.updategroupdetails'">
                        <i class="cux-icon cux-icon-file-text"></i><span>
                            <fmt:message key="updatecenter.updategroups.create" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--<a id="editUpdateGroup" data-bind="styledDisabled: updateGroupsTable() && updateGroupsTable().checkedRows().length !== 1">
                        <fmt:message key="updatecenter.updategroups.edit" />
                    </a>-->

                    <button id="editUpdateGroup" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: updateGroupsTable() && updateGroupsTable().checkedRows().length !== 1">
                        <i class="cux-icon cux-icon-edit"></i><span>
                            <fmt:message key="updatecenter.updategroups.edit" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--<a id="deleteUpdateGroup" data-bind="styledDisabled: (updateGroupsTable() && updateGroupsTable().selectedItemCount() === 0) || (DellClarity.SCVMM.ViewModel.UpdateCenter.selectedGroups() && DellClarity.SCVMM.ViewModel.UpdateCenter.selectedGroups().length === 0)">
                        <fmt:message key="updatecenter.updategroups.delete" />
                    </a>-->

                    <button id="deleteUpdateGroup" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: (updateGroupsTable() && updateGroupsTable().selectedItemCount() === 0) || (DellClarity.SCVMM.ViewModel.UpdateCenter.selectedGroups() && DellClarity.SCVMM.ViewModel.UpdateCenter.selectedGroups().length === 0)">
                        <i class="cux-icon cux-icon-trash"></i><span>
                            <fmt:message key="updatecenter.updategroups.delete" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--<a id="refreshUpdateGroup">
                        <fmt:message key="updatecenter.updategroups.refresh" />
                    </a>-->

                    <button id="refreshUpdateGroup" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                        <i class="cux-icon cux-icon-file-repeat"></i><span>
                            <fmt:message key="updatecenter.updategroups.refresh" />
                        </span>
                    </button>
                </li>
            </ul>
        </nav>
           <div class="master-table-wrapper">
                <!-- ko with: updateGroupsTable -->
                <table id="updateGroupsTable" class="dataTable">
                    <thead>
                        <tr>
                            <th scope="col" class="checkboxColumn">
                                <input type="checkbox" id="updateGroupsSelectAll"/>
                                <label for="updateGroupsSelectAll" class="visuallyhidden">
                                    <fmt:message key="updateGroupMasterDetails.selectAllUpdateGroups" />
                                </label>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="generic.name" /></strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="generic.description" /></strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="updateGroupMasterDetails.grouptype" /></strong>
                            </th>
                            <th scope="col">
                                <strong><fmt:message key="updateGroupMasterDetails.noofservers" /></strong>
                            </th>
                        </tr>
                    </thead>
                    <!-- ko if: loading() -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="updatecenter.updategroups.updategroupstable.loading" />
                                <span>&nbsp;</span>
                                <span class="icon spinner"></span>
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && (!data || data().length == 0) -->
                    <tbody>
                        <tr>
                            <td colspan="6">
                                <fmt:message key="scrollabletable.empty" />
                            </td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                    <!-- ko if: !loading() && data && data().length > 0 -->
                    <tbody data-bind="foreach: data">
                        <tr data-bind="css: { selected: DellClarity.SCVMM.ViewModel.UpdateCenter.selectedUpdateGroup() === $data }">
                            
                            <td class="checkboxColumn">
                                <!-- ko if: ispredefined -->
                                    <input type="checkbox" data-bind="styledDisabled: ispredefined" />
                                <!-- /ko -->

                                <!-- ko if: !ispredefined -->
                                    <input type="checkbox" data-bind="checked: checked, indexedid: 'updateGroup_'" />
                                <!-- /ko -->

                                <label class="visuallyhidden" data-bind="indexedfor: 'updateGroup_'">Select Update Group</label>
                            </td>

                            <td data-bind="text: name"></td>
                            <td data-bind="text: description"></td>
                            <td data-bind="text: grouptype"></td>
                            <td data-bind="text: noofservers"></td>
                        </tr>
                    </tbody>
                    <!-- /ko -->
                </table>
                <!-- /ko -->
            </div>

            </section>

            <section class="details" id="updateGroupDetails" data-bind="visible: selectedUpdateGroup() !== undefined">
                <header>
                    <h1>
                        <fmt:message key="generic.details" />
                    </h1>
                </header>
                <!-- <ul class="labelValuePairs" data-bind="if: selectedUpdateGroup() !== undefined">
                    <li>
                        <label for="selectedUpdateGroupName"><u>
                            <fmt:message key="generic.name" />
                        </u></label>
                        <span id="selectedUpdateGroupName" class="value" data-bind="text: selectedUpdateGroup().groupname"></span>
                    </li>
                    <li>
                        <label for="selectedUpdateGroupDescription"><u>
                            <fmt:message key="generic.description" />
                        </u></label>
                        <span id="selectedUpdateGroupDescription" class="value" data-bind="text: selectedUpdateGroup().description"></span>
                    </li> -->

                    <ul class="groupcontent" data-bind="if: selectedUpdateGroup() !== undefined" >
                        <li>
                          <span style="width:200px"><fmt:message key="updateGroupMasterDetails.details.servicetag" /></span>
                            <span style="width:200px"><fmt:message key="updateGroupMasterDetails.details.ipaddress" /></span>
                            <hr>
                        </li>
                        <!-- ko if: selectedUpdateGroup().servers && selectedUpdateGroup().servers.length> 0 -->
                        <li data-bind="foreach: selectedUpdateGroup().servers">
                             <span style="display: inline-block; word-wrap: break-word;width:200px" data-bind="text: servicetag"></span>
                            <span style="display: inline-block; word-wrap: break-word;width:200px" data-bind="text: ipaddress"></span><br/>
                        </li>
                        <!-- /ko -->
                    </ul>
                <!-- </ul> -->

                
            </section>
            </div>
            </section>
            </section>

            <section class="subtabSettingsPanel" data-bind="visible: activeTab() == 'pollingandnotification'">
            <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="updatecenter.updatesettings" />
                    </h1>
                </header>

                <nav id="subTabMenu" class="menu tabs" role="navigation">
                    <ul>
                        <li>
                            <a href="#/updateCenter.home/updatesettings">
                                <fmt:message key="updateCenter.updatesettings.updatesource" />
                            </a>
                        </li>
                        <li>
                            <a href="#/updateCenter.home/updategroups">
                                <fmt:message key="updateCenter.updatesettings.updategroups" />
                            </a>
                        </li>
                        <li class="selected">
                            <a href="#/updateCenter.home/pollingandnotification">
                                <fmt:message key="updateCenter.updatesettings.pollingandnotification" />
                            </a>
                        </li>
                         <li >
                            <a href="#/updateCenter.home/protectionvault">
                                <fmt:message key="updatecenter.updatesettings.protectionvault" />
                            </a>
                        </li>
                    </ul>
                </nav>
            <section class="subtabPanel" id="pollingandnotification">
                <p><fmt:message key="updatecenter.pollingandnotification.help" /></p>
                <h2>
                    <fmt:message key="updatecenter.pollingandnotification.title" />
                </h2>
                <p><fmt:message key="updatecenter.pollingandnotification.subhelp" /></p>
                <ul data-bind="foreach: pollingChoices" >
                    <li>
                      <label>
                        <input type="radio"
                               name="PollingChoices" 
                               data-bind="attr: { value: id }, checked: $parent.selectedPollingChoice, click: $parent.updatePollingChoice" />
                        <span data-bind="text: name"></span>
                      </label>    
                    </li>
                </ul>
            </section>

           </section>
            
             <section class="subtabSettingsPanel" data-bind="visible: activeTab() == 'protectionvault'">
            <header class="visuallyhidden">
                    <h1>
                        <fmt:message key="updatecenter.updatesettings" />
                    </h1>
                </header>

                <nav id="subTabMenu" class="menu tabs" role="navigation">
                    <ul>
                        <li>
                            <a href="#/updateCenter.home/updatesettings">
                                <fmt:message key="updateCenter.updatesettings.updatesource" />
                            </a>
                        </li>
                        <li>
                            <a href="#/updateCenter.home/updategroups">
                                <fmt:message key="updateCenter.updatesettings.updategroups" />
                            </a>
                        </li>
                        <li >
                            <a href="#/updateCenter.home/pollingandnotification">
                                <fmt:message key="updateCenter.updatesettings.pollingandnotification" />
                            </a>
                        </li>
                         <li class="selected">
                            <a href="#/updateCenter.home/protectionvault">
                                <fmt:message key="updatecenter.updatesettings.protectionvault" />
                            </a>
                        </li>
                    </ul>
                </nav>
            <section class="subtabPanel">
                <p><fmt:message key="updatecenter.protectionvault.help" /></p>
                 <nav class="action-buttons">
                    <ul class="inlineList taskbar">
                        <li>
                            <!--<a id="createProtectionVault" href="#/updateCenter.protectionvaultdetails">
                                <fmt:message key="updatecenter.updatesettings.create" />
                            </a>-->

                            <button id="createProtectionVault" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" >
                                <i class="cux-icon cux-icon-file-text"></i><span>
                                    <fmt:message key="updatecenter.updatesettings.create" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <!--<a id="editProtectionVault" data-bind="styledDisabled: protectionVaultTable() && protectionVaultTable().checkedRows().length !== 1">
                                <fmt:message key="updatecenter.updatesettings.edit" />
                            </a>-->

                            <button id="editProtectionVault" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: protectionVaultTable() && protectionVaultTable().checkedRows().length !== 1">
                                <i class="cux-icon cux-icon-edit"></i><span>
                                    <fmt:message key="updatecenter.updatesettings.edit" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <!--<a id="deleteProtectionVault" data-bind="styledDisabled: protectionVaultTable() && protectionVaultTable().selectedItemCount() === 0">
                                <fmt:message key="updatecenter.updatesettings.delete" />
                            </a>-->

                            <button id="deleteProtectionVault" class="cui-button cux-button cux-button-medium cux-button-primary" type="button" data-bind="styledDisabled: protectionVaultTable() && protectionVaultTable().selectedItemCount() === 0">
                                <i class="cux-icon cux-icon-trash"></i><span>
                                    <fmt:message key="updatecenter.updatesettings.delete" />
                                </span>
                            </button>
                        </li>
                        <li>
                            <!--<a id="refreshProtectionVault">
                                <fmt:message key="updatecenter.updatesettings.refresh" />
                            </a>-->

                            <button id="refreshProtectionVault" class="cui-button cux-button cux-button-medium cux-button-primary" type="button">
                                <i class="cux-icon cux-icon-repeat"></i><span>
                                    <fmt:message key="updatecenter.updatesettings.refresh" />
                                </span>
                            </button>

                        </li>
                    </ul>
                </nav>

               <!-- ko with: protectionVaultTable -->
                <table id="protectionVaultTable" class="dataTable">
                <thead>
                    <th scope="col" class="checkboxColumn">
                        <input id="cbSelectionAllRowsProtectionVault" type="checkbox" />
                       
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.protectionvault.name" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.protectionvault.description" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.protectionvault.vaulttype" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.protectionvault.location" /></strong>
                    </th>
                    <th scope="col">
                        <strong><fmt:message key="updatecenter.protectionvault.credentialprofile" /></strong>
                    </th>
                </thead>
                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="5">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && (!data || data().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="5">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr>
                        <td class="checkboxColumn">
                               <!-- ko if: typeof ispredefined != 'undefined' && ispredefined -->
                                    <input type="checkbox" data-bind="styledDisabled: ispredefined" />
                                <!-- /ko -->

                                <!-- ko if: typeof ispredefined == 'undefined' ||  (typeof ispredefined != 'undefined' && !ispredefined)-->
                                     <input name="vaults" type="checkbox" data-bind="checked: checked, indexedid: 'vault_'" />
                                <!-- /ko -->

                          
                            <label class="visuallyhidden" data-bind="indexedfor: 'vault_'">
                                <u>
                                    <fmt:message key="updateCenter.protectionvault.protectionvaultchoices" />
                                </u>
                            </label>
                            
                        </td>
                        
                        <td data-bind="text: name"></td>
                        <td data-bind="text: description"></td>
                        <td data-bind="text: vaultTypeDisplay"></td>
                        <td data-bind="text: location"></td>
                        <td data-bind="text: credentialProfileDisplay"></td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
            <!-- /ko -->

            </section>

           </section>

        </fieldset>
    </form>
</section>
