<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_managejobs_jobTree"  data-bind="with: DellClarity.SCVMM.ViewModel.ManageJobs">
    <section id="error_managejobs" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    <p>
        <fmt:message key="managejobs.jobtree.help" />
    </p>
    <form>
        <fieldset id="jobFilterFieldSet">
            <legend class="visuallyhidden"><fmt:message key="managejobs.jobfilter" /></legend>
            <label for="managejobFilter"><fmt:message key="managejobs.filter" /></label>
            <select id="managejobFilter" data-bind="options: jobTypesList,
                        optionsText: 'name',
                        optionsValue: 'id',
                        value: selectedFilter">
            </select>
        </fieldset>
        <section>
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="managejobs.welcome.firmwareupdate" />
                </h1>
            </header>
            <nav class="action-buttons">
            <ul class="inlineList taskbar">
                <li>
                    <!--<a id="firmwareRefresh" class="jobRefresh">
                        <fmt:message key="managejobs.welcome.refresh" />
                    </a>-->
                    <button id="firmwareRefresh" class="jobRefresh cux-button cux-button-medium cux-button-primary" type="button">
                        <i class="cux-icon cux-icon-repeat"></i><span>
                            <fmt:message key="managejobs.welcome.refresh" />
                        </span>
                    </button>
                </li>
                <li>
                    <!--<a id="cancelFirmwareJob" data-bind="styledDisabled: (manageJobsTable() && selectedJobs().length === 0)">
                        <fmt:message key="managejobs.welcome.cancel" />
                    </a>-->

                    <button id="cancelFirmwareJob" data-bind="styledDisabled: (manageJobsTable() && selectedJobs().length === 0)" class="cux-button cux-button-medium cux-button-danger" type="button">
                        <i class="cux-icon cux-icon-remove"></i><span>
                            <fmt:message key="managejobs.welcome.cancel" />
                        </span>
                    </button>
                </li>
            </ul>
            </nav>

            <!-- ko with: manageJobsTable -->
            <table id="manageJobsTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col" class="checkboxColumn">
                            <input id="cbSelectionAllRows" type="checkbox" />
                            <label for="cbSelectionAllRows" class="visuallyhidden">
                                <u>
                                    <fmt:message key="updatecenter.managejobs.jobchoices" />
                                </u>
                            </label>
                        </th>
                        <th scope="col" data-bind="sort: 'name'">
                            <strong><fmt:message key="managejobs.jobtree.jobname" /></strong>
                        </th>
                        <th scope="col" data-bind="sort: 'type'">
                            <strong><fmt:message key="managejobs.jobtype" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="managejobs.jobtree.jobdescription" /></strong>
                        </th>
                        <th scope="col" data-bind="sort:'startTime'">
                            <strong><fmt:message key="managejobs.jobtree.dateStarted" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="managejobs.jobtree.endtime" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="managejobs.jobtree.jobstatus" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="managejobs.jobtree.jobcompletionstatus" /></strong>
                        </th>
                    </tr>
                </thead>
                <!-- ko if: loading() -->
                <tbody>
                    <tr>
                        <td colspan="8">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && (!data || data().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="8">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() && data && data().length > 0 -->
                <tbody data-bind="foreach: data">
                    <tr> 

                        <td class="checkboxColumn">
                            <!-- ko if: !allowCancel -->
                                <input name="job" type="checkbox" data-bind="styledDisabled: allowCancel, checked: checked, indexedid: 'job_'" />
                            <!-- /ko -->

                            <!-- ko if: allowCancel -->
                                <input name="job" type="checkbox" data-bind="checked: checked, indexedid: 'job_'" />
                            <!-- /ko -->

                                <label class="visuallyhidden" data-bind="indexedfor: 'job_'">
                                    <u>
                                        <fmt:message key="updatecenter.managejobs.jobchoices" />
                                    </u>
                                </label>
                            </td>

                        <td>
                            <span data-bind="text: name, indexedid: 'jobName'"></span>
                        </td>
                        <td>
                            <span data-bind="text:type"></span>
                        </td>
                        <td>
                            <span data-bind="text: description"></span>
                        </td>
                        <td>
                            <time data-bind="time: startTime, timeFormat: 'LLL'"></time>
                        </td>
                        <td>
                            <time data-bind="time: endTime, timeFormat: 'LLL'"></time>
                        </td>
                        <td>
                            <span data-bind="text: status"></span>
                        </td>
                        <td>
                            <span data-bind="text: completionStatus"></span>
                            <!-- ko if: isRunning -->
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                            <!-- /ko -->
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !loading() -->
                <tfoot>
                    <tr>
                        <td colspan="8">
                            <!-- ko template: {name:DellClarity.ScrollableTable.templateName, data: $data} -->
                            <!-- /ko -->
                        </td>
                    </tr>
                </tfoot>
                <!-- /ko -->
            </table>
            <!-- /ko -->
        </section>
    </form>
</section>

