<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_protectionvault_template" data-bind="with: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails">
    <section id="error_protectionvaultdetails" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />

    <p>
         <fmt:message key="updatecenter.protectionvaultdetails.help" /> 
    </p>

    <form id="protectionvaultform" autocomplete="off">
        <fieldset data-bind="with: model">
            <legend>
               <fmt:message key="updatecenter.protectionvaultdetails.title" /> 
            </legend>
           
            <ul class="labelValuePairs">

                <li>
                    <label for="vaultname">
                        <u>
                            <fmt:message key="updatecenter.protectionvaultdetails.name" /> 
                        </u>
                    </label>
                    <input id="vaultname" name="vaultname" required data-bind="value: name, styledDisabled: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.editFlag() == true, event: { keyup: DellClarity.SCVMM.capsText, blur: DellClarity.SCVMM.trimText }, valueUpdate: 'input'" type="text" maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="updatecenter.protectionvaultdetails.name.title" />' class="value" placeholder='<fmt:message key="updatecenter.protectionvaultdetails.name.hint" />'>
                </li>
                <li>
                    <label for="vaultDescription">
                        <u>
                          <fmt:message key="updatecenter.protectionvaultdetails.description" /> 
                        </u>
                    </label>
                    <textarea id="description" name="description" maxlength="255" title='<fmt:message key="updatecenter.protectionvaultdetails.description.title" />' placeholder='<fmt:message key="updatecenter.protectionvaultdetails.desc.hint" />'  class="value"  data-bind="value: description, styledDisabled: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.editFlag() == true"></textarea>
                </li>
            </ul>
        </fieldset>

          <fieldset data-bind="with: model">

            <legend>
                <fmt:message key="updatecenter.protectionvaultdetails.locationdetails" />
            </legend>
           
            <ul class="labelValuePairs">

                <li>
                    <label for="locationtype">
                        <u>
                            <fmt:message key="updatecenter.protectionvaultdetails.vaulttype" />
                        </u>
                    </label>
                    <span class="value">
                   <select id="locationtype"  required data-bind="options: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.vaultTypes,
                                                             optionsText: 'name',
                                                             optionsValue: 'id',
                                                             value: vaultTypeId,
                                                             styledDisabled: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.editFlag() == true,
                                                             optionsCaption: '<fmt:message key="updatecenter.protectionvaultdetails.vaulttypecaption" />'"></select>
                        </span>
                </li>

                 <!-- ko if: vaultTypeId() == '1' -->
                <li>
                    <label for="locationpath">
                        <u>
                         <fmt:message key="updatecenter.protectionvaultdetails.vaultlocation" />
                        </u>
                    </label>
                     <span class="value">
                    <input id="locationpath" name="locationpath" type="text" class="value" required data-bind="value: location, styledDisabled: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.editFlag() == true, event: { change: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.validateLocationPath }"  placeholder='<fmt:message key="updatecenter.protectionvaultdetails.vaultlocation.hint"/>'>
                         </span>
                </li>
                <!-- /ko -->

                  <li data-bind="visible: vaultTypeId() == '1'">
                    <label for="accesscredential">
                        <u>
                            <fmt:message key="updatecenter.protectionvaultdetails.accesscredential" />
                        </u>
                    </label>
                        <span class="value">
                     <select id="accesscredential" data-bind="value: credentialProfileId,
                                        options: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.credentialTypes, attr: { required: vaultTypeId() === '1' },
                                        optionsValue: 'id', optionsText: 'name',  optionsCaption: '<fmt:message key="updatecenter.protectionvaultdetails.accesscredentialcaption" />'">
                    <option value="">
                      <fmt:message key="updatecenter.protectionvaultdetails.credentialprofile" />
                    </option>
                </select>
                            <a href="#/credentialProfile.details" id="createCredProfile">
                           <strong> <fmt:message key="updatecenter.protectionvaultdetails.credentialprofile.create" /> </strong>
                        </a>
                             </span>
                        
                </li>

            </ul>
        </fieldset>
      
          <fieldset data-bind="with: model">
            <legend>
             <fmt:message key="updatecenter.protectionvaultdetails.imagedetails" />
            </legend>
           
            <ul class="labelValuePairs">

                <li>
                    <label for="passphrase">
                        <u>
                          <fmt:message key="updatecenter.protectionvaultdetails.imagepassphrase" />
                        </u>
                    </label>
                     <span class="value">
                   <input id="passphrase" name="passphrase"  type="password" class="value" maxlength="32" size="32" required data-bind="value: passphrase, event: { change: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.validatePassword, keyup: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.matchPassword }, styledDisabled: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.editFlag() == true"/>
                         </span>
                </li>
                <li>
                    <label for="confirmpassphrase">
                        <u>
                       <fmt:message key="updatecenter.protectionvaultdetails.imagepassphrasecfrm" />
                        </u>
                    </label>
                     <span class="value">
                        <input id="confirmpassphrase" name="confirmpassphrase"  type="password"  class="value"  maxlength="32" size="32" required data-bind="value: confirmpassphrase ? confirmpassphrase : '', event: { change: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.matchPassword }, styledDisabled: DellClarity.SCVMM.ViewModel.ProtectionVaultDetails.editFlag() == true"/>
                         </span>
                </li>
               
            </ul>
        </fieldset>
     
             <!--fieldset data-bind="with: model">
          
              
               
                  <ul class="labelValuePairs">
                <li>
                     <span class="label">
                        <u>
                           Backup Image Retention Count
                        </u>
                    </span>
                    <input style=" margin-top: 5px;width:15px;height:12px" id="retentioncount" type="text" role="textbox" maxlength="2" size="2" data-bind="value: retentioncount"/>
                </li>
            </ul>
                </!--fieldset-->

        <div class="sectionEditButtons">
            <button id="vaultfinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                  <fmt:message key="updatecenter.protectionvaultdetails.saveform" /> 
            </button>
            <button id="vaultcancel" class="cux-button cux-button-large cux-button-danger" type="button">
                 <fmt:message key="updatecenter.protectionvaultdetails.cancelform" /> 
            </button>
        </div>
    </form>
</section>
