<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_runupdate_template" data-bind="with: DellClarity.SCVMM.ViewModel.RunUpdate">
    <section id="error_updatecenter_runupdate" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <form id="runUpdateForm" autocomplete="off">
        <fieldset data-bind="with: model">
            <legend>
                <fmt:message key="runupdate.title" />
            </legend>
            <p>
                <fmt:message key="updatecenter.runupdate.help" />
            </p>
            <ul class="labelValuePairs">

                <li>
                    <label for="runUpdateJobName">
                        <u>
                            <fmt:message key="updatecenter.runupdate.jobname" />
                        </u>
                    </label>
                    <input id="runUpdateJobName" name="runUpdateJobName" required data-bind="value: jobname, event: { change: DellClarity.SCVMM.ViewModel.RunUpdate.trimJobNameText }"  type="text" maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="updatecenter.runupdate.jobname.hint" />' class="value">
                </li>
                <li>
                    <label for="runUpdateJobDescription">
                        <u>
                            <fmt:message key="updatecenter.runupdate.jobdescription" />
                        </u>
                    </label>
                    <textarea id="runUpdateJobDescription" name="runUpdateJobDescription"  data-bind="value: jobdescription" class="value" maxlength="255" title='<fmt:message key="updatecenter.runupdate.jobdescription.title" />'></textarea>
                </li>

                <li>
                    <input type="checkbox" class="value" id="downgradeCheck" data-bind="checked: DellClarity.SCVMM.ViewModel.RunUpdate.isAllowDowngrade" />
                    <label for="downgradeCheck">
                        <u>
                            <fmt:message key="updatecenter.home.allowdowngrade" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <fieldset data-bind="with: model">
            <legend>
                <fmt:message key="updatecenter.runupdate.scheduleupdate" />
            </legend>
            <ul class="labelValuePairs">

                <li>
                    <label for="scheduleDate">
                        <u>
                            <fmt:message key="updatecenter.runupdate.scheduleupdate" />
                        </u>
                    </label>

                    <span class="value">
                        <input class="input-append date" type="text" id="scheduleDate" name="scheduleDate" data-bind="datepicker: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate, event: { change: DellClarity.SCVMM.ViewModel.RunUpdate.validateDate }, attr: { required: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate }, styledDisabled: 1==1" placeholder="Run Now" />
                        <a href="" id="clear">Clear calendar</a>
                        <span id="scheduleCalendar" class="add-on"><i class="schedule-icon cux-icon cux-icon-calendar" data-bind="datepicker: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate, event: { change: DellClarity.SCVMM.ViewModel.RunUpdate.validateDate }"></i></span>

                        <select class="scheduleHourMinute" id="scheduleHour" data-bind="options: DellClarity.SCVMM.ViewModel.RunUpdate.optionsHour, value: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledHour, styledDisabled: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate() == null || DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate().length == 0"></select>
                        <span id="scheduleHourMinuteSeparator">:</span>
                        <select class="scheduleHourMinute" id="scheduleMinute" data-bind="options: DellClarity.SCVMM.ViewModel.RunUpdate.optionsMinute, value: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledMinute, styledDisabled: DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate() == null || DellClarity.SCVMM.ViewModel.RunUpdate.scheduledDate().length == 0"></select>
                    </span>
                </li>
                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="updatecenter.runupdate.updatemethod" />
                        </u>
                    </span>
                    <span class="value">
                      <label for="updateMethod" class="visuallyhidden">
                        <u>
                          <fmt:message key="updatecenter.runupdate.updatemethod" />
                        </u>
                      </label>
                        <select id="updateMethod" required data-bind="options: $parent.updateMethodList,
                                                             optionsText: 'name',
                                                             optionsValue: 'id',
                                                             value: selectedUpdateMethod,
                                                             optionsCaption: '<fmt:message key="updatecenter.selectupdatemethod" />'"></select>
                    </span>
                </li>
 
            </ul>
            <p>
                <fmt:message key="updatecenter.runupdate.scheduleupdatehelp" />
            </p>
        </fieldset>
        
        <fieldset>
            <legend  class="visuallyhidden">
                <fmt:message key="runupdate.title" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <input type="checkbox" class="value" id="goToTheJobList" data-bind="checked: goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="updatecenter.runupdate.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>

        <div class="sectionEditButtons">
            <button id="runUpdateFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="updatecenter.runupdate.finish" />
            </button>
            <button id="runUpdateCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="updatecenter.runupdate.cancel" />
            </button>
        </div>
    </form>
</section>
