<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updategroupdetails_template" data-bind="with: DellClarity.SCVMM.ViewModel.UpdateGroupDetails">
    <section id="error_updategroupdetails" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="updategroupdetails.help" />
    </p>
    <form id="updateGroupDetailsForm" autocomplete="off">
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="updategroupdetails.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="groupName">
                        <u>
                            <fmt:message key="updategroupdetails.groupName" />
                        </u>
                    </label>
                    <input id="groupName" name="groupName" required data-bind="value: name, event: { keyup: DellClarity.SCVMM.capsText, blur: DellClarity.SCVMM.trimText }, valueUpdate: 'input'"  type="text" maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="updategroupdetails.name.hint" />' value=""  class="value" placeholder='<fmt:message key="updategroupdetails.groupName.hint"/>'>
                </li>
                <li>
                    <label for="updateGroupDescription">
                        <u>
                            <fmt:message key="updategroupdetails.description" />
                        </u>
                    </label>
                    <textarea id="updateGroupDescription" name="updateGroupDescription"  data-bind="value: description" class="value" maxlength="255" title='<fmt:message key="updategroupdetails.description.title" />' placeholder='<fmt:message key="updategroupdetails.description.hint"/>'></textarea>
                </li>
            </ul>
         </fieldset>

         <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="updategroupdetails.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="updategroupdetails.grouptype" />
                        </u>
                    </span>
                    <span class="value">
                        <label for="grouptype" class="visuallyhidden">
                            <u>
                                <fmt:message key="updategroupdetails.selectgrouptype" />
                            </u>
                        </label>
                        <select id="grouptype" name="grouptype" required
                            data-bind="options: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.updateGroupTypes, optionsText: 'name', optionsValue: 'id',
                                        value: grouptype,
                                        styledDisabled: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.editFlag() == true,
                                        optionsCaption: '<fmt:message key="updategroupdetails.selectgrouptype"/>' ">                     
                        </select>
                    </span>
                </li>
            </ul>
          </fieldset>
            
          <fieldset>
              <legend class="visuallyhidden">
                <fmt:message key="updategroupdetails.title" />
            </legend>
              
               
             <div style=" padding:1% 4% 1% 6%;width: 85%;">
                  <div style="padding-bottom: 10px;width: 100%">
                    <input  style="width:45%" id="filter" name="filter" placeholder='<fmt:message key="updategroupdetails.search.hint"/>' type="text" data-bind="value: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.filter, event: { keyup: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.searchFilter } " />
                    <a href="" id="clear">Clear calendar</a>
                </div>
                <div style="width: 45%; border-style: solid;  display: inline-block; box-sizing: border-box; border-width: 1px; float: left;">
                    <div class="multiselectTableHeader"><strong><fmt:message key="updategroupdetails.chooseservers" /></strong></div><hr/>
                    <p>
                        <span style="padding: 5px; font-size: 14px;/*10pt;*/"><strong><fmt:message key="updategroupdetails.paneheader1" /></strong></span>
                        <span style="padding: 5px;margin-left:0.8em; font-size: 14px;/*10pt;*/"><strong><fmt:message key="updategroupdetails.paneheader2" /></strong></span>
                    </p>
                
                    <div style="float: left;width:100%;">
                        <select name="allservers" id="allservers" multiple="multiple" class="multiselectTable" style="overflow-x: scroll; width:100%; height: 129px; font-family: sans-serif;" data-bind="foreach: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.updateGroupServersDummy">
                            <!-- ko if: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.updateGroupServersDummy -->
                                <option data-bind="attr: { id: id }, title: isupdatescheduled ? 'Job is scheduled/running on this server' : '', value: id, text: '&nbsp;' + servicetag + '&emsp;' + '&emsp;&emsp;&emsp;&emsp;&emsp;' + ipaddress, option: $data, styledDisabled: isupdatescheduled"></option>
                            <!-- /ko -->
                        </select>
                    </div>
                </div>
                <div class="btn" style="float: left; padding: 12% 1% 2% 1%;">
                    <input id="btnleft" value=">>" type="button" />
                    <br /><br />
                    <input id="btnright" value="<<" type="button" />
                </div>

                 <div style="width: 45%; display: inline-block; box-sizing: border-box; border-style: solid; border-width: 1px; float: left;">
                    <div class="multiselectTableHeader"><strong><fmt:message key="updategroupdetails.serversincluded" /></strong></div><hr/>
                    <p>
                        <span style="padding: 5px; font-size: 14px;/*10pt;*/"><strong><fmt:message key="updategroupdetails.paneheader1" /></strong></span>
                        <span style="padding: 5px;margin-left:0.8em; font-size: 14px;/*10pt;*/"><strong><fmt:message key="updategroupdetails.paneheader2" /></strong></span>
                    </p>
                
                    <div style="float: left;width:100%;">
                        <select name="selectedservers" id="selectedservers" multiple="multiple" class="multiselectTable" style="overflow-x: scroll; width:100%; height: 129px; font-family: sans-serif;" data-bind="foreach: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.selectedUpdateGroupServers">
                            <!-- ko if: DellClarity.SCVMM.ViewModel.UpdateGroupDetails.selectedUpdateGroupServers -->
                                <option data-bind="attr: { id: id }, title: isupdatescheduled ? 'Job is scheduled/running on this server' : '', value: id, text: '&nbsp;' + servicetag + '&emsp;' + '&emsp;&emsp;&emsp;&emsp;&emsp;' + ipaddress, option: $data, styledDisabled: isupdatescheduled"></option>
                            <!-- /ko -->
                        </select>
                    </div>
                </div>
            </div>
         </fieldset>
         
        <div class="sectionEditButtons">
            <button id="updateGroupDetailsFinish" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="updategroupdetails.save" />
            </button>
            <button id="updateGroupDetailsCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="updategroupdetails.cancel" />
            </button>
        </div>
    </form>
</section>
