<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatesourcedetails_template" data-bind="with: DellClarity.SCVMM.ViewModel.UpdateSourceDetails">
    <section id="error_updatesourcedetails" role="alert" class="messageBox" data-bind="template: { name: DellClarity.Controls.MessageBox.templateName }" />
    <p>
        <fmt:message key="updatesourcedetails.help" />
    </p>
    <form id="updateSourceDetailsForm" autocomplete="off">
        <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="updatesourcedetails.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="sourceName">
                        <u>
                            <fmt:message key="updatesourcedetails.sourceName" />
                        </u>
                    </label>
                    <input id="sourceName" name="sourceName" required data-bind="value: name, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isPreDefined() == true, event: { keyup: DellClarity.SCVMM.capsText, blur: DellClarity.SCVMM.trimText }, valueUpdate: 'input'"  type="text" maxlength="59" pattern="^.{1,59}$" title='<fmt:message key="updatesourcedetails.name.hint" />' value=""  class="value" placeholder='<fmt:message key="updatesourcedetails.sourceName.hint"/>'>
                </li>
                <li>
                    <label for="updateSourceDescription">
                        <u>
                            <fmt:message key="updatesourcedetails.description" />
                        </u>
                    </label>
                    <textarea id="updateSourceDescription" name="updateSourceDescription"  data-bind="value: description, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isPreDefined() == true" class="value" maxlength="255" title='<fmt:message key="updatesourcedetails.description.title" />' placeholder='<fmt:message key="updatesourcedetails.description.hint"/>'></textarea>
                </li>
            </ul>
         </fieldset>
         <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="updatesourcedetails.title" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="updatesourcedetails.sourcetype" />
                        </u>
                    </span>
                    <span class="value">
                        <label for="sourceType" class="visuallyhidden">
                            <u>
                                <fmt:message key="updatesourcedetails.selectsourcetype" />
                            </u>
                        </label>
                        <select id="sourceType" name="sourceType" required
                            data-bind="options: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.sourceTypes, optionsText: 'name', optionsValue: 'id',
                                        value: sourceType,
                                        styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true,
                                        optionsCaption: '<fmt:message key="updatesourcedetails.selectsourcetype"/>' ">                     
                        </select>
                    </span>
                </li>

                <!-- ko if: sourceType() == undefined -->
                <li>
                    <label for="updatesourcelocation">
                        <u>
                            <fmt:message key="updatesourcedetails.location" />
                        </u>
                    </label>
                    <input id="updatesourcelocation" name="updatesourcelocation" required data-bind="value: location" type="text" class="value">
                </li>
                <!-- /ko -->

                <!-- ko if: sourceType() == '1'  || sourceType() == '4' -->
                <li>
                    <label for="updateftpsourcelocation">
                        <u>
                            <fmt:message key="updatesourcedetails.location" />
                        </u>
                    </label>
                    <input id="updateftpsourcelocation" name="updateftpsourcelocation" required data-bind="value: location, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true, event: { change: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.validateFTPLocation, keyup: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.disableSave }" type="text" placeholder='<fmt:message key="updatesourcedetails.ftplocation.hint"/>' class="value">
                    <!-- <input id="updateftpsourcelocation" name="updateftpsourcelocation" required data-bind="value: location, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true, event: { change: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.validateFTPLocation }" type="text" placeholder='<fmt:message key="updatesourcedetails.ftplocation.hint"/>' class="value"> -->
                </li>
                <!-- /ko -->

                <!-- ko if: sourceType() == '2' || sourceType() == '3' -->
                <li>
                    <label for="updatedrmsourcelocation">
                        <u>
                            <fmt:message key="updatesourcedetails.location" />
                        </u>
                    </label>
                    <input id="updatedrmsourcelocation" name="updatedrmsourcelocation" required data-bind="value: location, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true, event: { change: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.validateDRMLocation, keyup: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.disableSave }" type="text" placeholder='<fmt:message key="updatesourcedetails.drmlocation.hint"/>' class="value">
                    <!-- <input id="updatedrmsourcelocation" name="updatedrmsourcelocation" required data-bind="value: location, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true, event: { change: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.validateDRMLocation }" type="text" placeholder='<fmt:message key="updatesourcedetails.drmlocation.hint"/>' class="value"> -->
                </li>
                <!-- /ko -->

            </ul>
         </fieldset>
         <fieldset data-bind="with: model">
            <legend class="visuallyhidden">
                <fmt:message key="updatesourcedetails.title" />
            </legend>
            <ul class="labelValuePairs">
                <!-- ko if: sourceType() != '4' -->
                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="updatesourcedetails.selectprofile.usethiscredentialprofile" />
                        </u>
                    </span>
                    <span class="value">
                        <label for="credProfile" class="visuallyhidden">
                            <u>
                                <fmt:message key="updatesourcedetails.selectprofile.credentialProfile" />
                            </u>
                        </label>
                        <select id="credProfile" name="credProfile" required
                            data-bind="options: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.credProfiles, optionsText: 'name', optionsValue: 'id',
                                        value: credentials, 
                                        styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isPreDefined() == true,
                                        optionsCaption: '<fmt:message key="updatesourcedetails.selectprofile.credentialProfile"/>' ">                     
                        </select>
                        <a id="createProfileDetails" data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isPreDefined() == true, event: { click: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.stopReload() }, attr: { href: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isPreDefined() == true ? null : '#/credentialProfile.details' }">
                            <fmt:message key="updatesourcedetails.selectprofile.createnew" />
                        </a>
                    </span>
                </li>
                <!-- /ko -->

                <li data-bind="visible: sourceType() == '1' || sourceType() == '4'">
                    <span class="label">
                        <u>
                             <fmt:message key="updatesourcedetails.selectprofile.usethisproxycredentials" />
                        </u>
                    </span>
                    <span class="value">
                        <label for="proxyCredMain" class="visuallyhidden">
                            <u>
                                <fmt:message key="updatesourcedetails.selectprofile.proxyProfile" />
                            </u>
                        </label>

                        <select id="proxyCredMain" name="proxyCredMain" 
                            data-bind="options: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.proxyCredProfiles, optionsText: 'name', optionsValue: 'id', 
                                        value: proxyCredentials,
                                        optionsCaption: '<fmt:message key="updatesourcedetails.selectprofile.proxyProfile"/>' ">                     
                        </select>
                        <a id="createProxyProfileDetails" href="#/credentialProfile.details" data-bind="event: { click: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.stopReload() }">
                            <fmt:message key="updatesourcedetails.selectproxyprofile.createnew" />
                        </a>
                    </span>
                </li>

                <li data-bind="visible: sourceType() != '3'">
                    <input type="checkbox" class="value" id="Checkbox1" data-bind="checked: isDefault, styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true && DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isDefaultSource() == true" name="setDefault" />
                    <label for="Checkbox1" data-bind="styledDisabled: DellClarity.SCVMM.ViewModel.UpdateSourceDetails.editFlag() == true && DellClarity.SCVMM.ViewModel.UpdateSourceDetails.isDefaultSource() == true">
                        <u>
                            <fmt:message key="updatesourcedetails.makeDefault" />
                        </u>
                    </label>
                </li>

            </ul>
        </fieldset>
        <div class="sectionEditButtons">
            <button id="testConnection" class="cux-button cux-button-large cux-button-primary" type="submit" data-bind="disable: enableSave">
                <fmt:message key="updatesourcedetails.testconnection" />
            </button>
            <button id="updateSourceDetailsFinish" class="cux-button cux-button-large cux-button-primary" type="submit" data-bind="enable: enableSave">
                <fmt:message key="updatesourcedetails.save" />
            </button>
            <!-- <button id="updateSourceDetailsFinish" type="submit">
                <fmt:message key="updatesourcedetails.save" />
            </button> -->
            <button id="updateSourceDetailsCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="updatesourcedetails.cancel" />
            </button>
        </div>
    </form>
</section>
