<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_updatecenter_viewlclogs_template"  data-bind="with: DellClarity.SCVMM.ViewModel.ViewLCLogs">
    <section id="error_updatecenter_viewlclogs" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    <p>
        <fmt:message key="updatecenter.viewlclogs.help" />
    </p>
    <form>
        <section>
            <header class="visuallyhidden">
                <h1>
                    <fmt:message key="updatecenter.viewlclogs.help" />
                </h1>
            </header>

            <!-- ko if: !DellClarity.SCVMM.ViewModel.ViewLCLogs.loading() && DellClarity.SCVMM.ViewModel.ViewLCLogs.lclogsTableRows() && DellClarity.SCVMM.ViewModel.ViewLCLogs.lclogsTableRows().length > 0 -->
            <div>
                <label for="searchFilter">
                    <u>
                        <fmt:message key="updatecenter.viewlclogs.search" />
                    </u>
                </label>
                <input  style="width:22%" name="searchFilter" id="searchFilter" type="text" data-bind="value: searchString, changeOnEnter: true, event: { keypress: loadSearchResults }" />
            </div>
            <br/>
            <!-- /ko -->

            <table id="viewLCLogsTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.viewlclogs.servicetag" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.viewlclogs.ipaddress" /></strong>
                        </th>
                        <th scope="col">
                            <strong><fmt:message key="updatecenter.viewlclogs.filename" /></strong>
                        </th>
                    </tr>
                </thead>
                <!-- ko if: DellClarity.SCVMM.ViewModel.ViewLCLogs.loading() -->
                <tbody>
                    <tr>
                        <td colspan="3">
                            <fmt:message key="scrollabletable.loading" />
                            <span>&nbsp;</span>
                            <span class="icon spinner"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: !DellClarity.SCVMM.ViewModel.ViewLCLogs.loading() && (!DellClarity.SCVMM.ViewModel.ViewLCLogs.lclogsTableRows() || DellClarity.SCVMM.ViewModel.ViewLCLogs.lclogsTableRows().length == 0) -->
                <tbody>
                    <tr>
                        <td colspan="3">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko with:  DellClarity.SCVMM.ViewModel.ViewLCLogs.lclogsTableRows -->
                <tbody oncontextmenu="return false;" data-bind="foreach: $data">
                    <tr> 
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                        <td>
                            <span data-bind="text: hostName"></span>
                        </td>
                        <!-- ko if: $data.fileName != "NOT AVAILABLE" -->
                        <td id="fileName">
                            <a data-bind="event: { click: DellClarity.SCVMM.ViewModel.ViewLCLogs.displaylclogs }"><span  data-bind="text: fileName"></span></a>
                        </td>
                        <!-- /ko -->
                        <!-- ko if: $data.fileName == "NOT AVAILABLE" -->
                        <td>
                            <span  data-bind="text: fileName"></span>
                        </td>
                        <!-- /ko -->
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>

            <div id="custom-menu">
                <ul>
                    <li><a data-bind="event: { click: DellClarity.SCVMM.ViewModel.ViewLCLogs.downloadLCLogFile }">Download</a> </li>
                </ul>
            </div>
        </section>
    </form>
</section>

