<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="whiteListPage" data-bind="with: DellClarity.SCVMM.ViewModel.WhiteList">
    <header>
        <h1><fmt:message key="whitelistsettings.title" /></h1>
    </header>
    <span><fmt:message key="whitelistsettings.help" />
    </span>
    <form>
        <fieldset>
            <legend class="visuallyhidden"><fmt:message key="whitelistsettings.enableserver" /></legend>
            <ul class="labelValuePairs">
                <li>
                    <input id="enableServerCheckbox" type="checkbox" class="value" data-bind="checked: enableWhiteList"/>
                    <label for="enableServerCheckbox"><u><fmt:message key="whitelistsettings.enableserverlabel" /></u></label>
                </li>
            </ul>
        </fieldset>
        <div id="taskTableDiv" data-bind="styledDisabled: enableWhiteList() === false">
            <fieldset>
                <legend class="visuallyhidden"><fmt:message key="whitelistsettings.addwhitelist" /></legend>
                <span id="addWhiteListSpan">
                    <label for="serviceTag" class="visuallyhidden"><fmt:message key="whitelistsettings.whitelist" /></label>
                    <input id="serviceTag" type="text"/>
                
                    <label for="addWhiteList" class="visuallyhidden"><fmt:message key="whitelistsettings.addbuttonlabel" /></label>
                    <button id="addWhiteList" type="button" ><fmt:message key="whitelistsettings.addbutton" /></button>
                </span>
            </fieldset>
        
            <ul class="inlineList taskbar">
                <li>
                    <a id="deleteWhiteList" data-bind="styledDisabled: selectedWhiteList() === undefined"><fmt:message key="whitelistsettings.deletelink" /></a>
                </li>
                <li>
                    <a data-bind="styledDisabled: enableWhiteList() === false, attr:{href: enableWhiteList() ? hrefLink() : null} "><fmt:message key="whitelistsettings.importwhitelist" /></a>
                </li>
            </ul>
            <table id="whiteListTable" class="dataTable">
                <thead>
                    <tr>
                        <th scope="col"><fmt:message key="whitelistsettings.servicetag" /></th>
                    </tr>
                </thead>
                <!-- ko if: !whiteListServiceTags || whiteListServiceTags().length == 0 -->
                <tbody>
                    <tr>
                        <td colspan="7">
                            <fmt:message key="scrollabletable.empty" />
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
                <!-- ko if: whiteListServiceTags && whiteListServiceTags().length > 0 -->
                <tbody data-bind="foreach: whiteListServiceTags">
                    <tr data-bind="css: { selected: $parent.selectedWhiteList() === $data }">
                        <td>
                            <span data-bind="text: serviceTag"></span>
                        </td>
                    </tr>
                </tbody>
                <!-- /ko -->
            </table>
        </div>
    </form>
</section>
