<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<section id="page_winpeUpdate_template" data-bind="with: DellClarity.SCVMM.ViewModel.WinpeUpdate.Details">
    <section id="error_winpeUpdate" role="alert" class="messageBox" data-bind="template: DellClarity.Controls.MessageBox.templateName"></section>
    <p>
        <fmt:message key="winpeupdate.help" />
    </p>
    <form>
        <!-- ko with: model -->
        <fieldset>
            <legend class="visuallyhidden">
                <fmt:message key="winpeupdate.jobnametitle" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="jobName"><u>
                        <fmt:message key="winpeupdate.jobname" />
                    </u></label>
                    <span id="jobName" class="value" data-bind="text: $parent.generatedJobName"></span>
                </li>
            </ul>
        </fieldset>
        <fieldset>
            <legend>
                <fmt:message key="winpeupdate.imageSource" />
            </legend>

            <ul class="labelValuePairs">
                <li>
                    <label for="customWinpeImage">
                        <u>
                            <fmt:message key="winpeupdate.customwinpeimage" />
                        </u>
                    </label>
                    <input id="customWinpeImage" type="text" class="value" data-bind="value: imagePath" required placeholder='<fmt:message key="winpeupdate.customwinpeimagepathplaceholder" />'>
                </li>
            </ul>
        </fieldset>
        <fieldset>
            <legend>
                <fmt:message key="winpeupdate.dtkpath" />
            </legend>
            <p>
                <fmt:message key="winpeupdate.choosedtkpathhelp" />
            </p>
            <ul class="labelValuePairs">
                <li>
                    <label for="dtkDriversPath">
                        <u>
                            <fmt:message key="winpeupdate.dtkdriverspath" />
                        </u>
                    </label>
                    <input id="dtkDriversPath" type="text" class="value" data-bind="value: dtkDriversPath" required placeholder='<fmt:message key="winpeupdate.dtkdriverspathplaceholder" />'>
                </li>
            </ul>
        </fieldset>
        <fieldset>
            <legend>
                <fmt:message key="winpeupdate.outputiso" />
            </legend>
            <ul class="labelValuePairs">
                <li>
                    <label for="isoFileName">
                        <u>
                            <fmt:message key="winpeupdate.isofilename" />
                        </u>
                    </label>
                    <input id="isoFileName" type="text" class="value" data-bind="value: isoFileName" required placeholder='<fmt:message key="winpeupdate.outputisoplaceholder" />' />
                </li>
            </ul>
        </fieldset>
        <fieldset>
            <legend>
                <fmt:message key="winpeupdate.credentialprofile" />
            </legend>
            <ul class="labelValuePairs">
                <!--Removed for the BETA, please do not delete-->
                <!--<li>
                        <input id="publishWinPeImage" type="checkbox" class="value" data-bind="checked: publishWinPeImage" />
                        <label for="publishWinPeImage"><u>Publish WinPE Image on all SCVMM PXE Servers</u></label>
                    </li>-->

                <li>
                    <span class="label">
                        <u>
                            <fmt:message key="winpeupdate.credentialprofile" />
                        </u>
                    </span>
                    <span class="value">
                        <label for="credProfile" class="visuallyhidden">
                            <u>
                                <fmt:message key="winpeupdate.credentialprofile" />
                            </u>
                        </label>
                        <select id="credProfile" name="credProfile" required
                            data-bind="options: DellClarity.SCVMM.ViewModel.WinpeUpdate.Details.credProfiles,
                                        optionsText: 'name',
                                        optionsValue: 'id',
                                        value: DellClarity.SCVMM.ViewModel.WinpeUpdate.Details.credentialProfile,
                                        optionsCaption: '<fmt:message key="winpeupdate.selectcredentialprofile"/>' ">                     
                        </select>
                        <a id="createCredProfile" data-bind="attr: { href: '#/credentialProfile.details' }">
                            <fmt:message key="winpeupdate.createnew" />
                        </a>
                    </span>
                </li>

                <li>
                    <input id="goToTheJobList" type="checkbox" class="value" data-bind="checked: $parent.goToTheJobList" />
                    <label for="goToTheJobList">
                        <u>
                            <fmt:message key="winpeupdate.gotothejoblist" />
                        </u>
                    </label>
                </li>
            </ul>
        </fieldset>
        <!-- /ko -->
        <div class="sectionEditButtons">
            <button id="winpeUpdate" class="cux-button cux-button-large cux-button-primary" type="submit">
                <fmt:message key="winpeupdate.update" />
            </button>
            <button id="winpeCancel" class="cux-button cux-button-large cux-button-danger" type="button">
                <fmt:message key="winpeupdate.cancel" />
            </button>
        </div>
    </form>
</section>
