﻿DellClarity.Localization.Translations = {
    genericTerms: {
        about: 'About',
        confirm: 'Confirm',
        save: 'Save',
        cancel: 'Cancel',
        enabled: 'Enabled',
        disabled: 'Disabled',
        expand: 'Expand',
        collapse: 'Collapse',
        select: 'Select',
        url: 'Url',
        response: 'Response',
        lineNumber: 'Line Number',
        minimize: 'Minimize',
        maximize: 'Maximize',
        normal: 'Normal'
    },
    core: {
        confirm: 'Confirm',
        genericexception: 'An error has occured.',
        networkexception: 'A network exception has occurred. Please click refresh on your browser.',
        enabled: 'Enabled',
        disabled: 'Disabled',
        nopassword: 'No Password',
        stars: '********',
        select: 'Select',
        actionInProgress: 'An action is in progress',
        pleaseWait: 'Please wait...'
    },
    validation: {
        required: 'Please fill out this field',
        pattern: 'Please use the required format: {title}',
        email: {
            hint: 'JohnDoe@domain.com',
            example: 'Enter an email address (e.g. JohnDoe@domain.com)',
        },
        url: {
            hint: 'http://',
            example: 'Enter a website address (e.g. http://company.com)',
        },
        number: {
            example: 'Enter a number (e.g. {example})',
            invalidMin: 'Value must be at least {min}',
            invalidMax: 'Value must be no higher than {max}',
            invalidRange: 'Value must be between {min} and {max}',
            invalidStep: 'Value must be an increment of {step} from {min}',
        },
        date: {
            hint: 'mm/dd/yyyy',
            example: 'Enter a date (e.g. {example})',
            invalidMin: 'Value must be on or after {min}',
            invalidMax: 'Value must be on or before {max}',
            invalidRange: 'Value must be between {min} and {max}',
            invalidStep: {
                days: 'Value must be an increment of {step} days from {min}',
                hours: 'Value must be an increment of {step} hours from {min}',
                minutes: 'Value must be an increment of {step} minutes from {min}',
            },
        },
        datetime: {
            hint: 'mm/dd/yyyy hh:mm pm',
            example: 'Enter a date and time (e.g. {example})',
        }
    },
    table: {
        zeroRecords: "There are no items available.",
        loadingData: 'Loading Data...',
        tasks: 'Other Tasks'
    },
    wizard: {
        cancel: "Cancel",
        saveAndContinue: 'Save and Continue',
        next: "Next",
        finish: "Finish",
        stepXofY: "Step %%currentStep%% of %%totalSteps%%",
        submit: "Submit",
        save: "Save",
        confirmcanceltitle: "Confirm",
        confirmcancel: "Are you sure you want to cancel?",
        successtitle: "Success",
        successmessage: "Your changes have been saved successfully."
    },
    loadingText: {
        loading: "Loading...",
        noData: "No Data Available"
    },
    dateFilterText: {
        from: "From: ",
        to: "To: "
    }
};