/// <summary>
/// NOTE: This version of this control is not supported in DellClarity 2.5.
/// A new version of this control will be created soon and will be compatible with the new API.
/// </summary>
if (DellClarity.Config.apiVersion < 2.5) {
    DellClarity.HealthIndicator = {
        templateUrl: 'templates/healthindicatortemplate.html',
        templateName: "baseHealthIndicatorTemplate",

        CreateHealthIndicator: function (healthIndicatorModel) {
            var initialized = false;

            return {
                model: healthIndicatorModel,
                calculatedThresholds: [],
                calculatedThresholdType: 'healthyThreshold',

                initialize: function () {
                    if (initialized) {
                        this.reset();
                    }

                    DellClarity.Resources.loadTemplate(DellClarity.HealthIndicator.templateName, DellClarity.HealthIndicator.templateUrl);

                    var self = this;

                    self.model.thresholds.sort(function (a, b) {
                        return (a.min - b.min);
                    });

                    var min = self.model.thresholds[0].min;
                    var max = self.model.thresholds[self.model.thresholds.length - 1].max;
                    var range = max - min;

                    $(self.model.thresholds).each(function (index, value) {
                        if (self.model.percentcomplete >= value.min && self.model.percentcomplete <= value.max)
                            self.calculatedThresholdType = value.thresholdtype;

                        self.calculatedThresholds.push({
                            thresholdtype: value.thresholdtype,
                            calculatedWidth: (((value.max - value.min) / range) * 100)
                        });
                    });

                    initialized = true;
                    this.reset();
                },

                reset: function () {
                }
            };
        }
    };
}
