/// <summary>
/// This control is used to define the framework to build the table grid using JQGrid component.
/// </summary>
if (DellClarity.Config.apiVersion <= 2.5) {
    DellClarity.JQGridTable = (function () {
     
        var pagereqobj = null;
        var self = this;
        var options = null;
        var finalData = null;
        var gridObjSelectionArray = null; gridObjSelectionArray = {};
        var requestProcessing = false; // Flag indicates data fetching in progress or not
       	var gridObjTableArray = null; gridObjTableArray = {};
       	var minWidth = 1024;
       	var relativeWidth = 330;
      	var resizeFlag = false;
		var enableScroll = false;
       	var pagination = false;
       	var rowsPerPage = 0;
		var defaultPageNum = 1;
		var	defaultRowHeight=22;
		var defaultOptions = {
            targetId: 'tablegrid',
            url: '',
            datatype: 'json',
            loadonce: false,
            sortname: '',
            sortorder: '',
			sortable:false,
            hoverrows: true,
            gridview: true,
            rowNum:0,
            height: 'auto',
            ignoreCase: true,
            altRows: false,
            rownumbers: false,
            multiselect: true,
			scrollOffset:0,
            cellEdit: false,
            totaltime: 0,         
            ajaxGridOptions: {
                accept: 'application/json', contentType: 'application/json; charset=utf-8',
                error: function (error, textStatus) {
                    if (error.status == 403)
                        document.location.href = "authtimeout.html";
                }
            },
            shrinkToFit: true,
            forceFit: true,
            autowidth: true,
            subGrid: true,
            subGridOptions: {
                "plusicon": "ui-icon-triangle-1-e",
                "minusicon": "ui-icon-triangle-1-s",
                "openicon": "ui-icon-arrowreturn-1-e",
                "reloadOnExpand": true,
                "selectOnExpand": false
            },
            onSelectRow: function (id, isSelected) {
                var isRowDisable = $("#" + options.targetId).find('#' + id + ' input[type=checkbox]').prop('disabled');
                var tr = $("#" + options.targetId)[0].rows.namedItem(id);


                if (!isRowDisable) {

                    updateMainGridOnRowSelect(id, isSelected);
                    EnableHTMLElementsOnSelection();

                    EnableGridHeaderCheckBox();
                }
                else {
                    $(tr).removeClass("ui-state-highlight");
                }

            },
            onPaging: function (pgButton) {
            
                enableScroll = false;
                var pagerId = this.p.pager.substr(1); // get paper id like "pager"                  

                var currentValue = $("#" + options.targetId).getGridParam('page');
                var nextValue = 0;
                // newUserEnteredValue is in the most cases the same as in this.p.page
                // only wrong values like -10 entered by user will not update
                // "page" parameter
                var totalPages = $("#" + options.targetId).jqGrid("getGridParam", "lastpage");
                if (pgButton.indexOf("next") >= 0) {

                    nextValue = ++currentValue;
                }
                else if (pgButton.indexOf("prev") >= 0) {
                    nextValue = --currentValue;
                }
                else if (pgButton.indexOf("last") >= 0)
                    nextValue = $("#" + options.targetId).getGridParam('lastpage');
                else if (pgButton.indexOf("first") >= 0)
                    nextValue = 1;
                else if (pgButton === "user") { // User input value

                    nextValue = $('input.ui-pg-input', "#pg_" + $.jgrid.jqID(pagerId)).val();

                    if (nextValue > totalPages || nextValue < 1 || isNaN(nextValue)) {

                        $('input.ui-pg-input', "#pg_" + $.jgrid.jqID(pagerId)).val(this.p.page);
                        return "stop";
                    }
                }
       

            },
            beforeSelectRow: function (rowid, e) {

                var element = document.activeElement;
                var rowData = $("#" + options.targetId).getRowData(rowid);
                if (element.type == "checkbox") { //enabling row select only when checkbox is selected

                    return true;
                }

                return false;
            },
            onSelectAll: function (aSel, selected) {
               
                if (selected) {
                    // uncheck "readonly" rows              

                    var cbs = $("tr.jqgrow > td > input.cbox:disabled", $("#" + options.targetId)[0]);

                    cbs.removeAttr("checked");

                }

                for (i = 0; i < aSel.length; i++) {
                    id = aSel[i];
                    var isRowDisable = $("#" + options.targetId).find('#' + id + ' input[type=checkbox]').prop('disabled');
                    var tr = $("#" + options.targetId)[0].rows.namedItem(id);
               
                    if (!isRowDisable)
                        updateMainGridOnRowSelect(id, selected);
                    else {
                        $(tr).removeClass("ui-state-highlight");
                    }

                }

                EnableHTMLElementsOnSelection();

                if (selected) {
                    $('#cb_' + options.targetId).prop('indeterminate', false);
                    $('#cb_' + options.targetId).prop('checked', true);
                } else {
                    $('#cb_' + options.targetId).prop('checked', false);
                    $('#cb_' + options.targetId).prop('indeterminate', false);
                }
            },
            beforeProcessing: function (data, status, xhr) {
                finalData = null;

                if (options.pollUrl != null)
                    dataPoll(options.targetId, data.responseObj);
            },

            loadComplete: function () {
                
				var rowIds = $(this).getDataIDs();
					var gridObjKey = null;
					var rowData = null;
				  
					var page = $("#" + options.targetId).jqGrid("getGridParam", "page");
			
				//	$('div.noResultsDiv').hide();
					
				
					$.each(rowIds, function (index, rowid) {
					    rowData = $("#" + options.targetId).getRowData(rowid);

					    if (rowData['childnodes'] == "0") {
					        $("#" + rowid + " td.sgcollapsed", $("#" + options.targetId)[0]).unbind('click').html('');
					    }
					
						gridObjKey = options.targetId + rowData['nodetype'] + rowData['id'];
										
						if (gridObjSelectionArray[gridObjKey] == null) {
							//if Obj doesnt exist create one.

							createGridSelectionObject(gridObjKey, rowData, options.targetId, rowid, true);

						}
						else {
							gridObjSelectionArray[gridObjKey].rowid = rowid;

						}
									 
					  
						var nodeObj = new Object();
						nodeObj.id = rowData['id'];
						nodeObj.nodetype = rowData['nodetype'];
						nodeObj.children = new Array();
						nodeObj.rowdata = rowData;
						gridObjSelectionArray[gridObjKey].nodeObj = nodeObj;
				
						var cboxid = "jqg_" + options.targetId + "_" + rowid;

						if (rowData['isreadonly'] != null && rowData['isreadonly'] == "true") {
						    $("#" + options.targetId).find("td > input.cbox[id=" + cboxid + "]").attr("disabled", true);
						    gridObjSelectionArray[gridObjKey].isreadonlyrow = true;

						}
						else
						    updateGridSelections(options.targetId, gridObjKey, true);


					});
				 
   
            },
            serializeGridData: function (postData) {

                var request = new Object();
                request.requestObj = new Object();

                request.requestObj.nodeId = '';
                request.requestObj.nodetype = '';
               
                request.criteriaObj = new Object();
               
                request.criteriaObj.filterObj = null;
                request.criteriaObj.filterObj = [];
             
                var filterData = null;

                var pagerid = $("#" + options.targetId).getGridParam('pager');
                var loadonceattrib= $("#" + options.targetId).getGridParam('loadonce');

                if (pagerid != null && !loadonceattrib) { //enable serverside pagination if loadonce attrib =true then data is cached and if pager is set client pagination will be enabled.

                    request.criteriaObj.paginationObj = new Object();

                    var currentPage = $("#" + options.targetId).getGridParam('page');
                    var rowCountPerPage = $("#" + options.targetId).getGridParam('rowNum');
                    var totalItemsCount = $("#" + options.targetId).getGridParam('records');

                    request.criteriaObj.paginationObj.currentPage = currentPage;
                    request.criteriaObj.paginationObj.rowCountPerPage = rowCountPerPage;
                    request.criteriaObj.paginationObj.totalItemsCount = totalItemsCount;

                }
                
                for (param in pagereqobj.requestObj) {
                
                    request.requestObj[param] = pagereqobj.requestObj[param];                   
                 
                    if (param == "filterParams" && request.requestObj[param] != null) { //If filters are set construct filterobj with the selected filters.
                      
                   
                        for (var i = 0; i < request.requestObj[param].length;i++) {
                             request.criteriaObj.filterObj.push(request.requestObj[param][i]);
                      
                        }
                    }

                }

                return JSON.stringify(request);

            },
            subGridBeforeExpand: function (divid, rowid) {
            /* Adjust the width as per resolution/browser window resizing */
                var parentTableWidth = window.innerWidth;
              
                if (parentTableWidth <= minWidth) {
                   
                    $("#" + options.targetId).setGridWidth(minWidth - relativeWidth, true);
                    if ($("#" + options.targetId).parents('.tabPanel')!=null)
                      $("#" + options.targetId).parents('.tabPanel').width($("#" + options.targetId).width());
                }
                       
                //gridObjTableArray is stored with the list of expanded nodes preserved for use while resolution/ browser window  width changes as same nodes needss to be expanded.
                //clear this list when a node is expanded newly.
                if (!resizeFlag) {
                    gridObjTableArray = null; gridObjTableArray = {};
                }
                else { resizeFlag = false; }
             
                        
              
                var expanded = jQuery("td.sgexpanded", "#" + options.targetId)[0];
           
                if (expanded) {
                    setTimeout(function () {                
                        $(expanded).trigger("click");
                    }, 100);
                   
                }
               
            },
            gridComplete: function () {

                var pagerid = $("#" + options.targetId).getGridParam('pager');
                var rowNum = $("#" + options.targetId).getGridParam('rowNum');             
            
             
                var totalRows = $("#" + options.targetId).getGridParam('records');

           //     $('div.noResultsDiv').hide();
                //$(pagerid).hide();

                if (totalRows == 0) {
                    $('div.noResultsDiv').show();
                }
                else {
                    $('div.noResultsDiv').hide();
                }

                if (totalRows == 0) {
                    $(pagerid).hide();
                } else if (totalRows <= rowNum) {
                    $(pagerid).show();
                    $(pagerid + '_center').css("visibility", "hidden");
                } else {
                    $(pagerid).show();
                    $(pagerid + '_center').css("visibility", "visible");
                }
                 
                $("#" + options.targetId).jqGrid('setGridParam', { subGridRowExpanded: ChildGrid });

                //Grid Column Names Alignment
                if (pagereqobj.nodecolModel != null) {
                    for (var nodelevel = 0; nodelevel < pagereqobj.nodecolModel.length ; nodelevel++) {
                        if (pagereqobj.nodecolModel[nodelevel].colModel != null) {
                            for (var index = 0; index < pagereqobj.nodecolModel[nodelevel].colModel.length; index++) {
                                $("#" + options.targetId).jqGrid('setLabel', pagereqobj.nodecolModel[nodelevel].colModel[index].name, '', { 'text-align': 'left' });
                            }
                        }
                    }
                }

                //Setting cursor default for non sortable columns
                if ($("#" + options.targetId)[0] && $("#" + options.targetId)[0].p) {
                    var cm = $("#" + options.targetId)[0].p.colModel;

                    if ($("#" + options.targetId)[0].grid) {
                        $.each($("#" + options.targetId)[0].grid.headers, function (index, value) {
                            var cmi = cm[index], colName = cmi.name;
                            if (!cmi.sortable && colName !== 'rn' && colName !== 'cb' && colName !== 'subgrid') {
                                $('div.ui-jqgrid-sortable', value.el).css({ cursor: "default" });
                            }
                        });

                        $($("#" + options.targetId)[0].grid.hDiv).find(".ui-jqgrid-labels th.ui-th-column").unbind("mouseenter").unbind("mouseleave");
                    }
                }

                /* Adjust the width as per resolution/browser window resizing */
           
                $(window).bind('resize', function (e) {
              
                    window.resizeEvt;
                    clearTimeout(window.resizeEvt);
                    window.resizeEvt = setTimeout(function () {
                        resizeFlag = true;
                        var origTableWidth = $("#" + options.targetId).width();
                        var parentTableWidth = window.innerWidth;
                                      
                      
                        if (parentTableWidth <= minWidth) {

                            $("#" + options.targetId).setGridWidth(minWidth - relativeWidth, true);
                           
                        }
                        else {
                            $("#" + options.targetId).setGridWidth(parentTableWidth - relativeWidth, true);
                           
                        }
                        if ($("#" + options.targetId).parents('.tabPanel') != null)
                            $("#" + options.targetId).parents('.tabPanel').width($("#" + options.targetId).width());

                        for (var p in gridObjTableArray) {

                            $("#" + options.targetId).jqGrid('collapseSubGridRow', gridObjTableArray[p].rowId);
                            $("#" + options.targetId).jqGrid('expandSubGridRow', gridObjTableArray[p].rowId);


                        }
                    }, 250);
                 
                });
                requestProcessing = false;
            },

		};
		
		function EnableGridHeaderCheckBox() {
		    var gridObjSelectionArray_cpy = null
		    gridObjSelectionArray_cpy = {};
		    gridObjSelectionArray_cpy = cloneObject(gridObjSelectionArray);
		    var selectedRows = 0;
		    var indeterminateRows = 0;
		    var indeterminateFlag = false;

		    for (var p in gridObjSelectionArray_cpy) {
		        if (gridObjSelectionArray_cpy.hasOwnProperty(p) && gridObjSelectionArray_cpy[p] != null) {

		            if (gridObjSelectionArray_cpy[p].isRootNode && gridObjSelectionArray_cpy[p].isSelected) {
		                if (gridObjSelectionArray_cpy[p].indeterminateState) {
		                    indeterminateRows = indeterminateRows + 1;
		                    indeterminateFlag = true;
		                }else
		                    selectedRows = selectedRows + 1;
		            } else if (gridObjSelectionArray_cpy[p].isRootNode && gridObjSelectionArray_cpy[p].indeterminateState) {
		                indeterminateRows = indeterminateRows + 1;
		                indeterminateFlag = true;
		            }
		        }
		    }

		    if ((selectedRows + indeterminateRows) == $("#" + options.targetId).getGridParam("reccount") && indeterminateFlag) {
		        $('#cb_' + options.targetId).prop('checked', false);
		        $('#cb_' + options.targetId).prop('indeterminate', true);
		    } else if ((selectedRows + indeterminateRows) == $("#" + options.targetId).getGridParam("reccount")) {
		        $('#cb_' + options.targetId).prop('indeterminate', false);
		        $('#cb_' + options.targetId).prop('checked', true);
		    } else if ((selectedRows + indeterminateRows) > 0) {
		        $('#cb_' + options.targetId).prop('checked', false);
		        $('#cb_' + options.targetId).prop('indeterminate', true);
		    } else {
		        $('#cb_' + options.targetId).prop('checked', false);
		        $('#cb_' + options.targetId).prop('indeterminate', false);
		    }

		}

		function dataPoll(grid, jobId) {
		    var self = this;

		    $('#load_' + grid).show();

		    var request = new Object();
		    request.requestObj = new Object();
		    request.requestObj = { "id" : jobId };
		   

		    $.ajax({
		        url: options.pollUrl,
		        type: "POST",
		        dataType: 'json',
		        contentType: 'application/json; charset=utf-8',
		        //accept: 'application/json',
		        data: JSON.stringify(request),
		        success: function (gridResponse) {

		            if (gridResponse != null && gridResponse.rows !== null && gridResponse.rows.length > 0) {

		                $('#load_'+ grid).hide();

		                finalData = gridResponse.rows;
		                $("#" + grid).jqGrid('clearGridData');
						var numOfRows = 0;
						var pageNumber=1;
						// If pagination is enabled restrict rowNum  property of Grid to the defined number of pages else define rowNum to be total number of rows recieved
		                if (!pagination)
		                    numOfRows = finalData.length;
		                else
		                {
		                    numOfRows = rowsPerPage;
							pageNumber = defaultPageNum;
						}

                        $("#" + grid).jqGrid('setGridParam', { datatype: 'local', data: finalData, rowNum: numOfRows , page: pageNumber}).trigger("reloadGrid");
		              
		            }
		            else {
		           
		                 //   alert('here');
		                    if (self.dataTimeout)
		                        clearTimeout(self.dataTimeout);

		                    self.dataTimeout = setTimeout(function () {
		                        dataPoll(grid, jobId);
		                    });
		                
		            }
		        }
		    });
		}

		function updateMainGridOnRowSelect (id, isSelected) {
		    var rowData = $("#" + options.targetId).getRowData(id);
		    var gridObjKey = options.targetId + rowData['nodetype'] + rowData['id'];
		    //var parentGridObjKey = gridObjSelectionArray[gridObjKey].parentGridKey;
		    var parentGridObjKey;

		    if (gridObjSelectionArray[gridObjKey] != null) {
		        gridObjSelectionArray[gridObjKey].isSelected = isSelected;
		        parentGridObjKey = gridObjSelectionArray[gridObjKey].parentGridKey;
		    }
		
		    if ( gridObjSelectionArray[gridObjKey]!=null && gridObjSelectionArray[gridObjKey].selectOnLoad != null && !gridObjSelectionArray[gridObjKey].selectOnLoad) {
		        if ((isSelected || !isSelected)) {
		            //mark all child as false

		            if (gridObjSelectionArray[gridObjKey].childTable != null) {
		                for (var key in gridObjSelectionArray) {
		                    if (gridObjSelectionArray.hasOwnProperty(key)) {

		                        if (gridObjSelectionArray[key] != null) {
		                            if (gridObjSelectionArray[key].tableId == gridObjSelectionArray[gridObjKey].childTable) {
		                                gridObjSelectionArray[key].persistState = false;
		                            }

		                        }
		                    }
		                }
		            }
		            else {
		                gridObjSelectionArray[gridObjKey].indeterminateState = false;
		                markIndeterminate(gridObjKey, false);

		            }
		        }
		    }


		    updateGridSelections(options.targetId, gridObjKey, false);
		}
		function updateSubGridOnRowSelect(id, isSelected, childGridID) {


		    var rowData = $("#" + childGridID).getRowData(id);

		    var gridObjKey = childGridID + rowData['nodetype'] + rowData['id'];

		    //var parentGridObjKey = gridObjSelectionArray[gridObjKey].parentGridKey;
		    var parentGridObjKey;

		    if (gridObjSelectionArray[gridObjKey] != null) {
		        parentGridObjKey = gridObjSelectionArray[gridObjKey].parentGridKey;
		    }

		    if (gridObjSelectionArray[gridObjKey]!=null && gridObjSelectionArray[gridObjKey].selectOnLoad != null && !gridObjSelectionArray[gridObjKey].selectOnLoad) {

		        if (isSelected || !isSelected) {
		            //mark all child as false

		            if (gridObjSelectionArray[gridObjKey].childTable != null) {
		                for (var key in gridObjSelectionArray) {
		                    if (gridObjSelectionArray.hasOwnProperty(key)) {

		                        if (gridObjSelectionArray[key] != null) {

		                            if (gridObjSelectionArray[key].tableId == gridObjSelectionArray[gridObjKey].childTable) {

		                                gridObjSelectionArray[key].persistState = false;
		                            }

		                        }
		                    }
		                }
		            }
		        }

		    }


		    gridObjSelectionArray[gridObjKey].isSelected = isSelected;

		    if (gridObjSelectionArray[parentGridObjKey] != null && gridObjSelectionArray[parentGridObjKey].isSelected) {

		        if (!isSelected) {
		            gridObjSelectionArray[gridObjKey].persistState = true;
		        }
		        else
		            gridObjSelectionArray[gridObjKey].persistState = false;
		    }
		    else if (gridObjSelectionArray[parentGridObjKey] != null && !gridObjSelectionArray[parentGridObjKey].isSelected) {
		        if (isSelected) {
		            gridObjSelectionArray[gridObjKey].persistState = true;
		        }
		        else
		            gridObjSelectionArray[gridObjKey].persistState = false;
		    }


		    updateGridSelections(childGridID, gridObjKey, false);

		}

        function EnableHTMLElementsOnSelection(nodetype) {
            //Checking for disable/enable elements in page level on grid selection change
            var isDisable = true;
          
            if (pagereqobj!=null && pagereqobj.disabledElements != null) {
               
                for (var key in gridObjSelectionArray) {
                    if (gridObjSelectionArray.hasOwnProperty(key)) {
                        if ((gridObjSelectionArray[key] != null)) {
                            if (gridObjSelectionArray[key].isSelected){
                                isDisable = false;
                                break;
                            }
                        }
                    }

                }
         

                for (var element = 0; element < pagereqobj.disabledElements.length ; element++) {
                
                    if (!isDisable) {
                        $("#" + pagereqobj.disabledElements[element]).removeAttr("disabled");
                        $("#" + pagereqobj.disabledElements[element]).removeClass("disabled");
                    }
                    else {

                        //Unchecking the checkbox on disabling when there are no items selected in Grid. Bug#64353
                        if ($('#' + pagereqobj.disabledElements[element]).is(':checkbox'))
                            $('#' + pagereqobj.disabledElements[element]).prop('checked', false);

                        $("#" + pagereqobj.disabledElements[element]).attr("disabled", "disabled");
                        $("#" + pagereqobj.disabledElements[element]).removeClass("disabled");
                    }
                }

            }
            
       }


        function cloneObject(obj) {
            if (obj === null || typeof obj !== 'object') {
                return obj;
            }

            var temp = obj.constructor();
            for (var key in obj) {
                temp[key] = cloneObject(obj[key]);
            }

            return temp;
        }
        
  

    function resizeSubgridColumnWidth(tableObj, childColModel) {
            colModel = $(tableObj).jqGrid("getGridParam", "colModel");

            if (colModel == null)
                return childColModel;

            var resizeWidth = 0, totalCols = colModel.length;

            var colModelArray = new Array();
            var displayColModelIndex;
           
            for (var i = 0 ; i < colModel.length; i++) {
                if (colModel[i] != null) {
                    if (colModel[i].hidedlg !=null && colModel[i].hidedlg)
                        resizeWidth = resizeWidth + colModel[i].widthOrg;
                    else if (colModel[i].hidden != null && colModel[i].hidden)
                        resizeWidth = resizeWidth + 1;
                    else {
                        displayColModelIndex = i;
                        break;

                    }
                }

            }
            if (displayColModelIndex == null)
                return childColModel;

            for (i = displayColModelIndex; i < colModel.length; i++) {
                if (colModel[i]!=null && (colModel[i].hidedlg || colModel[i].hidden))
                    continue;
                else
                    colModelArray.push(i);
            }

            resizeWidth = resizeWidth + totalCols;
            
            var childgrid_colModelArray = new Array();
            for (var i = 0; childColModel!=null && i < childColModel.length; i++) {

                if (childColModel[i] !== null && (childColModel[i].hidedlg || childColModel[i].hidden))
                    continue;
                else {
                    displayColModelIndex = i; break;

                }
            }
            if (displayColModelIndex == null)
                return childColModel;

            for (i = displayColModelIndex;childColModel!=null && i < childColModel.length; i++) {
                if (childColModel[i]!=null && (childColModel[i].hidden || childColModel[i].hidedlg))
                    continue;
                else
                    childgrid_colModelArray.push(i);
            }

            
                var colModelArrayIndex = 0; var i;
                for (i = 0; childgrid_colModelArray!=null && i < childgrid_colModelArray.length - 1 ; i++) {

                    if (i == 0) {
                        childColModel[childgrid_colModelArray[i]].width = colModel[colModelArray[colModelArrayIndex]].width - resizeWidth;

                    }
                    else {

                        childColModel[childgrid_colModelArray[i]].width = colModel[colModelArray[colModelArrayIndex]].width + totalCols;

                    }

                    colModelArrayIndex++;
                }
                if (childColModel != null && childColModel[childgrid_colModelArray[i]]!=null)
                childColModel[childgrid_colModelArray[i]].width = colModel[colModelArray[colModelArrayIndex]].width;

      
            return childColModel;
        }
		
		     function getSelectedRows() {

            var obj = {};
            var parentobj = {};
            var tempArray = null;
            tempArray = {};
            retJSONObjArray = null
            retJSONObjArray = {};
            var gridObjSelectionArray_cpy = null
            gridObjSelectionArray_cpy = {};
            gridObjSelectionArray_cpy = cloneObject(gridObjSelectionArray);

            for (var p in gridObjSelectionArray_cpy) {
                if (gridObjSelectionArray_cpy.hasOwnProperty(p) && gridObjSelectionArray_cpy[p] != null) {
             
                    if (gridObjSelectionArray_cpy[p].isRootNode && (gridObjSelectionArray_cpy[p].isSelected || gridObjSelectionArray_cpy[p].indeterminateState)) {

                          retJSONObjArray[p] = gridObjSelectionArray_cpy[p];
                            retJSONObjArray[p].visited = false;
 
                    }
                    else {
                   
                        if (!gridObjSelectionArray_cpy[p].isreadonlyrow && (gridObjSelectionArray_cpy[p].isSelected || gridObjSelectionArray_cpy[p].indeterminateState)) {
                       
                            var parentGridObjKey = gridObjSelectionArray_cpy[p].parentGridKey;
                            if (gridObjSelectionArray_cpy[parentGridObjKey] != null) {
                                if (gridObjSelectionArray_cpy[parentGridObjKey].isSelected) {
                                   
                                    if (gridObjSelectionArray_cpy[parentGridObjKey].indeterminateState) {
                                        retJSONObjArray[p] = gridObjSelectionArray_cpy[p];
                                        retJSONObjArray[p].visited = false;
                                    }
                                    else {  }

                                }
                                else if (!gridObjSelectionArray_cpy[parentGridObjKey].isSelected) {
                                    if (gridObjSelectionArray_cpy[parentGridObjKey].indeterminateState) {
                                        retJSONObjArray[p] = gridObjSelectionArray_cpy[p];
                                        retJSONObjArray[p].visited = false;
                                    }

                                }
                            }
                        }
                    }
                   
                }
            }
            
            //console.log("retJSONObjArray==" + JSON.stringify(retJSONObjArray));
            retJSONNodeObjArray = null;
            retJSONNodeObjArray = new Array();
          
           for (var p in retJSONObjArray) {
               if (retJSONObjArray.hasOwnProperty(p) && retJSONObjArray[p] != null && retJSONObjArray[p].isRootNode && !retJSONObjArray[p].visited) {
                   // 
                    if (retJSONObjArray[p].childTable != null)
                        {createRowSelectionObj(p);}
                               
                    retJSONNodeObjArray.push(retJSONObjArray[p].nodeObj);
            
                }

            }

         //  console.log("retJSONNodeObjArray==" + JSON.stringify(retJSONNodeObjArray));
           return retJSONNodeObjArray;
       
        }
		
		  function createRowSelectionObj(gridObjKey) {

            var key;
            for (key in retJSONObjArray) {
                if (retJSONObjArray.hasOwnProperty(key) && retJSONObjArray[key]) {

                    if (retJSONObjArray[key].tableId == retJSONObjArray[gridObjKey].childTable) {
                  
                        if (retJSONObjArray[key].childTable != null) {
                            createRowSelectionObj(key);
                        }
                        var parentGridObjKey = retJSONObjArray[key].parentGridKey;
                        if (retJSONObjArray[parentGridObjKey] != null) {
                            retJSONObjArray[parentGridObjKey].nodeObj.children.push(retJSONObjArray[key].nodeObj);
                      
                        }
                    }
                }
            }
		  }
		  function updateParentGridSelections(childGridID, gridObjKey, selectOnLoad) {

		      if (gridObjSelectionArray[gridObjKey] && gridObjSelectionArray[gridObjKey].isRootNode) {

		          if (!gridObjSelectionArray[gridObjKey].persistState) {
		              if (gridObjSelectionArray[gridObjKey].isSelected) {
		                  var state = $("#" + gridObjSelectionArray[gridObjKey].tableId).find('#' + gridObjSelectionArray[gridObjKey].rowid + ' input[type=checkbox]').prop('checked');
		                  if (!state) {

		                      $("#" + gridObjSelectionArray[gridObjKey].tableId).jqGrid('setSelection', gridObjSelectionArray[gridObjKey].rowid);
		                  }
		              }
		              else {
		                  var state = $("#" + gridObjSelectionArray[gridObjKey].tableId).find('#' + gridObjSelectionArray[gridObjKey].rowid + ' input[type=checkbox]').prop('checked');
		                  if (state) {

		                      $("#" + gridObjSelectionArray[gridObjKey].tableId).jqGrid('setSelection', gridObjSelectionArray[gridObjKey].rowid);
		                  }
		              }
		          }
		          if (gridObjSelectionArray[gridObjKey].indeterminateState)
		              $("#" + gridObjSelectionArray[gridObjKey].tableId).find('#' + gridObjSelectionArray[gridObjKey].rowid + ' input[type=checkbox]').prop('indeterminate', true);

		      }

		      do {

		            if (gridObjSelectionArray[gridObjKey]){
		                parentGridObjKey = gridObjSelectionArray[gridObjKey].parentGridKey;
		                updateParentNodeSelectionState(parentGridObjKey);
		                gridObjKey = parentGridObjKey;
		            }

		      } while (parentGridObjKey != null);

		      
		  }
   
		  function updateChildGridSelections(childGridID, gridObjKey, selectOnLoad) {
		    
		      for (var key in gridObjSelectionArray) {
		          if (gridObjSelectionArray.hasOwnProperty(key)) {
		         
		              if (gridObjSelectionArray[key]) {
		              
		                  if (gridObjSelectionArray[key].tableId == gridObjSelectionArray[gridObjKey].childTable) {
		                 
		                      var parent = gridObjSelectionArray[key].parentGridKey;

		                      if (gridObjSelectionArray[parent] != null || (gridObjSelectionArray[parent] == null && gridObjSelectionArray[parent].isRootNode)) {
		                         
		                          if (gridObjSelectionArray[parent].isSelected) {
		                              gridObjSelectionArray[key].selectOnLoad = selectOnLoad;
									
									if (!gridObjSelectionArray[parent].indeterminateState && !gridObjSelectionArray[parent].persistState) {
	                                  gridObjSelectionArray[key].persistState = false;
		                              }
									  
		                              if (gridObjSelectionArray[key] != null && !gridObjSelectionArray[key].persistState) {
		                                
		                                  gridObjSelectionArray[key].isSelected = true;
		                                  var state = $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('checked');
										   gridObjSelectionArray[key].indeterminateState = false;
										   
		                                  if (!state) {
		                                      $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
		                                  }
										   else if (state && gridObjSelectionArray[key].indeterminateState) {//new
		                                     
		                                      gridObjSelectionArray[key].indeterminateState = false;
		                                      $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('checked',false);
		                                      $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
 
		                                
		                                  }
		                                  if (gridObjSelectionArray[key].indeterminateState)
		                                  { markIndeterminate(key, true); }


		                              }
		                              else {
		                                 // gridObjSelectionArray[key].selectOnLoad = selectOnLoad;
		                                  var state = $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('checked');
		                                  if (gridObjSelectionArray[key].isSelected) {
		                                      if (!state)
		                                          $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
		                                  }
		                                  else if (!gridObjSelectionArray[key].isSelected) {
		                                      if (state)
		                                          $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
		                                  }

		                                  if (gridObjSelectionArray[key].indeterminateState) {
		                                      markIndeterminate(key, true);
		                                  }

		                              }

		                          }
		                          else {   //If parent Node unselected
		                         
		                              if (gridObjSelectionArray[key] != null && !gridObjSelectionArray[key].persistState) {
		                             
		                                  gridObjSelectionArray[key].selectOnLoad = selectOnLoad;
		                                  gridObjSelectionArray[key].isSelected = false;
		                                  var state = $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('checked');
		                                  if (state) {
		                                      $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
		                                  }
										  else if (!state && gridObjSelectionArray[key].indeterminateState) {//new

		                                      gridObjSelectionArray[key].indeterminateState = false;
		                                      $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('checked', true);
		                                      $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);


		                                  }
		                                  if (gridObjSelectionArray[key].indeterminateState) {
		                                      markIndeterminate(key, true);
		                                  }

		                              }
		                              else {
		                                  gridObjSelectionArray[key].selectOnLoad = selectOnLoad;
		                                  var state = $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('checked');

		                                  if (gridObjSelectionArray[key].isSelected) {
		                                      if (!state)
		                                          $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
		                                  }
		                                  else if (!gridObjSelectionArray[key].isSelected) {
		                                      if (state)
		                                          $("#" + gridObjSelectionArray[key].tableId).jqGrid('setSelection', gridObjSelectionArray[key].rowid);
		                                  }
		                             
		                                  if (gridObjSelectionArray[key].indeterminateState) {
		                                      markIndeterminate(key, true);
		                                  }


		                              }
		                          }

		                      }

		                  }
		              }
		          }
		      }
		          //update state of this node once childs are updated  send only this as parent

		          if (gridObjSelectionArray[gridObjKey] != null) {
		              updateParentNodeSelectionState(gridObjKey);
		          }

		  }

		  function updateGridSelections(childGridID, gridObjKey, selectOnLoad)
          {
		      var parentGridObjKey = null;

            if (gridObjSelectionArray[gridObjKey])
                 parentGridObjKey=gridObjSelectionArray[gridObjKey].parentGridKey;
          
            if (gridObjSelectionArray[parentGridObjKey] == null)  {}       
       
            if (gridObjSelectionArray[gridObjKey] != null && gridObjSelectionArray[gridObjKey].childTable != null) {

                     updateChildGridSelections(childGridID, gridObjKey, selectOnLoad);
                  
                }//end childtable
                //start parent selections find all parents of this node and update states .
             
                if (gridObjSelectionArray[gridObjKey] != null) {

                    //find all parents for this parent
                    updateParentGridSelections(childGridID, gridObjKey, selectOnLoad);
                
                }
		  }

		  function markIndeterminate(key, flag) {

		      $("#" + gridObjSelectionArray[key].tableId).find('#' + gridObjSelectionArray[key].rowid + ' input[type=checkbox]').prop('indeterminate', flag);
		  }

		  function updateParentNodeSelectionState(parentGridObjKey)
         {
            var displayedRecords=0;
            var selectedRecords = 0;
            var indeterminateRecords = 0;
            var readonlyrows = 0;

            if (gridObjSelectionArray[parentGridObjKey] == null)
                return;

            for (var key in gridObjSelectionArray) {
                if (gridObjSelectionArray.hasOwnProperty(key)) {

                    if (gridObjSelectionArray[key]) {
                        if (gridObjSelectionArray[key].parentGridKey == parentGridObjKey) {
                          
                            displayedRecords++;
                            //   if (gridObjSelectionArray[key].isSelected && !gridObjSelectionArray[key].indeterminateState) {
                            if (gridObjSelectionArray[key].isSelected && !gridObjSelectionArray[key].isreadonlyrow) {
                                selectedRecords++;
                             
                            }
                            if (gridObjSelectionArray[key].isreadonlyrow)
                                readonlyrows++;

                            if (gridObjSelectionArray[key].indeterminateState)
                                indeterminateRecords++;
                        }
                    }
                }
            }
            var actualrows = selectedRecords + readonlyrows;

         if (selectedRecords != 0 && selectedRecords < displayedRecords) {
             
             {
                 if (gridObjSelectionArray[parentGridObjKey].isSelected && actualrows == displayedRecords) {

                     gridObjSelectionArray[parentGridObjKey].indeterminateState = false;
                     markIndeterminate(parentGridObjKey, false);
                 }
                 else if (!gridObjSelectionArray[parentGridObjKey].isSelected && actualrows == displayedRecords) {
                     gridObjSelectionArray[parentGridObjKey].selectOnLoad = false;
                     gridObjSelectionArray[parentGridObjKey].isSelected = true;

                     var state = $("#" + gridObjSelectionArray[parentGridObjKey].tableId).find('#' + gridObjSelectionArray[parentGridObjKey].rowid + ' input[type=checkbox]').prop('checked');
                     if (!state) {

                         $("#" + gridObjSelectionArray[parentGridObjKey].tableId).jqGrid('setSelection', gridObjSelectionArray[parentGridObjKey].rowid);
                     }
                     gridObjSelectionArray[parentGridObjKey].indeterminateState = false;
                     markIndeterminate(parentGridObjKey, false);
                 }

                 else {
                     gridObjSelectionArray[parentGridObjKey].indeterminateState = true;
                     markIndeterminate(parentGridObjKey, true);
                 }
             }
            }
         else if (selectedRecords == 0) {
             {
                 
                /* if (gridObjSelectionArray[parentGridObjKey].isSelected && displayedRecords < gridObjSelectionArray[parentGridObjKey].totalRecords && actualrows != displayedRecords) {
                     gridObjSelectionArray[parentGridObjKey].indeterminateState = true;
                     markIndeterminate(parentGridObjKey, true);
                   
                 }
                  
                 else*/ {
                     if (indeterminateRecords > 0) {


                     }
                     else if (readonlyrows == displayedRecords) { }
                     else {
                         gridObjSelectionArray[parentGridObjKey].isSelected = false;
                         gridObjSelectionArray[parentGridObjKey].selectOnLoad = false;

                         var state = $("#" + gridObjSelectionArray[parentGridObjKey].tableId).find('#' + gridObjSelectionArray[parentGridObjKey].rowid + ' input[type=checkbox]').prop('checked');
                         if (state) {

                             $("#" + gridObjSelectionArray[parentGridObjKey].tableId).jqGrid('setSelection', gridObjSelectionArray[parentGridObjKey].rowid);
                         }
                         gridObjSelectionArray[parentGridObjKey].indeterminateState = false;
                         markIndeterminate(parentGridObjKey, false);
                     }
                 }
             }
          
            }
         else if (selectedRecords == displayedRecords) {
       
             if (!gridObjSelectionArray[parentGridObjKey].isSelected && displayedRecords < gridObjSelectionArray[parentGridObjKey].totalRecords) {
                 gridObjSelectionArray[parentGridObjKey].indeterminateState = true;
                 markIndeterminate(parentGridObjKey, true);
              
             }
             else {
                 if (indeterminateRecords > 0) {


                 }
                 else {
                     gridObjSelectionArray[parentGridObjKey].selectOnLoad = false;
                     gridObjSelectionArray[parentGridObjKey].isSelected = true;

                     var state = $("#" + gridObjSelectionArray[parentGridObjKey].tableId).find('#' + gridObjSelectionArray[parentGridObjKey].rowid + ' input[type=checkbox]').prop('checked');
                     if (!state) {

                         $("#" + gridObjSelectionArray[parentGridObjKey].tableId).jqGrid('setSelection', gridObjSelectionArray[parentGridObjKey].rowid);
                     }
                     gridObjSelectionArray[parentGridObjKey].indeterminateState = false;
                     markIndeterminate(parentGridObjKey, false);
                 }
              }
            }
       
         if (indeterminateRecords > 0) {
             gridObjSelectionArray[parentGridObjKey].indeterminateState = true;
             markIndeterminate(parentGridObjKey, true);
            
         }

         for (var key in gridObjSelectionArray) {
             if (gridObjSelectionArray.hasOwnProperty(key)) {

                 if (gridObjSelectionArray[key]) {
                     if (gridObjSelectionArray[key].parentGridKey == parentGridObjKey) {
                       
                         if (gridObjSelectionArray[key].persistState) {
                             gridObjSelectionArray[parentGridObjKey].persistState = true;
                             break;
                         }
                     }

                 }
             }
         }

        }
		     function createGridSelectionObject(gridObjKey, rowData, tableId, rowid, isRootNode) {
           
            gridObjSelectionArray[gridObjKey] = {};
            gridObjSelectionArray[gridObjKey].isSelected = false;
            gridObjSelectionArray[gridObjKey].indeterminateState = false;
            gridObjSelectionArray[gridObjKey].parent = null;
            gridObjSelectionArray[gridObjKey].parentGridKey = null;
            gridObjSelectionArray[gridObjKey].childTable = null;
            
            gridObjSelectionArray[gridObjKey].refresh = false;
            gridObjSelectionArray[gridObjKey].tableId = tableId;
            gridObjSelectionArray[gridObjKey].totalRecords = 0;
            gridObjSelectionArray[gridObjKey].displayedRecords = 0;
            gridObjSelectionArray[gridObjKey].unselectedRecords = 0;
            gridObjSelectionArray[gridObjKey].selectedRecords = 0;
            gridObjSelectionArray[gridObjKey].unknownRecords = 0;
            gridObjSelectionArray[gridObjKey].rowid = rowid;
            gridObjSelectionArray[gridObjKey].nodetype = rowData['nodetype'];
            gridObjSelectionArray[gridObjKey].page = 0;
            gridObjSelectionArray[gridObjKey].isRootNode = isRootNode;
            gridObjSelectionArray[gridObjKey].persistState = false;
            gridObjSelectionArray[gridObjKey].selectOnLoad = true;
            gridObjSelectionArray[gridObjKey].isreadonlyrow = false;
           
        }
		  function updateParentNodeInfo(parentRowID,parentRowKey, gridObjKey) {

           // alert(parentRowKey + "====" + parentRowID);
            var currentTable = null;
            var parentTable = null;
            var parentrowid = parentRowKey;
            var parentrowArr = parentRowKey.split("_");
            retValue=options.targetId;
            var key="";
            for (var i = 0; i < parentrowArr.length-1; i++) {
                key=key+parentrowArr[i]+"_";
                currentTable=options.targetId+"_"+key+"table";
                retValue=retValue+";"+currentTable;
                
            }
           
            return retValue ;
        }
    function updateParentIdInfo(parentRowID, parentRowKey, gridObjKey) {

         
            var currentTable = null;
            var parentTable = null;
            var parentrowid = parentRowKey;
            var parentrowIdArr = parentRowKey.split("_");
            retValue = parentrowIdArr[0];
            var key = parentrowIdArr[0];
            for (var i = 1; i < parentrowIdArr.length; i++) {
                key= key+"_"+parentrowIdArr[i];
                retValue = retValue +";"+ key;
            

            }

            return retValue;
        }
		function storeParentChildTableRef(childGridID,parentGridObjKey)
		{
			
			if(parentGridObjKey!=null && gridObjSelectionArray[parentGridObjKey]!=null)
		    {
			    tableRefObj[childGridID].parentTable=gridObjSelectionArray[parentGridObjKey].tableId;
				tableRefObj[childGridID].parentRowId=gridObjSelectionArray[parentGridObjKey].rowId;
				tableRefObj[childGridID].parentGridKey=parentGridObjKey;
			}
			
	
		}
        function ChildGrid(parentRowID, parentRowKey) {
		
            requestProcessing = true;
          
             childTableSubstring = "_" + parentRowKey;
          
             var colModel = $(this).jqGrid("getGridParam", "colModel");
         
            var childgrid_colName, childgrid_colModel;
            var hideChildGridHeader = false;
            var setChildGridCaption = null;
            var isLeafChildGrid = false;
            pagination = false;
            serverPagination = false;
            loadOnceAttrib = true;
            enableScroll = false;
            rowsPerPage = 0;
			defaultPageNum = 1;
            // retrieve the row data of  parent   row for this child grid   
			var rowNum = '';
            var treelevel = parentRowKey.split("_").length;
      
        var childTableSubstring = "_" + parentRowKey;
        var parentTableId = "#" + parentRowID.replace(childTableSubstring, '').trim();
      
         if (gridObjTableArray[parentTableId] == null)
                gridObjTableArray[parentTableId] = {};

		gridObjTableArray[parentTableId].rowId = parentRowKey;
		if (gridObjTableArray[parentTableId].page == null)
			gridObjTableArray[parentTableId].page = 1;
		//else         
		//	defaultPageNum = gridObjTableArray[parentTableId].page;
        
      
        var parentRowData = $(parentTableId).getRowData(parentRowKey);
    
        if (pagereqobj.nodecolModel != null) {

            for (var nodelevel = 0; nodelevel < pagereqobj.nodecolModel.length ; nodelevel++) {
           
                if (pagereqobj.nodecolModel[nodelevel] != null && (pagereqobj.nodecolModel[nodelevel].type="root" && pagereqobj.nodecolModel[nodelevel].name == parentRowData['nodetype'])) {
                    {
                        
                      
                                if (pagereqobj.nodecolModel[nodelevel + 1] != null) {
                                if (pagereqobj.nodecolModel[nodelevel + 1].hideColHeader == true)
                                    hideChildGridHeader = true;
                                if (pagereqobj.nodecolModel[nodelevel + 1].caption != null)
                                    setChildGridCaption = pagereqobj.nodecolModel[nodelevel + 1].caption;
                                if (pagereqobj.nodecolModel[nodelevel + 1].isLeaf != null)
                                    isLeafChildGrid = pagereqobj.nodecolModel[nodelevel + 1].isLeaf;
                                if (pagereqobj.nodecolModel[nodelevel + 1].paging != null) {
                                    pagination = pagereqobj.nodecolModel[nodelevel + 1].paging;

                                    if (pagereqobj.nodecolModel[nodelevel + 1].loadOnce != null)
                                        loadOnceAttrib = pagereqobj.nodecolModel[nodelevel + 1].loadOnce;
                                }
                                if (pagereqobj.nodecolModel[nodelevel + 1].NumOfRows != null)
                                { rowsPerPage = pagereqobj.nodecolModel[nodelevel + 1].NumOfRows; }
                                if (pagereqobj.nodecolModel[nodelevel + 1].NumOfRows != null)
                                    enableScroll = pagereqobj.nodecolModel[nodelevel + 1].enableScroll;

                                childgrid_colName = pagereqobj.nodecolModel[nodelevel + 1].colNames; // Get the column name/model for child grid
                                childgrid_colModel = pagereqobj.nodecolModel[nodelevel + 1].colModel;
                                break;
                            }

                      

                    }
                }
            }
        }
            
    
    
           
            var childGridID = options.targetId + "_" + parentRowKey + "_table";
            var childGridPagerID = parentRowID + "_pager";
            childGridPagerID = options.targetId + "_" + parentRowKey + "_pager";


           
            var idprefix = parentRowKey + "_";
            var childwidth = $("#" + childGridID).width();
            colModel = $(this).jqGrid("getGridParam", "colModel");
        
            if (!isLeafChildGrid)
                childgrid_colModel= resizeSubgridColumnWidth(this, childgrid_colModel);

          
            if (pagination==null || !pagination)
            {  childGridPagerID = "";
         
            }

            if (rowsPerPage == null )
                rowsPerPage = 0;

            var rowNum = rowsPerPage;

            if (enableScroll)
                rowNum = 0;

            
            // alert(childGridPagerID+pagination);
         
          
            // add a table and pager HTML elements to the parent grid row - this will render the child grid here
           
            $('#' + parentRowID).append('<table id=' + childGridID + '></table><div id=' + childGridPagerID + ' class=scroll></div>');
            //   $('#' + parentRowID).find("td").css("background-color", "#C5C5C5");
           
            $("#" + childGridID).jqGrid({

                url: options.url,
                mtype: "POST",
                datatype: "json",
                page: defaultPageNum,
                colNames: childgrid_colName,
                colModel: childgrid_colModel,
                idPrefix: idprefix,
                gridview: true,
                autowidth: true,
                hidegrid :false,
                altRows: false,
                multiselect: $("#" + options.targetId).getGridParam('multiselect'),
                loadonce: loadOnceAttrib,//true,
                height: '100%',
                shrinkToFit: true,
                rowNum: rowNum,
                pager: "#" + childGridPagerID,
                forceFit: true,
                subGrid: true,
                ajaxGridOptions: {
                    accept: 'application/json', contentType: 'application/json; charset=utf-8',
                    error: function (error, textStatus) {
                        if (error.status == 403)
                            document.location.href = "authtimeout.html";
                    }
                },
              
                subGridOptions: {
                    "plusicon": "ui-icon-triangle-1-e",
                    "minusicon": "ui-icon-triangle-1-s",
                    "openicon": "ui-icon-arrowreturn-1-e",
                    "reloadOnExpand": true,
                    "selectOnExpand": false
                },
				onPaging: function (pgButton) {
				
                    enableScroll = false;                  
                    var pagerId = this.p.pager.substr(1); // get paper id like "pager"                  
               
                    var currentValue = $("#" + childGridID).getGridParam('page');
                    var nextValue = 0;
                    // newUserEnteredValue is in the most cases the same as in this.p.page
                    // only wrong values like -10 entered by user will not update
                    // "page" parameter
                    var totalPages = $("#" + childGridID).jqGrid("getGridParam", "lastpage");
                    if (pgButton.indexOf("next") >= 0) {
                    
                        nextValue = ++currentValue;
                    }
                    else if (pgButton.indexOf("prev") >= 0) {
                        nextValue = --currentValue;
                    }
                    else if (pgButton.indexOf("last") >= 0)
                        nextValue = $("#" + childGridID).getGridParam('lastpage');
                    else if (pgButton.indexOf("first") >= 0)
                        nextValue = 1;
                    else if (pgButton === "user") { // User input value
                     
                        nextValue = $('input.ui-pg-input', "#pg_" + $.jgrid.jqID(pagerId)).val();
                 
                        if (nextValue > totalPages || nextValue < 1 || isNaN(nextValue)) {

                            $('input.ui-pg-input', "#pg_" + $.jgrid.jqID(pagerId)).val(this.p.page);
                            return "stop";
                        }
                    }
                
                        if (gridObjTableArray[parentTableId] != null)
                            gridObjTableArray[parentTableId].page = nextValue;
                                  
                       
				},
				beforeSelectRow: function (rowid, e) {

				    var element = document.activeElement;
				    var rowData = $("#" + childGridID).getRowData(rowid);
				    if (element.type == "checkbox") { //enabling row select only when checkbox is selected

				        return true;
				    }

				    return false;
				},
                onSelectRow: function (id, isSelected) {

                    var tr = $("#" + childGridID)[0].rows.namedItem(id);
                
                    var isRowDisable = $("#" + childGridID).find('#' + id + ' input[type=checkbox]').prop('disabled');
            
                    if (isSelected && isRowDisable) {
                        $("#" + childGridID).find('#' + id + ' input[type=checkbox]').attr('checked', false);
                        $(tr).removeClass("ui-state-highlight");
                    }

                    if (!isRowDisable) {

                        var rowData = $("#" + childGridID).getRowData(id);

                        var gridObjKey = childGridID + rowData['nodetype'] + rowData['id'];

                        var parentGridObjKey = null;

                        if(gridObjSelectionArray[gridObjKey]) {

                        parentGridObjKey = gridObjSelectionArray[gridObjKey].parentGridKey;

                        if (gridObjSelectionArray[gridObjKey].selectOnLoad != null && !gridObjSelectionArray[gridObjKey].selectOnLoad) {

                            if (isSelected || !isSelected) {
                                //mark all child as false

                                if (gridObjSelectionArray[gridObjKey].childTable != null) {
                                    for (var key in gridObjSelectionArray) {
                                        if (gridObjSelectionArray.hasOwnProperty(key)) {

                                            if (gridObjSelectionArray[key] != null) {

                                                if (gridObjSelectionArray[key].tableId == gridObjSelectionArray[gridObjKey].childTable) {

                                                    gridObjSelectionArray[key].persistState = false;
                                                }

                                            }
                                        }
                                    }
                                }
                            }

                        }
                    }


                        gridObjSelectionArray[gridObjKey].isSelected = isSelected;

                        if (gridObjSelectionArray[parentGridObjKey] != null && gridObjSelectionArray[parentGridObjKey].isSelected) {

                            if (!isSelected) {
                                gridObjSelectionArray[gridObjKey].persistState = true;
                            }
                            else
                                gridObjSelectionArray[gridObjKey].persistState = false;
                        }
                        else if (gridObjSelectionArray[parentGridObjKey] != null && !gridObjSelectionArray[parentGridObjKey].isSelected) {
                            if (isSelected) {
                                gridObjSelectionArray[gridObjKey].persistState = true;
                            }
                            else
                                gridObjSelectionArray[gridObjKey].persistState = false;
                        }


                        updateGridSelections(childGridID, gridObjKey, false);

                        EnableHTMLElementsOnSelection();

                        EnableGridHeaderCheckBox();
                    }
                },
                
                beforeProcessing: function (data, status, xhr) {
                    finalData = null;

                    if (options.pollUrl != null)
                        dataPoll(childGridID, data.responseObj);
                 
              
                  
                    
                },
              
                loadComplete: function (data) {
               
                   var totalRecords = $("#" + childGridID).jqGrid("getGridParam", "records");
                
                    var page = $("#" + childGridID).jqGrid("getGridParam", "page");
                    var childRowIds = $("#" + childGridID).getDataIDs();
                    var gridObjKey = null;var parentGridObjKey = null;
                    
                
				   
                    $.each(childRowIds, function (index, childrowid) {
                    
                        var childRowData = $("#" + childGridID).getRowData(childrowid);

                    
                        if (childRowData['childnodes'] == "0") {
                           $('#' + childrowid).children("td.sgcollapsed").unbind().html("").removeClass("ui-sgcollapsed sgcollapsed");
                        
                        }
                       
					if(isLeafChildGrid)
					    $("#" + childrowid).css({ "background": "#e8e9ea", "border-top": "0 none", "border-right": "0 none", "border-left": "0 none", "border-bottom": "0 none" });

                        gridObjKey = childGridID + childRowData['nodetype'] + childRowData['id'];
                       
                        if (gridObjSelectionArray[gridObjKey] == null) {
                            //if Obj doesnt exist create one.
                            createGridSelectionObject(gridObjKey, childRowData, childGridID, childrowid, false);

                        }
                        else {
                            gridObjSelectionArray[gridObjKey].rowid = childrowid;

                        }

                        gridObjSelectionArray[gridObjKey].parentRowKey = parentRowKey;
                        gridObjSelectionArray[gridObjKey].page = page;

						
				    	var  childTableSubstring = "_" + parentRowKey;
					    var parentTableId =  parentRowID.replace(childTableSubstring, '').trim();
				


                        var parentrowData = $("#"+parentTableId).getRowData(parentRowKey);
                       
                        parentGridObjKey = parentTableId + parentrowData['nodetype'] + parentrowData['id'];
                   
                        gridObjSelectionArray[gridObjKey].parentGridKey = parentGridObjKey;

                        if (gridObjSelectionArray[parentGridObjKey] != null) {
                            
                                gridObjSelectionArray[parentGridObjKey].childTable = gridObjSelectionArray[gridObjKey].tableId;
                           
                            
                        }
                    
                        if (index == 0 && gridObjSelectionArray[parentGridObjKey] != null)
                            gridObjSelectionArray[parentGridObjKey].totalRecords = totalRecords;
           
                        var nodeObj = new Object();
                        nodeObj.id = childRowData['id'];
                        nodeObj.nodetype = childRowData['nodetype'];
                        nodeObj.children = new Array();
                        gridObjSelectionArray[gridObjKey].nodeObj = nodeObj;

                        var cboxid = "jqg_" + childGridID + "_" + childrowid;


                        if (childRowData['isreadonly'] != null && childRowData['isreadonly'] == "true" || (gridObjSelectionArray[parentGridObjKey] != null && gridObjSelectionArray[parentGridObjKey].isreadonlyrow)) {
                            $("#" + childGridID).find("td > input.cbox[id=" + cboxid + "]").attr("disabled", true);
                            gridObjSelectionArray[gridObjKey].isreadonlyrow = true;
                        }

                    });
					//storeParentChildTableRef(childGridID,parentGridObjKey);
                    updateGridSelections(childGridID, parentGridObjKey,true);
                   
                },

                serializeGridData: function (postData) {
                    var myPostData = $.extend({}, postData); // make a copy of the input parameter
                 
                    //Get the parent node type [group/server/device]
                    //pass this these request parameters to server to fetch the child nodes for this parent
       
                  
                    //uncomment this code for filter
                    if (pagereqobj.requestObj.filterObj != null) {
                       
                        DellClarity.MultiselectView.init();
                    }
                        

				   var  childTableSubstring = "_" + parentRowKey;
				   var parentTableId = "#" + parentRowID.replace(childTableSubstring, '').trim();
				   var rowData = $(parentTableId).getRowData(parentRowKey);
				
                    var request = new Object();
                    request.requestObj = new Object();

                    request.requestObj.nodeId = rowData['id'];
                    request.requestObj.nodetype = rowData['nodetype'];
                  //  request.requestObj.nodedatatype = rowData['nodedatatype'];

               
					
                    request.criteriaObj = new Object();
                
                    request.criteriaObj.filterObj = null;
                    request.criteriaObj.filterObj = [];

                    var filterData = null;//new Object();
                

                    var pagerid = $("#" + childGridID).getGridParam('pager');
                    var loadonceattrib = $("#" + childGridID).getGridParam('loadonce');

                 //  alert(pagerid);
                  //  alert(loadonceattrib);

               
                    if (pagerid != null && !loadonceattrib)//if server side pagination enabled pass the pagination object in request
               
                    {

                        request.criteriaObj.paginationObj = new Object();

                        var currentPage = $("#" + childGridID).getGridParam('page');
                        var rowCountPerPage = $("#" + childGridID).getGridParam('rowNum');
                        var totalItemsCount = $("#" + childGridID).getGridParam('records');

                
                        request.criteriaObj.paginationObj.currentPage = currentPage;
                        request.criteriaObj.paginationObj.rowCountPerPage = rowCountPerPage;
                        request.criteriaObj.paginationObj.totalItemsCount = totalItemsCount;
                    }



                    for (param in pagereqobj.requestObj) {

                        request.requestObj[param] = pagereqobj.requestObj[param];


                        if (param == "filterParams" && request.requestObj[param] != null) {

                           
                            for (var i = 0; i < request.requestObj[param].length; i++) {
                                request.criteriaObj.filterObj.push(request.requestObj[param][i]);
                               
                            }
                        }

                    }

              
                    return JSON.stringify(request);
                },
                subGridBeforeExpand: function (divid, rowid) {
                 
                  
                    var childTableSuffix = "_" + rowid;
                    var parentTableId = "#" + divid.replace(childTableSuffix, '').trim();
                    var expanded = jQuery("td.sgexpanded", parentTableId)[0];
                    if (expanded) {
                        setTimeout(function () {
                            $(expanded).trigger("click");
                        }, 100);
                    }
                },
                gridComplete: function () {
                 
                    $("#cb_" + childGridID).hide();
                  
                 
                    $("#" + childGridID).jqGrid('setGridParam', { subGridRowExpanded: ChildGrid });
                    var totalRecords = $("#" + childGridID).jqGrid("getGridParam", "records");
                    var pagerid = $("#" + childGridID).jqGrid("getGridParam", "pager");
                    var rowNum = $("#" + childGridID).jqGrid("getGridParam", "rowNum");          
                  
                                 

                 
                    //  Grid Column Names Alignment
                    if (pagereqobj.nodecolModel != null) {
                        for (var nodelevel = 0; nodelevel < pagereqobj.nodecolModel.length ; nodelevel++) {
                            for (var index = 0; index < pagereqobj.nodecolModel[nodelevel].colModel.length; index++) {
                               
                                if (pagereqobj.nodecolModel[nodelevel].colModel[index] != null)
                                    $("#" + childGridID).jqGrid('setLabel', pagereqobj.nodecolModel[nodelevel].colModel[index].name, '', { 'text-align': 'left' });
                               
                            }
                        }
                    }
               
                    //Setting cursor default for non sortable columns
                    if ($("#" + childGridID)[0] && $("#" + childGridID)[0].p) {
                        var cm = $("#" + childGridID)[0].p.colModel;

                        if ($("#" + childGridID)[0].grid) {
                            $.each($("#" + childGridID)[0].grid.headers, function (index, value) {
                                var cmi = cm[index], colName = cmi.name;
                                if (!cmi.sortable && colName !== 'rn' && colName !== 'cb' && colName !== 'subgrid') {
                                    $('div.ui-jqgrid-sortable', value.el).css({ cursor: "default" });
                                }
                            });

                            $($("#" + childGridID)[0].grid.hDiv).find(".ui-jqgrid-labels th.ui-th-column").unbind("mouseenter").unbind("mouseleave");
                        }
                    }
					
                      if(enableScroll){
                        {
                            var totalRecords = $("#" + childGridID).jqGrid("getGridParam", "records");
                            //alert(totalRecords);
                       
                            if (rowsPerPage != null && rowsPerPage != "" && (totalRecords>=rowsPerPage))
                               $("#" + childGridID).setGridHeight(parseInt(defaultRowHeight) * rowsPerPage, true);
                

                        }

                      }
                
                      var childTableName = "#" + childGridID;
                  
                      for (var p in gridObjTableArray) {

                          if (p == childTableName && gridObjTableArray[p] != null) {
                                                   
                                $(p).jqGrid('collapseSubGridRow', gridObjTableArray[p].rowId);
                                $(p).jqGrid('expandSubGridRow', gridObjTableArray[p].rowId);
                             
                          }

                      }
                      requestProcessing = false;
                }



            });
            if (hideChildGridHeader == true) {
                $("#" + childGridID).closest("div.ui-jqgrid-view")
                            .children("div.ui-jqgrid-hdiv")
                            .hide();
               }
            if(setChildGridCaption !=null)
                $("#" + childGridID).jqGrid('setCaption', setChildGridCaption);

         

            if (isLeafChildGrid) {
                $("#" + childGridID).jqGrid('hideCol', 'subgrid');
                          
            }
            //override css settings 
           $("#" + childGridID).closest(".ui-subgrid").find("td[colspan=1]").first().css({ 'border-bottom-color': '#f6f6f7', 'border-left-color': '#f6f6f7', 'border-right-color': '#f6f6f7', 'background-color': '#f6f6f7' });//css({ "background-color": "#FFFFFF", "border-right-color": "#FFFFF" });;//.hide();
          
           
        }
        var returnTable = {
         
            create: function (opts, dataToPass) {

                var self = this;
                // alert('create');
                
                self.buildPageRequest(dataToPass);
                self.initGrid();
                options = $.extend(true, $.extend(true, {}, defaultOptions), opts);
                requestProcessing = true;
                var table = $("#" + options.targetId);
                // create jqgrid with the specified option
                table.jqGrid(options);

                var origTableWidth = $("#" + options.targetId).width();
              
                origTableWidth = $("#" + options.targetId).parent().width();
                $("#" + options.targetId).setGridWidth(origTableWidth, true);
            
          
            },

            buildPageRequest: function (dataToPass) {
                pagereqobj = dataToPass;
            },

          
            initGrid: function()
            {
                gridObjSelectionArray = null;
                finalData = null;
                gridObjSelectionArray = {};
                tableRefObj = null; tableRefObj = {};
                gridObjTableArray = null; gridObjTableArray = {};
                minWidth = 1024; relativeWidth = 330;
                resizeFlag = false;
                enableScroll = false;
                pagination = false;
                rowsPerPage = 0;
                defaultPageNum = 1;
                defaultRowHeight = 22;
                requestProcessing = false;
            },
        
            postGrid: function (opts, dataToPass) {
               
                var retNodeObj = getSelectedRows();
                //console.log("runupdate==" + JSON.stringify(retNodeObj));
                return retNodeObj;
            },

            isDataFetchInProgress: function () {
               
                return requestProcessing;
            },

            reloadGrid: function (opts, dataToPass) {
                var self = this;
                self.buildPageRequest(dataToPass);

                self.initGrid();
                options = $.extend(true, $.extend(true, {}, defaultOptions), opts);

                $('#cb_' + options.targetId).prop('checked', false);
                $('#cb_' + options.targetId).prop('indeterminate', false);
                if (pagereqobj.disabledElements != null) {
                    for (var element = 0; element < pagereqobj.disabledElements.length ; element++) {
                        $("#" + pagereqobj.disabledElements[element]).attr("disabled", "disabled");
                        $("#" + pagereqobj.disabledElements[element]).removeClass("disabled");
                    }
                }

                $("#" + options.targetId).jqGrid('clearGridData');
                $("#" + options.targetId).jqGrid('setGridParam', { loadonce: false, datatype: 'json' }).trigger("reloadGrid");
                //$("#" + options.targetId).jqGrid(options).trigger("reloadGrid");

            },

            unloadGrid: function (opts) {
                $("#" + opts.targetId).jqGrid('GridUnload');
            }

        };

        return returnTable;
    })();

}
