
DellClarity.MultiselectView = (function () {
    var responseData = null;
    var filteraction = null;
    var totalselected = 0;
    var filterResponseData = null;

    var retVal = {
        templateName: 'templates/multiselectview.html',
        filterTypes: ko.observableArray(), //Stores  the filter object required to render filter view
        //initialize event handlers for filter view once the  page is laid out
        init: function () {
            var self = this;
            $(".msv-dropdown-menu").hide();


            documentClickEvent();


        },

        loadFilterOptions: function (filterParams) {
            var self = this;

            DellClarity.Ajax.GetJSON(filterParams.url, null,
                function (response) {

                    filterParams.data = response;


                    self.filterTypes(self.create(filterParams));// Will create the filter Object and set the filterTypes,this will create the multicolumn filter view                  



                },

                function (error) {
                    DellClarity.Controls.MessageBox.createErrorMessage(filterParams.error, error);
                }
            );


        },
        //create multiselect multicolumn view and return the filter view object
        create: function (params) {
            var self = this;
            filterSelectionArr = null; filterSelectionArr = new Array();
            responseData = null;
            responseData = params.data; // repsonse recieved post request for filter data from backend
            filteraction = params.action;
            totalselected = 0;
            filterResponseData = null;
            if (responseData) {
                filterResponseData = new Array();
                for (var i = 0, l = responseData.length; i < l; i++) {
                    if (responseData[i].options != null && responseData[i].options.length > 0) {

                        filterResponseData[i] = new Object(); //construct a filter object for each filter type                                             

                        if (responseData[i].id != null)
                            filterResponseData[i].id = responseData[i].id;      //set the filter id                                          
                        else
                            filterResponseData[i].id = i;


                        if (responseData[i].name != null)
                            filterResponseData[i].name = responseData[i].name;      // set the filter header                     
                        else
                            filterResponseData[i].name = "";


                        filterResponseData[i].options = new Array();; // construct options array for each filter type object 

                        for (var j = 0, k = responseData[i].options.length; j < k; j++) {
                            filterResponseData[i].options[j] = new Object();
                            filterResponseData[i].options[j]["isSelected"] = false;  // depending on this value the checkbox  is set/reset in the view.

                            if (responseData[i].options[j]["id"] != null)
                                filterResponseData[i].options[j]["id"] = responseData[i].options[j]["id"];  //set the options id        
                            else
                                filterResponseData[i].options[j]["id"] = j;


                            if (responseData[i].options[j]["name"] != null)
                                filterResponseData[i].options[j]["name"] = responseData[i].options[j]["name"];  // set the filter options label     
                            else
                                filterResponseData[i].options[j]["name"] = "";
                        }


                    }
                }
            }

            return filterResponseData;
        },
        reset: function () {
            var self = this;
            filterSelectionArr = null; filterSelectionArr = new Array();
            self.filterTypes(null);
            totalselected = 0;

         /*   if (filterResponseData == null) {
                self.filterTypes(filterResponseData);
                return;
            }*/

            for (var i = 0, l = filterResponseData.length; i < l; i++) {
                if (filterResponseData[i].options != null && filterResponseData[i].options.length > 0) {
                    for (var j = 0, k = filterResponseData[i].options.length; j < k; j++) {

                        filterResponseData[i].options[j]["isSelected"] = false;

                    }
                }
            }

            self.filterTypes(filterResponseData);

        },


        //This event handler is called when a checkbox option is selected.
        filterevnthandler: function (data, event) {

            event.stopPropagation();
            var targetid = event.target.id;
            var checked = event.target.checked;  // Get the ckeckbox state selection.
            var seperatorIndex = (targetid).indexOf('_');
            var optGroup = (targetid).substring(0, seperatorIndex);  // get the parent id of the selected checkbox option. Use this as index to store all the selection options belonging to this parent.


            if (filterSelectionArr == null)
                filterSelectionArr = new Array();

            delete data.isSelected; // delete the isSelected attrib from the response filterObj 

            var type = objectFindByKey(filterSelectionArr, 'id', optGroup); // Find the filtertype given the group it belongs to

            if (checked) {
                //if no object exist create one and push to filter types array that is used for filter view display
                if (type == null) {
                    var obj = new Object();
                    obj.id = optGroup;
                    obj.options = new Array();
                    obj.options.push(data);
                    filterSelectionArr.push(obj);

                }
                else {
                    //If object exists the  update the options list for the specific filter type
                    filterSelectionArr[type].options.push(data);

                }
                totalselected++;
            }
            else {
                totalselected--;
                //if unchecked filter option then remove from  filter array.
                var option = objectFindByKey(filterSelectionArr[type].options, 'id', data.id); // get the selected filteroption object given the selected option id

                if (option != null) {
                    filterSelectionArr[type].options.splice(option, 1);

                }

                if (filterSelectionArr[type].options.length == 0)
                    filterSelectionArr.splice(type, 1);

            }

            if (totalselected == 0)
                filterSelectionArr = null;

            filteraction(filterSelectionArr);
            return true;

        },

    };

    function objectFindByKey(array, key, value) {
        for (var i = 0; i < array.length; i++) {
            if (array[i][key] === value) {
                return i; // return index of  matching key
            }
        }
        return null;
    }

    function removeByIndex(arr, index) {
        arr.splice(index, 1);
    }

    // Handle all filter events.
    function documentClickEvent() {

        $('#multiselect-dropdown-view').on('mousedown', function (e) {
            e.preventDefault();

        });

        $(document).on("click", function (e) {

            if (!(e.target.id == "multiselect-dropdown-view")) {

                if (e.target.id == "msv-rowid" || e.target.id == "msv-multicolumnid" || e.target.id == "msv-optionlabelid" || e.target.id == "msv-optiondivid" ||
                    e.target.id == "msv-optionheaderid" || e.target.id == "msv-dropdown-ul" || e.target.id == "msv-columnid") {
                    e.stopPropagation();
                }
                else

                    $(".msv-dropdown-menu").hide();
                e.stopPropagation();
            }
            else {
                $(".msv-dropdown-menu").is(":visible") ? $(".msv-dropdown-menu").hide() : $(".msv-dropdown-menu").show();


            }

            e.stopImmediatePropagation();
        });

    }


    DellClarity.Resources.loadTemplate(retVal.templateName);
    return retVal;
})();
