/// <summary>
/// NOTE: This version of this control is not supported in DellClarity 2.5.
/// A new version of this control will be created soon and will be compatible with the new API.
/// </summary>
if (DellClarity.Config.apiVersion < 2.5) {
    //$.contextMenu.types.myType = function (item, opt, root) {
    //    $('<span>' + item.customName + '</span>').appendTo(this);
    //    this.on('contextmenu:focus', function (e) {
    //        alert("estoy en el focus")
    //    }).on('contextmenu:blur', function (e) {
    //        alert("estoy en el blur")
    //    }).on('keydown', function (e) {
    //        alert("estoy keydown");
    //    });
    //};
    (function ($) {
        $.fn.quickMenu = function (menuItems, options) {

            this.each(function () {

                //Set option defaults
                var defaultMenuItem = {
                    label: '',
                    action: function () {
                    },
                    separator: false,
                    disabled: false
                };
                $.each(menuItems, function (index, item) {
                    menuItems[index] = $.extend(true, $.extend(true, {}, defaultMenuItem), item);
                });

                //Create menu items
                var contextMenuItems = {};
                $.each(menuItems, function (index, item) {
                    contextMenuItems["item" + index] = (item.separator) ? "-" : { name: item.label, callback: item.action, disabled: item.disabled, className: item.className };
                });


                if (typeof (options) != 'undefined') {
                    //Set context menu (internal control)
                    $.contextMenu({
                        selector: '#' + this.id,
                        items: contextMenuItems,
                        trigger: 'left',
                        ignoreRightClick: true,
                        position: options.position,
                        className: options.className
                    });
                } else {
                    //Set context menu (internal control)
                    $.contextMenu({
                        selector: '#' + this.id,
                        items: contextMenuItems,
                        trigger: 'left',
                        ignoreRightClick: true
                    });
                }

                $(this).keyup(function (event) {
                    if (event.which != 9)
                        return;

                    event.stopPropagation();

                    var offset = $(this).offset();

                    var hasChildren = $(this).children().length > 0;

                    var height = $(this).height();
                    if (height == 0 && hasChildren)
                        height = $($(this).children()[0]).height();

                    var width = $(this).width();
                    if (width == 0 && hasChildren)
                        width = $($(this).children()[0]).width();

                    var position = { x: offset.left + width, y: offset.top + height };
                    $(this).contextMenu(position);

                }).keydown(function (event) {
                    if (event.which != 9)
                        return;

                    event.stopPropagation();

                    $(this).contextMenu("hide");
                });
            });
        };
    })(jQuery);
}
