
DellClarity.Controls.Tooltip = (function() {

    var template = '<div class="tooltip"><span class="close"></span><div class="content">this is a test!</div></div>';

    var defaultOptions = {
        closable: false
    };

    var $target;
    var tooltipOptions;
    var $tooltip;
    
    function raiseError() {
        throw new Error('Tooltip target cannot be found.');
    }
    
    function showTip() {
        $tooltip.fadeIn(100);
    }
    
    function hideTip() {
        $tooltip.fadeOut(100);
    }

    var tooltip = {
        
        create: function(targetId, options) {

            if (!targetId) raiseError();

            $target = $('#' + targetId);
            if (!$target.length) raiseError();

            tooltipOptions = $.extend(defaultOptions, options);

            $tooltip = $(template);
            var $close = $tooltip.insertAfter($target).find('span.close');

            if (!tooltipOptions.closable)
                $close.css("display", "none");
            else
                $close.click(hideTip);

            $target.click(showTip);

        }
    };

    return tooltip;
})();
