/// <summary>
/// NOTE: This version of this control is not supported in DellClarity 2.5.
/// A new version of this control will be created soon and will be compatible with the new API.
/// </summary>
if (DellClarity.Config.apiVersion < 2.5) {
    DellClarity.TopologyView = Class.extend({

        init: function (id, options) {
            this.defaultUrl = options.statesUrl;
            this.id = id;
            this.container = null;
            this.widthView = 800;
            this.heightView = 400;
        },

        render: function (container, dto) {

            this.container = container;

            //Creates a chassis empty
            $("#" + container).append("<div alt='' id='" + this.id + "' style='width:" + this.widthView + "px; height:" + this.heightView + "px;'></div>");

            //Fills the chassis with the images
            this.loadStateImage(this.id);
        },

        loadStateImage: function (imageId) {

            var idRequest = new DellClarity.IdRequest(imageId);

            DellClarity.Ajax.PostJSON(this.defaultUrl, idRequest, this.whenDtoIsLoaded.bind(this));
        },

        whenDtoIsLoaded: function (response) {
            var switches = response;
            var idContainer = this.id + "_map";

            var divButtons = "<div id='" + idContainer + "_buttons' style='width:" + this.widthView + "px; height:20px; background-color:gainsboro;'>taskbar</div>";
            $("#" + this.id).append(divButtons);

            var divTop = "<div id='" + idContainer + "_top' style='width:" + this.widthView + "px; height:50px;'></div>";
            $("#" + this.id).append(divTop);

            var divCenter = "<div id='" + idContainer + "_center' style='width:" + this.widthView + "px; height:280px; '></div>";
            $("#" + this.id).append(divCenter);

            var divBottom = "<div id='" + idContainer + "_bottom' style='width:" + this.widthView + "px; height:50px;'></div>";
            $("#" + this.id).append(divBottom);

            //Number of the slots columns in the chassis       
            var topSwitches = 0;
            var bottomSwitches = 0;
            var divSwitchContainer;
            var divSwitch;

            for (var item in switches) {

                if (switches[item].Location == 1) {

                    divSwitchContainer = "<div id='" + idContainer + "_switchContainer_" + switches[item].ID + "' class='widthTop' style='float:left; height:50px;'></div>";
                    $("#" + idContainer + "_top").append(divSwitchContainer);

                    divSwitch = "<div id='" + idContainer + "_switch_" + switches[item].ID + "' class='switchImage'></div>";
                    $("#" + idContainer + "_switchContainer_" + switches[item].ID).append(divSwitch);

                    topSwitches = topSwitches + 1;
                }
                else {

                    divSwitchContainer = "<div id='" + idContainer + "_switchContainer_" + switches[item].ID + "' class='widthBottom' style='float:left; height:50px;'></div>";
                    $("#" + idContainer + "_bottom").append(divSwitchContainer);

                    divSwitch = "<div id='" + idContainer + "_switch_" + switches[item].ID + "' class='switchImage'></div>";
                    $("#" + idContainer + "_switchContainer_" + switches[item].ID).append(divSwitch);

                    bottomSwitches = bottomSwitches + 1;
                }

                switch (switches[item].State) {
                    case 1:
                        $("#" + idContainer + "_switch_" + switches[item].ID).css("background-color", "green");
                        break;
                    case 2:
                        $("#" + idContainer + "_switch_" + switches[item].ID).css("background-color", "yellow");
                        break;
                    case 3:
                        $("#" + idContainer + "_switch_" + switches[item].ID).css("background-color", "red");
                        break;
                    case 4:
                        $("#" + idContainer + "_switch_" + switches[item].ID).css("background-color", "orange");
                        break;
                    case 5:
                        $("#" + idContainer + "_switch_" + switches[item].ID).css("background-color", "turquoise");
                        break;
                    default:
                        break;
                }
            };
            var widthTopDiv = this.widthView / topSwitches;
            var widthbottomDiv = this.widthView / bottomSwitches;

            $(".widthTop").css("width", widthTopDiv);
            $(".widthBottom").css("width", widthbottomDiv);
        }

    });
}
