(function () {
    /// <summary>
    /// TODO: Refactor this!!!
    /// WARNING: Any or all of these functions may become obsolete in a future version of DellClarity. Avoid using them!
    /// </summary>
    DellClarity.About = {
        getVersion: function (targetID) {
            var url = targetID.toLowerCase() === 'login' ? urlConfig.LoginAbout.getVersion : urlConfig.About.getVersion;
            DellClarity.Ajax.Request(url, urlConfig.getMethod, DellClarity.About.getVersionResponse);
        },
        getVersionResponse: function (response) {
            var jobResponse = response.evalJSON(true).JobResponse;
            if (jobResponse.responseCode == "0") {
                var version = jobResponse.responseObj;

                $('spProductName').innerHTML = version.ProductName;
                $('spMajor').innerHTML = version.Major;
                $('spMinor').innerHTML = version.Minor;
                $('spBuild').innerHTML = version.Build;
                $('spRevision').innerHTML = version.Revision;
            }
        }
    };


    //#region Legacy API Support (backward compatibility)

    if (DellClarity.Config.apiVersion < 2.5) {
        // PreLoader and Templates.Loader have been consolidated into DellClarity.Resources
        DellClarity.PreLoader = DellClarity.Resources;
        DellClarity.Templates = {
            Loader: DellClarity.Resources
        };

        // DellClarity.UI is obsolete
        DellClarity.UI = {
            Modal: null,
            Wizard: null,
            overrideTabId: null,
            Errors: [],
            Notifications: [],
            RecordID: null,
            Url: null,
            GlobalElementEvents: null
        };

        // DellClarity.config has been replaced by DellClarity.Config,
        // and the options listed below are now obsolete
        DellClarity.options = DellClarity.Config;
        DellClarity.config = {
            mainDivId: 'main',
            mainContentDivId: 'mainContent',
            mainModelErrorsDivId: 'mainContentErrors',
        };

        // The following global variables have been replaced by DellClarity.Config
        if (typeof KICK_START_AFTER_LOAD_FUNC === 'function')
            DellClarity.initialize = KICK_START_AFTER_LOAD_FUNC;

        // The following DellClarity.Config settings are obsolete
        DellClarity.Config.charting = true;
        DellClarity.Config.chassisView = true;
        DellClarity.Config.topologyView = true;
        DellClarity.Config.combinedScript = true;
        DellClarity.Config.minifiedScripts = true;

        // The following properties are obsolete
        DellClarity.Item = null;
        DellClarity.URL = null,
        DellClarity.URLHandler = null;
        DellClarity.Collections = {};

        // CoreUrls is obsolete
        DellClarity.CoreUrls = {
            changelog: 'dellclarity.core/changelog.html',
            about: {
                getAboutData: 'about/getaboutdata',
                aboutTemplate: 'templates/abouttemplate.html'
            },
            menu: {
                getMenu: 'menu/getmenu'
            }
        };


        // Most of the following enumerations have been moved to DellClarity.Constants
        DellClarity.DataSortingConstants = {
            //"order" : number // the order to do sort, it must be 0, 1, 2. 0 means no sort, 1 means ascending order and 2 means descending order
            ASCENDING: DellClarity.Constants.DataSortingConstants.ASCENDING,
            DESCENDING: DellClarity.Constants.DataSortingConstants.DESCENDING
        };
        DellClarity.ModalIcons = {
            Check: 'icon check_48',
            Critical: 'icon critical_48',
            Info: 'icon information_48',
            NonCritical: 'icon nonCritical_48',
            Success: 'icon statusOK_48',
            Unknown: 'icon statusUnknown_48'
        };
        DellClarity.MessageTypes = {
            Success: 'Success',
            Warning: 'Warning',
            Info: 'Info'
        };
        DellClarity.WindowStates = {
            Minimized: "minimized",
            Normal: "normal",
            Maximized: "maximized"
        };

        // Url.config has been replaced by DellClarity.Navigation.viewMap
        DellClarity.Urls = {
            setUrlConfig: function (urlConfig) {
                DellClarity.Navigation.viewMap = urlConfig;
            },
            getVirtualAppRoot: function () {
                return DellClarity.Config.virtualAppRoot;
            },
            getAppUrl: DellClarity.__resolveUrl
        };

        // DellClarity.ModelBinding is obsolete.
        DellClarity.ModelBinding = {
            mainModelErrors: ko.observable(),

            // This function is obsolete.
            // All unhandled errors are automatically caught by DellClarity.error()
            usingMainModelErrors: function () {
                var mainContentErrors = $("#" + DellClarity.config.mainModelErrorsDivId);
                return mainContentErrors.length > 0;
            },

            // This function is obsolete.
            // All unhandled errors are automatically caught by DellClarity.error()
            bindMainModelErrors: function () {
                var mainContentErrors = $("#" + DellClarity.config.mainModelErrorsDivId);
                if (mainContentErrors.length > 0) {
                    ko.cleanNode(mainContentErrors.get(0));
                    ko.applyBindings(DellClarity.ModelBinding, mainContentErrors.get(0));
                }
            },

            menuViewModel: {
                items: ko.observableArray([])
            },

            baseViewModel: null,

            setBaseViewModel: function (appBaseViewModel) {
                DellClarity.ModelBinding.baseViewModel = appBaseViewModel;
            },

            bindModelToMainContent: function () { }
        };

        // Replaced by String.isNumber()
        window.isNumber = function (n) {
            if (typeof n === 'number')
                return true;
            if (typeof n === 'string')
                return n.isNumber();
            return false;
        };

        // If this function is still needed, then it should be
        // refactored to Array.prototype.sortAscending() instead
        window.sortAscending = function (theArray, prop1, prop2) {
            if (!prop1) {
                theArray.sort();
            }

            theArray.sort(function (top1, top2) {
                var top11 = typeof top1[prop1] === 'function' ? top1[prop1]() : top1[prop1];
                var top21 = typeof top2[prop1] === 'function' ? top2[prop1]() : top2[prop1];

                if (top11 == top21) {
                    if (prop2) {
                        var top12 = typeof top1[prop2] === 'function' ? top1[prop2]() : top1[prop2];
                        var top22 = typeof top2[prop2] === 'function' ? top2[prop2]() : top2[prop2];

                        return top12 == top22 ? 0 : (top12 < top22 ? -1 : 1);
                    } else {
                        return 0;
                    }
                } else {
                    return top11 < top21 ? -1 : 1;
                }
            });
        };

        ko.observableArray.fn.sortAscending = function (prop1, prop2) {
            var underlyingArray = this();
            this.valueWillMutate();
            sortAscending(underlyingArray, prop1, prop2);
            this.valueHasMutated();
        };

        ko.bindingHandlers.useDatePicker = {
            init: function (element) {
                $(element).datepicker();
            }
        };
     

        // These animations should be done via CSS instead
        jQuery.fn.extend({
            slideRight: function () {
                return this.each(function () {
                    jQuery(this).animate({ width: 'show' }, 1000);
                });
            },
            slideLeft: function () {
                return this.each(function () {
                    jQuery(this).animate({ width: 'hide' }, 1000);
                });
            },
            slideToggleWidth: function () {
                return this.each(function () {
                    var el = jQuery(this);
                    if (el.css('display') === 'none') {
                        el.slideRight();
                    } else {
                        el.slideLeft();
                    }
                });
            }
        });
    }

    //#endregion

    //#region Legacy API initialization (backward compatibility)

    if (DellClarity.Config.apiVersion < 2.5) {
        var existingHandler = DellClarity.initialize;

        /// <summary>
        /// Perform custom initialization logic and wire-up document-level event handlers.
        /// </summary>
        DellClarity.initialize = function () {
            ko.validation.configure({ insertMessages: false });

            //we have a main content error block, so bind it
            var mainContentErrors = $("#mainContentErrors");
            if (mainContentErrors.length > 0) {
                ko.cleanNode($("#mainContentErrors").get(0));
                ko.applyBindings(DellClarity.ModelBinding, $("#mainContentErrors").get(0));
            }

            DellClarity.Helpers.refreshTooltips();

            // Call any previously-bound initialization function
            if (existingHandler)
                existingHandler();

            $(document).on('keyup blur', 'textarea[maxlength]', null, function () {
                // Store the maxlength and value of the field.
                var maxlength = $(this).attr('maxlength');
                var val = $(this).val();

                // Trim the field if it has content over the maxlength.
                if (val.length > maxlength) {
                    $(this).val(val.slice(0, maxlength));
                }
            });

            $(document).on('keyup blur', 'select', null, function () {

                //triggers change event on blur or keyup
                $(this).trigger('change');

            });

            // Minimize/Show/Maximize the details panel when the window state buttons are clicked
            $(document).on('click.setWindowState', '.windowStateButton', function (e) {
                var $this = $(this);

                // Determine the new window state
                var newState = DellClarity.WindowStates.Normal;
                if ($this.hasClass(DellClarity.WindowStates.Minimized))
                    newState = DellClarity.WindowStates.Minimized;
                else if ($this.hasClass(DellClarity.WindowStates.Maximized))
                    newState = DellClarity.WindowStates.Maximized;

                // Call the helper method to set the details window state on the current view model
                DellClarity.Helpers.setDetailsWindowState(newState);

                e.preventDefault();
            });

            // Whenever a tab is clicked, show the corresponding tab contents
            $(document).on('click.setActiveTab', '.tab', function (e) {
                DellClarity.Helpers.setActiveTab(this);
                e.preventDefault();
            });

            // Resize again whenever the brower is resized
            $(window).resize(function () {
                DellClarity.Helpers.waitForFinalEvent(function () {
                    DellClarity.Helpers.resize();
                }, 1000, "resize");
            });
        };
    }

    //#endregion
})();
