if (!DellClarity.Localization)
	DellClarity.Localization = { };

DellClarity.Localization.Translator = (function () {
	var appSpecificLocalizationObject = null;

	return {
		setAppSpecificLocalizationObject: function (localizationObject) {
			appSpecificLocalizationObject = localizationObject;
		},

		translateByPropertyName: function (propertyName, formatParameters) {
			if (appSpecificLocalizationObject == null) {
				alert("No app specific localization object set");
				return null;
			}

			var token = Object.getNestedPropertyValue(appSpecificLocalizationObject, propertyName);
			if (token == null)
				return null;

			return this.translate(token, formatParameters);
		},

		translate: function (token, formatParameters) {
			var returnVal = token;

			if (formatParameters) {
				$.each(formatParameters, function (key, value) {
					returnVal = returnVal.replace(new RegExp('%%' + key + '%%', 'g'), value);
				});
			}

			return returnVal;
		}
	};
})();
