DellClarity.ModelBinding = (function () {

    var baseViewModel = null;

    return {
        mainModelErrors: ko.observable(null),
        menuViewModel: ko.observable(),
        
        setBaseViewModel: function (appBaseViewModel) {
            baseViewModel = appBaseViewModel;
        },

        usingMainModelErrors: function () {
            var mainContentErrors = $("#" + DellClarity.Config.mainModelErrorsDivId);
            return mainContentErrors.length > 0;
        },

        bindMainModelErrors: function () {
            var mainContentErrors = $("#" + DellClarity.Config.mainModelErrorsDivId);
            if (mainContentErrors.length > 0)
                ko.applyBindings(DellClarity.ModelBinding, mainContentErrors.get(0));
        },

        bindModelToMainContent: function () {
            if (baseViewModel == null) {
                alert("No base view model set!");
                return;
            }

            DellClarity.ModelBinding.mainModelErrors(null);

            DellClarity.ModelBinding.mainModelErrors.subscribe(function () {
                DellClarity.Helpers.resize();
            });

            var mainContentDiv = $('#' + DellClarity.Config.mainContentDivId);
            // ko.cleanNode(mainContentDivNode);
            ko.applyBindings(baseViewModel, mainContentDiv.get(0));

            mainContentDiv.css('visibility', 'visible');
        }
    };
})();
