DellClarity.Session = (function() {
    var currentTimer;
    var sessionTimeoutInMilliseconds = 0;
    var navigationSubscription = null;

    var resetTimeout = function () {
        if (!isLoggedIn())
            return;

        if (currentTimer) {
            clearTimeout(currentTimer);
        }
        currentTimer = setTimeout(warnUser, sessionTimeoutInMilliseconds);

        turnHandlersOff();
        turnHandlersOn();
    };

    var warnUser = function () {
        turnHandlersOff();
        document.location.href = '#/sessionExpired';
    };

    var turnHandlersOff = function () {
        $(document).off('click', resetTimeout);
        $(document).off('keypress', resetTimeout);
        if (navigationSubscription)
            navigationSubscription.dispose();
    };

    var turnHandlersOn = function () {
        $(document).on('click', resetTimeout);
        $(document).on('keypress', resetTimeout);
        navigationSubscription = DellClarity.Navigation.navigationComplete.subscribe(resetTimeout);
    };

    var isLoggedIn = function () {
        return location.pathname.indexOf("login.html") < 0;
    };

    return {
        configure: function (minutes) {
            if (!minutes)
                return;

            minutes = parseInt(minutes);
            if (isNaN(minutes) || minutes <= 0)
                return;

            sessionTimeoutInMilliseconds = minutes * 60 * 1000;
            if (sessionTimeoutInMilliseconds == 0)
                return;

            resetTimeout();
        }
    }
})();
