<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<div class="advancedWizard" data-bind="attr: {id: id}">
    <nav class="advancedWizardSteps">
        <ol data-bind="foreach: steps">
            <li class="advancedWizardStep" data-bind="css: { 'active': isActive(), 'hasSubSteps': hasSubSteps(), 'noSubSteps': !hasSubSteps(), completed: !wizard.editMode() && isCompleted }">
                <a data-bind="text: title, click: click, css: { disabled: isDisabled }"></a>

                <!-- ko if: subSteps.length > 0 -->
                <ol data-bind="foreach: subSteps, visible: isActive">
                    <li class="advancedWizardStep noSubSteps" data-bind="css: { 'active': isActive(), completed: !wizard.editMode() && isCompleted }">
                        <a data-bind="text: title, click: click, css: { disabled: isDisabled }"></a>
                    </li>
                </ol>
                <!-- /ko -->
            </li>
        </ol>
    </nav>

    <div class="advancedWizardContents">
        <!-- ko if: wizardInfoMessage() != null -->
            <div id="wizardInfoMessage" data-bind="template: {name: DellClarity.Controls.MessageBox.templateName, data: wizardInfoMessage}">
            </div>
        <!-- /ko -->

        <ol data-bind="foreach: denormalizedSteps">
            <li class="stepContents" data-bind="visible: isActive(), css: {'active': isActive(), 'scrollable': $parent.isScrollable() }">
                <!-- ko template: templateName -->
                <!-- /ko -->
            </li>
        </ol>
        
        <div class="sectionEditButtons">
            <!-- ko with: activeStep -->
                <!-- ko ifnot: $parent.propertyPageMode -->
                    <span class="stepProgressText" data-bind="text: wizard.stepProgressText"></span>

                    <button id="idAdvanceWizardBackBtn" class="cux-button cux-button-large cux-button-primary" data-bind="enable: !isFirstStep() && isBackButtonActive(), click: wizard.goToPreviousStep" type="button">
                        <fmt:message key="wizard.back" />
                    </button>

                    <button id="idAdvancedWizardNextBtn" class="cux-button cux-button-large cux-button-primary" data-bind="click: nextButtonHandler, enable: isNextButtonActive() && !isLastStep(), text: nextButtonText()" type="submit">
                    </button>

                    <button id="idAdvancedWizardFinishBtn" class="cux-button cux-button-large cux-button-primary" data-bind="click: nextButtonHandler, enable: isFinishButtonActive() || (isNextButtonActive() && isLastStep()), text: finishButtonText()" type="submit">
                    </button>
                <!-- /ko -->
            
                <!-- ko if: $parent.propertyPageMode -->
                    <button id="idAdvancedWizardNextBtn" class="cux-button cux-button-large cux-button-primary" data-bind="click: nextButtonHandler, enable: isNextButtonActive()" type="submit">
                        <fmt:message key="wizard.save" />
                    </button>
                <!-- /ko -->
            <!-- /ko -->

            <button id="idAdvancedWizardCancelBtn" class="cux-button cux-button-large cux-button-danger" data-bind="click: cancel" type="button">
                <fmt:message key="wizard.cancel" />
            </button>
        </div>
    </div>
</div>

